UNIT EditStuff;

{$O+}

(* (C) 1990-1995 by Johannes Leckebusch *)

(* Stand 07. 02. 95 *)

INTERFACE

USES Objects, {My}Views, GLFTypes, GLFBase;

CONST
	(* ASCII-Codes *)
	nul =		#0; (* -> Extended Key *)
        soh =           #1;
        stx =           #2;
        etx =           #3;
        eot =           #4;
        enq =           #5;
        ack =           #6;
        bel =           #7;
	bs =		#8; (* ctrl-bs liefert DEL = #127 *)
        ctrlbs =        #127;
        ht =            #9;
	tab =		#9;
        lf =            #10;
        vt =            #11;
        ff =            #12;
	cr =		#13;
        so =            #14;
        si =            #15;
        dle =           #16;
        dc1 =           #17;
        dc2 =           #18;
        dc3 =           #19;
        dc4 =           #20;
        nak =           #21;
        syn =           #22;
        etb =           #23;
        can =           #24;
        em =            #25;
        sub =           #26;
	esc =		#27;
        fs =            #28;
        qs =            #29;
        rs =            #30;
        us =            #31;

	linedel =	#25; (* ^Y *)
        lineundel =     #21; (* ^U *)

      (* Extended Keys: *)

  (* Die Bezeichnungen folgen den Angaben im Anhang A2 des QuickPascal-
     Handbuches, jedoch wird (bei den Pfeiltasten) jeweils "key" angehngt *)

  (* Arrow *)

        ctrlins =       #4;
        shiftins =      #5;
        ctrldel =       #6;
        shiftdel =      #7;

	upkey =		#72;
	downkey =	#80;
        scrollupkey =   #24;
        scrolldownkey = #25;
	leftkey =	#75;
	rightkey =	#77;
	pgupkey =	#73;
	pgdownkey =	#81;
	homekey =	#71;
	endkey =	#79;
	inskey =	#82;
	delkey =	#83;

  (* CTRL + Arrow *)

	ctrlprtsc =	#114;
	ctrlleft =	#115;
	ctrlright =	#116;
	ctrlend =	#117;
	ctrlpgdn =	#118;
	ctrlhome =	#119;

	ctrlpgup =	#132;

	nullkey =	#3;
	shifttab =	#15;

  (* CONTROL + Letter *)

        ctrla =         #01;
        ctrlb =         #02;
        ctrlc =         #03;
        ctrld =         #04;
        ctrle =         #05;
        ctrlf =         #06;
        ctrlg =         #07;
        ctrlh =         #08;
        ctrli =         #09;
        ctrlj =         #10;
        ctrlk =         #11;
        ctrll =         #12;
        ctrlm =         #13;
        ctrln =         #14;
        ctrlo =         #15;
        ctrlp =         #16;
        ctrlq =         #17;
        ctrlr =         #18;
        ctrls =         #19;
        ctrlt =         #20;
        ctrlu =         #21;
        ctrlv =         #22;
        ctrlw =         #23;
        ctrlx =         #24;
        ctrly =         #25;
        ctrlz =         #26;

  (* ALT + Letter *)

	alta =		#30;
	altb =		#48;
	altc =		#46;
	altd =		#32;
	alte =		#18;
	altf =		#33;
	altg =		#34;
	alth =		#35;
	alti =		#23;
	altj =		#36;
	altk =		#37;
	altl =		#38;
	altm =		#50;
	altn =		#49;
	alto =		#24;
	altp =		#25;
	altq =		#16;
	altr =		#19;
	alts =		#31;
	altt =		#20;
	altu =		#22;
	altv =		#47;
	altw =		#17;
	altx =		#45;
	alty =		#21;
	altz =		#44;

  (* ALT + Number *)

	alt1 =		#120;
	alt2 =		#121;
	alt3 =		#122;
	alt4 =		#123;
	alt5 =		#124;
	alt6 =		#125;
	alt7 =		#126;
	alt8 =		#127;
	alt9 =		#128;
	alt0 =		#129;
	altminus =	#130;
	altgleich =	#131;

  (* Function *)

	f1 =		#59;
	f2 =		#60;
	f3 =		#61;
	f4 =		#62;
	f5 =		#63;
	f6 =		#64;
	f7 =		#65;
	f8 =		#66;
	f9 =		#67;
	f10 =		#68;

	f11 =		#133;
	f12 =		#134;

  (* SHIFT + Function *)

	shiftf1 =	#84;
	shiftf2 =	#85;
	shiftf3 =	#86;
	shiftf4 =	#87;
	shiftf5 =	#88;
	shiftf6 =	#89;
	shiftf7 =	#90;
	shiftf8 =	#91;
	shiftf9 =	#92;
	shiftf10 =	#93;

	shiftf11 =	#135;
	shiftf12 =	#136;

  (* CTRL + Function *)

	ctrlf1 =	#94;
	ctrlf2 =	#95;
	ctrlf3 =	#96;
	ctrlf4 =	#97;
	ctrlf5 =	#98;
	ctrlf6 =	#99;
	ctrlf7 =	#100;
	ctrlf8 =	#101;
	ctrlf9 =	#102;
	ctrlf10 =	#103;

	ctrlf11 = 	#137;
	ctrlf12 =	#138;

  (* ALT + Function *)

	altf1 =		#104;
	altf2 =		#105;
	altf3 =		#106;
	altf4 =		#107;
	altf5 =		#108;
	altf6 =		#109;
	altf7 =		#110;
	altf8 =		#111;
	altf9 =		#112;
	altf10 =	#113;

	altf11 =	#139;
	altf12 =	#140;

PROCEDURE zentriere (VAR R: TRect);
FUNCTION istSichtbar (R: TRect; view: PScroller): BOOLEAN;
FUNCTION istAusserhalb (R: TRect; view: PScroller): BOOLEAN;
FUNCTION hatBreite (R: TRect): INTEGER;
FUNCTION hatHoehe (R: TRect): INTEGER;

FUNCTION kleinVon (VAR ch: CHAR): BOOLEAN;
(* Liefert TRUE, wenn das Zeichen GROSSGESCHRIEBEN war und wandelt es
   in ein kleines Zeichen um. *)
PROCEDURE grossVon (VAR ch: CHAR);
(* Wandelt einen Kleinbuchstaben in einen Grobuchstaben um. Die Assymetrie
   der beiden Routinen rhrt daher, da WordBase Bezeichner auf Klein-
   Schreibung normalisiert und fr grogeschriebene Zeichen ein Bit in der
   Schreibungs-Bitmap setzt (Kleinbuchstaben sind hufiger).
   Bei der Renormalisierung wird diese Bit ausgewertet, um den Aufruf von
   grossVon zu steuern, es mu aber nicht neu gesetzt werden.
*)

PROCEDURE GotoXY (x, y: INTEGER);
PROCEDURE WriteString (view: PView; s: STRING);
PROCEDURE WriteStrLn (view: PView; s: STRING);
PROCEDURE WriteChr (view: PView; ch: CHAR);
PROCEDURE WriteIntF (view: PView; i: LONGINT; f: INTEGER);
PROCEDURE WriteInt (view: PView; i: LONGINT);
PROCEDURE WriteBool (view: PView; b: BOOLEAN);
PROCEDURE WritePointer (view: PView; p: POINTER);
PROCEDURE WriteTyp (view: PView; typ: einGenTyp);
PROCEDURE WriteFlags (view: PView; f: einFlagSet);
PROCEDURE MeldFileOn (fname: STRING);
PROCEDURE MeldFileOff;
PROCEDURE Protokoll (Titel, Text: STRING);
PROCEDURE zeigMeldung (Titel, Text: STRING);
FUNCTION  zeigFrage (Titel, Text: STRING): BOOLEAN;
PROCEDURE zeigKoordinaten (Titel, Text: STRING; x, y: INTEGER);
PROCEDURE zeigFehler (Zeilen: INTEGER; Fehlertext: STRING;
                      Fehlernummer: INTEGER);

FUNCTION EditStringTitel (X, Y, max: INTEGER; t: STRING; VAR s: STRING): CHAR;
FUNCTION EditString (X, Y, max: INTEGER; VAR s: STRING): CHAR;
FUNCTION EditName (name, obj: GLP; X, Y, max: INTEGER; VAR s: STRING): GLP;
FUNCTION EditNameZahl (name, obj: GLP; X, Y, max: INTEGER; VAR s: STRING): GLP;

PROCEDURE EditNumTitel (name: GLP; x, y, max: INTEGER; Nmin, Nmax: LONGINT;
                        VAR num: LONGINT);

PROCEDURE EditZahl (name: STRING; x, y, max: INTEGER; Nmin, Nmax: LONGINT;
                        VAR num: LONGINT);

PROCEDURE LiesTaste (VAR ch, code: CHAR);
PROCEDURE LiesNochmal (VAR ch, code: CHAR);

IMPLEMENTATION

USES Crt, Drivers, {My}Dialogs, {My}App, Fields;

PROCEDURE zentriere (VAR R: TRect);
BEGIN
(* Anscheinend Absturz im Protected-Mode bei Zugriff auf Desktop *)
  IF Desktop <> NIL THEN
    R.Move ((Desktop^.Size.X - R.B.X) DIV 2, (Desktop^.Size.Y - R.B.Y) DIV 2);
END (* zentriere *);

FUNCTION istSichtbar (R: TRect; view: PScroller): BOOLEAN;
BEGIN
  WITH view^ DO BEGIN
    {zeigKoordinaten ('istSichtbar', 'Origin: ', Origin.X, Origin.Y);}
    istSichtbar := (R.A.X < {Origin.X} 1 + Size.X + Delta.X) AND
                   (R.A.Y < {Origin.Y} 1 + Size.Y + Delta.Y) AND
                   (R.B.X > {Origin.X} 1 + Delta.X) AND
                   (R.B.Y > {Origin.Y} 1 + Delta.Y);
  END (* WITH *);
END (* istSichtbar *);

FUNCTION istAusserhalb (R: TRect; view: PScroller): BOOLEAN;
BEGIN
  WITH view^ DO BEGIN
    (* zeigKoordinaten ('displayObjekte', 'Delta: ', Delta.X, Delta.Y); *)
    istAusserhalb := (R.A.X > {Origin.X} 1 + Size.X + Delta.X) AND
                     (R.A.Y > {Origin.Y} 1 + Size.Y + Delta.Y);
  END (* WITH *);
END (* istAusserhalb *);

FUNCTION hatBreite (R: TRect): INTEGER;
BEGIN
  WITH R DO BEGIN
    hatBreite := B.X - A.X;
  END (* WITH *);
END (* hatBreite *);

FUNCTION hatHoehe (R: TRect): INTEGER;
BEGIN
  WITH R DO BEGIN
    hatHoehe := B.Y - A.Y;
  END (* WITH *);
END (* hatHoehe *);

FUNCTION kleinVon (VAR ch: CHAR): BOOLEAN;
CONST offset = ORD ('a') - ORD ('A');
BEGIN
  CASE ch OF
    'A'..'Z':  BEGIN
                 ch := CHR (ORD (ch) + offset);
                 kleinVon := TRUE;
               END;
    '':       BEGIN ch := ''; kleinVon := TRUE; END;
    '':       BEGIN ch := ''; kleinVon := TRUE; END;
    '':       BEGIN ch := ''; kleinVon := TRUE; END;
    '':       BEGIN ch := ''; kleinVon := TRUE; END;
    '':       BEGIN ch := ''; kleinVon := TRUE; END;
    '':       BEGIN ch := ''; kleinVon := TRUE; END;
    '':       BEGIN ch := ''; kleinVon := TRUE; END;
    ELSE       kleinVon := FALSE;
  END (* CASE *);
END (* kleinVon *);

PROCEDURE grossVon (VAR ch: CHAR);
BEGIN
  CASE ch OF
    'a'..'z':  ch := UpCase (ch);
    '':       ch := '';
    '':       ch := '';
    '':       ch := '';
    '':       ch := '';
    '':       ch := '';
    '':       ch := '';
    '':       ch := '';
  END (* CASE *);
END (* grossVon *);

VAR   col, globx, globy:   INTEGER;

PROCEDURE GotoXY (x, y: INTEGER);
BEGIN
  globx := x; globy := y;
  IF globx < 0 THEN globx := 0;
  IF globy < 0 THEN globy := 0;
END (* GotoXY *);

PROCEDURE WriteString (view: PView; s: STRING);
BEGIN
  view^.WriteStr (globx, globy, s, col);
  INC (globx, LENGTH (s));
END (* WriteString *);

PROCEDURE WriteStrLn (view: PView; s: STRING);
BEGIN
  view^.WriteStr (globx, globy, s, col);
  INC (globy); globx := 0;
END (* WriteStrLine *);

PROCEDURE WriteChr (view: PView; ch: CHAR);
BEGIN
  view^.WriteChar (globx, globy, ch, col, 1);
  INC (globx);
END (* WriteChr *);

PROCEDURE WriteInt (view: PView; i: LONGINT);
VAR  s:  STRING [10];
BEGIN
  Str (i, s);
  WriteString (view, s);
END (* WriteInt *);

PROCEDURE WriteIntF (view: PView; i: LONGINT; f: INTEGER);
VAR  s:  STRING [10];
BEGIN
  Str (i, s);
  IF LENGTH (s) < f THEN BEGIN
    view^.WriteChar (globx, globy, ' ', col, f - LENGTH (s));
    INC (globx, f - LENGTH (s));
  END;
  WriteString (view, s);
END (* WriteIntF *);

PROCEDURE WriteBool (view: PView; b: BOOLEAN);
BEGIN
  IF b THEN WriteString (view, 'TRUE') ELSE WriteString (view, 'FALSE');
END (* WriteBool *);

PROCEDURE WritePointer (view: PView; p: POINTER);
VAR  PS:  STRING [9];
BEGIN
  PS := StringVonPointer (p);
  WriteString (view, PS);
END (* WritePointer *);

PROCEDURE WriteTyp (view: PView; typ: einGenTyp);
BEGIN
  WriteString (view, StringVonTyp (typ));
END (* WriteTyp *);

PROCEDURE WriteFlags (view: PView; f: einFlagSet);
BEGIN
  WriteString (view, StringVonFlags (f));
END;

PROCEDURE zeigKoordinaten (Titel, Text: STRING; x, y: INTEGER);
VAR  xs, ys: STRING [5];
BEGIN
  Str (x, xs); Str (y, ys);
  zeigMeldung (Titel, Text + xs + ', ' + ys);
END (* zeigKoordinaten *);

VAR  MeldOffen:  BOOLEAN;
     MeldDatei:  ASCII;

PROCEDURE MeldFileOn (fname: STRING);
VAR  KompaktDat:  LONGINT;
BEGIN
  Assign (MeldDatei, fname);
  Rewrite (MeldDatei);
  MeldOffen := TRUE;
  WriteLn (MeldDatei, 'Datei: ', fname);
  KompaktDat := SystemDatum;
  WriteLn (MeldDatei, 'Time: ', StringVonDatum (KompaktDat, TRUE));
END (* MeldFileOn *);

PROCEDURE MeldFileOff;
(* wird in einTraverser16.Done gerufen *)
VAR KompaktDat:  LONGINT;
BEGIN
  IF MeldOffen THEN BEGIN
    KompaktDat := SystemDatum;
    WriteLn (MeldDatei, 'Time: ', StringVonDatum (KompaktDat, TRUE));
    WriteLn (MeldDatei, '<END OF TRACE>');
    Close (MeldDatei);
    MeldOffen := FALSE;
  END;
END (* MeldFileOff *);

PROCEDURE Protokoll (Titel, Text: STRING);
BEGIN
  IF MeldOffen THEN BEGIN
    {Append (MeldDatei);}
    WriteLn (MeldDatei, '[', Titel:50, '] ', Text);
    Flush (MeldDatei);
  END
END (* Protokoll *);

PROCEDURE zeigMeldung (Titel, Text: STRING);
VAR  Box:        PDialog;
     R:          TRect;
     Control:    WORD;
     Breite:     INTEGER;
     TexHaelfte: INTEGER;
     Mitte:   INTEGER;
BEGIN
  IF MeldOffen THEN BEGIN
    {Append (MeldDatei);}
    WriteLn (MeldDatei, '[', Titel:50, '] ', Text);
    Flush (MeldDatei);
  END
  ELSE BEGIN

    IF NOT ObjekteInitialisiert OR (Desktop = NIL) THEN BEGIN
      WriteLn;
      Write (Titel, ': ', Text); ReadLn;
      EXIT;
    END;

    IF LENGTH (Text) > LENGTH (Titel) THEN
      Breite := LENGTH (Text) + 10
    ELSE Breite := LENGTH (Titel) + 10;
    IF Odd (Breite) THEN INC (Breite);
    Mitte := Breite DIV 2;
    R.Assign (0, 0, Breite, 7);
    zentriere (R);
    Box := NEW (PDialog, Init (R, Titel));
    IF Box = NIL THEN EXIT;
    WITH Box^ DO BEGIN
      TexHaelfte := LENGTH (Text); IF Odd (TexHaelfte) THEN INC (TexHaelfte);
      TexHaelfte := TexHaelfte DIV 2;
      R.Assign (Mitte - TexHaelfte, 2, Mitte + TexHaelfte, 3);
      Insert (NEW (PStaticText, Init (R, Text)));
      R.Assign (Mitte - 3, 4, Mitte + 3, 6);
      Insert (NEW (PButton, Init (R, '~O~K', cmOK, bfDefault)));
    END (* WITH *);
    Control := DeskTop^.ExecView (Box);
    Dispose (Box, Done);
  END (* ELSE *);
END (* zeigMeldung *);

FUNCTION  zeigFrage (Titel, Text: STRING): BOOLEAN;
VAR  Box:        PDialog;
     R:          TRect;
     Control:    WORD;
     Breite:     INTEGER;
     TexHaelfte: INTEGER;
     Mitte:      INTEGER;
     Zeilen, i:  INTEGER;
     Textlaenge: INTEGER;
     start:      INTEGER;
BEGIN
  IF NOT ObjekteInitialisiert THEN EXIT;

  Zeilen := 1; Textlaenge := 0; start := 1;
  FOR i := 1 TO LENGTH (Text) DO BEGIN
    IF Text [i] = #13 THEN BEGIN
      INC (Zeilen);
      IF i - start > Textlaenge THEN Textlaenge := i - start;
      start := i;
    END (* IF *);
  END (* FOR *);
  IF Textlaenge = 0 THEN Textlaenge := LENGTH (Text);

  IF Textlaenge > LENGTH (Titel) THEN
    Breite := Textlaenge + 8
  ELSE Breite := LENGTH (Titel) + 8;

  IF Odd (Breite) THEN INC (Breite);
  Mitte := Breite DIV 2;
  R.Assign (0, 0, Breite, 6 + Zeilen);
  zentriere (R);
  Box := NEW (PDialog, Init (R, Titel));
  WITH Box^ DO BEGIN
    TexHaelfte := Textlaenge; IF Odd (TexHaelfte) THEN INC (TexHaelfte);
    TexHaelfte := TexHaelfte DIV 2;
    R.Assign (Mitte - TexHaelfte, 2, Mitte + TexHaelfte, 3 + Zeilen);
    Insert (NEW (PStaticText, Init (R, Text)));
    (* Was'n das fr'n Bug: Default ist immer der zuletzt insertierte
       Button - egal, welches bf-Flag ich setze... *)
    R.Assign (Mitte + 2, 3 + Zeilen, Mitte + 9, 5 + Zeilen);
    Insert (NEW (PButton, Init (R, '~N~ein', cmNo, bfNormal)));
    R.Assign (Mitte - 9, 3 + Zeilen, Mitte - 2, 5 + Zeilen);
    Insert (NEW (PButton, Init (R, '~J~a', cmYes, bfDefault)));
  END (* WITH *);
  Control := DeskTop^.ExecView (Box);
  Dispose (Box, Done);
  zeigFrage := (Control = cmYes);
END (* zeigFrage *);

PROCEDURE zeigFehler (Zeilen: INTEGER; Fehlertext: STRING;
                      Fehlernummer: INTEGER);
VAR  Box:        PDialog;
     R:          TRect;
     Control:    WORD;
     Breite:     INTEGER;
     StrMitte:   INTEGER;
     NumStr:     STRING [4];
BEGIN
  IF MeldOffen THEN BEGIN
    WriteLn (MeldDatei, '{', Fehlertext, '}, FNr: ', Fehlernummer);
  END
  ELSE BEGIN
    IF NOT ObjekteInitialisiert THEN EXIT;

    IF Zeilen = 0 THEN Zeilen := 1;
    IF Fehlernummer <> 0 THEN BEGIN
      Str (Fehlernummer, NumStr);
      FehlerText := FehlerText + (*#13 + #3 +*) NumStr;
      (* INC (Zeilen); *)
    END;
    Breite := LENGTH (Fehlertext) DIV Zeilen + 8;
    StrMitte := LENGTH (Fehlertext) DIV (2 * Zeilen) + 4;
    R.Assign (0, 0, Breite, Zeilen + 8);
    zentriere (R);
    Box := NEW (PDialog, Init (R, 'Meldung'));
    WITH Box^ DO BEGIN
      R.Assign (4, 2, 4 + LENGTH (Fehlertext) DIV Zeilen, 3 + Zeilen);
      Insert (NEW (PStaticText, Init (R, Fehlertext)));
      R.Assign (StrMitte - 3, Zeilen + 5, StrMitte + 3, Zeilen + 7);
      Insert (NEW (PButton, Init (R, '~O~K', cmOK, bfDefault)));
    END (* WITH *);
    Control := DeskTop^.ExecView (Box);
    Dispose (Box, Done);
  END (* IF NOT MeldOffen *);
END (* zeigFehler *);

VAR	InsertMode:		BOOLEAN;
	globCH, globCode:	CHAR;

PROCEDURE LiesTaste (VAR ch, code: CHAR);
BEGIN
  globCh := ReadKey;
  IF globCh = nul THEN BEGIN
    globCode := ReadKey;
  END
  ELSE globCode := nul;
  ch := globCh; code := globCode;
END (* LiesTaste *);

PROCEDURE LiesNochmal (VAR ch, code: CHAR);
BEGIN
  ch := globCh; code := globCode;
END (* LiesNochmal *);

PROCEDURE EditZahl (name: STRING; x, y, max: INTEGER; Nmin, Nmax: LONGINT;
                        VAR num: LONGINT);
VAR Bounds:         TRect;
    Dialog:         PDialog;
    Control:        PView;
    R:              TRect;
    C:              WORD;
    breite, mitte:  INTEGER;
    offs:           INTEGER;
    titel:          STRING [80];
    mins, maxs:     STRING;
BEGIN
{zeigMeldung ('EditZahl', name);}
  IF name <> '' THEN
    (* name soll ein PName-Handle sein *)
    titel := name
  ELSE BEGIN
    (* ersatzweise Wertebereich als Titel *)
    Str (Nmin, mins); Str (Nmax, maxs);
    titel := '[' + mins + '...' + maxs + ']';
  END;
  INC (max, 2); (* Platz fr die Scrollpfeile *)
  offs := max; IF ODD (offs) THEN INC (offs);
  offs := offs DIV 2;
  breite := max + 2;
  IF LENGTH (titel) + 10 > breite THEN breite := LENGTH (titel) + 10;
  IF ODD (breite) THEN INC (breite);
  IF breite < 30 THEN breite := 30;
  mitte := breite DIV 2;
{zeigMeldung ('EditZahl', 'Bounds.Assign');}
  Bounds.Assign (X, Y, X + breite, Y + 7);
  zentriere (Bounds);
{zeigMeldung ('EditZahl', 'NEW PDialog');}
  Dialog := NEW (PDialog, Init (Bounds, titel));
  WITH Dialog^ DO BEGIN
    R.Assign (mitte - offs, 2, mitte + offs, 3);
    Control := NEW (PNumInputLine, Init (R, max, Nmin, Nmax));
    Insert (Control);
    R.Assign (mitte - 8, 4, mitte - 2, 6);
    Insert (NEW (PButton, Init (R, '~O~K', cmOK, bfDefault)));
    R.Assign (mitte + 1, 4, mitte + 11, 6);
    Insert (NEW (PButton, Init (R, 'Abbruch', cmCancel, bfNormal)));
    SelectNext (False);
  END (* WITH *);
{zeigMeldung ('EditZahl', 'Dialog^.SetData');}
  Dialog^.SetData (num);
{zeigMeldung ('EditZahl', 'DeskTop^.ExecView');}
  C := DeskTop^.ExecView (Dialog);
  IF C <> cmCancel THEN BEGIN
    Dialog^.GetData (num);
  END
  ELSE num := 0;
  Dispose (Dialog, Done);
END (* EditNumTitel *);

PROCEDURE EditNumTitel (name: GLP; x, y, max: INTEGER; Nmin, Nmax: LONGINT;
                        VAR num: LONGINT);
VAR Bounds:         TRect;
    Dialog:         PDialog;
    Control:        PView;
    R:              TRect;
    C:              WORD;
    breite, mitte:  INTEGER;
    offs:           INTEGER;
    titel:          STRING [80];
    mins, maxs:     STRING;
BEGIN
  IF name <> NIL THEN
    (* name soll ein PName-Handle sein *)
    titel := name^.StringVonDaten
  ELSE BEGIN
    (* ersatzweise Wertebereich als Titel *)
    Str (Nmin, mins); Str (Nmax, maxs);
    titel := '[' + mins + '...' + maxs + ']';
  END;
  INC (max, 2); (* Platz fr die Scrollpfeile *)
  offs := max; IF ODD (offs) THEN INC (offs);
  offs := offs DIV 2;
  breite := max + 2;
  IF LENGTH (titel) + 6 > breite THEN breite := LENGTH (titel) + 6;
  IF ODD (breite) THEN INC (breite);
  IF breite < 30 THEN breite := 30;
  mitte := breite DIV 2;
  Bounds.Assign (X, Y, X + breite, Y + 6);
  Dialog := NEW (PDialog, Init (Bounds, titel));
  WITH Dialog^ DO BEGIN
    R.Assign (mitte - offs, 1, mitte + offs, 2);
    Control := NEW (PNumInputLine, Init (R, max, Nmin, Nmax));
    Insert (Control);
    R.Assign (mitte - 8, 3, mitte - 2, 5);
    Insert (NEW (PButton, Init (R, '~O~K', cmOK, bfDefault)));
    R.Assign (mitte + 1, 3, mitte + 11, 5);
    Insert (NEW (PButton, Init (R, 'Abbruch', cmCancel, bfNormal)));
    SelectNext (False);
  END (* WITH *);
  Dialog^.SetData (num);
  C := DeskTop^.ExecView (Dialog);
  IF C <> cmCancel THEN BEGIN
    Dialog^.GetData (num);
  END;
  Dispose (Dialog, Done);
END (* EditNumTitel *);

FUNCTION EditName (name, obj: GLP; X, Y, max: INTEGER; VAR s: STRING): GLP;
VAR  titel: STRING [80];
     ch:    CHAR;
BEGIN
  IF name <> NIL THEN BEGIN
    (* name soll ein PName-Handle sein *)
    titel := name^.StringVonDaten;
  END
  ELSE BEGIN
    (* ersatzweise Datentyp als Titel *)
    titel := StringVonTyp (obj^.meinTyp);
  END (* ELSE *);
  ch := EditStringTitel (X, Y, max, titel, s);
  IF ch = esc THEN EditName := NIL ELSE EditName := obj;
END (* EditName *);

FUNCTION EditNameZahl (name, obj: GLP; X, Y, max: INTEGER; VAR s: STRING): GLP;
VAR code:   INTEGER;
    dummyg: GLP;
BEGIN
{R-}
  REPEAT
    dummyg := EditName (name, obj, X, Y, max, s);
    IF obj <> NIL THEN code := obj^.NumVonString (s);
  UNTIL (code = 0) OR (obj = NIL);
{$R+}
  EditNameZahl := dummyg;
END (* EditNameZahl *);

FUNCTION EditStringTitel (X, Y, max: INTEGER; t: String; VAR s: STRING): CHAR;
VAR Bounds:         TRect;
    Dialog:         PDialog;
    Control:        PInputLine;
    R:              TRect;
    C:              WORD;
    breite, mitte:  INTEGER;
    offs:           INTEGER;
    hs:             STRING;
BEGIN
  breite := max + 2; IF ODD (breite) THEN INC (breite);
  offs := max; IF ODD (offs) THEN INC (offs);
  offs := offs DIV 2;
  IF breite < 30 THEN breite := 30; mitte := breite DIV 2;
  Bounds.Assign (X, Y, X + breite, Y + 6);
  Dialog := NEW (PDialog, Init (Bounds, t));
  WITH Dialog^ DO BEGIN
    R.Assign (mitte - offs, 1, mitte + offs, 2);
    Control := NEW (PInputLine, Init (R, 255));
    Insert (Control);
    R.Assign (mitte - 8, 3, mitte - 2, 5);
    Insert (NEW (PButton, Init (R, '~O~K', cmOK, bfDefault)));
    R.Assign (mitte + 1, 3, mitte + 11, 5);
    Insert (NEW (PButton, Init (R, 'Abbruch', cmCancel, bfNormal)));
    SelectNext (False);
  END (* WITH *);
  hs := s;
  (*Dialog^.SetData (hs);*)
  Control^.SetData (hs);
  C := DeskTop^.ExecView (Dialog);
  IF C <> cmCancel THEN BEGIN
    (*Dialog^.GetData (hs);*)
    Control^.GetData (hs);
    s := hs; (* GetData berschreibt sonst bei Strings < 255 Chars Speicher! *)
    EditStringTitel := cr;
  END
  ELSE EditStringTitel := esc;
  Dispose (Dialog, Done);
END (* EditStringTitel *);

FUNCTION EditString (X, Y, max: INTEGER; VAR s: STRING): CHAR;
BEGIN
  EditString := EditStringTitel (x, y, max, 'String8', s);
END (* EditString *);

BEGIN
  InsertMode := TRUE;
  MeldOffen := FALSE;
  col := 1; globx := 0; globy := 0;
END (* EditStuff *).
