UNIT GLFBase;

{$F+}
{$O+}

(* (C) 1990, 1991, 1992, 1993, 1994, 1995 by Johannes Leckebusch *)
(* Version 0.902 *)

(* Stand: 07. 02. 95 *)

(* Turbo-Version *)
(* bertragung von QP nach TP: 3. 12. 90 *)
(* Version 0.104 - neuesObjekt in GLFBase mit Anmelden von erzeugeMich *)
(* berlegungen zur Einbindung in Turbo-Vision: 26. 12. 90 *)
(* Erweiterung um Vision: 27. 03. 91 *)
(* Erweiterung um Signatur: 0.200 - 07. 12. 92 *)
(* Signatur und Referenz f. Simpel-Editor entfernt: 25. 3. 93 *)
(* Signatur und Referenz wg. Parser wieder eingefhrt (Ende November 93) *)
(* Optimierung von INIT (keine NIL oder Null-Initialisierung *)

(*$V- akzeptiere verschiedene Stringtypen als Parameter *)

INTERFACE

USES Objects, Drivers, {My}Views, {My}Dialogs, GLFTypes;

TYPE
        GLP = ^GLF;

        einGenArray =   ARRAY [einGenRange] OF GLP;
        einGenArrayPointer = ^einGenArray;

        PPair =         ^einPair;
        einPair =       RECORD Left, Right: GLP; END;

    PBuffText = ^TBuffText;
    TBuffText =   OBJECT (TScroller)
                    VirtualX, VirtualY:     LONGINT;
                    (* die Weltkoordinaten des Cursors, von denen
                       auf die Koordinaten im Fenster durch Delta
                       umgerechnet wird *)
                    DeltaFactor:            LONGINT;
                    LongDelta:              TLongPoint;
                    LongLimit:              TLongPoint;
                    col1, col2:      BYTE;
                    (* Standard-Schreibfarbe, anwenden ber GetColor (colx).
                    col1: Normal, col2: Highlight *)
                    CONSTRUCTOR Init (VAR Bounds: TRect; LimX, LimY: INTEGER;
                                      Offs: TPoint;
                                      AHScrollBar, AVScrollBar: PScrollBar);
                        (* Write-Routinen in Weltkoordinaten, die
                           DeltaX, DeltaY bercksichtigen, den
                           Text aber gepuffert bis zum rechten Fenster-
                           Rand ausgeben (impl ClearToEndOfLine): *)

                      PROCEDURE GotoXY (x, y: LONGINT);
                        (* GotoXY in Weltkoordinaten *)

                      PROCEDURE SetLongLimit (CONST LX, LY: LONGINT);
                      PROCEDURE ScrollTo (X, Y: {INTEGER}LONGINT);
                      PROCEDURE Scroll (X, Y: {INTEGER}LONGINT);
                      PROCEDURE ScrollDraw; VIRTUAL;
                      PROCEDURE WriteString (CONST s: STRING; CONST bs, be: INTEGER);
                      PROCEDURE WriteStringOff (CONST off: INTEGER; CONST s: STRING; CONST bs, be: INTEGER;
                                  CONST zeigZeilenEnde: BOOLEAN;
                                  CONST zeigTextEnde: BOOLEAN);
                      PROCEDURE WriteStrLn (CONST s: STRING);
                      PROCEDURE WriteLn;
                      PROCEDURE WriteChr (ch: CHAR);
                      PROCEDURE WriteIntF (i: LONGINT; f: INTEGER);
                      PROCEDURE WriteInt (i: LONGINT);
                      PROCEDURE WritePoint (poin: TPoint);
                      PROCEDURE WriteRect (rect: TRect);
                      PROCEDURE WriteBool (b: BOOLEAN);
                      PROCEDURE WritePointer (p: POINTER);
                      PROCEDURE WriteGLFPointer (p: GLP);
                      PROCEDURE WriteTyp (typ: einGenTyp);
                      PROCEDURE WriteFlags (f: einFlagSet);
                      PROCEDURE zeigFehler (Zeilen: INTEGER; Fehlertext: STRING; Fehlernummer: INTEGER);

                      PROCEDURE WriteChar (CONST X, Y: LONGINT; C: CHAR; Color: Byte;
                                           Count: INTEGER); VIRTUAL;
                      PROCEDURE WriteStr (CONST X, Y: LONGINT; CONST Str: STRING; Color: BYTE);
                        VIRTUAL;
                      PROCEDURE WriteStrOff (off, X, Y: LONGINT; CONST Str: STRING; Color: BYTE);
                        VIRTUAL;
                      PROCEDURE ClrScr; VIRTUAL;
                      PROCEDURE ClrEOS; VIRTUAL;
                      PROCEDURE ClrEol (CONST markiereAbschnitte, markiereTextEnde: BOOLEAN);
                        VIRTUAL;
                  END (* TBuffText *);

    PMonitorGrafik = ^TMonitorGrafik;
    TMonitorGrafik = OBJECT (TBuffText)
                       dasObjekt: GLP;
                       dieWurzel: GLP;
                       (* Wurzel dient zum Erkennen von Update-Events,
                          wenn das Objekt von Traverser bearbeitet wird *)
                       CONSTRUCTOR Init (VAR Bounds: TRect; LimX, LimY: INTEGER;
                                         AHScrollBar, AVScrollBar: PScrollBar;
                                         Objekt, Wurzel: GLP);
                       PROCEDURE HandleEvent (VAR Event: TEvent); VIRTUAL;
                       PROCEDURE Draw; VIRTUAL;
                     END (* TMonitorGrafik *);

(******************************************************************)

    PMonitorWindow = ^TMonitorWindow;
    TMonitorWindow = OBJECT (TWindow)
                      CONSTRUCTOR Init (VAR Bounds: TRect; LimX, LimY: INTEGER;
                                        ATitle: TTitleStr;
                                        Objekt, Wurzel: GLP);

                      PROCEDURE HandleEvent (VAR Event: TEvent); VIRTUAL;
                      PROCEDURE MonitorObjekt (Bounds: TRect; LimX, LimY: INTEGER;
                                               Objekt, Wurzel: GLP);
                  END (* TGLFWindow *);

(******************************************************************)
{
  eineKopierProzedur =  PROCEDURE (VAR qu; anzahl: CARDINAL);
}
  GLF = OBJECT (TObject)
          meinTyp:      einGenTyp;  (* 2 Byte *)
          meineReferenz: LONGINT;   (* 4 Byte *)
          meineFlags:   einFlagSet; (* 2 Byte *)
          meineSignatur: LONGINT;   (* 4 Byte *)
                                    (* 4 Byte Summe + 2 VMT = 14 *)

          CONSTRUCTOR   Init (CONST xflags: einFlagSet);
          FUNCTION      gran (g: WORD): WORD; VIRTUAL;
          DESTRUCTOR    Done; VIRTUAL;
          DESTRUCTOR    DoneCluster; VIRTUAL;
            (* siehe LoeschCluster, Datenpointer NICHT verfolgen *)

          (* Der Typ "ASCII" ist in GLFTypes als SYSTEM.Text deklariert,
             weil sich der Bezeichner Text sonst mit Text = ^STRING ber-
             schneidet, der in den Objektbibliotheken definiert ist.
          *)

          PROCEDURE WriteReport (VAR Datei: ASCII; CONST formatieren: BOOLEAN;
                                 CONST zeilenAufSeite: WORD;
                                 VAR seite, zeile, xpos: WORD;
                                 CONST endlos, kennung: BOOLEAN;
                                 CONST Filter: PeinDruckerFilter;
                                 CONST Pref, Suff: CHAR;
                                 CONST AbsKenn: CHSet);
            VIRTUAL;

          FUNCTION      erzeugeMich (CONST xflags: einFlagSet): GLP; VIRTUAL;
          FUNCTION      meinTypIst: einGenTyp;
          FUNCTION      TypeOfIs: GLP;

          FUNCTION      isAbstract: BOOLEAN; VIRTUAL;
          FUNCTION      isTerminal: BOOLEAN; VIRTUAL;
          FUNCTION      isSubclass (CONST class: einGenTyp): BOOLEAN; VIRTUAL;
          FUNCTION      isSuperclass (CONST subclass, superclass: einGenTyp): BOOLEAN;
          FUNCTION      are2Subclasses (CONST class1, class2: einGenTyp): BOOLEAN;
          FUNCTION      are3Subclasses (CONST class1, class2, class3: einGenTyp): BOOLEAN;
          FUNCTION      are4Subclasses (CONST class1, class2, class3, class4: einGenTyp): BOOLEAN;
          FUNCTION      are5Subclasses (CONST class1, class2, class3,
                                        class4, class5: einGenTyp): BOOLEAN;
          FUNCTION      meineAttribute: GLP; VIRTUAL;
          FUNCTION      habeAttribute: BOOLEAN; VIRTUAL;
          PROCEDURE     setAttribute (CONST a: GLP); VIRTUAL;
          FUNCTION      AnzahlElementeIst: LONGINT; VIRTUAL;

          FUNCTION      RueckIst: GLP; VIRTUAL;
          FUNCTION      neuSig: LONGINT;
          FUNCTION      neuNum: LONGINT;

          (* ff werden hufig berschrieben und sind besonders zeitkritisch *)
          PROCEDURE     getFlags (VAR flags: einFlagSet);
          PROCEDURE     setFlags (CONST flags: einFlagSet);
          PROCEDURE     setzeFlag (CONST flag: einFlag);
          PROCEDURE     nulleFlag (CONST flag: einFlag);
          FUNCTION      hatFlag (CONST flag: einFlag): BOOLEAN;
          PROCEDURE     nulleNetzFlag (CONST flag: einFlag; CONST Sig: LONGINT); VIRTUAL;
          PROCEDURE     nulleClusterFlag (CONST flag: einFlag; CONST Sig: LONGINT); VIRTUAL;
          PROCEDURE     setzeNetzFlag (CONST flag: einFlag; CONST Sig: LONGINT); VIRTUAL;
          PROCEDURE     setzeClusterFlag (CONST flag: einFlag; CONST Sig: LONGINT); VIRTUAL;

          {PROCEDURE     LoeschPfad; VIRTUAL;}
          PROCEDURE LoeschPfad (CONST Sig: LONGINT); VIRTUAL;
            (* Pfad NILen fr das Lschen ber ALLE Pointer *)

          {PROCEDURE     LoeschCluster; VIRTUAL;}
          PROCEDURE LoeschCluster (CONST Sig: LONGINT); VIRTUAL;
            (* Pfad NILen fr das Lschen nur ber Struktur, nicht
               ber DatenPointer *)

          FUNCTION      StringVonDaten: STRING; VIRTUAL;
          (* liefert die "Eigendaten" eines Objektes *)
          FUNCTION      getDataStr: STRING; VIRTUAL;
          (* liefert den String der Daten, die am Datapointer eines
             Objektes mit Assoziationen wie Knoten, Listenelement,
             Netzstring etc. hngen *)
          FUNCTION      StringVonTyp: STRING;
          FUNCTION      DatenVonString (CONST s: STRING): BOOLEAN; VIRTUAL;
          FUNCTION      NumVonString (CONST s: STRING): INTEGER; VIRTUAL;
          FUNCTION      StrLaenge: WORD; VIRTUAL;
          FUNCTION      DatenZeilen: WORD; VIRTUAL;
          PROCEDURE     zeigDaten (CONST view: PBuffText; CONST x, y: WORD); VIRTUAL;

          PROCEDURE     setzFensterInhalt (CONST FensterInhalt: PBuffText); VIRTUAL;
          FUNCTION      getFensterInhalt: PBuffText; VIRTUAL;
          PROCEDURE     zeigFenster (CONST view: PBuffText; CONST x, y, b, h: WORD;
                                     CONST zeichneFen: BOOLEAN);
            VIRTUAL;
                        (* Inhaltsdarstellung f. Edit: *)

          FUNCTION     Edit (CONST view: PBuffText; CONST x, y, b, h: WORD;
                             CONST name: GLP): GLP;
                         VIRTUAL;
                        (* manuelle Inhaltsvernderung *)

          PROCEDURE     hole (CONST index; VAR elem); VIRTUAL;

          (* Es fehlt eigentlich ein Messageversenden nur im Cluster! *)
          PROCEDURE     startNetzMessage (CONST view: PBuffText; VAR ereignis: TEvent);
            VIRTUAL;
          PROCEDURE     sendNetzMessage (CONST view: PBuffText; CONST What, Command: WORD;
                                         CONST InfoPtr: POINTER);
                        VIRTUAL;
          PROCEDURE     sMessage (CONST What, Command: WORD; CONST InfoPtr: POINTER);
                        VIRTUAL;
          PROCEDURE     sende (CONST view: PBuffText; VAR ereignis: TEvent;
                               CONST Sig: LONGINT);
            VIRTUAL;
          PROCEDURE     setOffset (CONST off: TPoint); VIRTUAL; (* Dummy *)
          PROCEDURE     zeigFlags (CONST Titel: STRING); VIRTUAL;
          FUNCTION      waehleFlag (CONST Titel: STRING; VAR Flag: einFlag): BOOLEAN;
            VIRTUAL;
          PROCEDURE     Abstract (CONST t: STRING);
          PROCEDURE     Monitor (CONST view: PBuffText); VIRTUAL;
                        (* fr Debug-Zwecke *)
          PROCEDURE     zeigMonitorFenster (CONST x1, y1, x2, y2: INTEGER;
                                            wurzel: GLP);
  END (* GLF *);

  PSignateur = ^einSignateur;
  einSignateur =    OBJECT (GLF)
                      Sig:  LONGINT;
                      CONSTRUCTOR   Init (CONST xflags: einFlagSet);
                      FUNCTION      neueSignatur: LONGINT;
                      FUNCTION      erzeugeMich (CONST xflags: einFlagSet): GLP; VIRTUAL;
                      FUNCTION      isAbstract: BOOLEAN; VIRTUAL;
                      FUNCTION      isSubclass (CONST class: einGenTyp): BOOLEAN; VIRTUAL;
                    END (* einSignateur *);

VAR PrintScreen:              BOOLEAN;

PROCEDURE doMyExit; (* Siehe Programmierhandbuch S. 221 *)

FUNCTION bekannt (typ: einGenTyp): BOOLEAN;
FUNCTION abstrakt (typ: einGenTyp): BOOLEAN;
PROCEDURE ObjektAnmelden (typ: einGenTyp; o: GLP);
FUNCTION neuesObjekt (CONST typ: einGenTyp; CONST xflags: einFlagSet): GLP;
FUNCTION ObjekteInitialisiert: BOOLEAN;
PROCEDURE setReady;
FUNCTION getType (typ: einGenTyp): GLP;
FUNCTION getSize (typ: einGenTyp): INTEGER;
FUNCTION needHeap (typ: einGenTyp): LONGINT;
PROCEDURE killObjekt (VAR gen: GLP);

PROCEDURE InitEreignis (VAR e: TEvent);

PROCEDURE TRON;
PROCEDURE TROFF;
FUNCTION isTrace: BOOLEAN;
PROCEDURE Trace (CONST n: STRING);
PROCEDURE zeigTrace (CONST Titel, Text: STRING);

(********************************************************************)
IMPLEMENTATION
(********************************************************************)

USES Crt, EditStuff, {My}App, {My}StdDlg;

CONST CTrace =  FALSE;
      CHeapTrace = FALSE;

VAR   ObjekteSindInitialisiert: BOOLEAN;
      doTrace:                  BOOLEAN;
      derSignateur:             PSignateur;
      derNumerateur:            PSignateur;

(********************* ExitProcedure ****************************)

PROCEDURE doMyExit;
BEGIN
  (* Dateien schlieen... *)

  IF ExitCode <> 0 THEN BEGIN
    {HeapMan^.Protokoll;}
    Protokoll ('Der Simpel-Editor wird beendet wegen',
               'TP-Fehler: ' + StringVonError (ExitCode) +
               '; ' + atString (ErrorAddr));
    MeldFileOff;

    IF doTrace THEN
      zeigTrace ('Der Simpel-Editor wird beendet wegen',
                   'TP-Fehler: ' + StringVonError (ExitCode) +
                   '; ' + atString (ErrorAddr))
    ELSE
      zeigMeldung ('Der Simpel-Editor wird abgebrochen wegen',
                   'TP-Fehler: ' + StringVonError (ExitCode) +
                   '; ' + atString (ErrorAddr));
    ErrorAddr := NIL;
  END (* IF *);
END (* doMyExit *);

(***************** Methoden von TBuffText ***********************)

CONSTRUCTOR TBuffText.Init (VAR Bounds: TRect; LimX, LimY: INTEGER;
                            Offs: TPoint;
                            AHScrollBar, AVScrollBar: PScrollBar);
BEGIN
  INHERITED Init (Bounds, AHScrollBar, AVScrollBar);
  GrowMode := gfGrowHiX + gfGrowHiY;
  Options := Options OR ofFramed;
  SetLimit (LimX, LimY);
  col1 := 1; col2 := 2;
  {VirtualX := 0; VirtualY := 0;}
  Delta := Offs;
  {}DeltaFactor := CDeltaFactor{};
  AHScrollBar^.SetValue (Offs.X); AVScrollBar^.SetValue (Offs.Y);
END (* Init *);

PROCEDURE TBuffText.SetLongLimit (CONST LX, LY: LONGINT);
VAR  Anzahl: INTEGER;
BEGIN
  IF LY > High (INTEGER) THEN Anzahl := High (INTEGER)
  ELSE Anzahl := LY;
  SetLimit (LX, Anzahl);
  LongLimit.X := LX; LongLimit.Y := LY;
END (* SetLongLimit *);

PROCEDURE TBuffText.Scroll (X, Y: LONGINT);
BEGIN
  IF (LongDelta.X + X >= 0) THEN LongDelta.X := LongDelta.X + X;
  IF (LongDelta.Y + Y >= 0) THEN LongDelta.Y := LongDelta.Y + Y;
  Delta.X := LongDelta.X;
  IF LongDelta.Y >= DeltaFactor THEN
    Delta.Y := LongDelta.Y DIV DeltaFactor + Y MOD DeltaFactor
  ELSE Delta.Y := LongDelta.Y;
  Draw;
  IF HScrollBar <> nil THEN BEGIN
    HScrollBar^.SetValue (Delta.X);
    HScrollbar^.Draw;
  END;
  IF VScrollBar <> nil THEN BEGIN
    VScrollBar^.SetValue (Delta.Y);
    VScrollbar^.Draw;
  END;
END (* Scroll *);

PROCEDURE TBuffText.ScrollTo (X, Y: {INTEGER}LONGINT);
VAR  toX, toY:  LONGINT;
     fix:       BOOLEAN;
BEGIN
  fix := FALSE;
  toX := X - LongDelta.X; toY := Y - LongDelta.Y;
  IF toY < 0 THEN BEGIN
    (* Y ist oberhalb des Fensterrandes *)
    fix := TRUE;
  END
  ELSE IF toY >= Size.Y THEN BEGIN
    (* Y ist unterhalb des Fensterrandes *)
    Y := Y - Size.Y + 1;
    fix := TRUE;
  END
  ELSE Y := LongDelta.Y;

  IF toX < 0 THEN BEGIN
    fix := TRUE;
  END
  ELSE IF toX >= Size.X THEN BEGIN
    X := X - Size.X + 1;
    fix := TRUE;
  END
  ELSE X := Delta.X;

  IF fix THEN BEGIN
    LongDelta.X := X; LongDelta.Y := Y;
    Delta.X := X;
    Delta.Y := Y DIV DeltaFactor + Y MOD DeltaFactor;

    (*************************************************************)
    Draw;
    IF HScrollBar <> nil THEN BEGIN
      HScrollBar^.SetValue(Delta.X);
      HScrollbar^.Draw;
    END;
    IF VScrollBar <> nil THEN BEGIN
      VScrollBar^.SetValue(Delta.Y);
      VScrollbar^.Draw;
    END;
    (**** Komisch - wieso fhrt stattdessen das ff zu Problemen? ****)

    {
    TScroller.ScrollTo (X, Y DIV DeltaFactor + Y MOD DeltaFactor);
    }
  END;
END (* ScrollTo VIRTUAL *);

PROCEDURE TBuffText.GotoXY (x, y: LONGINT);
(* GotoXY in Weltkoordinaten *)
BEGIN
  VirtualX := x; VirtualY := y;
  SetCursor (x - Delta.X,
             y - LongDelta.Y);
END (* GotoXY *);

procedure TBuffText.ScrollDraw;
var
  D: TPoint;
  Y: LONGINT;
begin
  if HScrollBar <> nil then D.X := HScrollBar^.Value
  else D.X := 0;
  if VScrollBar <> nil then D.Y := VScrollBar^.Value
  else D.Y := 0;
  if (D.X <> Delta.X) or (D.Y <> Delta.Y) then
  begin
    IF D.Y <> Delta.Y THEN BEGIN
      Y := LongLimit.Y DIV LONGINT (Limit.Y) * LONGINT (D.Y);
      LongDelta.Y := Y;
      D.Y := Y DIV DeltaFactor + Y MOD DeltaFactor;
    END (* IF vertikal verndert *);

    SetCursor (INTEGER
      (LONGINT (Cursor.X) + LONGINT (Delta.X) - LONGINT (D.X)), INTEGER
      (LONGINT (Cursor.Y) + LONGINT (Delta.Y) - LONGINT (D.Y)));
    Delta := D;

    {if DrawLock <> 0 then DrawFlag := True else} DrawView;
  end;
end (* ScrollDraw *);

PROCEDURE TBuffText.WriteString (CONST s: STRING; CONST bs, be: INTEGER);
VAR  vors, mitts, nachs:  STRING;
BEGIN
  IF bs <> be THEN BEGIN
    IF (bs = 1) AND (be = LENGTH (s)) THEN
      WriteStr (VirtualX, VirtualY, s, col2)
    ELSE BEGIN
      vors := Copy (s, 1, bs);
      mitts := Copy (s, bs, be - bs);
      nachs := Copy (s, be, LENGTH (s) - be);
      WriteStr (VirtualX, VirtualY, vors, col1);
      WriteStr (VirtualX, VirtualY, mitts, col2);
      WriteStr (VirtualX, VirtualY, nachs, col1);
    END (* ELSE *)
  END (* IF bs <> be *)
  ELSE WriteStr (VirtualX, VirtualY, s, col1);
  INC (VirtualX, LENGTH (s));
END (* WriteString *);

PROCEDURE TBuffText.WriteStringOff (CONST off: INTEGER; CONST s: STRING;
                                    CONST bs, be: INTEGER;
                                    CONST zeigZeilenEnde: BOOLEAN;
                                    CONST zeigTextEnde: BOOLEAN);
VAR  vors, mitts, nachs:  STRING;
BEGIN
  IF (bs <> be) AND (bs < be) THEN BEGIN
    IF (bs = 0) AND (be = LENGTH (s)) THEN BEGIN
{zeigMeldung ('WriteStringOff', 'ganzeZeile');}
      WriteStrOff (off, VirtualX, VirtualY, s, col2);
    END
    ELSE BEGIN
{zeigMeldung ('WriteStringOff', 'off: ' + StringVonNum (off) +
', bs: ' + StringVonNum (bs) + ', be: ' + StringVonNum (be));}
      IF off < bs THEN BEGIN
        vors := Copy (s, off + 1, bs - off);
        mitts := Copy (s, bs + 1, be - bs);
        nachs := Copy (s, be + 1, LENGTH (s) - be);
      END
      ELSE BEGIN
        vors := '';
        IF off < be THEN BEGIN
          mitts := Copy (s, off + 1, be - off);
          nachs := Copy (s, be + 1, LENGTH (s) - be);
        END
        ELSE BEGIN
          mitts := '';
          nachs := Copy (s, off + 1, LENGTH (s) - off);
        END (* ELSE *);
      END (* ELSE *);
      WriteStr (VirtualX, VirtualY, vors, col1);
      WriteStr (VirtualX + LENGTH (vors), VirtualY, mitts, col2);
      WriteStr (VirtualX + LENGTH (vors) + LENGTH (mitts), VirtualY, nachs, col1);
    END (* ELSE *)
  END (* IF bs <> be *)
  ELSE WriteStrOff (off, VirtualX, VirtualY, s, col1);
  INC (VirtualX, LENGTH (s) - off);
  IF zeigZeilenEnde THEN BEGIN
     WriteChar (VirtualX, VirtualY, cZeilEndMarke, col2, 1);
    IF zeigTextEnde THEN WriteChar (VirtualX + 1, VirtualY, cTextEndMarke, col2, 1);
  END (* IF zeigZeilenEnde *);
END (* WriteStringOff *);

PROCEDURE TBuffText.WriteStrLn (CONST s: STRING);
BEGIN
  WriteStr (VirtualX, VirtualY, s, col1);
  INC (VirtualY); VirtualX := 0;
END (* WriteStrLn *);

PROCEDURE TBuffText.WriteLn;
BEGIN
  INC (VirtualY); VirtualX := 0;
END (* WriteLn *);

PROCEDURE TBuffText.WriteChr (ch: CHAR);
BEGIN
  WriteChar (VirtualX, VirtualY, ch, col1, 1);
  INC (VirtualX);
END (* WriteChr *);

PROCEDURE TBuffText.WriteIntF (i: LONGINT; f: INTEGER);
VAR  s:  STRING [10];
BEGIN
  Str (i, s);
  IF LENGTH (s) < f THEN BEGIN
    WriteChar (VirtualX, VirtualY, ' ', col1, f - LENGTH (s));
    INC (VirtualX, f - LENGTH (s));
  END;
  WriteString (s, 0, 0);
END (* WriteIntF *);

PROCEDURE TBuffText.WriteInt (i: LONGINT);
VAR  s:  STRING [10];
BEGIN
  Str (i, s);
  WriteString (s, 0, 0);
END (* WriteInt *);

PROCEDURE TBuffText.WritePoint (poin: TPoint);
BEGIN
  WriteString ('X: ', 0, 0); WriteIntF (poin.X, 5);
  WriteString (', Y: ', 0, 0); WriteIntF (poin.Y, 5);
END (* WritePoint *);

PROCEDURE TBuffText.WriteRect (rect: TRect);
BEGIN
  WriteString ('X1: ', 0, 0); WriteIntF (rect.A.X, 5);
  WriteString (', Y1: ', 0, 0); WriteIntF (rect.A.Y, 5);
  WriteString (', X2: ', 0, 0); WriteIntF (rect.B.X, 5);
  WriteString (', Y2: ', 0, 0); WriteIntF (rect.B.Y, 5);
END (* WriteRect *);

PROCEDURE TBuffText.WriteBool (b: BOOLEAN);
BEGIN
  IF b THEN WriteString ('TRUE', 0, 0) ELSE WriteString ('FALSE', 0, 0);
END (* WriteBool *);

PROCEDURE TBuffText.WritePointer (p: POINTER);
VAR  tricky: RECORD
               CASE BOOLEAN OF
                 TRUE: (LowP, HiP: WORD);
                 FALSE: (poin: POINTER);
               END;
     PS:     STRING [9];
     LowS:   STRING [4];
BEGIN
  tricky.poin := p;
  HexWord (tricky.HiP, PS);
  appendChar (PS, ':');
  HexWord (tricky.LowP, LowS);
  appendString (PS, LowS);
  WriteString (PS, 0, 0);
END (* WritePointer *);

PROCEDURE TBuffText.WriteGLFPointer (p: GLP);
BEGIN
  WritePointer (POINTER (p));
  IF p <> NIL THEN BEGIN
    WriteString (p^.StringVonTyp, 0, 0);
    WriteString (p^.StringVonDaten, 0, 0);
  END (* IF p <> NIL *);
END (* WriteGLFPointer *);

PROCEDURE TBuffText.WriteTyp (typ: einGenTyp);
BEGIN
  WriteString (StringVonTyp (typ), 0, 0);
END (* WriteTyp *);

PROCEDURE TBuffText.WriteFlags (f: einFlagSet);
BEGIN
  WriteString (StringVonFlags (f), 0, 0);
END (* WriteFlags *);

PROCEDURE TBuffText.zeigFehler (Zeilen: INTEGER;
          Fehlertext: STRING; Fehlernummer: INTEGER);
BEGIN
  EditStuff.zeigFehler (Zeilen, Fehlertext, Fehlernummer);
END (* zeigFehler *);

PROCEDURE TBuffText.WriteChar (CONST X, Y: LONGINT; C: CHAR; Color: BYTE;
                               Count: INTEGER);
VAR breite: INTEGER;
VAR buff: TDrawBuffer;
BEGIN
  breite := Size.X + Delta.X - X; IF breite < 1 THEN breite := 1;
  Color := GetColor (Color);
  MoveChar (buff, ' ', Color, breite);
  MoveChar (buff, C, Color, Count);
  WriteLine (X - LongDelta.X, Y - LongDelta.Y, breite, 1, buff);
END (* WriteChar *);

PROCEDURE TBuffText.WriteStr (CONST X, Y: LONGINT; CONST Str: STRING; Color: BYTE);
VAR breite: INTEGER;
    b:      INTEGER;
    buff:   TDrawBuffer;
BEGIN
  breite := Size.X + Delta.X - X; IF breite < 1 THEN breite := 1;
  Color := GetColor (Color);
  MoveStr (buff, Str, Color);
  b := breite - LENGTH (Str); IF b < 0 THEN b := 0;
  MoveChar (buff [LENGTH (Str)], ' ', GetColor (col1), b);
  WriteLine (X - LongDelta.X, Y - LongDelta.Y, breite, 1, buff);
END (* WriteStr *);

PROCEDURE TBuffText.WriteStrOff (off, X, Y: LONGINT; CONST Str: STRING;
                                 Color: BYTE);
VAR breite: INTEGER;
    b:      INTEGER;
    bstr:   STRING;
    buff:   TDrawBuffer;
BEGIN
  INC (off);
  {bstr := Copy (Str, off, LENGTH (Str));}
    (* Copy rechnet selbst Restlnge aus *)
  breite := Size.X + Delta.X - X; IF breite < 1 THEN breite := 1;
  bstr := Copy (Str, off, breite);
  Color := GetColor (Color);
  MoveStr (buff, bstr, Color);
  b := breite - LENGTH (bstr); IF b < 0 THEN b := 0;
{
zeigMeldung ('MoveChar', 'b: ' + StringVonNum (b) + ', LENGTH (bstr): ' +
                                 StringVonNum (LENGTH (bstr)));
}
  {IF b + LENGTH (bstr) > MaxViewWidth - 1 THEN
  b := MaxViewWidth - LENGTH (bstr) - 1;
  }
  MoveChar (buff [LENGTH (bstr)], ' ', GetColor (col1), b);
  WriteLine (X - LongDelta.X, Y - LongDelta.Y, breite, 1, buff);
END (* WriteStrOff *);

PROCEDURE TBuffText.ClrScr;
BEGIN
  INHERITED Draw;
END (* ClrScr *);

PROCEDURE TBuffText.ClrEOS;
VAR  yl:          INTEGER;
     oldx, oldy:  INTEGER;
     breite:      INTEGER;
     Color:       BYTE;
VAR buff: TDrawBuffer;
BEGIN
  breite := Size.X;
  Color := GetColor (col1);
  MoveChar (buff, ' ', Color, breite);
  HideCursor;
  FOR yl := VirtualY - LongDelta.Y TO Size.Y DO BEGIN
    WriteLine (Delta.X, yl, breite, 1, buff);
  END (* FOR *);
  ShowCursor;
END (* ClrEOS *);

PROCEDURE TBuffText.ClrEol (CONST markiereAbschnitte, markiereTextEnde: BOOLEAN);
BEGIN
  IF markiereAbschnitte THEN BEGIN
     WriteChar (VirtualX, VirtualY, cZeilEndMarke, col2, 1);
     IF markiereTextEnde THEN WriteChar (VirtualX, VirtualY, cTextEndMarke, col2, 1);
  END
  ELSE WriteChr (' ');
END (* ClrEol *);

(*********************** Methoden zu TMonitorGrafik *******************)

CONSTRUCTOR TMonitorGrafik.Init (VAR Bounds: TRect; LimX, LimY: INTEGER;
                                 AHScrollBar, AVScrollBar: PScrollBar; Objekt,
                                 Wurzel: GLP);
VAR  Offs:  TPoint;
BEGIN
  WITH Offs DO BEGIN X := 0; Y := 0; END;
  INHERITED Init (Bounds, LimX, LimY, Offs, AHScrollBar, AVScrollBar);
  dasObjekt := Objekt; dieWurzel := Wurzel;
END (* Init *);

PROCEDURE TMonitorGrafik.Draw;
BEGIN
  INHERITED Draw;
  GotoXY (0, 0);
  dasObjekt^.Monitor (@SELF);
END (* Draw *);

PROCEDURE TMonitorGrafik.HandleEvent (VAR Event: TEvent);
BEGIN
  INHERITED HandleEvent (Event);
  IF (Event.What = evBroadCast) THEN BEGIN
    IF Event.Command = cmGLFObjektUpdate THEN BEGIN
      IF (Event.InfoPtr = dasObjekt) OR (Event.InfoPtr = dieWurzel)
        THEN Draw;
    END (* IF *);
  END (* IF evBroadCast *);
END (* HandleEvent *);

(**************** Methoden von MonitorWindows ********************)

CONSTRUCTOR TMonitorWindow.Init (VAR Bounds: TRect; LimX, LimY: INTEGER;
                                 ATitle: TTitleStr;
                                 Objekt, Wurzel: GLP);
BEGIN
  INHERITED Init (Bounds, ATitle, 0);
  MonitorObjekt (Bounds, LimX, LimY, Objekt, Wurzel);
END (* Init *);

PROCEDURE TMonitorWindow.HandleEvent (VAR Event: TEvent);
VAR dummyp:  POINTER;
BEGIN
  CASE Event.What OF
    evKeyDown: IF Event.KeyCode = kbEsc THEN BEGIN
                 Event.What := evCommand;
                 Event.Command := cmClose;
               END;
    evCommand: CASE Event.Command OF
                 cmSchliesseFormular: Event.Command := cmClose;
               END (* CASE *);
  END (* CASE *);
  INHERITED HandleEvent (Event);
END (* HandleEvent *);

PROCEDURE TMonitorWindow.MonitorObjekt (Bounds: TRect; LimX, LimY: INTEGER;
                                        Objekt, Wurzel: GLP);
VAR  HScrollBar, VScrollBar:  PScrollBar;
     Inneres:                 PBuffText;
     R:                       TRect;
     obj:                     GLP;
     kn:                      GLP;
BEGIN
  VScrollBar := StandardScrollBar (sbVertical + sbHandleKeyboard);
  HScrollBar := StandardScrollBar (sbHorizontal + sbHandleKeyboard);
  GetExtent (Bounds);
  Bounds.Grow (-1, -1);
  Inneres := NEW (PMonitorGrafik,
                  Init (Bounds, LimX, LimY, HScrollBar, VScrollBar, Objekt, Wurzel));
  Insert (Inneres);
END (* macheObjektGrafik *);

(****************************** Methoden zu GLF ************************)

CONSTRUCTOR GLF.Init (CONST xflags: einFlagSet);
(* Optimierung 5. 12. 93:
   Objekte, die von TObject abgeleitet sind und INHERITED Init aufrufen,
   lschen alle Objektvariablen mit 0. Das Initialisieren von
   Variablen auf 0 oder Pointern auf NIL ist also berflssig (betrchtlicher
   Zeitgewinn, vor allem in MEDUSA).
*)
BEGIN
  INHERITED Init;
  meinTyp := generisch; {meineReferenz := 0;}
  meineFlags := [initialisiert, besucht] + xflags;
  {meineSignatur := 0;}
END;

CONST   Granulation =   8;

FUNCTION GLF.gran (g: WORD): WORD;
BEGIN
  DEC (g);
  gran := (g DIV Granulation + 1) * Granulation;
END (* gran *);

PROCEDURE GLF.WriteReport (VAR Datei: ASCII; CONST formatieren: BOOLEAN;
                CONST zeilenAufSeite: WORD; VAR seite, zeile, xpos: WORD;
                CONST endlos, kennung: BOOLEAN;
                CONST Filter: PeinDruckerFilter;
                CONST Pref, Suff: CHAR;
                CONST AbsKenn: CHSet);
BEGIN
  Abstract ('WriteReport');
END (* WriteReport *);

FUNCTION GLF.erzeugeMich (CONST xflags: einFlagSet): GLP;
BEGIN
  erzeugeMich := NEW (GLP, Init (xflags));
END (* erzeugeMich *);

DESTRUCTOR GLF.Done;
BEGIN
END (* Done *);

DESTRUCTOR GLF.DoneCluster;
BEGIN
END (* DoneCluster *);

PROCEDURE GLF.LoeschPfad;
BEGIN
  meineSignatur := Sig;
  Include (meineFlags, geloescht);
END (* LoeschPfad *);

PROCEDURE GLF.LoeschCluster;
BEGIN
  Include (meineFlags, geloescht);
END (* LoeschCluster *);

FUNCTION GLF.meinTypIst: einGenTyp;
BEGIN meinTypIst := MeinTyp;
END (* meinTypIst *);

FUNCTION GLF.TypeOfIs: GLP;
BEGIN
  TypeOfIs := TypeOf (SELF);
END (* TypeOfIs *);

FUNCTION GLF.isAbstract: BOOLEAN;
BEGIN
  isAbstract := TRUE;
END (* isAbstract *);

FUNCTION GLF.isTerminal: BOOLEAN;
BEGIN
  isTerminal := TRUE;
END (* isTerminal *);

FUNCTION GLF.isSubclass (CONST class: einGenTyp): BOOLEAN;
BEGIN
  isSubclass := class = generisch;
END (* isSubclass *);

FUNCTION GLF.isSuperclass (CONST subclass, superclass: einGenTyp): BOOLEAN;
BEGIN
{zeigMeldung ('GLF.IsSuperclass', StringVonTyp (meinTyp));}
  isSuperclass := isSubclass (subclass) AND
              NOT isSubclass (superclass);
END (* isSuperclass *);

FUNCTION GLF.are2Subclasses (CONST class1, class2: einGenTyp): BOOLEAN;
BEGIN
  are2Subclasses := isSubclass (class1) OR isSubclass (class2);
END (* are2Subclasses *);

FUNCTION GLF.are3Subclasses (CONST class1, class2, class3: einGenTyp): BOOLEAN;
BEGIN
  are3Subclasses := are2Subclasses (class1, class3) OR isSubclass (class3);
END (* are3Subclasses *);

FUNCTION GLF.are4Subclasses (CONST class1, class2, class3, class4: einGenTyp): BOOLEAN;
BEGIN
  are4Subclasses := are3Subclasses (class1, class2, class3) OR isSubclass (class4);
END (* are4Subclasses *);

FUNCTION GLF.are5Subclasses (CONST class1, class2, class3,
                         class4, class5: einGenTyp): BOOLEAN;
BEGIN
  are5Subclasses := are4Subclasses (class1, class2, class3, class4) OR
                   isSubclass (class5);
END (* are5Subclasses *);

FUNCTION GLF.meineAttribute: GLP;
BEGIN
  Abstract ('meineAttribute'); meineAttribute := NIL;
END (* meineAttribute *);

FUNCTION  GLF.habeAttribute: BOOLEAN;
BEGIN habeAttribute := FALSE;
END (* habeAttribute *);

PROCEDURE GLF.setAttribute (CONST a: GLP);
BEGIN Abstract ('setAttribute'); END;

FUNCTION GLF.AnzahlElementeIst: LONGINT;
BEGIN
  Abstract ('AnzahlElementeIst'); AnzahlElementeIst := 0;
END (* AnzahlElementeIst *);

FUNCTION GLF.RueckIst: GLP;
BEGIN
  Abstract ('RueckIst'); RueckIst := NIL;
END (* RueckPointerIst *);

FUNCTION GLF.neuSig: LONGINT;
BEGIN
  neuSig := derSignateur^.neueSignatur;
END (* neuSig *);

FUNCTION GLF.neuNum: LONGINT;
BEGIN
  neuNum := derNumerateur^.neueSignatur;
END (* neuNum *);

PROCEDURE GLF.getFlags (VAR flags: einFlagSet);
BEGIN
  flags := meineFlags;
END (* meineFlagsSind *);

PROCEDURE GLF.setFlags (CONST flags: einFlagSet);
BEGIN
  meineFlags := flags;
END (* setFlags *);

PROCEDURE GLF.setzeFlag (CONST flag: einFlag);
VAR  Proj:  GLP;
     Event: TEvent;
BEGIN
  Include (meineFlags, flag);
END (* setzeFlag *);

PROCEDURE GLF.nulleFlag (CONST flag: einFlag);
BEGIN
  Exclude (meineFlags, flag);
END (* nulleFlag *);

FUNCTION GLF.hatFlag (CONST flag: einFlag): BOOLEAN;
BEGIN
  hatFlag := flag IN meineFlags;
END (* hatFlag *);

PROCEDURE GLF.nulleClusterFlag (CONST flag: einFlag; CONST Sig: LONGINT);
BEGIN
  nulleNetzFlag (flag, Sig);
END (* nulleDupFlag *);

PROCEDURE GLF.nulleNetzFlag (CONST flag: einFlag; CONST Sig: LONGINT);
(* Mit dieser Nachricht kann ein Flag im ganzen Netz gelscht werden.
   Sie ist selbstabweisend.
*)
BEGIN
  meineSignatur := Sig;
  IF flag = initialisiert THEN meineFlags := []
  ELSE Exclude (meineFlags, flag);
END (* NulleNetzFlag *);

PROCEDURE GLF.setzeClusterFlag (CONST flag: einFlag; CONST Sig: LONGINT);
BEGIN
(* Ist das wirklich ok, das auf setzeNETZFlag zurckzufhren?? *)
  setzeNetzFlag (flag, Sig);
END (* setzeDupFlag *);

PROCEDURE GLF.setzeNetzFlag (CONST flag: einFlag; CONST Sig: LONGINT);
(* Mit dieser Nachricht kann das ganze Netz als "besucht" markiert werden,
   ev. zur Vorbereitung auf "zaehleNetz". Sie ist selbstabweisend.
*)
BEGIN
  meineSignatur := Sig;
  meineFlags := meineFlags + [flag, initialisiert];
END (* setzeNetzFlag *);

PROCEDURE GLF.zeigDaten (CONST view: PBuffText; CONST x, y: WORD);
BEGIN
  view^.WriteStr (x, y, StringVonDaten, 1);
END (* zeigDaten *);

FUNCTION GLF.StrLaenge: WORD;
BEGIN
  StrLaenge := LENGTH (StringVonDaten);
END (* StrLaenge *);

FUNCTION GLF.DatenZeilen: WORD;
BEGIN
  DatenZeilen := 1;
END (* DatenZeilen *);

FUNCTION GLF.StringVonTyp: STRING;
BEGIN
  StringVonTyp := '<' + GLFTypes.StringVonTyp (meinTyp) + '>';
END (* StringVonTyp *);

FUNCTION GLF.StringVonDaten: STRING;
BEGIN
  StringVonDaten := StringVonTyp;
  (* Vorgesehen: <Typ>
                 (Liste, Element2)
                 {Menge Element2}
                 [Vektor Element2]
  *)
END (* StringVonDaten *);

FUNCTION GLF.getDataStr: STRING;
BEGIN
  getDataStr := StringVonDaten;
END (* getDataStr *);

FUNCTION GLF.DatenVonString (CONST s: STRING): BOOLEAN;
BEGIN
  DatenVonString := FALSE;
END (* DatenVonString *);

FUNCTION GLF.NumVonString (CONST s: STRING): INTEGER;
(* Das Resultat ist ein Code, der den Erfolg der Umwandlung anzeigt! *)
BEGIN
  NumVonString := 0;
END (* NumVonString *);

PROCEDURE GLF.setzFensterInhalt (CONST FensterInhalt: PBuffText);
BEGIN Abstract ('setzFensterInhalt');
END;

FUNCTION GLF.getFensterInhalt: PBuffText;
BEGIN Abstract ('getFensterInhalt');
END;

PROCEDURE GLF.zeigFenster (CONST view: PBuffText; CONST x, y, b, h: WORD;
                           CONST zeichneFen: BOOLEAN);
BEGIN Abstract ('zeigFenster');
END;

FUNCTION GLF.Edit (CONST view: PBuffText;
                   CONST x, y, b, h: WORD;
                   CONST name: GLP): GLP;
BEGIN
  Edit := @SELF;
END;

PROCEDURE GLF.sMessage (CONST What, Command: WORD; CONST InfoPtr: POINTER);
VAR  Event: TEvent;
BEGIN
  Event.What := What; Event.Command := Command;
  Event.InfoPtr := InfoPtr;
  sende (NIL, Event, neuSig);
END (* sMessage *);

PROCEDURE GLF.sendNetzMessage (CONST view: PBuffText; CONST What, Command: WORD;
                               CONST InfoPtr: POINTER);
VAR  Event: TEvent;
BEGIN
  Event.What := What; Event.Command := Command;
  Event.InfoPtr := InfoPtr;
  startNetzMessage (view, Event);
END (* sendNetMessage *);

PROCEDURE GLF.startNetzMessage (CONST view: PBuffText; VAR ereignis: TEvent);
BEGIN
  sende (view, ereignis, neuSig);
END (* startNetzMessage *);

PROCEDURE GLF.sende (CONST view: PBuffText; VAR ereignis: TEvent;
                     CONST Sig: LONGINT);
VAR dummyg:       POINTER;
    bearbeitet:   BOOLEAN;
    PName:        GLP;
BEGIN
  setzeFlag (msgempfangen);
  meineSignatur := Sig;
  bearbeitet := TRUE;
  CASE ereignis.What OF
    evCommand: CASE ereignis.Command OF
                  cmEditObjekt: BEGIN
                                  dummyg := Edit (NIL, 0, 0,
                                              Length (StringVonDaten) + 2, 0,
                                              NIL {getPName});
                                END;
                  cmMonitor:    zeigMonitorFenster (0, 0, 60, 16, NIL);
                  ELSE bearbeitet := FALSE;
               END (* inneres CASE *);
    ELSE bearbeitet := FALSE;
  END (* CASE *);
  IF bearbeitet THEN BEGIN
     InitEreignis (Ereignis);
  END;
END (* sende *);

PROCEDURE GLF.setOffset (CONST off: TPoint);
BEGIN Abstract ('setOffset'); END;

PROCEDURE GLF.zeigMonitorFenster (CONST x1, y1, x2, y2: INTEGER; wurzel: GLP);
VAR
    MonitorFen:    PMonitorWindow;
    Bounds:        TRect;
    Fenstername:   STRING;
BEGIN
(* Wurzel dient zum Erkennen von Update-Events,
   wenn das Objekt von Traverser bearbeitet wird *)
  IF wurzel = NIL THEN wurzel := @SELF;
  Bounds.Assign (x1, y1, x2, y2);
  zentriere (Bounds);
  Fenstername := 'Monitor: ' + StringVonTyp;
  MonitorFen := NEW (PMonitorWindow, Init (Bounds, 255, 300, Fenstername,
                     @SELF, wurzel));
  DeskTop^.Insert (MonitorFen);
END (* zeigMonitorFenster *);

FUNCTION GLF.waehleFlag (CONST Titel: STRING; VAR Flag: einFlag): BOOLEAN;

CONST cFlagBreite =  22;
      cFlagHoehe =   16;
      cBoxBreite =   cFlagBreite + 16;
      cBoxHoehe =    cFlagHoehe + 4;

TYPE TFlagboxDaten =  RECORD
                        RadioButtonData:  WORD;
                      END (* RECORD *);

VAR  Box:             PDialog;
     R:               TRect;
     Schalter:        PRadioButtons;
     SItem:           PSItem;
     Control:         WORD;
     Daten:           TFlagBoxDaten;
     FInd:            einFlag;
BEGIN
    R.Assign (0, 0, cBoxBreite, cBoxHoehe);
    zentriere (R);
    Box := NEW (PDialog, Init (R, Titel));
    WITH Box^ DO BEGIN

      R.Assign (3, 2, 3 + cFlagBreite, 2 + cFlagHoehe);

      SItem := NIL;
      FOR FInd := kollabiert DOWNTO geladen DO BEGIN
        SItem := NewSItem (StringVonFlag (FInd), SItem);
      END (* FOR *);
      Schalter := NEW (PRadioButtons, Init (R, SItem));
      Insert (Schalter);

      R.Assign (cFlagBreite + 4, cBoxHoehe DIV 2 - 2, cFlagBreite + 14, cBoxHoehe DIV 2 - 0);
      Insert (NEW (PButton, Init (R, '~O~K', cmOK, bfDefault)));
      R.Assign (cFlagBreite + 4, cBoxHoehe DIV 2 + 1, cFlagBreite + 14, cBoxHoehe DIV 2 + 3);
      Insert (NEW (PButton, Init (R, 'Abbruch', cmCancel, bfNormal)));
    END (* WITH *);
    Daten.RadioButtonData := WORD (geladen);
    Box^.SetData (Daten);
    Control := DeskTop^.ExecView (Box);
    Flag := geladen;
    IF Control <> cmCancel THEN BEGIN
       Box^.GetData (Daten);
       BYTE (Flag) := Daten.RadioButtonData;
    END;
    Dispose (Box, Done);
    waehleFlag := Control <> cmCancel;
END (* waehleFlag *);

PROCEDURE GLF.zeigFlags (CONST Titel: STRING);

CONST cFlagBreite =  22;
      cFlagHoehe =   16;
      cBoxBreite =   cFlagBreite + 16;
      cBoxHoehe =    cFlagHoehe + 4;

TYPE TFlagboxDaten =  RECORD
                        CheckBoxData:  WORD;
                      END (* RECORD *);

VAR  Box:             PDialog;
     R:               TRect;
     Schalter:        PCheckBoxes;
     SItem:           PSItem;
     Flag:            einFlag;
     Control:         WORD;
     Daten:           TFlagBoxDaten;

BEGIN
    R.Assign (0, 0, cBoxBreite, cBoxHoehe);
    zentriere (R);
    Box := NEW (PDialog, Init (R, Titel));
    WITH Box^ DO BEGIN

      R.Assign (3, 2, 3 + cFlagBreite, 2 + cFlagHoehe);

      SItem := NIL;
      FOR Flag := kollabiert DOWNTO geladen DO BEGIN
        SItem := NewSItem (StringVonFlag (Flag), SItem);
      END (* FOR *);
      Schalter := NEW (PCheckBoxes, Init (R, SItem));
      Insert (Schalter);

      R.Assign (cFlagBreite + 4, cBoxHoehe DIV 2 - 2, cFlagBreite + 14, cBoxHoehe DIV 2 - 0);
      Insert (NEW (PButton, Init (R, '~O~K', cmOK, bfDefault)));
      R.Assign (cFlagBreite + 4, cBoxHoehe DIV 2 + 1, cFlagBreite + 14, cBoxHoehe DIV 2 + 3);
      Insert (NEW (PButton, Init (R, 'Abbruch', cmCancel, bfNormal)));
    END (* WITH *);
    Daten.CheckboxData := WORD (meineFlags);
    Box^.SetData (Daten);
    Control := DeskTop^.ExecView (Box);
    IF Control <> cmCancel THEN BEGIN
       Box^.GetData (Daten);
       WORD (meineFlags) := Daten.CheckboxData;
    END;
    Dispose (Box, Done);
END (* zeigFlags *);

PROCEDURE GLF.Abstract (CONST t: STRING);
BEGIN
  zeigMeldung ('Abstrakte Methode', t + ' in ' + StringVonTyp +
               ' nicht implementiert!');
END (* Abstract *);

PROCEDURE GLF.Monitor (CONST view: PBuffText);
BEGIN
  view^.GotoXY (0, 0);
  view^.WriteString  ('Meine Adresse:    ', 0, 0); view^.WritePointer (@SELF);
  view^.WriteLn;
  view^.WriteString  ('Flags:            ', 0, 0);
  view^.WriteFlags (meineFlags); view^.WriteLn;
END (* Monitor *);

CONSTRUCTOR einSignateur.Init (CONST xflags: einFlagSet);
BEGIN
  INHERITED Init (xflags);
  meinTyp := Signateur;
  {Sig := 0;}
END (* Init *);

FUNCTION einSignateur.neueSignatur: LONGINT;
BEGIN
  INC (Sig); neueSignatur := Sig;
END (* neueSignatur *);

FUNCTION einSignateur.erzeugeMich (CONST xflags: einFlagSet): GLP;
BEGIN
  erzeugeMich := NEW (PSignateur, Init (xflags));
END (* erzeugeMich *);

FUNCTION einSignateur.isSubclass (CONST class: einGenTyp): BOOLEAN;
BEGIN
  isSubclass := (class = Signateur) OR INHERITED isSubClass (class);
END (* isSubclass *);

FUNCTION einSignateur.isAbstract: BOOLEAN;
BEGIN
  isAbstract := FALSE;
END (* isAbstract *);

(************* Methoden fr die Vererbung an "einLader": ***********)

PROCEDURE GLF.hole (CONST index; VAR elem);
BEGIN Abstract ('hole'); END;

PROCEDURE InitEreignis (VAR e: TEvent);
BEGIN
  WITH e DO BEGIN
    What := evNothing;
    InfoPtr := NIL;
  END (* With *);
END (* InitEreignis *);

PROCEDURE TRON;
BEGIN doTrace := TRUE;
END;

PROCEDURE TROFF;
BEGIN doTrace := FALSE;
END;

FUNCTION isTrace: BOOLEAN;
BEGIN
  isTrace := doTrace;
END;

PROCEDURE Trace (CONST n: STRING);
BEGIN
  IF doTrace THEN zeigMeldung ('Trace', n);
END;

PROCEDURE zeigTrace (CONST Titel, Text: STRING);
BEGIN
  IF doTrace THEN zeigMeldung (Titel, Text);
END;

VAR     PErzeugerTabelle: einGenArrayPointer;

FUNCTION ObjekteInitialisiert: BOOLEAN;
BEGIN
  ObjekteInitialisiert := ObjekteSindInitialisiert;
END (* ObjekteInitialisiert *);

FUNCTION neuesObjekt (CONST typ: einGenTyp; CONST xflags: einFlagSet): GLP;
VAR  s:             STRING;
     typs1, typs2:  STRING [30];
     obj:           GLP;
BEGIN
  IF (typ = FehlerTyp0) OR (typ >= FehlerTypX) THEN BEGIN
    Protokoll ('neuesObjekt', 'Fehlerhafter Typ: ' + StringVonNum (typ));
    neuesObjekt := NIL;
    EXIT;
  END (* IF Typfehler *);
  IF PErzeugerTabelle^ [typ] <> NIL THEN BEGIN
    IF PErzeugerTabelle^ [typ]^.meinTypIst = typ THEN BEGIN
      obj := PErzeugerTabelle^ [typ]^.erzeugeMich (xflags);
{
      zeigTrace ('-----> Neues Objekt erzeugt',
                 StringVonTyp (obj^.meinTyp) +
                 atString (obj));
}
      neuesObjekt := obj;
    END
    ELSE BEGIN
      typs1 := StringVonTyp (typ);
      typs2 := StringVonTyp (PErzeugerTabelle^ [typ]^.meinTypIst);
      s := 'Statt erzeugeMich fr' + #13 + typs1 + ' ' +
      typs2 + #13 + 'angemeldet!';
      zeigFehler (3, s, 0);
      neuesObjekt := NIL;
    END (* IF *);
  END
  ELSE BEGIN
    typs1 := StringVonTyp (typ);
    s := 'erzeugeMich fr ' + typs1 + ' nicht angemeldet!';
    zeigFehler (1, s, 0);
    neuesObjekt := NIL;
  END (* IF *);
END (* neuesObjekt *);

FUNCTION bekannt (typ: einGenTyp): BOOLEAN;
BEGIN
  bekannt := PErzeugerTabelle^ [typ] <> NIL;
END (* bekannt *);

FUNCTION abstrakt (typ: einGenTyp): BOOLEAN;
BEGIN
  abstrakt := (PErzeugerTabelle^ [typ] <> NIL) AND
              PErzeugerTabelle^ [typ]^.isAbstract;
END (* abstrakt *);

FUNCTION getType (typ: einGenTyp): GLP;
VAR  s:             STRING;
     typs1, typs2:  STRING [30];
BEGIN
  IF PErzeugerTabelle^ [typ] <> NIL THEN BEGIN
    IF PErzeugerTabelle^ [typ]^.meinTypIst = typ THEN BEGIN
      getType := PErzeugerTabelle^ [typ]^.TypeOfIs;
    END
    ELSE BEGIN
      typs1 := StringVonTyp (typ);
      typs2 := StringVonTyp (PErzeugerTabelle^ [typ]^.meinTypIst);
      s := 'Statt getType fr' + #13 + typs1 + ' ' +
      typs2 + #13 + 'angemeldet!';
      Write (s); ReadLn;
      getType := NIL;
    END (* IF *);
  END
  ELSE BEGIN
  {
    typs1 := StringVonTyp (typ);
    s := 'getTyp fr ' + typs1 + ' nicht angemeldet!';
    Write (s); ReadLn;
  }
    getType := NIL;
  END (* IF *);
END (* getType *);

FUNCTION needHeap (typ: einGenTyp): LONGINT;
BEGIN
  needHeap := LONGINT (getSize (typ)) * cHeapFactor + cHeapMin;
END (* needHeap *);

FUNCTION getSize (typ: einGenTyp): INTEGER;
VAR  s:             STRING;
     typs1, typs2:  STRING [30];
BEGIN
  IF PErzeugerTabelle^ [typ] <> NIL THEN BEGIN
    IF PErzeugerTabelle^ [typ]^.meinTypIst = typ THEN BEGIN
      getSize := SizeOf (PErzeugerTabelle^ [typ]^);
    END
    ELSE BEGIN
      typs1 := StringVonTyp (typ);
      typs2 := StringVonTyp (PErzeugerTabelle^ [typ]^.meinTypIst);
      s := 'Statt getType fr' + #13 + typs1 + ' ' +
      typs2 + #13 + 'angemeldet!';
      Write (s); ReadLn;
      getSize := maxInt;
    END (* IF *);
  END
  ELSE BEGIN
  {
    typs1 := StringVonTyp (typ);
    s := 'getTyp fr ' + typs1 + ' nicht angemeldet!';
    Write (s); ReadLn;
  }
    getSize := maxInt;
  END (* IF *);
END (* getSize *);

PROCEDURE killObjekt (VAR gen: GLP);
VAR  typ:   einGenTyp;
BEGIN
  IF gen <> NIL THEN BEGIN
    DISPOSE (gen, Done);
  END (* IF gen <> NIL *);
END (* neuesObjekt *);

PROCEDURE InitErzeugerTabelle;
VAR       i:  einGenTyp;
BEGIN
  NEW (PErzeugerTabelle);
  FOR i := generisch TO LetzterTyp DO
    PErzeugerTabelle^ [i] := NIL;
END (* InitErzeugerTabelle *);

PROCEDURE ObjektAnmelden (typ: einGenTyp; o: GLP);
BEGIN
  PErzeugerTabelle^ [typ] := o;
END (* ObjektAnmelden *);

PROCEDURE setReady;
BEGIN
  ObjekteSindInitialisiert := TRUE;
END (* setReady *);

VAR    Erzeuger:        GLP;

BEGIN
  doTrace := CTrace; Trace ('GLFBase');
  ObjekteSindInitialisiert := FALSE;

  InitErzeugerTabelle;

  NEW (derSignateur, Init ([])); ObjektAnmelden (Signateur, derSignateur);
  NEW (derNumerateur, Init ([]));

  NEW (Erzeuger, Init ([])); ObjektAnmelden (generisch, Erzeuger);
  PrintScreen := FALSE;
END (* GLFBase *).
