UNIT GLFInit;

{$O+}
{$F+}

(* (C) 1990, 1991, 1992, 1993, 1994, 1995 by Johannes Leckebusch
   Stand: 07. 02. 1995
   Version 0.902
*)

INTERFACE

USES Drivers, {My}Views,
     GLFTypes, GLFBase, GLFQuadruple, GLFLists,
     GLFWindows;

PROCEDURE InitGLF;

PROCEDURE InitMenu (VAR dieMenuLeiste1: einListenPointer);

IMPLEMENTATION

{$I SIMPDEF.INC}

USES App,
     GLFStructures, GLFNodes, ObjStrings, TextBase, SimpelText, TVMenus,
{$IFDEF mitMedusa}      GLFWordBase, GLFLexikon, Medusa,
{$ENDIF mitMedusa}
     TVMenuString;

PROCEDURE InitGLF;
VAR g: GLP;
BEGIN
  zeigTrace ('InitGLF', 'Objekt generisch erzeugen und anmelden');

  NEW (g, Init ([])); Objektanmelden (generisch, g);

  NEW (einStrukturPointer (g), Init ([])); ObjektAnmelden (Struktur, g);

  (* GLFStrings *)

  NEW (einStringPointer (g), Init ([])); ObjektAnmelden (StringG, g);

  NEW (einString8Pointer (g), Init ([])); ObjektAnmelden (String8, g);

  (* GLFNodes *)

  NEW (einKnotenPointer (g), Init ([])); ObjektAnmelden (Knoten, g);
  NEW (einTriplePointer (g), Init ([])); ObjektAnmelden (Triple, g);

{$IFDEF mitMedusa}
  (* GLFWordBase *)

  NEW (einNetzStringPointer (g), Init ([])); ObjektAnmelden (NetzString, g);
  NEW (einSymtabEintragsPointer (g), Init ([])); ObjektAnmelden (SymtabEintrag, g);
{  NEW (einTextIndexPointer (g), Init ([])); ObjektAnmelden (TextIndex, g);}

  (* GLFLexikon *)

  NEW (einLexikonPointer (g), Init ([])); ObjektAnmelden (Lexikon, g);
  NEW (einSymtabellenPointer (g), Init ([])); ObjektAnmelden (Symtabelle, g);
{$ENDIF mitMedusa}

  (* GLFQuadruple *)

  NEW (einQuadruplePointer (g), Init ([])); ObjektAnmelden (Quadruple, g);
  NEW (einGluePointer (g), Init ([])); ObjektAnmelden (Glue, g);

  (* NEW (einFormGluePointer (g), Init ([])); ObjektAnmelden (FormGlue, g); *)
  NEW (einListGluePointer (g), Init ([])); ObjektAnmelden (ListGlue, g);
  NEW (einTextGluePointer (g), Init ([])); ObjektAnmelden (TextGlue, g);
  NEW (einMerkerPointer (g), Init ([])); ObjektAnmelden (Merker, g);
  (*41*)
  (* GLFLists *)

  NEW (einListenPointer (g), Init ([])); ObjektAnmelden (Liste, g);
  NEW (einTabellenPointer (g), Init ([])); ObjektAnmelden (Tabelle, g);

  NEW (einTextPointer (g), Init ([])); ObjektAnmelden (TextBas, g);
  NEW (einSimpleTextPointer (g), Init ([])); ObjektAnmelden (SimpleText, g);
{$IFDEF mitMedusa}
  NEW (einParserPointer (g), Init ([])); ObjektAnmelden (Parser, g);
{$ENDIF mitMedusa}

  NEW (einMenuStringPointer (g), Init ([])); ObjektAnmelden (MenuString, g);

  (* TVMenus *)

  NEW (einTVMenuPointer (g), Init ([])); ObjektAnmelden (TVMenu, g);
  zeigTrace ('InitGLF', 'END');
END (* InitGLF *);

PROCEDURE InitMenu (VAR dieMenuLeiste1{, dieMenuLeiste2}: einListenPointer);

VAR
     Eintrag:         GLP;
     dasMenu:         einTVMenuPointer;
BEGIN

(***************************** Erstes Men ********************************)
  zeigTrace ('InitMenu', 'Menleiste erzeugen');

  GLP (dieMenuLeiste1) := neuesObjekt (Liste, []);

  (* GBE-Infomen *)

  GLP (dasMenu) := neuesObjekt (TVMenu, []);
  WITH dasMenu^ DO BEGIN

    insertTextUndCode ('SIMPEL-~E~ditor',     '',         kbnoKey, cmNothing, hcNoContext);
    insertTextUndCode ('~I~nfo SIMPEL',       '',         kbNoKey, cmGBE, hcNoContext);
    insertTextUndCode ('~H~ilfe',             'F1',       kbF1,    cmHelp, hcNoContext);
    insertTextUndCode ('-',                   '',         kbNoKey, cmNothing, hcNoContext);
    insertTextUndCode ('Freier ~S~peicher',   'Alt-S',    kbAltS,  cmSpeicher, hcNoContext);
{   insertTextUndCode ('Error auslsen',  '',      kbnoKey, cmError, hcNoContext);}
    insertTextUndCode ('-',                   '',        kbNoKey, cmNothing, hcNoContext);
    insertTextUndCode ('Hohe Bildauflsung',  '',        kbNoKey, cmHighScreen, hcNoContext);
    insertTextUndCode ('Normale Bildauflsung', '',      kbNoKey, cmLowScreen, hcNoContext);
    insertTextUndCode ('Schwarzwei-Bildschirm', '',     kbNoKey, cmBWScreen, hcNoContext);
    insertTextUndCode ('Schwarzwei-Hochaufl.', '',      kbNoKey, cmBWHighScreen, hcNoContext);
  END (* WITH *);
  Eintrag := dieMenuLeiste1^.InsertAfter (dasMenu);

  (* Dateimen *)

  GLP (dasMenu) := neuesObjekt (TVMenu, []);
  WITH dasMenu^ DO BEGIN
    insertTextUndCode ('~D~OS',                        '',      kbNoKey,   cmNothing, hcNoContext);


    insertTextUndCode ('~V~erzeichnis ndern',         'Alt-V', kbAltV,    cmChangeDir, hcNoContext);
    insertTextUndCode ('-',                            '',      kbNoKey,   cmNothing, hcNoContext);
    insertTextUndCode ('DOS aufrufen',                 '',      kbNoKey,   cmDosShell, hcNoContext);
    insertTextUndCode ('DOS-Programm',                 '',      kbNoKey,   cmDosProgramm, hcNoContext);
    insertTextUndCode ('-',                            '',      kbNoKey,   cmNothing, hcNoContext);
    insertTextUndCode ('Quit SIMPEL',                  'Alt-X', kbAltQ,    cmQuit, hcNoContext);
  END (* WITH *);
  Eintrag := dieMenuLeiste1^.InsertAfter (dasMenu);

  (* Text-Men *)

  GLP (dasMenu) := neuesObjekt (TVMenu, []);
  WITH dasMenu^ DO BEGIN
    insertTextUndCode ('~T~exte',                         '',         kbNoKey,   cmNothing, hcNoContext);
    insertTextUndCode ('Leeres Textfenster',              'Ctrl-F3',  kbCtrlF3,  cmNeuerText, hcNoContext);
    insertTextUndCode ('Lade Textdatei in neues Fenster', 'F3',       kbF3,      cmLadeNeuenText, hcNoContext);
    insertTextUndCode ('Filter fr Texte Laden',          'F4',       kbF4,      cmTexteLaden, hcNoContext);
    insertTextUndCode ('Alle Texte drucken',              '',         kbNoKey,   cmTexteDrucken, hcNoContext);
    insertTextUndCode ('-',                               '',         kbNoKey,   cmNothing, hcNoContext);
    insertTextUndCode ('Schliee Fenster',                'ESC',      kbEsc,     cmSchliesseFormular, hcNoContext);
  END (* WITH *);
  Eintrag := dieMenuLeiste1^.InsertAfter (dasMenu);

  (* Clipboard-Men *)

  GLP (dasMenu) := neuesObjekt (TVMenu, []);
  WITH dasMenu^ DO BEGIN
    insertTextUndCode ('~C~lipboard',                  '',          kbNoKey,   cmNothing, hcNoContext);
    insertTextUndCode ('Clipboard editieren',          'Shift-F1', kbShiftF1,      cmEditClipboard, hcNoContext);
  END (* WITH *);
  Eintrag := dieMenuLeiste1^.InsertAfter (dasMenu);

{$IFDEF mitMedusa}
  (* Parser-Men *)

  GLP (dasMenu) := neuesObjekt (TVMenu, []);
  WITH dasMenu^ DO BEGIN
    insertTextUndCode ('~M~edusa',                      '',         kbNoKey,   cmNothing, hcNoContext);
    insertTextUndCode ('Neues Parserfenster',          'Ctrl-F7',   kbCtrlF7,  cmNeuerParser, hcNoContext);
    insertTextUndCode ('Lade Text in neuen Parser',    'F7',        kbF7,      cmLadeNeuenParser, hcNoContext);
    insertTextUndCode ('Filter fr Parser Laden',      'Shift-F7',  kbShiftF4, cmParserLaden, hcNoContext);
  END (* WITH *);
  Eintrag := dieMenuLeiste1^.InsertAfter (dasMenu);
{$ENDIF mitMedusa}

  zeigTrace ('InitMenu', 'setReady');
  setReady;
  zeigTrace ('InitMenu', 'END');
END (* InitMenu *);

END (* GLFInit *).
