UNIT GLFOverInit;

(* (C) 1990-1995 by Johannes Leckebusch
   Stand: 02. 02. 1995
*)

INTERFACE

{$I SIMPDEF.INC}

{$IFDEF mitOverlays}
USES Overlay;
{$ENDIF mitOverlays}

IMPLEMENTATION

{USES Crt EditStuff, GLFBase;}

{$IFDEF mitOverlays}
CONST  cOverBuffer =
                      (* 98304; *)
                      131072;
                      (* 163840; *)
                      (* 196608; *) (* 192 K *)
                      (* 262144; *) (* 256 K *)
                      (* 328280; *)
       cDecrement =   16384;
       cReserve =     32768;

       cRetryBuffer =  cOverBuffer DIV 3;

VAR   OvrName:         STRING [60];
      OverBuffer:      LONGINT;
      RetryBuffer:     LONGINT;
{$ENDIF mitOverlays}

{ Cursorgre von Rasterzeile bis Rasterzeile setzen
  0 = oberste Rasterzeile
  Farb:  7 = unterste Rasterzeile
  Mono: 14 = unterste Rasterzeile
}
procedure CursorForm (von, bis: byte);
begin
  asm
    mov ah,1
    mov ch,von
    mov cl,bis
    int 10h
  end;
end (* CursorForm *);

PROCEDURE CursorOff;
{Cursor ausschalten:}
BEGIN
  CursorForm(32,32);
END (* CursorOff *);

PROCEDURE CursorOn;
{Cursor wieder einschalten:}
BEGIN
  if mem[$40:$49]<>7
    then CursorForm(5,7)    { Farb-Karte }
    else CursorForm(12,14); { Mono-Karte }
END (* CursorOn *);

BEGIN
WriteLn ('GLFOverInit');

{$IFDEF mitOverlays}
  OvrName := 'RSIMPEL.OVR';
  OvrInit (OvrName);
  IF OvrResult = OvrNotFound THEN OvrName := 'A:RSIMPEL.OVR';
  REPEAT
    OvrInit (OvrName);
    IF OvrResult = OvrNotFound THEN BEGIN
      WriteLn ('Overlay-Datei "', OvrName, '" nicht gefunden!');
      Write   ('Bitte Dateipfad + Name eingeben: ');
      ReadLn (OvrName);
    END;
  UNTIL ((OvrResult <> OvrNotFound) OR (OvrName = ''));
  IF OvrName = '' THEN BEGIN
    WriteLn ('Programm abgebrochen!');
    Halt;
  END (* IF Abbruch *);

  OverBuffer := cOverBuffer;
  WHILE (OverBuffer + cReserve) > MaxAvail DO BEGIN
    DEC (OverBuffer, cDecrement);
  END (* WHILE *);
  RetryBuffer := OverBuffer DIV 3;

  {OvrInitEMS;}
  OvrSetBuf (OverBuffer);
  OvrSetRetry (RetryBuffer);
{$ENDIF mitOverlays}

END (* GLFOverInit *).