Unit GLFWindows;
{$F+}
{$O+}

(* (C) 1991, 1992, 1993, 1994, 1995 by Johannes Leckebusch
   Version: 0.902
   Stand: 07. 02. 95
*)

{$I SIMPDEF.INC}

INTERFACE

USES Objects, Drivers (*kbAltX*), {My}Views (*cmQuit*), {My}Menus, {My}App,
     {My}Dialogs, {My}StdDlg, GLFTypes, GLFBase, GLFViews;

FUNCTION macheMenu (meinMenu: GLP; R: TRect; lokal: BOOLEAN): PMenuBar;

TYPE

      GLFVision = OBJECT (TApplication)
                    Menu1:   PMenuBar;

                    CONSTRUCTOR Init (men: GLP);

                    FUNCTION GetPalette: PPalette; VIRTUAL;
                    PROCEDURE InitMenuBar; VIRTUAL;
                    PROCEDURE InitStatusLine; VIRTUAL;
                    PROCEDURE SetScreenMode (Mode: Word);
                    PROCEDURE WriteShellMsg; VIRTUAL;
                    PROCEDURE DOSProgramm; VIRTUAL;
                  END (* GLFVision *);


    PMyMenuBar =      ^TMyMenuBar;
    TMyMenuBar =      OBJECT (TMenuBar)
                        FUNCTION GetPalette: PPalette; VIRTUAL;
                        FUNCTION NewSubView (VAR Bounds: TRect; AMenu: PMenu;
                           AParentMenu: PMenuView): PMenuView; VIRTUAL;
                      END (* TMyMenuBar *);

    PMyMenuBox =      ^TMyMenuBox;
    TMyMenuBox =      OBJECT (TMenuBox)
                        FUNCTION GetPalette: PPalette; VIRTUAL;
                        CONSTRUCTOR Init (VAR Bounds: TRect; AMenu: PMenu;
                                          AParentMenu: PMenuView);
                      END (* TMyMenuBox *);

    PEditor =          ^Editor;
    Editor =           OBJECT (GLFVision)
                        Clipboard: GLP;
                        Helptext:  GLP;
                        Stunde, Minute, Sekunde, hSekunde: WORD;
                        CONSTRUCTOR Init (men: GLP);
                        PROCEDURE Run; VIRTUAL;
                        PROCEDURE positioniere (TextObj: GLP); VIRTUAL;
                        FUNCTION NeuerTextAusFile (CONST Dateiname: STRING; CONST abm: TRect): GLP;
                          VIRTUAL;
                        PROCEDURE HandleEvent (VAR Event: TEvent); VIRTUAL;
                        PROCEDURE zeigGBELogo;
                        PROCEDURE zeigMeldung (Titel, m: STRING);
                        PROCEDURE idle; VIRTUAL;
                      END (* EditorBaumEditor *);

    PMyWindow = ^TMyWindow;
    TMyWindow = OBJECT (TWindow)
                  CONSTRUCTOR Init (VAR Bounds: TRect; ATitle: TTitleStr;
                                    ANumber: INTEGER);
                  FUNCTION GetPalette: PPalette; VIRTUAL;
                  PROCEDURE SetTitle (ATitle: TTitleStr); VIRTUAL;
                  PROCEDURE SetPTitle (PTitle: GLP); VIRTUAL;
                  PROCEDURE HandleEvent (VAR Event: TEvent); VIRTUAL;
                END (* MyWindow *);

    PSimpleTextWindow = ^TSimpleTextWindow;
    TSimpleTextWindow = OBJECT (TMyWindow)
                          CONSTRUCTOR Init (VAR Bounds: TRect;
                                            LimX, LimY: INTEGER;
                                            Offs: TPoint;
                                            ATitle: TTitleStr; TextO: GLP);
                          PROCEDURE macheTextGrafik (LimX, LimY: INTEGER;
                                                     Offs: TPoint;
                                                     TextO: GLP);
                          FUNCTION StandardScrollBar (AOptions: Word): PScrollBar;
                            VIRTUAL;
                          PROCEDURE WriteStatus (CONST s: STRING);
                          PROCEDURE WriteCharCode (CONST s: STRING);
                        END (* TSimpleTextWindow *);

    PWindowBrowserWindow = ^TWindowBrowserWindow;
    TWindowBrowserWindow = OBJECT (TMyWindow)
                      WindowBrowser: PWindowBrowser;
                      CONSTRUCTOR Init (VAR Bounds: TRect; ATitle: TTitleStr;
                                        Start, PreSelect: WORD);
                      DESTRUCTOR Done; VIRTUAL;
                      PROCEDURE macheWindowBrowser (VAR Bounds: TRect;
                                                 Start, PreSelect: WORD);
                      FUNCTION GetTheWindow: PWindow; VIRTUAL;
                    END (* TGLFTypWindow *);

(************************** globale Routinen ***************************)

PROCEDURE doWindowBrowser (tit: STRING; Bounds: TRect);

PROCEDURE getFilename (VAR name: STRING; Titel, Ueberschr: STRING; laden: BOOLEAN);

IMPLEMENTATION

USES Crt, DOS,
     EditStuff,
     GLFStructures, GLFQuadruple, GLFLists, TVMenuString,
     TextBase, SimpelText,
     TVMenus, Memory;

CONST

  cGBEStack =           128;
  cGBEFileBuffer =      2040;

CONST
  cBrowseSpaltenbreite =     30;
  cGenBrowseSpaltenbreite =  35;
  cGLFWindowBreite =         75;
  cGLFWindowHoehe =          22;

VAR  dieMenus: GLP;

FUNCTION macheMenu (meinMenu: GLP; R: TRect; lokal: BOOLEAN): PMenuBar;
VAR  MenuItem:          PMenuItem;
     AMenu:             PMenuItem;
     dasMenu:           GLP; (* Das ist der Pointer auf eine Menuliste *)
     derEintrag:        GLP;  (* Das ist der Pointer auf einen MenuString *)
     derEString:        TMenuStr; (* Menueintrag *)
     derSString:        TMenuStr; (* Suffix *)
     Taste, Befehl,
     Kontext:           WORD;
     fertig:            BOOLEAN;
BEGIN
  R.B.Y := R.A.Y + 1;

  WITH einListenPointer (meinMenu)^ DO BEGIN
    dasMenu := get (LastElement);
    fertig := FALSE;
    AMenu := NIL;
    REPEAT
      WITH einTVMenuPointer (dasMenu)^ DO BEGIN
        derEintrag := get (LastElement); (* wir mssen von hinten her anfangen *)
        MenuItem := NIL (* letzter hat kein NEXT *);

        REPEAT
          einMenuStringPointer (derEintrag)^.holeStringUndCode
            (derEString, derSString, Taste, Befehl, Kontext);
          IF derEString = '-' THEN
            MenuItem := NewLine (MenuItem)
          ELSE
            MenuItem := NewItem (derEString, derSString,
                                 Taste, Befehl, Kontext,
                                 MenuItem);
          derEintrag := get (PrevElement);
        UNTIL IndexIst = 0; (* Jetzt ist der Menutitel noch offen *)
        einMenuStringPointer (derEintrag)^.holeString (derEString);
        AMenu := NewSubMenu (derEString, IndexIst,
                             NewMenu (MenuItem), AMenu);
      END (* WITH dasMenu *);
      IF IndexIst = 0 THEN BEGIN
        fertig := TRUE
      END
      ELSE BEGIN
        dasMenu := get (PrevElement);
      END (* ELSE *);
    UNTIL fertig;
  END (* WITH meinMenu *);
  IF lokal THEN
    macheMenu := NEW (PMyMenuBar, Init (R, NewMenu (AMenu)))
  ELSE
    macheMenu := NEW (PMenuBar, Init (R, NewMenu (AMenu)));
END (* macheMenu *);

(******************************* TMyMenuBar ***************************)
CONST
 {CMenuView   = #2#3#4#5#6#7;}
  CMenuView   = #9#4#10#5#6#7;

FUNCTION TMyMenuBar.GetPalette: PPalette;
const
  P: string[Length(CMenuView)] = CMenuView;
begin
  GetPalette := @P;
END (* GetPalette *);

function TMyMenuBar.NewSubView (VAR Bounds: TRect; AMenu: PMenu;
  AParentMenu: PMenuView): PMenuView;
BEGIN
  NewSubView := New (PMyMenuBox, Init (Bounds, AMenu, AParentMenu));
END (* NewSubView *);

FUNCTION TMyMenuBox.GetPalette: PPalette;
const
  P: STRING [Length(CMenuView)] = CMenuView;
begin
  GetPalette := @P;
END (* GetPalette *);

CONSTRUCTOR TMyMenuBox.Init (VAR Bounds: TRect; AMenu: PMenu;
  AParentMenu: PMenuView);
var
  W, H, L: Integer;
  P: PMenuItem;
  R: TRect;
begin
  W := 10;
  H := 2;
  if AMenu <> nil then
  begin
    P := AMenu^.Items;
    while P <> nil do
    begin
      if P^.Name <> nil then
      begin
        L := CStrLen(P^.Name^) + 6;
        if P^.Command = 0 then Inc(L, 3) else
          if P^.Param <> nil then Inc(L, CStrLen(P^.Param^) + 2);
        if L > W then W := L;
      end;
      Inc(H);
      P := P^.Next;
    end;
  end;
  R.Copy(Bounds);
  if R.A.X + W < R.B.X then
    R.B.X := R.A.X + W
  else BEGIN
    R.A.X := R.B.X - W - 1;
    R.B.X := R.B.X - 1;
  END;
  IF R.A.Y + H < R.B.Y then
    R.B.Y := R.A.Y + H
  ELSE R.B.Y := R.B.Y - 1;
  TMenuView.Init(R);
  State := State or sfShadow;
  Options := Options or ofPreProcess;
  Menu := AMenu;
  ParentMenu := AParentMenu;
END (* Init *);

(******************************** GLFVision **************************)

CONSTRUCTOR GLFVision.Init (men: GLP);
BEGIN
  dieMenus := men;
  ScreenMode := mem [Seg0040:$49];
  INHERITED Init;
  eventMask := eventMask OR evBroadCast OR evMouse;
END (* Init *);

FUNCTION GLFVision.GetPalette: PPalette;
CONST {CMyColor =      CAppColor + #$30#$3B;}
      CMyColor =
        #$07#$70#$78#$74#$20#$28#$24#$17#$1F#$1A#$31#$31#$1E#$71#$1F +
    #$37#$3F#$3A#$13#$13#$3E#$21#$3F#$70#$7F#$7A#$13#$13#$70#$7F#$7E +
    #$70#$7F#$7A#$13#$13#$70#$70#$7F#$7E#$20#$2B#$2F#$78#$2E#$70#$30 +
    #$3F#$3E#$1F#$2F#$1A#$20#$72#$31#$31#$30#$2F#$3E#$31#$13#$38#$00 +
    #$17#$1F#$1A#$71#$71#$1E#$17#$1F#$1E#$20#$2B#$2F#$78#$2E#$10#$30 +
    #$3F#$3E#$70#$2F#$7A#$20#$12#$31#$31#$30#$2F#$3E#$31#$13#$38#$00 +
    #$37#$3F#$3A#$13#$13#$3E#$30#$3F#$3E#$20#$2B#$2F#$78#$2E#$30#$70 +
    #$7F#$7E#$1F#$2F#$1A#$20#$32#$31#$71#$70#$2F#$7E#$71#$13#$38#$00 +
    #$30#$3B;

      CMyBlackWhite = CAppColor + #$70#$7E;
      CMyMonochrome = CAppColor + #$70#$7E;
      P:              ARRAY [apColor..apMonochrome] OF
                        STRING [Length (CMyColor)] =
                          (CMyColor, CMyBlackWhite, CMyMonochrome);
BEGIN
  GetPalette := @P [AppPalette];
END (* GetPalette *);

PROCEDURE GLFVision.InitMenuBar;
VAR  R: TRect;
BEGIN
  GetExtent (R);
  Menu1 := macheMenu (dieMenus, R, FALSE);
  menuBar := Menu1;
END (* InitMenuBar *);

PROCEDURE GLFVision.InitStatusLine;
VAR  R:  TRect;
BEGIN
  GetExtent (R);
  R.A.Y := R.B.Y - 1;
  StatusLine := NEW (PStatusLine, Init (R,
    NewStatusDef (0, $FFFF,
      NewStatusKey ('~Alt-X~ Exit', kbAltX, cmQuit,
        NewStatusKey ('~Esc~ Close', kbEsc, cmClose,
          NewStatusKey ('~F10~ Men', kbF10, cmMenu,
          NIL)
        )
      ),
      NIL)
  ));
END (* InitStatusLine *);

PROCEDURE GLFVision.SetScreenMode (Mode: Word);
BEGIN
  INHERITED SetScreenMode (Mode);
  Redraw;
END (* SetScreenMode *);

PROCEDURE GLFVision.WriteShellMsg;
BEGIN
  PrintStr ('Geben Sie EXIT ein, um zum SIMPEL-Editor zurckzukehren ...');
END (* WriteShellMsg *);

PROCEDURE GLFVision.DosProgramm;
VAR  ch:                  CHAR;
     Programm:            STRING;
BEGIN
  Programm := '';
  ch := EditStringTitel (1, 11, 76,
    'DOS-Programm und Parameter (durch Leerzeichen getrennt) eingeben:',
    Programm);
  IF Programm = '' THEN EXIT;
  Programm := '/C ' + Programm;

  DoneSysError;
  DoneEvents;
  DoneVideo;
  DoneDosMem;
  SwapVectors;
  Exec (GetEnv ('COMSPEC'), Programm);
  SwapVectors;
  InitDosMem;
  InitVideo;
  InitEvents;
  InitSysError;
  Redraw;
END (* DosProgramm *);

CONST  WinCount: INTEGER = 0;

CONSTRUCTOR Editor.Init (men: GLP);
BEGIN
  INHERITED Init (men);
  Clipboard := NIL; Helptext := NIL;
END (* Init *);

PROCEDURE Editor.zeigMeldung (Titel, m: STRING);
VAR  Box:        PDialog;
     R:          TRect;
     Control:    WORD;
     Breite:     INTEGER;
     StrMitte:   INTEGER;
BEGIN
  Breite := LENGTH (m) + 8; StrMitte := LENGTH (m) DIV 2 + 4;
  R.Assign (40 - Breite DIV 2, 8, 40 + Breite DIV 2, 16);
  Box := NEW (PDialog, Init (R, Titel));
  WITH Box^ DO BEGIN
    R.Assign (4, 3, 4 + LENGTH (m), 4);
    Insert (NEW (PStaticText, Init (R, m)));
    R.Assign (StrMitte - 3, 5, StrMitte + 3, 7);
    Insert (NEW (PButton, Init (R, '~O~K', cmOK, bfDefault)));
  END (* WITH *);
  Control := DeskTop^.ExecView (Box);
  Dispose (Box, Done);
END (* zeigMeldung *);

PROCEDURE Editor.idle;
VAR       neuSek:           WORD;
          X, Y:             INTEGER;
          Jahr, Monat, Tag,
          DayOfWeek:        WORD;
          st, mi, se:       STRING [2];
          P:                POINTER;

  PROCEDURE s (CONST w: WORD; VAR t: STRING);
  BEGIN
    Str (w:2, t);
    IF w < 10 THEN t [1] := '0';
  END (* s *);

BEGIN
  INHERITED idle;
  IF PrintScreen THEN BEGIN
    P := Message (Desktop^.Owner, evCommand, cmTextDrucken, NIL);
    PrintScreen := FALSE;
  END;
  GetTime (Stunde, Minute, neuSek, hSekunde);
  IF neuSek <> Sekunde THEN BEGIN
    Sekunde := neuSek;
    X := WhereX; Y := WhereY;
    HideCursor;
    TextBackground (LightGray); TextColor (Black);

    GetDate (Jahr, Monat, Tag, DayOfWeek);
    Crt.GotoXY (ScreenWidth - 30, 1);
    CASE DayOfWeek OF
      0: Write ('Sonntag');
      1: Write ('Montag');
      2: Write ('Dienstag');
      3: Write ('Mittwoch');
      4: Write ('Donnerstag');
      5: Write ('Freitag');
      6: Write ('Samstag');
    END (* CASE *);
    Write (', ', Tag, '.', Monat, '.', Jahr);

    Crt.GotoXY (ScreenWidth - 7, 1);
    s (Stunde, st); s (Minute, mi); s (Sekunde, se);
    Write (st, ':', mi, ':', se);
    Crt.GotoXY (X, Y);
  END (* IF *);
END (* idle *);

PROCEDURE Editor.zeigGBELogo;
VAR  Box:        PDialog;
     R:          TRect;
     Control:    WORD;
     Nachkomma:  STRING [4];
     I:          INTEGER;
BEGIN
  R.Assign (0, 0, 53, 16);
  zentriere (R);
  Box := NEW (PDialog, Init (R, 'SIMPEL'));
  Str (CVersion MOD 1000, Nachkomma);
  FOR I := LENGTH (Nachkomma) TO 2 DO
    Nachkomma := '0' + Nachkomma;
  WITH Box^ DO BEGIN
    R.Assign ( 2,  2, 51, 8);
    Insert (NEW (PStaticText, Init (R,
      #3 + 'Objektorientierter Text- und Programmeditor'+ #13 +
      #3 + 'SIMPEL' + #13 +
      #3 + '(C) 90-96 by Johannes Leckebusch' + #13 +
      #3 + 'Vollversion: ' + StringVonNum (CVersion DIV 1000) + '.'
         + Nachkomma + #13 +
      #3 + 'Professur Ungruens S I M P E L - Editor')));
    R.Assign (2, 8, 51, 13);
    Insert (NEW (PStaticText, Init (R,
      #3 + 'Updates im Gruppenprogrammteil MEDUSA der Maus MB' + #13 +
      #3 + 'V32.bis + ISDN unter 08023/9104' + #13 +
      #3 + 'oder URL' + #13 +
      #3 + 'http://ourworld.compuserve.com/homepages/joedel/')));
    R.Assign (22, 13, 32, 15);
    Insert (NEW (PButton, Init (R, '~O~K', cmOK, bfDefault)));
  END (* WITH *);
  Control := DeskTop^.ExecView (Box);
  Dispose (Box, Done);
END (* zeigGBELogo *);

PROCEDURE Editor.Run;
VAR DummyP:    POINTER;
    Dateiname: STRING;
    dummy:     GLP;
    Suff:      STRING [4];
    dummyfile: Text;
    Dir:       DirStr;
    Name:      NameStr;
    Ext:       ExtStr;
BEGIN
  DummyP := Message (Desktop^.Owner, evCommand, cmSetClipboard, NIL);

  IF ParamCount <> 0 THEN
    DummyP := Message (DeskTop^.Owner, evCommand, cmGetCommandline, NIL);
  IF ClipBoard <> NIL THEN BEGIN
(**)
    Dateiname := 'SIMPEL.FIL';
    Assign (dummyfile, Dateiname);
(*$I-*)
    Reset (dummyfile);
    IF IOResult <> 0 THEN BEGIN
      FSplit (ParamStr (0), Dir, Name, Ext);
      Dateiname := Dir + Dateiname;
    END (* IF IOResult <> 0 *);
(*$I+*)

    Suff := einSimpleTextPointer (ClipBoard)^.holeName (
      einSimpleTextPointer (ClipBoard)^.DateiSuffix);
    {zeigMeldung ('Clipboard-Text laden', Dateiname);}
    dummy := ClipBoard^.Edit (NIL, 0, 0, 0, 0, NIL);
    ClipBoard^.sendNetzMessage (ClipBoard^.getFensterInhalt, evCommand, cmTextLaden, @Dateiname);
    einSimpleTextPointer (ClipBoard)^.compiliereDruckerfilter;
{zeigMeldung ('Run', 'TextLoeschen');}
    einSimpleTextPointer (ClipBoard)^.TextLoeschen;
{zeigMeldung ('Run', 'Dateiname rcksetzen');}
    einSimpleTextPointer (ClipBoard)^.setzeName (
      einSimpleTextPointer (ClipBoard)^.DateiSuffix, Suff);
{zeigMeldung ('Run', 'Clipboard schlieen');}

    dummyp := Message (Desktop, evCommand, cmClose, NIL);
{zeigMeldung ('Run', 'nach Message (Desktop)');}
(**)
  END (* ClipBoard *);
  INHERITED Run;
END (* Run *);

PROCEDURE Editor.positioniere (TextObj: GLP);
VAR abm:  TRect;
    d:    INTEGER;
BEGIN
  einSimpleTextPointer (TextObj)^.getAbmess (abm, d);
  WITH abm DO BEGIN
    abm.Move (0 - a.x, 0 - a.y);
    abm.Move (RANDOM (ScreenWidth + a.x - b.x),
              RANDOM (ScreenHeight - 2 + a.y - b.y));
  END (* WITH abmess *);
  einSimpleTextPointer (TextObj)^.setAbmess (abm, 0);
END (* positioniere *);

FUNCTION Editor.NeuerTextAusFile (CONST Dateiname: STRING; CONST abm: TRect): GLP;
VAR  TextObj:      GLP;
     dummy:        GLP;
BEGIN
{zeigMeldung ('NeuerTextAusFile', 'BEGIN');}
  TextObj := neuesObjekt (SimpleText, [setFormular]);
  IF (Clipboard <> NIL) AND NOT (einSimpleTextPointer (Clipboard)^.hatTextflag (FensterImmerGross))
    THEN BEGIN
    einSimpleTextPointer (TextObj)^.setAbmess (abm, 0);
    positioniere (TextObj);
  END (* IF NOT FensterImmerGross *);
  dummy := TextObj^.Edit (NIL, 0, 0, 0, 0, NIL);
{zeigMeldung ('NeuerTextAusFile', 'sendNetzMessage cmTextLaden');}
  TextObj^.sendNetzMessage (TextObj^.getFensterInhalt, evCommand, cmTextLaden, @Dateiname);
  NeuerTextAusFile := TextObj;
{zeigMeldung ('NeuerTextAusFile', 'END');}
END (* NeuerTextAusFile *);

PROCEDURE Editor.HandleEvent (VAR Event: TEvent);
VAR  Bounds:       TRect;
     BrowseBounds: TRect;
     abm:          TRect;
     d:            INTEGER;
     clearev:      BOOLEAN;
     dummyp:       POINTER;
     Kommentar:    STRING;
     FName:        STRING;
     ch:           CHAR;
     TextObj:      GLP;
     dummy:        GLP;
     MausEvent:    TEvent;
     MausCount:    INTEGER;
     beenden:      BOOLEAN;
     Dir:          DirStr;
     Helpname:     DirStr;
     Name:         NameStr;
     Ext:          ExtStr;

  PROCEDURE ChangeDir;
  VAR  D: PChDirDialog;
       c: WORD;
  BEGIN
    D := PChDirDialog (ValidView (NEW (PChDirDialog, Init (0, 0 {hlChangeDir}))));
    IF D <> NIL THEN BEGIN
      c := DeskTop^.ExecView (D);
      Dispose (D, Done);
    END;
  END (* ChangeDir *);

  PROCEDURE DoTile;
  (* Duplikate Identifier wg. Desktop^.Tile - war in 6.0 kein Fehler! *)
  VAR  R: TRect;
  BEGIN
    Desktop^.GetExtent (R);
    Desktop^.Tile (R);
  END (* DoTile *);

  PROCEDURE DoCascade;
  (* siehe oben - (Do)Tile *)
  VAR  R: TRect;
  BEGIN
    Desktop^.GetExtent (R);
    Desktop^.Cascade (R);
  END (* DoCascade *);

  PROCEDURE zeigHilfe;
  BEGIN
    zeigMeldung ('Hilfe', 'Hier soll spter eine Programmanleitung stehen');
  END (* zeigHilfe *);

  PROCEDURE zeigSpeicher;
  VAR s:                  STRING [80];
      Bytes, Avail, Max:  STRING [12];
  BEGIN
    Str (MemAvail, Bytes);
    Str (MemAvail DIV 1024, Avail); Str (MaxAvail DIV 1024, Max);
    s := 'Gesamt: ' + Bytes + ' (' + Avail + ' KB), Max: ' + Max +
         ' KB; Stack: '+ StringVonNum (SPtr);
    zeigMeldung ('Freier Speicher', s);
  END (* zeigSpeicher *);

  PROCEDURE TexteLaden;
  VAR  Filter:      STRING;
       DateiName:   STRING;
       DateiPfad:   STRING;
       Ext:         STRING [3];
       ch:          CHAR;
       SRec:        SearchRec;
       dummy:       GLP;
       a:           TRect;
  BEGIN (* TexteLaden *)
    GetDir (0, Filter);
    ch := EditStringTitel (4, 10, 70, 'Pfadname mit Wildcards fr Texte Laden', Filter);
    IF ch <> Esc THEN BEGIN
      FSplit (Filter, DateiPfad, DateiName, Ext);
      DateiName := Dateiname + Ext;
      FindFirst (DateiName, 0, SRec);
      DateiPfad := Filter;
      SYSTEM.Delete (DateiPfad, LENGTH (DateiPfad) - LENGTH (DateiName) + 1,
                     LENGTH (DateiName));
{zeigMeldung (Dateipfad, '-------' + DateiName + '--------');}
      a.Assign (0, 0, 77, 20);
      WHILE (DosError = 0) AND (MaxAvail >= needHeap (SimpleText)) DO BEGIN
        DateiName := DateiPfad + SRec.Name;
        TextObj := NeuerTextAusFile (DateiName, a);
        FindNext (SRec);
      END (* WHILE *);
    END (* IF *);
  END (* TexteLaden *);

  PROCEDURE ParserLaden;
  VAR  Filter:      STRING;
       DateiName:   STRING;
       DateiPfad:   STRING;
       Ext:         STRING [3];
       ch:          CHAR;
       SRec:        SearchRec;
       dummy:       GLP;

  BEGIN (* ParserLaden *)
    GetDir (0, Filter);
    ch := EditStringTitel (4, 10, 70, 'Pfadname mit Wildcards fr Parser Laden', Filter);
    IF ch <> Esc THEN BEGIN
      FSplit (Filter, DateiPfad, DateiName, Ext);
      DateiName := Dateiname + Ext;
      FindFirst (DateiName, 0, SRec);
      DateiPfad := Filter;
      SYSTEM.Delete (DateiPfad, LENGTH (DateiPfad) - LENGTH (DateiName) + 1,
                     LENGTH (DateiName));
{zeigMeldung (Dateipfad, '-------' + DateiName + '--------');}
      WHILE (DosError = 0) AND (MaxAvail >= needHeap (Parser))DO BEGIN
        TextObj := neuesObjekt (Parser, [setFormular]);
        positioniere (TextObj);
        dummy := einSimpleTextPointer (TextObj)^.Edit (NIL, 0, 0, 0, 0, einSimpleTextPointer (TextObj)^.TextName);
        DateiName := DateiPfad + SRec.Name;
        TextObj^.sendNetzMessage (TextObj^.getFensterInhalt, evCommand, cmTextLaden,
                                  @DateiName);
        FindNext (SRec);
      END (* WHILE *);
    END (* IF *);
  END (* TexteLaden *);

BEGIN (* Editor.HandleEvent *)

  IF (Event.What = evCommand) AND (Event.Command = cmQuit) THEN BEGIN
    IF NOT einSimpleTextPointer (Clipboard)^.hatTextflag (ExitOhneFrage) THEN BEGIN
      IF einSimpleTextPointer (Clipboard)^.hatTextflag (SpeichImmerFragen) THEN
        beenden := zeigFrage ('SIMPEL beenden',
                              #3 + 'Wollen Sie wirklich den Editor verlassen?' +
 #13 +
                              #3 + 'Bei editierten Texten erfolgt Abfrage auf Speichern')
      ELSE
        beenden := zeigFrage ('SIMPEL beenden',
                              #3 + 'Wollen Sie wirklich den Editor verlassen' + #13 +
                              #3 + 'und alles automatisch speichern?');
    END
    ELSE beenden := TRUE;
    IF beenden THEN BEGIN
    (* Alle noch offenen Fenster schlieen, wenn Programm verlassen
       werden soll. Dies soll die Fenster veranlassen, zu prfen,
       ob noch Daten gesichert werden mssen. *)
      {zeigMeldung ('Editor.HandleEvent', 'cmQuit');}
      {}
      REPEAT
        dummyp := Message (Desktop, evBroadcast, cmClose(*All*), NIL);
      UNTIL dummyp = NIL;
    END ELSE BEGIN
      ClearEvent (Event); EXIT;
    END (* IF zeigFrage *);
  END (* IF cmQuit *);

  IF (Event.What = evMouseDown) THEN BEGIN
   (* Fensterbrowser mit rechter Maustaste rufen: *)
    IF Event.Buttons AND mbRightButton <> 0 THEN BEGIN

    (* Das Problem mit Double-Klick ist, da dieses erst bei einem
       zweiten Tastendruck gemeldet wird, der kurz nach einem vorangehenden
       erfolgt ist. Der erste Mausklick lst aber schon die Aktion fr einen
       einfachen Mausklick aus! *)
      FOR MausCount := 1 TO 25 DO BEGIN
        Delay (10);
        GetMouseEvent (MausEvent);
        IF MausEvent.Buttons AND mbRightButton <> 0 THEN BEGIN
          zeigMeldung ('Maus-Doppelklick', 'Hier soll ein Popup-Men kommen');
          ClearEvent (Event);
          Exit;
        END (* IF Double *);
      END (* FOR *);

      BrowseBounds.A := Event.Where;
      WITH BrowseBounds DO BEGIN
        IF A.X > 7 THEN DEC (A.X, 7) ELSE A.X := 0;
        IF A.Y > 3 THEN DEC (A.Y, 3) ELSE A.Y := 0;
{BrowseBounds.Assign (0, 0, 35, 10);}
        B.X := A.X + 35;
        B.Y := A.Y + 10;
      END (* WITH *);
      doWindowBrowser ('Gewnschtes Fenster whlen', BrowseBounds);
      ClearEvent (Event);
    END (* IR rechte Maustaste *);
  END (* IF evMouse *);

  INHERITED HandleEvent (Event);

  CASE Event.What OF
    evCommand: BEGIN
                 clearev := TRUE;
                 CASE Event.Command OF
                   cmChangeDir:       BEGIN
                                        ChangeDir;
                                      END;
                   cmDosProgramm:     BEGIN
                                        DosProgramm;
                                      END;
                   cmWindowBrowse:    BEGIN
                                        BrowseBounds.Assign (0, 0, 35, 10);
                                        zentriere (BrowseBounds);
                                        doWindowBrowser ('Gewnschtes Fenster whlen', BrowseBounds);
                                      END;
                   cmNeuerText:       IF MaxAvail >= needHeap (SimpleText) THEN BEGIN
                                        TextObj := neuesObjekt (SimpleText, [setFormular]);
                                        positioniere (TextObj);
                                        dummy := TextObj^.Edit (NIL, 0, 0, 0, 0,
                                                       einSimpleTextPointer (TextObj)^.TextName);
                                      END
                                      ELSE ZeigMeldung ('Speicher ' + StringVonNum (MaxAvail),
                                                        'reicht nicht fr neuen Text');
                   cmEditClipboard:   BEGIN
                                        IF Clipboard <> NIL THEN BEGIN
{zeigmeldung ('cmEditClipboard', 'Clipboard <> NIL');}
                                          einSimpleTextPointer (Clipboard)^.setzeName (
                                            einSimpleTextPointer (Clipboard)^.Textname, 'Clipboard');
{zeigmeldung ('nach setzeName', 'rufe Edit');}
                                          dummy := einSimpleTextPointer (Clipboard)^.Edit (NIL, 0, 0, 0, 0,
                                                           einSimpleTextPointer (Clipboard)^.TextName)
                                        END (* IF *)
                                        ELSE zeigMeldung ('Clipboard', 'Kein Clipboard gesetzt');
                                      END;
                   cmGetClipboard:    BEGIN
                                        ClearEvent (Event); Event.InfoPtr := Clipboard;
                                        clearev := FALSE;
                                      END;
                   cmSetClipboard:    IF MaxAvail >= needHeap (SimpleText) THEN BEGIN
                                        IF Clipboard = NIL THEN BEGIN
                                          Clipboard := neuesObjekt (SimpleText, [setFormular]);
                                          positioniere (Clipboard);
                                          einSimpleTextPointer (Clipboard)^.setzeInternFlag (istClipboard);
                                        END (* IF noch kein Clipboard *);
                                        ClearEvent (Event); Event.InfoPtr := Clipboard;
                                        clearev := FALSE;
                                      END
                                      ELSE BEGIN
                                        zeigMeldung ('Speicher: ' + StringVonNum (Maxavail),
                                        'Speicher reicht nicht, um Clipboard anzulegen');
                                        ClearEvent (Event); Event.InfoPtr := NIL;
                                        clearev := FALSE;
                                      END;
                   cmLadeNeuenText:   IF MaxAvail >= needHeap (SimpleText) THEN BEGIN
                                        TextObj := neuesObjekt (SimpleText, [setFormular]);
                                        positioniere (TextObj);
                                        dummy := TextObj^.Edit (NIL, 0, 0, 0, 0, einSimpleTextPointer (TextObj)^.TextName);
                                        TextObj^.sendNetzMessage (TextObj^.getFensterInhalt,
                                                                  evCommand, cmTextLaden, NIL);
                                      END
                                      ELSE ZeigMeldung ('Speicher ' + StringVonNum (MaxAvail),
                                                        'reicht nicht fr neuen Text');
                   cmTexteLaden:      BEGIN
                                        TexteLaden;
                                      END;
{$IFDEF mitMedusa}
                   cmNeuerParser:     IF MaxAvail >= needHeap (Parser) THEN BEGIN
                                        TextObj := neuesObjekt (Parser, [setFormular]);
                                        positioniere (TextObj);
                                        dummy := TextObj^.Edit (NIL, 0, 0, 0, 0,
                                                       einSimpleTextPointer (TextObj)^.TextName);
                                      END
                                      ELSE ZeigMeldung ('Speicher ' + StringVonNum (MaxAvail),
                                                        'reicht nicht fr neuen Text');
                   cmLadeNeuenParser: IF MaxAvail >= needHeap (Parser) THEN BEGIN
                                        TextObj := neuesObjekt (Parser, [setFormular]);
                                        positioniere (TextObj);
                                        dummy := TextObj^.Edit (NIL, 0, 0, 0, 0, einSimpleTextPointer (TextObj)^.TextName);
                                        TextObj^.sendNetzMessage (TextObj^.getFensterInhalt,
                                                                  evCommand, cmTextLaden, NIL);
                                      END
                                      ELSE ZeigMeldung ('Speicher ' + StringVonNum (MaxAvail),
                                                        'reicht nicht fr neuen Text');
                   cmParserLaden:      BEGIN
                                        ParserLaden;
                                      END;
{$ENDIF mitMedusa}
                   cmTexteDrucken:    BEGIN
                                        dummyp := Message (Desktop, evBroadcast, cmTexteDrucken, @SELF);
                                      END;
                   cmGetCommandline:  IF MaxAvail >= needHeap (SimpleText) THEN BEGIN
                                        {zeigMeldung ('Commandline', ParamStr (0) + ', ' + ParamStr (1));}

                                        abm.Assign (0, 0, ScreenWidth, ScreenHeight - 2);

                                        FName := ParamStr (1);
                                        TextObj := NeuerTextAusFile (FName, abm);
                                      END
                                      ELSE ZeigMeldung ('Speicher ' + StringVonNum (MaxAvail),
                                                        'reicht nicht fr neuen Text');
                   cmGBE:             zeigGBELogo;
                   cmCascade:         DoCascade;
                   cmTile:            DoTile;
                   {cmHelp:            zeigHilfe;}
                   cmGetHelp:         BEGIN
                                        ClearEvent (Event); Event.InfoPtr := Helptext;
                                        clearev := FALSE;
                                      END;
                   cmClearHelp:       BEGIN
                                        Helptext := NIL;
                                      END;
                   cmHelp:            BEGIN
                                        IF helptext <> NIL THEN BEGIN
                                          dummy := einSimpleTextPointer (helptext)^.Edit (NIL, 0, 0, 0, 0,
                                                       einSimpleTextPointer (helptext)^.TextName);
                                        END
                                        ELSE BEGIN
                                          IF MaxAvail >= needHeap (SimpleText) THEN BEGIN

                                            abm.Assign (0, 0, ScreenWidth, ScreenHeight - 2);

                                            FSplit (ParamStr (0), Dir, Name, Ext);
                                            Helpname := Dir + 'SIMPANL.TXT';
                                            helptext := NeuerTextAusFile (Helpname, abm);
                                            einSimpleTextPointer (helptext)^.setzeTextFlag (nurLesen);
                                          END
                                          ELSE ZeigMeldung ('Speicher ' + StringVonNum (MaxAvail),
                                                            'reicht nicht fr neuen Text');
                                        END (* ELSE *);
                                      END (* cmHelp *);
                   cmSpeicher:        zeigSpeicher;
                   cmError:           RunError (1000);
                   cmPROTOKOLL:       BEGIN
                                        Kommentar := '';
                                        ch := EditStringTitel (5, 11, 70,
                                          'Dateiname fr Protokoll oder <RET> fr Bildschirmanzeige',
                                          Kommentar);
                                        IF Kommentar <> '' THEN BEGIN
                                          MeldFileOn (Kommentar);
                                        END (* IF Kommentar *);
                                      END;
                   cmTRON:            BEGIN
                                        TRON;
                                        Kommentar := '';
                                        ch := EditStringTitel (5, 11, 70,
                                          'Dateiname fr Trace oder <RET> fr Bildschirmanzeige',
                                          Kommentar);
                                        IF Kommentar <> '' THEN BEGIN
                                          MeldFileOn (Kommentar);
                                        END (* IF Kommentar *);
                                      END;
                   cmTROFF:           BEGIN
                                        MeldFileOff;
                                        TROFF;
                                      END;

                   cmHighScreen:      BEGIN
                                        SetScreenMode (smCO80 + smFont8x8);
                                      END;
                   cmLowScreen:       BEGIN
                                        SetScreenMode (smCO80);
                                      END;
                   cmBWScreen:        BEGIN
                                        SetScreenMode (smBW80);
                                      END;
                   cmBWHighScreen:        BEGIN
                                        SetScreenMode (smBW80 + smFont8x8);
                                      END;
                   ELSE clearev := FALSE;
                 END (* CASE *);
                 IF clearev THEN ClearEvent (Event);
    END (* CASE evCommand *);
  END (* CASE Event.What *);
END (* HandleEvent *);

(******************* Methoden von TMyWindow *************************)

CONSTRUCTOR TMyWindow.Init;
BEGIN
  INHERITED Init (Bounds, ATitle, ANumber);
  Palette := wpGrayWindow;
END (* Init *);

CONST
  CBlueWindow      = #8#9#10#11#12#13#14#15;
  CCyanWindow      = #16#17#18#19#20#21#22#23;
  CGrayWindow      = #24#25#26#27#28#29#30#31;
  CWindowPalette   = #03#128#129#128#128#29#30#19 + #64#65;
                     { 1   2   3   4   5  6  7  8 +   9  10}

FUNCTION TMyWindow.GetPalette: PPalette;
const
  P: string[Length(CWindowPalette)] = CWindowPalette;
BEGIN
  {GetPalette := TWindow.GetPalette;}
  GetPalette := @P
END (* GetPalette *);

PROCEDURE TMyWindow.SetTitle (ATitle: TTitleStr);
BEGIN
  DisposeStr (Title);
  Title := NewStr (ATitle);
  Redraw; (* zeichnet Subview neu, also auch Frame! *)
END (* SetTitle *);

PROCEDURE TMyWindow.SetPTitle (PTitle: GLP);
VAR  STitle:  STRING [80];
BEGIN
  IF (PTitle <> NIL) AND (PTitle^.isSubclass (String8)) THEN BEGIN
    STitle := PTitle^.StringVonDaten;
    SetTitle (STitle);
  END
  ELSE BEGIN SetTitle ('');
  END;
END (* SetPTitle *);

PROCEDURE TMyWindow.HandleEvent (VAR Event: TEvent);
VAR dummyp:  POINTER;
BEGIN
  CASE Event.What OF
    evKeyDown: IF (Event.KeyCode = kbEsc)
               THEN BEGIN
                 Event.What := evCommand;
                 Event.Command := cmClose;
               END;
    evCommand: CASE Event.Command OF
                 cmSchliesseFormular: Event.Command := cmClose;
                 cmSetWindowTitle:    SetPTitle (Event.InfoPtr);
                 {
                 cmClose:             BEGIN
                                        IF NOT zeigFrage ('***Fenster schlieen*
**',
                                               'Wollen Sie wirklich das Fenster schlieen?') THEN
                                        ClearEvent (Event); Event.InfoPtr := NIL;
                                        EXIT;
                                      END;
                 cmCloseAll:          zeigMeldung ('TMyWindow', 'cmCloseAll');
                 }
               END (* CASE *);
  END (* CASE *);
  TWindow.HandleEvent (Event);
END (* HandleEvent *);

(****************** Methoden von TSimpleTextWindows *****************)

CONSTRUCTOR TSimpleTextWindow.Init (VAR Bounds: TRect; LimX, LimY: INTEGER;
                                    Offs: TPoint;
                                    ATitle: TTitleStr; TextO: GLP);
VAR  MenuLeiste:   einListenPointer;
     Menu:         PMenuBar;
     R:            TRect;
BEGIN
{zeigMeldung ('TSimpleTextWindow.Init', 'INHERITED ...');}
  INHERITED Init (Bounds, ATitle, 0);
  Options := Options + ofTileable;
{zeigMeldung ('TSimpleTextWindow.Init', 'macheTextGrafik');}
  macheTextGrafik (LimX, LimY, Offs, TextO);

{zeigMeldung ('TSimpleTextWindow.Init', 'InitMenu');}
  einStrukturPointer (TextO)^.InitMenu (GLP (MenuLeiste));
  GetExtent (R);
  R.Grow (-1, -1);

{zeigMeldung ('TSimpleTextWindow.Init', 'macheMenu');}
  Menu := MacheMenu (MenuLeiste, R, TRUE);

{zeigMeldung ('TSimpleTextWindow.Init', 'MenuLeist^.LoeschPfad');}
  MenuLeiste^.LoeschPfad (MenuLeiste^.neuSig);
{zeigMeldung ('TSimpleTextWindow.Init', 'MenuLeiste.Done');}
  DISPOSE (MenuLeiste, Done);

{zeigMeldung ('TSimpleTextWindow.Init', 'InsertMenu');}
  Insert (Menu);

{zeigMeldung ('TSimpleTextWindow.Init', 'END');}
END (* Init *);

PROCEDURE TSimpleTextWindow.macheTextGrafik (LimX, LimY: INTEGER;
                                             Offs: TPoint;
                                             TextO: GLP);
VAR  HScrollBar, VScrollBar:  PScrollBar;
     Inneres:                 PTextGrafik;
     R:                       TRect;
     Bounds:                  TRect;
BEGIN
  VScrollBar := StandardScrollBar (sbVertical + sbHandleKeyboard);
  HScrollBar := StandardScrollBar (sbHorizontal + sbHandleKeyboard);
  GetExtent (Bounds);
  Bounds.Grow (-1, -1);
  Bounds.A.Y := Bounds.A.Y + 1;
  Inneres := NEW (PTextGrafik, Init (Bounds, LimX, LimY, Offs, HScrollBar, VScrollBar,
                                     TextO));
  Insert (Inneres);
  TextO^.setzFensterInhalt (Inneres);
END (* macheTextGrafik *);

FUNCTION TSimpleTextWindow.StandardScrollBar (AOptions: Word): PScrollBar;
VAR
  R: TRect;
  S: PScrollBar;
BEGIN
  GetExtent (R);
  IF AOptions AND sbVertical = 0 THEN
    {R.Assign (R.A.X + 18, R.B.Y - 1, R.B.X - 2, R.B.Y)}
    R.Assign (R.A.X + 26, R.B.Y - 1, R.B.X - 2, R.B.Y)
  ELSE
    R.Assign (R.B.X - 1, R.A.Y + 1, R.B.X, R.B.Y - 1);
  S := New (PScrollBar, Init (R));
  Insert (S);
  if AOptions and sbHandleKeyboard <> 0 then
    S^.Options := S^.Options or ofPostProcess;
  StandardScrollBar := S;
END (* StandardScrollBar *);

PROCEDURE TSimpleTextWindow.WriteStatus (CONST s: STRING);
VAR R: TRect;
BEGIN
  GetExtent (R);
  WriteStr (R.A.X + 2, R.B.Y - 1, s, 2);
END (* WriteStatus *);

PROCEDURE TSimpleTextWindow.WriteCharCode (CONST s: STRING);
VAR R: TRect;
BEGIN
  GetExtent (R);
  WriteStr (R.A.X + 6, R.A.Y, s, 2);
END (* WriteStatus *);

(********************* Methoden von TypVektorWindows *********************)

CONSTRUCTOR TWindowBrowserWindow.Init (VAR Bounds: TRect; ATitle: TTitleStr;
                                       Start, PreSelect: WORD);
VAR  B:  TRect;
BEGIN
  TWindow.Init (Bounds, ATitle, 0);
  flags := flags OR wfZoom;
  B := Bounds;
  macheWindowBrowser (B, Start, PreSelect);
  B.Grow (2, 1);
  Bounds.B.X := Bounds.A.X + B.B.X - B.A.X;
  Bounds.B.Y := Bounds.A.Y + B.B.Y - B.A.Y;
  IF Bounds.B.X > ScreenWidth THEN
    Bounds.Move (ScreenWidth - Bounds.B.X, 0);
  ChangeBounds (Bounds);
END (* Init *);

DESTRUCTOR TWindowBrowserWindow.Done;
BEGIN
  TWindow.Done;
END (* Done *);

PROCEDURE TWindowBrowserWindow.macheWindowBrowser (VAR Bounds: TRect;
                                                Start, PreSelect: WORD);
VAR
    HScrollBar, VScrollBar:  PScrollBar;
BEGIN
  VScrollBar := StandardScrollBar (sbVertical + sbHandleKeyboard);
  (* HScrollBar := StandardScrollBar (sbHorizontal + sbHandleKeyboard); *)
  HScrollBar := NIL;
  GetExtent (Bounds);
  Bounds.Grow (-1, -1);
  WindowBrowser := NEW (PWindowBrowser, Init (Bounds, 25, HScrollBar, VScrollBar,
                 Desktop^.First, Start, PreSelect));
  Insert (WindowBrowser);
END (* macheWindowBrowser *);

FUNCTION TWindowBrowserWindow.GetTheWindow: PWindow;
BEGIN
  GetTheWindow := WindowBrowser^.GetTheWindow;
END (* GetTheWindow *);

PROCEDURE doWindowBrowser (tit: STRING; Bounds: TRect);
VAR  BrowserWindow:   PWindowBrowserWindow;
     Control:         WORD;
     dasWindow:       PWindow;
BEGIN
  BrowserWindow := NEW (PWindowBrowserWindow,
                    Init (Bounds, tit, 0, 1));
  dasWindow := NIL;
  Control := DeskTop^.ExecView (BrowserWindow);

  IF Control <> cmCancel THEN
    dasWindow := BrowserWindow^.GetTheWindow;

  DISPOSE (BrowserWindow, Done);
  IF dasWindow <> NIL THEN dasWindow^.MakeFirst;
END (* doWindowBrowser *);

PROCEDURE getFilename (VAR Name: STRING; Titel, Ueberschr: STRING; laden: BOOLEAN);
VAR  FileDialog:     PFileDialog;
     DN:           DirStr;
     NN:           NameStr;
     EN:           ExtStr;
     oldDir:       DirStr;
BEGIN
  FSplit (Name, DN, NN, EN);
  Name := NN + EN;

  GetDir (0, oldDir);
  IF (DN <> '') AND (DN [LENGTH (DN)] = '\') THEN BEGIN
    IF NOT ((LENGTH (DN) = 3) AND (DN [2] = ':')) THEN
      Delete (DN, LENGTH (DN), 1);
{zeigMeldung ('Der DN-String enthlt:', DN);}
  END;
  ChDir (DN);

  IF laden THEN
    FileDialog := NEW (PFileDialog,
                       Init (Name, Titel, Ueberschr, fdOpenButton + fdOkButton, 0))
  ELSE
    FileDialog := NEW (PFileDialog,
                       Init (Name, Titel, Ueberschr, fdOkButton, 0));
  IF FileDialog <> NIL THEN BEGIN
    IF Desktop^.ExecView (FileDialog) <> cmCancel THEN BEGIN
      FileDialog^.GetFileName (Name);
    END (* IF *)
    ELSE Name := '';
    DISPOSE (FileDialog, Done);
  END
  ELSE name := '';
  ChDir (oldDir);
END (* getFilename *);

END (* GLFWindows *).
