UNIT MEDUSA;

{$F+}
{$O+}

(* (C) 1990, 1991, 1992, 1993 by Johannes Leckebusch
   Version 0.703
   Stand: 05. 12. 1993
*)

INTERFACE

USES Objects, Drivers,
     GLFTypes, GLFBase, ObjStrings, GLFWordBase, GLFLexikon,
     SimpelText, GLFViews;


TYPE einSymbol = (leer, Semikolon, KlammAuf, KlammZu, MultZeich, Plus,
                  Komma, Minus, Punkt, Doppelpunkt, DivZeich, Zuweisung,
                  kleinergleich, kleiner, gleich, groessergleich, groesser,

                  ProgSym, MethodSym, BeginSym, EndSym,
                  ConstSym, VarSym, NotSym,
                  IfSym, ThenSym, EndIfSym,
                  WhileSym, DoSym, EndWhileSym,
                  IntType, FloatType, StringType,
                  ReadSym, WriteSym,

                  {Es sollte eigentlich zwischen Konstante, Variable etc.
                  einerseits und Datentypen andererseits unterschieden
                  werden! Variable, Konstante und Funktionen knnen demselben
                  Datentyp zugeordnet sein.}

                  Kommentar,
                  Syntaxfehler,

                  IntZahl, FloatZahl,
                  IntConst, FloatConst, StringConst,
                  IntVar, FloatVar, StringVar,
                  Bezeichner, MethodName,
                  StringLit);

     einSymbolset = SET OF einSymbol;

      einToken = RECORD
                   BezString:    GLP;
                   CASE Symbol: einSymbol OF
                     IntConst,
                     IntVar:       (IntWert:      LONGINT);
                     FloatConst,
                     FloatVar:     (FloatWert:    EXTENDED);
                     Stringconst,
                     StringLit,
                     StringVar:    (SConst:       PSTRING);
                 END (* einToken *);

      einSymtabEintragsPointer = ^einSymtabEintrag;
      einSymtabEintrag = OBJECT (einNetzString)
                           Token:  einToken;
                           CONSTRUCTOR Init (xflags: einFlagSet);
                           FUNCTION erzeugeMich (CONST xflags: einFlagSet): GLP; VIRTUAL;
                           FUNCTION isSubClass (CONST class: einGenTyp): BOOLEAN; VIRTUAL;
                           FUNCTION neuerNetzString: GLP; VIRTUAL;
                         END (* einSymtabEintrag *);

      einSymtabellenPointer = ^eineSymtabelle;
      eineSymtabelle = OBJECT (einLexikon)
                         AeussererLevel: GLP; (* Symboltabelle der Umgebung *)
                         CONSTRUCTOR Init (xflags: einFlagSet);
                         FUNCTION erzeugeMich (CONST xflags: einFlagSet): GLP; VIRTUAL;
                         FUNCTION isSubClass (CONST class: einGenTyp): BOOLEAN; VIRTUAL;
                         FUNCTION neuerNetzString: GLP; VIRTUAL;
                         FUNCTION insertSymbol (CONST SymText: STRING; Sym: einSymbol): GLP;
                         FUNCTION findeBegriff (wort: STRING; CONST exakt: BOOLEAN): GLP;
                           VIRTUAL;
                         FUNCTION findeSymbol (CONST wort: STRING; CONST lokal: BOOLEAN): GLP;
                       END (* eineSymtabelle *);


  einParserflag =    (ProtScan, (* Scanner-Output protokokollieren *)
                     ProtPars, (* Parser-Output protokollieren *)
                     EndFlag,
                     Fehler,
                     Parsflag4,
                     Parsflag5,
                     Parsflag6,
                     Parsflag7,
                     Parsflag8,
                     Parsflag9,
                     Parsflag10,
                     Parsflag11,
                     Parsflag12,
                     Parsflag13,
                     Parsflag14,
                     Parsflag15,
                     Parsflag16,
                     Parsflag17,
                     Parsflag18,
                     Parsflag19,
                     Parsflag20,
                     Parsflag21,
                     Parsflag22,
                     Parsflag23,
                     Parsflag24,
                     Parsflag25,
                     Parsflag26,
                     Parsflag27,
                     Parsflag28,
                     Parsflag29,
                     Parsflag30,
                     Parsflag31
                    );

  einParserflagSet =  SET OF einParserFlag;

  einParserPointer = ^einParser;
  einParser = OBJECT (einSimpleText)
                Parserflags: einParserflagSet;
                ProtText:    GLP;
                ProtView:    PBuffText;
                ScanX:       LONGINT;
                OldScanX:    LONGINT;
                ScanY:       LONGINT;
                OldScanY:    LONGINT;
                OldTextX:    LONGINT;
                OldTextY:    LONGINT;
                ScanZeile:   einStringPointer;
                ch:          CHAR;
                SymString:   STRING;
                Wortsymbole: einSymbolset;
                Typsymbole:  einSymbolset;
                Token:       einToken;
                Ende:        BOOLEAN;
                globaleSymboltabelle: einSymtabellenPointer;

                CONSTRUCTOR Init (xflags: einFlagSet);
                DESTRUCTOR Done; VIRTUAL;
                PROCEDURE LoeschPfad (CONST Sig: LONGINT); VIRTUAL;

                FUNCTION erzeugeMich (CONST xflags: einFlagSet): GLP; VIRTUAL;
                FUNCTION isSubClass (CONST class: einGenTyp): BOOLEAN; VIRTUAL;
                PROCEDURE nulleNetzFlag (CONST flag: einFlag; CONST Sig: LONGINT);
                  VIRTUAL;
                PROCEDURE setzeNetzFlag (CONST flag: einFlag; CONST Sig: LONGINT);
                  VIRTUAL;
(* Flagbehandlung *)
                PROCEDURE zeigParserFlags (CONST Titel: STRING); VIRTUAL;
                PROCEDURE setzeParserflag (CONST Flag: einParserflag);
                PROCEDURE rueckParserflag (CONST Flag: einParserflag);
                FUNCTION hatParserflag (CONST Flag: einParserflag): BOOLEAN;
                FUNCTION StringVonParserflag (CONST Flag: einParserflag): STRING;
                FUNCTION StringVonParserflags: STRING;

                PROCEDURE InitMenu (VAR dieMenuLeiste: GLP);
                  VIRTUAL;
                PROCEDURE sende (CONST view: PBuffText; VAR ereignis: TEvent;
                                 CONST Sig: LONGINT);
                  VIRTUAL;
                PROCEDURE Scan ({CONST Titel: STRING;} Symtab: einSymtabellenPointer);
                  VIRTUAL;
                PROCEDURE ScanStart (CONST Titel: STRING);
                PROCEDURE NextScanLine;
                PROCEDURE getChar;
                FUNCTION getSymbol (skipKommentar: BOOLEAN;
                  Symtab: einSymtabellenPointer): BOOLEAN; VIRTUAL;
                FUNCTION StringVonSymbol (CONST sym: einSymbol): STRING;
                FUNCTION StringVonSymbolSet (CONST symset: einSymbolSet): STRING;
                PROCEDURE WriteSymbol; VIRTUAL;
                PROCEDURE Number; VIRTUAL;
                PROCEDURE Identifier (Symtab: einSymtabellenPointer); VIRTUAL;
                PROCEDURE getComment;
                PROCEDURE getString;
                PROCEDURE Parse (CONST Titel: STRING); VIRTUAL;
                PROCEDURE Execute (CONST Titel: STRING); VIRTUAL;
                PROCEDURE Fehlermeldung (CONST Titel: STRING;
                                         Meldung: STRING;
                                         erwartet: einSymbolSet;
                                         gefunden: einSymbol);
              PRIVATE
                PROCEDURE ProtLine;
                PROCEDURE ProtChar (CONST chr: CHAR);
                PROCEDURE ProtStr (CONST s: STRING);
              END (* einParser *);

IMPLEMENTATION

USES App, Views, Dialogs,
     EditStuff, GLFLists, GLFWindows;

(* Methoden Symboltabelle *)

CONSTRUCTOR einSymtabEintrag.Init;
BEGIN
  INHERITED Init (xflags);
  meinTyp := SymtabEintrag;
  {
  WITH Token DO BEGIN
    Symbol := leer; BezString := NIL;
  END;
  }
END (* Init *);

FUNCTION einSymtabEintrag.erzeugeMich (CONST xflags: einFlagSet): GLP;
BEGIN
  erzeugeMich := NEW (einSymtabEintragsPointer, Init (xflags));
END (* erzeugeMich *);

FUNCTION einSymtabEintrag.isSubclass (CONST class: einGenTyp): BOOLEAN;
BEGIN
  isSubclass := (class = SymtabEintrag) OR INHERITED isSubClass (class);
END (* isSubclass *);

FUNCTION einSymtabEintrag.neuerNetzString: GLP;
BEGIN
  neuerNetzString := neuesObjekt (SymtabEintrag, []);
END (* neuerNetzString *);

(* Symboltabelle *)

CONSTRUCTOR eineSymtabelle.Init;
BEGIN
  INHERITED Init (xflags);
  meinTyp := Symtabelle;
  {AeussererLevel := NIL;}
END (* Init *);

FUNCTION eineSymtabelle.erzeugeMich (CONST xflags: einFlagSet): GLP;
BEGIN
  erzeugeMich := NEW (einSymtabellenPointer, Init (xflags));
END (* erzeugeMich *);

FUNCTION eineSymtabelle.isSubclass (CONST class: einGenTyp): BOOLEAN;
BEGIN
  isSubclass := (class = SymtabEintrag) OR INHERITED isSubClass (class);
END (* isSubclass *);

FUNCTION eineSymtabelle.neuerNetzString: GLP;
BEGIN
  neuerNetzString := neuesObjekt (SymtabEintrag, []);
END (* neuerNetzString *);

FUNCTION eineSymtabelle.insertSymbol (CONST SymText: STRING; Sym: einSymbol):
  GLP;
VAR  Eintrag:   einSymtabEintragsPointer;
BEGIN
  GLP (Eintrag) := InsertStringConst (SymText, TRUE);
  Eintrag^.Token.Symbol := Sym;
  insertSymbol := Eintrag;
END (* insertSymbol *);

FUNCTION eineSymtabelle.findeBegriff (wort: STRING; CONST exakt: BOOLEAN): GLP;
VAR  Begriff: GLP;
BEGIN
  Begriff := INHERITED findeBegriff (wort, exakt);
  IF (Begriff = NIL) AND (AeussererLevel <> NIL) THEN
    Begriff := einLexikonPointer (AeussererLevel)^.findeBegriff (wort, exakt);
  findeBegriff := Begriff;
END (* findeBegriff *);

FUNCTION eineSymtabelle.findeSymbol (CONST wort: STRING; CONST lokal: BOOLEAN): GLP;
VAR  Begriff: GLP;
BEGIN
  IF NOT lokal THEN Begriff := findeBegriff (wort, TRUE)
  ELSE Begriff := INHERITED findeBegriff (wort, TRUE);
  findeSymbol := Begriff;
END (* findeSymbol *);

(* Parsermethoden *)

CONSTRUCTOR einParser.Init;
BEGIN
  INHERITED Init (xflags);
  meinTyp := Parser;
  meineTextFlags := [InsertFlag, AutoIndent, DruckFormfeed,
                     loescheInUndo, loescheInClipboard];

  Parserflags := [ProtPars];
  {
  ProtText := NIL; ProtView := NIL;
  ScanX := 0; OldScanX := 0; ScanY := 0; OldScanY := 0;
  ScanZeile := NIL;
  }
  Wortsymbole := [Bezeichner, Methodname, IntConst, FloatConst,
                  IntVar, FloatVar, StringVar];
  Typsymbole := [IntType, FloatType, StringType];
  {
  WITH Token DO BEGIN
    Symbol := leer; BezString := NIL;
  END;
  SymString := '';

  globaleSymboltabelle := NIL;
  }
END (* Init *);

DESTRUCTOR einParser.Done;
BEGIN
  INHERITED Done;
  IF ProtText <> NIL THEN DISPOSE (ProtText, Done);
  IF globaleSymboltabelle <> NIL THEN DISPOSE (globaleSymboltabelle, Done);
END (* Done *);

PROCEDURE einParser.LoeschPfad (CONST Sig: LONGINT);
BEGIN
  INHERITED LoeschPfad (Sig);
  IF ProtText <> NIL THEN BEGIN
    IF Sig = ProtText^.meineSignatur THEN ProtText := NIL
    ELSE ProtText^.LoeschPfad (Sig);
  END;
  IF ScanZeile <> NIL THEN BEGIN
    IF Sig = ScanZeile^.meineSignatur THEN ScanZeile := NIL
    ELSE ScanZeile^.LoeschPfad (Sig);
  END;
  IF globaleSymboltabelle <> NIL THEN BEGIN
    IF Sig = globaleSymboltabelle^.meineSignatur THEN globaleSymboltabelle := NIL
    ELSE globaleSymboltabelle^.LoeschPfad (Sig);
  END;
END (* LoeschPfad *);

PROCEDURE einParser.nulleNetzFlag (CONST flag: einFlag; CONST Sig: LONGINT);
BEGIN
  IF Sig <> meineSignatur THEN BEGIN
    INHERITED nulleNetzFlag (flag, Sig);
    IF ProtText <> NIL THEN ProtText^.nulleNetzFlag (flag, Sig);
    IF ScanZeile <> NIL THEN ScanZeile^.nulleNetzFlag (flag, Sig);
    IF globaleSymboltabelle <> NIL THEN globaleSymboltabelle^.nulleNetzFlag (flag, Sig);
  END (* IF *);
END (* nulleNetzFlag *);

PROCEDURE einParser.setzeNetzFlag (CONST flag: einFlag; CONST Sig: LONGINT);
BEGIN
  IF Sig <> meineSignatur THEN BEGIN
    INHERITED setzeNetzFlag (flag, Sig);
    IF ProtText <> NIL THEN ProtText^.setzeNetzFlag (flag, Sig);
    IF ScanZeile <> NIL THEN ScanZeile^.setzeNetzFlag (flag, Sig);
    IF globaleSymboltabelle <> NIL THEN globaleSymboltabelle^.setzeNetzFlag (flag, Sig);
  END (* IF *);
END (* setzeNetzFlag *);

FUNCTION einParser.erzeugeMich (CONST xflags: einFlagSet): GLP;
BEGIN
  erzeugeMich := NEW (einParserPointer, Init (xflags));
END (* erzeugeMich *);

FUNCTION einParser.isSubclass (CONST class: einGenTyp): BOOLEAN;
BEGIN
  isSubclass := (class = Parser) OR INHERITED isSubClass (class);
END (* isSubclass *);

PROCEDURE einParser.setzeParserFlag (CONST Flag: einParserFlag);
BEGIN
  INCLUDE (ParserFlags, Flag);
END (* setzeParserFlag *);

PROCEDURE einParser.rueckParserFlag (CONST Flag: einParserFlag);
BEGIN
  EXCLUDE (ParserFlags, Flag);
END (* rueckParserFlag *);

FUNCTION  einParser.hatParserFlag (CONST Flag: einParserFlag): BOOLEAN;
BEGIN
  hatParserFlag := Flag IN ParserFlags;
END (* hatParsFlag *);

FUNCTION einParser.StringVonParserflag (CONST flag: einParserflag): STRING;
BEGIN
      CASE flag OF
	ProtScan:       StringVonParserFlag := 'ProtScan';
	ProtPars:       StringVonParserFlag := 'ProtPars';
        EndFlag:        StringVonParserFlag := 'EndFlag';
        Fehler:         StringVonParserFlag := 'Fehler';
        ParsFlag4:      StringVonParserFlag := 'ParsFlag4';
        ParsFlag5:      StringVonParserFlag := 'ParsFlag5';
        ParsFlag6:      StringVonParserFlag := 'ParsFlag6';
        ParsFlag7:      StringVonParserFlag := 'ParsFlag7';
        ParsFlag8:      StringVonParserFlag := 'ParsFlag8';
        ParsFlag9:      StringVonParserFlag := 'ParsFlag9';
        ParsFlag10:     StringVonParserFlag := 'ParsFlag10';
        ParsFlag11:     StringVonParserFlag := 'ParsFlag11';
        ParsFlag12:     StringVonParserFlag := 'ParsFlag12';
        ParsFlag13:     StringVonParserFlag := 'ParsFlag13';
        ParsFlag14:     StringVonParserFlag := 'ParsFlag14';
        ParsFlag15:     StringVonParserFlag := 'ParsFlag15';
        ParsFlag16:     StringVonParserFlag := 'ParsFlag16';
        ParsFlag17:     StringVonParserFlag := 'ParsFlag17';
        ParsFlag18:     StringVonParserFlag := 'ParsFlag18';
        ParsFlag19:     StringVonParserFlag := 'ParsFlag19';
        ParsFlag20:     StringVonParserFlag := 'ParsFlag20';
        ParsFlag21:     StringVonParserFlag := 'ParsFlag21';
        ParsFlag22:     StringVonParserFlag := 'ParsFlag22';
        ParsFlag23:     StringVonParserFlag := 'ParsFlag23';
        ParsFlag24:     StringVonParserFlag := 'ParsFlag24';
        ParsFlag25:     StringVonParserFlag := 'ParsFlag25';
        ParsFlag26:     StringVonParserFlag := 'ParsFlag26';
        ParsFlag27:     StringVonParserFlag := 'ParsFlag27';
        ParsFlag28:     StringVonParserFlag := 'ParsFlag28';
        ParsFlag29:     StringVonParserFlag := 'ParsFlag29';
        ParsFlag30:     StringVonParserFlag := 'ParsFlag30';
        ParsFlag31:     StringVonParserFlag := 'ParsFlag31';
      END (* CASE *);
END (* StringVonParserflag *);

FUNCTION einParser.StringVonParserflags: STRING;
VAR     i:      einParserflag;
        s:      STRING;
BEGIN
  s := '{';
  FOR i := ProtScan TO Parsflag31 DO BEGIN
    IF i IN Parserflags THEN BEGIN
      Insert (StringVonParserFlag (i) + ' ', s, LENGTH (s) + 1);
    END (* IF *);
  END (* FOR *);
  s := s + '}';
  StringVonParserflags := s;
END (* StringVonParsflags *);

PROCEDURE einParser.zeigParserFlags (CONST Titel: STRING);

CONST cFlagBreite =  20;
      cFlagHoehe =   16;
      cBoxBreite =   2 * cFlagBreite + 18;
      cBoxHoehe =    cFlagHoehe + 5;

TYPE TFlagboxDaten =  RECORD
                        ParserflagData:  WORD;
                        ParserXflagData: WORD
                      END (* RECORD *);

     Tricky2 =        RECORD
                        CASE BOOLEAN OF
                          FALSE: (dieFlags: einParserFlagset);
                          TRUE:  (LowFlags, HighFlags: WORD);
                        END;

VAR  Box:             PDialog;
     R:               TRect;
     Schalter:        PCheckBoxes;
     SItem:           PSItem;
     PFlag:           einParserFlag;
     Control:         WORD;
     Daten:           TFlagBoxDaten;
     Trick2:          Tricky2;

BEGIN (* zeigParserFlags *)
    R.Assign (0, 0, cBoxBreite, cBoxHoehe);
    zentriere (R);
    Box := NEW (PDialog, Init (R, Titel));
    WITH Box^ DO BEGIN

      (* Flags der Parser-Objekte: *)

      R.Assign (3, 3, 3 + cFlagBreite, 3 + cFlagHoehe);
      SItem := NIL;
      FOR PFlag := Parsflag15 DOWNTO Protscan DO BEGIN
        SItem := NewSItem (StringVonParserFlag (PFlag), SItem);
      END (* FOR *);
      Schalter := NEW (PCheckBoxes, Init (R, SItem));
      Insert (Schalter);
      R.Assign (3, 2, 3 + cFlagBreite, 3);
      Insert (NEW (PLabel, Init (R, 'Parserflags', Schalter)));

      R.Assign (5 + cFlagBreite, 3, 5 + 2 * cFlagBreite, 3 + cFlagHoehe);
      SItem := NIL;
      FOR PFlag := Parsflag31 DOWNTO Parsflag16 DO BEGIN
        SItem := NewSItem (StringVonParserFlag (PFlag), SItem);
      END (* FOR *);
      Schalter := NEW (PCheckBoxes, Init (R, SItem));
      Insert (Schalter);
      R.Assign (5 + cFlagBreite, 2, 5 + 2 * cFlagBreite, 3);
      Insert (NEW (PLabel, Init (R, 'Parserflags', Schalter)));

      R.Assign (2 * cFlagBreite + 6, cBoxHoehe DIV 2 - 2, 2 * cFlagBreite + 16, cBoxHoehe DIV 2 - 0);
      Insert (NEW (PButton, Init (R, '~O~K', cmOK, bfDefault)));
      R.Assign (2 * cFlagBreite + 6, cBoxHoehe DIV 2 + 1, 2 * cFlagBreite + 16, cBoxHoehe DIV 2 + 3);
      Insert (NEW (PButton, Init (R, 'Abbruch', cmCancel, bfNormal)));
    END (* WITH *);
    Trick2.dieFlags := ParserFlags;
    Daten.ParserflagData := Trick2.LowFlags;
    Daten.ParserXflagData := Trick2.HighFlags;
    Box^.SetData (Daten);
    Control := DeskTop^.ExecView (Box);
    IF Control <> cmCancel THEN BEGIN
       Box^.GetData (Daten);
       Trick2.LowFlags := Daten.ParserflagData;
       Trick2.HighFlags := Daten.ParserXflagData;
       ParserFlags := Trick2.dieFlags;
    END;
    Dispose (Box, Done);
END (* zeigParserFlags *);

PROCEDURE einParser.sende (CONST view: PBuffText; VAR ereignis: TEvent;
                           CONST Sig: LONGINT);
VAR  bearbeitet:  BOOLEAN;
BEGIN
  INHERITED sende (view, Ereignis, Sig);
  IF Ereignis.What = evNothing THEN EXIT;
  bearbeitet := TRUE;
  CASE Ereignis.What OF
    evCommand: CASE Ereignis.Command OF
                 cmScan:     BEGIN
                               ScanStart ('Scannerprotokoll');
                               Scan (globaleSymboltabelle);
                             END;
                 cmParse:    Parse ('Parserprotokoll');
                 cmExecute:  Execute ('Execute');
                 cmParsFlags: BEGIN
                                zeigParserFlags ('Schalter fr Parser');
                              END;
                 ELSE bearbeitet := FALSE;
               END (* CASE *);
    ELSE bearbeitet := FALSE;
  END (* CASE *);
  IF bearbeitet THEN BEGIN
    InitEreignis (Ereignis)
  END;
END (* sende *);

PROCEDURE einParser.ScanStart (CONST Titel: STRING);
VAR	d:     GLP;
        dummy: GLP;
        Eintrag: einSymtabEintragsPointer;
BEGIN
  OldTextX := TextX; OldTextY := TextY;
  { Protokoll-Text erzeugen }

  IF hatParserflag (ProtScan) OR hatParserflag (ProtPars) THEN BEGIN
    IF ProtText = NIL THEN BEGIN
      ProtText := neuesObjekt (SimpleText, []);
      einSimpleTextPointer (ProtText)^.loescheTextflag (AutoUmbruch);
      einSimpleTextPointer (ProtText)^.setzeInternFlag (istProtokollpuffer);
    END;

    { Fenster ffnen }

{zeigMeldung ('Parser.ScanStart', 'ProtText.sendNetzMessage');}
    ProtText^.sendNetzMessage (ProtText^.getFensterInhalt, evCommand, cmOeffneFormular, NIL);

{zeigMeldung ('Parser.ScanStart', 'ProtText.getFensterInhalt');}
    ProtView := einSimpleTextPointer (ProtText)^.getFensterInhalt;
{zeigMeldung ('Parser.ScanStart', 'ProtText.setTitle');}
    PMyWindow (ProtView^.Owner)^.setTitle (Titel);
    IF hatParserflag (ProtScan) OR hatParserflag (ProtPars) THEN BEGIN
{zeigMeldung ('Parser.ScanStart', 'ProtText^.TextLoeschen');}
      einSimpleTextPointer (ProtText)^.TextLoeschen;
    END (* IF *);
  END (* IF hatParserflag *);

{zeigMeldung ('Parser.ScanStart', 'Symboltabelle initialisieren');}
  IF globaleSymboltabelle <> NIL THEN BEGIN
{zeigMeldung ('Parser.ScanStart', 'Symboltabelle.Loeschpfad');}
    globaleSymboltabelle^.Loeschpfad (neuSig);
{zeigMeldung ('Parser.ScanStart', 'Symboltabelle.Done');}
    DISPOSE (globaleSymboltabelle, Done);
  END (* IF dieSymboltabelle *);

{zeigMeldung ('Parser.ScanStart', 'Symboltabelle := neuesObjekt');}

  GLP (globaleSymboltabelle) := neuesObjekt (Symtabelle, []);

  GLP (Eintrag) := globaleSymboltabelle^.InsertSymbol ('PROGRAM', ProgSym);
  GLP (Eintrag) := globaleSymboltabelle^.InsertSymbol ('METHOD', MethodSym);
  GLP (Eintrag) := globaleSymboltabelle^.InsertSymbol ('BEGIN', BeginSym);
  GLP (Eintrag) := globaleSymboltabelle^.InsertSymbol ('END', EndSym);
  GLP (Eintrag) := globaleSymboltabelle^.InsertSymbol ('CONST', ConstSym);
  GLP (Eintrag) := globaleSymboltabelle^.InsertSymbol ('VAR', VarSym);
  GLP (Eintrag) := globaleSymboltabelle^.InsertSymbol ('NOT', NotSym);
  GLP (Eintrag) := globaleSymboltabelle^.InsertSymbol ('IF', IfSym);
  GLP (Eintrag) := globaleSymboltabelle^.InsertSymbol ('THEN', ThenSym);
  GLP (Eintrag) := globaleSymboltabelle^.InsertSymbol ('EndIF', EndIfSym);
  GLP (Eintrag) := globaleSymboltabelle^.InsertSymbol ('WHILE', WhileSym);
  GLP (Eintrag) := globaleSymboltabelle^.InsertSymbol ('DO', DoSym);
  GLP (Eintrag) := globaleSymboltabelle^.InsertSymbol ('EndWHILE', EndWhileSym);
  GLP (Eintrag) := globaleSymboltabelle^.InsertSymbol ('INTEGER', IntType);
  GLP (Eintrag) := globaleSymboltabelle^.InsertSymbol ('FLOAT', FloatType);
  GLP (Eintrag) := globaleSymboltabelle^.InsertSymbol ('STRING', StringType);
  GLP (Eintrag) := globaleSymboltabelle^.InsertSymbol ('Read', ReadSym);
  GLP (Eintrag) := globaleSymboltabelle^.InsertSymbol ('Write', WriteSym);

  ScanX := 0; OldScanX := 0; ScanY := 0; OldScanY := 0;
  ch := nul;
  Token.Symbol := leer;
  d := FirstElement;
  GLP (ScanZeile) := getActual;

{zeigMeldung ('Parser.ScanStart', 'Symboltabelle fertig initialisiert');}

  IF (ScanZeile = NIL) THEN BEGIN
    Fehlermeldung ('Scannerfehler in Scanstart', 'Finde keine erste Textzeile',
                   [], leer);
    Ende := TRUE; setzeParserflag (Fehler);
  END (* IF *)
  ELSE BEGIN
    Ende := FALSE; rueckParserflag (Fehler);
  END;

  { Text scannen }

  getChar; { ein Zeichen vorausschauen - auf das erste! }
END (* ScanStart *);

PROCEDURE einParser.ProtLine;
VAR  ev: TEvent;
BEGIN
  IF ProtText <> NIL THEN BEGIN
    WITH ev DO BEGIN
      What := evCommand;
      Command := cmCr;
    END (* WITH *);
    ProtText^.sende (ProtView, ev, NeuSig);
  END
  ELSE Fehlermeldung ('Scannerfehler in Protline', 'Protokolltext ist NIL',
                      [], leer);
END (* ProtLine *);

PROCEDURE einParser.ProtChar (CONST chr: CHAR);
VAR  ev: TEvent;
BEGIN
  IF ProtText <> NIL THEN BEGIN
    WITH ev DO BEGIN
      What := evCommand;
      Command := cmWriteZch; InfoChar := chr;
    END (* WITH *);
    ProtText^.sende (ProtView, ev, NeuSig);
  END
  ELSE Fehlermeldung ('Scannerfehler in ProtChar', 'Protokolltext ist NIL',
                      [], leer);
END (* ProtChar *);

PROCEDURE einParser.ProtStr (CONST s: STRING);
VAR  ev: TEvent;
BEGIN
  IF ProtText <> NIL THEN BEGIN
    WITH ev DO BEGIN
      What := evCommand;
      Command := cmWriteText; InfoPtr := @s;
    END (* WITH *);
    ProtText^.sende (ProtView, ev, NeuSig);
  END
  ELSE Fehlermeldung ('Scannerfehler in ProtStr', 'Protokolltext ist NIL',
                      [], leer);
END (* ProtStr *);

PROCEDURE einParser.NextScanLine;
VAR     d: GLP;
BEGIN
  d := NextElement;
  IF d <> NIL THEN BEGIN
    ScanX := 0; INC (ScanY);
    IF hatParserflag (ProtScan) OR hatParserflag (ProtPars) THEN ProtLine;
    GLP (ScanZeile) := getActual;
  END
  ELSE ScanZeile := NIL;
END (* NextScanLine *);

FUNCTION einParser.StringVonSymbolSet (CONST symset: einSymbolSet): STRING;
VAR  s:   STRING;
     sym: einSymbol;
BEGIN
  s := '';
  FOR sym := leer TO StringLit DO BEGIN
    IF sym IN symset THEN
      s := s + StringVonSymbol (sym) + ', ';
  END;
  IF s <> '' THEN SYSTEM.Delete (s, LENGTH (s) - 1, 2);
  StringVonSymbolSet := s;
END (* StringVonSymbolSet *);

FUNCTION einParser.StringVonSymbol (CONST sym: einSymbol): STRING;
BEGIN
  CASE sym OF
    leer:           StringVonSymbol := 'leer';
    Semikolon:      StringVonSymbol := 'Semikolon';
    KlammAuf:       StringVonSymbol := 'KlammAuf';
    KlammZu:        StringVonSymbol := 'KlammZu';
    MultZeich:      StringVonSymbol := 'MultZeich';
    Plus:           StringVonSymbol := 'Plus';
    Komma:          StringVonSymbol := 'Komma';
    Minus:          StringVonSymbol := 'Minus';
    Punkt:          StringVonSymbol := 'Punkt';
    Doppelpunkt:    StringVonSymbol := 'Doppelpunkt';
    DivZeich:       StringVonSymbol := 'DivZeich';
    Zuweisung:      StringVonSymbol := 'Zuweisung';
    kleinergleich:  StringVonSymbol := 'kleinergleich';
    kleiner:        StringVonSymbol := 'kleiner';
    gleich:         StringVonSymbol := 'gleich';
    groessergleich: StringVonSymbol := 'groessergleich';
    groesser:       StringVonSymbol := 'groesser';
    ProgSym:        StringVonSymbol := 'ProgSym';
    MethodSym:      StringVonSymbol := 'MethodSym';
    BeginSym:       StringVonSymbol := 'BeginSym';
    EndSym:         StringVonSymbol := 'EndSym';
    ConstSym:       StringVonSymbol := 'ConstSym';
    VarSym:         StringVonSymbol := 'VarSym';
    NotSym:         StringVonSymbol := 'NotSym';
    IfSym:          StringVonSymbol := 'IfSym';
    ThenSym:        StringVonSymbol := 'ThenSym';
    EndIfSym:       StringVonSymbol := 'EndIfSym';
    WhileSym:       StringVonSymbol := 'WhileSym';
    DoSym:          StringVonSymbol := 'DoSym';
    EndWhileSym:    StringVonSymbol := 'EndWhileSym';
    IntType:        StringVonSymbol := 'IntType';
    FloatType:      StringVonSymbol := 'FloatType';
    StringType:     StringVonSymbol := 'StringType';
    ReadSym:        StringVonSymbol := 'ReadSym';
    WriteSym:       StringVonSymbol := 'WriteSym';
    Bezeichner:     StringVonSymbol := 'Bezeichner';
    MethodName:     StringVonSymbol := 'MethodName';
    Kommentar:      StringVonSymbol := 'Kommentar';
    Stringconst:    StringVonSymbol := 'Stringconst';
    StringLit:      StringVonSymbol := 'StringLit';
    Syntaxfehler:   StringVonSymbol := 'Syntaxfehler';
    IntZahl:        StringVonSymbol := 'IntZahl';
    FloatZahl:      StringVonSymbol := 'FloatZahl';
    IntConst:       StringVonSymbol := 'IntConst';
    FloatConst:     StringVonSymbol := 'FloatConst';
    IntVar:         StringVonSymbol := 'IntVar';
    StringVar:      StringVonSymbol := 'StringVar';
    FloatVar:       StringVonSymbol := 'FloatVar';
  END (* CASE *);
END (* StringVonSymbol *);

PROCEDURE einParser.WriteSymbol;
BEGIN
  WITH Token DO BEGIN
    CASE Symbol OF
      leer .. Syntaxfehler,
      IntVar, FloatVar, StringVar:
                     BEGIN
                       ProtChar ('{');
                       ProtStr (StringVonSymbol (Symbol));
                       ProtChar ('}');
                     END;
      IntZahl:       BEGIN ProtStr ('{#');
                           ProtStr (StringVonNum (IntWert));
                           ProtChar ('}');
                     END;
      IntConst:      BEGIN ProtStr ('{=');
                           ProtStr (StringVonNum (IntWert));
                           ProtChar ('}');
                     END;
      FloatZahl:     BEGIN ProtStr ('{<REAL>}');
                     END;
      FloatConst:    BEGIN ProtStr ('{<REALCONST>}');
                     END;
      Bezeichner,
      MethodName,
      StringConst:   BEGIN ProtStr ('{|');
                           ProtStr (SymString);
                           ProtStr ('|}');
                     END;
      StringLit:     BEGIN ProtStr ('{"');
                           ProtStr (SymString);
                           ProtStr ('"}');
                     END;
      ELSE           ProtStr ('>>> Scannerfehler!!! (' +
                             StringVonNum (ORD (Symbol)) + ')');
    END (* CASE *);
  END (* WITH Token *);
END (* WriteSymbol *);

PROCEDURE einParser.getChar;
BEGIN
  IF Ende THEN BEGIN ch := nul; EXIT; END;
  IF (ScanZeile <> NIL) AND (ScanX >= ScanZeile^.StringLaenge) THEN BEGIN
    NextScanLine; ch := ' '; EXIT;
  END;
  WITH ScanZeile^ DO BEGIN
    IF ScanZeile = NIL THEN BEGIN
      Ende := TRUE; EXIT;
    END;
    hole (ScanX, ch); INC (ScanX);
    IF hatParserflag (ProtScan) THEN ProtChar (ch);
  END (* WITH *);
END (* getChar *);

PROCEDURE einParser.getComment;
BEGIN
  {Es wurde die Folge "(*" gelesen}
  getChar;
  IF ch = '(' THEN BEGIN
    getChar; IF ch = '*' THEN getComment;
  END;
  REPEAT
    WHILE ch <> '*' DO BEGIN
      getChar;
      IF ch = '(' THEN BEGIN
        getChar; IF ch = '*' THEN getComment;
      END;
    END (* WHILE *);
    getChar;
  UNTIL ch = ')';
  getChar;
  Token.Symbol := Kommentar;
END (* getComment *);

PROCEDURE einParser.getString;
BEGIN
  {Es wurde ein "'" gelesen}
  getChar;
  WITH Token DO BEGIN
    SymString := '';
    WHILE (ch <> '''') AND NOT Ende DO BEGIN
      appendChar (SymString, ch); getChar;
    END;
    getChar;
    Symbol := StringLit;
  END (* WITH Token *);
END (* getString *);

PROCEDURE einParser.Number;
VAR  i:   INTEGER;
BEGIN
  WITH Token DO BEGIN
    IntWert := 0;
    WHILE ch IN ['0'..'9'] DO BEGIN
      IntWert := IntWert * 10 + ORD (ch) - ORD ('0');
      getChar;
    END (* WHILE *);
    Symbol := IntZahl;
  END (* WITH Token *);
END (* Number *);

PROCEDURE einParser.Identifier (Symtab: einSymtabellenPointer);
VAR   SymP: einSymtabEintragsPointer;
BEGIN
  SymString := '';
  WHILE ch IN ['A'..'Z', 'a'..'z', '0'..'9'] DO BEGIN
    appendChar (SymString, ch);
    getChar;
  END (* WHILE *);
{zeigMeldung ('Identifier', 'Symtab: ' + atString (Symtab));}
  GLP (SymP) := Symtab^.findeBegriff (SymString, TRUE);
  IF SymP = NIL THEN BEGIN
    Token.Symbol := Bezeichner;
    Token.BezString := NIL;
  END
  ELSE BEGIN
    Token := SymP^.Token;
    Token.BezString := SymP;
  END (* ELSE *);
END (* Identifier *);

FUNCTION einParser.getSymbol (skipKommentar: BOOLEAN;
                               Symtab: einSymtabellenPointer): BOOLEAN;
VAR  getNextChar: BOOLEAN;
     writeProt:   BOOLEAN;
BEGIN
  getSymbol := TRUE;
  WHILE ch = ' ' DO getChar;
  getNextChar := TRUE; writeProt := TRUE;
  OldScanX := ScanX; IF OldScanX > 0 THEN DEC (OldScanX);
  OldScanY := ScanY;
  WITH Token DO BEGIN
    CASE ch OF
      ';':       Symbol := Semikolon;
      '(':       BEGIN
                   getChar;
                   IF ch = '*' THEN BEGIN
                     getComment;
                     IF skipKommentar THEN BEGIN
                       getSymbol :=
                         getSymbol (TRUE, Symtab); writeProt := FALSE;
                     END;
                   END
                   ELSE Symbol := KlammAuf;
                   getNextChar := FALSE;
                 END;
      ')':       Symbol := KlammZu;
      '*':       Symbol := MultZeich;
      '+':       Symbol := Plus;
      ',':       Symbol := Komma;
      '-':       Symbol := Minus;
      '.':       Symbol := Punkt;
      '/':       Symbol := DivZeich;
      '0'..'9':  BEGIN Number; getNextChar := FALSE; END;
      ':':       BEGIN
                   getChar;
                   IF ch = '=' THEN Symbol := Zuweisung
                   ELSE BEGIN Symbol := Doppelpunkt; getNextChar := FALSE;
                   END (* IF *);
                 END;
      '<':       BEGIN
                   getChar;
                   IF ch = '=' THEN Symbol := kleinergleich
                   ELSE BEGIN Symbol := kleiner; getNextChar := FALSE;
                   END;
                 END;
      '=':       Symbol := gleich;
      '>':       BEGIN
                   getChar;
                   IF ch = '=' THEN Symbol := groessergleich
                   ELSE BEGIN Symbol := groesser; getNextChar := FALSE;
                   END (* ELSE *);
                 END;
      'A'..'Z',
      'a'..'z':  BEGIN Identifier (Symtab); getNextChar := FALSE; END;
      '''':      BEGIN getString; getNextChar := FALSE; END;
      ELSE       Symbol := leer;
    END (* CASE *);
  END (* WITH Token *);
  IF getNextChar THEN getChar;
  IF hatParserFlag (Protpars) AND writeProt THEN WriteSymbol;
  getSymbol := NOT Ende;
END (* getSymbol *);

PROCEDURE einParser.Scan ({CONST Titel: STRING;} Symtab: einSymtabellenPointer);
BEGIN
{zeigMeldung ('Parser.Scan', 'ScanStart:');}
  {ScanStart (Titel);}

  WHILE NOT Ende DO BEGIN
    {getChar; WriteChar;}
{zeigMeldung ('Parser.Scan', 'getSymbol:');}
    IF NOT getSymbol (FALSE, Symtab) THEN Break;
  END (* WHILE *);
  IF NOT (hatParserFlag (ProtScan) OR hatParserFlag (ProtPars)) THEN
    Fehlermeldung ('Scanner', 'ohne Protokoll - Fertig', [], leer);
END (* Scan *);

PROCEDURE einParser.Parse;

  FUNCTION failSymbol (CONST Struktur: STRING; CONST dogetSym: BOOLEAN;
                       CONST symbols: einSymbolSet;
                       Symtab: einSymtabellenPointer): BOOLEAN;
  BEGIN
    WITH Token DO BEGIN
      IF dogetSym THEN BEGIN
         IF NOT GetSymbol (TRUE, Symtab) THEN BEGIN
           failSymbol := TRUE; EXIT;
         END (* IF *);
      END (* IF *);
      IF NOT (Symbol IN symbols) THEN BEGIN
        Fehlermeldung ('Syntaxfehler in ' + Struktur, '', symbols, Symbol);
        failSymbol := TRUE;
      END
      ELSE failSymbol := FALSE;
    END (* WITH *);
  END (* failSymbol *);

  PROCEDURE getProgram (Symtab: GLP);
  VAR  ProgName: STRING;

    PROCEDURE getBlock (Symtab: einSymtabellenPointer;
                        CONST Blockname: STRING);
    FORWARD;

    PROCEDURE getConstDeclaration (Symtab: einSymtabellenPointer);
    VAR Konstante: einSymtabEintragsPointer;
        Name:      STRING;
    BEGIN (* getConstDeclaration *)
      WITH Token DO BEGIN
        Name := SymString;
        IF NOT ((Symbol = Bezeichner) OR
                ((Symbol IN Wortsymbole) AND
                 (Symtab^.findeSymbol (SymString, TRUE) = NIL)
               )) THEN BEGIN
          Fehlermeldung ('<ConstDeklaration>',
                         '{' + StringVonSymbol (Symbol) +
                         '} ist kein erlaubter Konstantenname oder lokal schon vergeben.',
                          [], leer);
          EXIT;
        END (* IF kein Bezeichner oder lokal verwendet *);
        IF failSymbol ('CONST =', TRUE, [gleich], Symtab) THEN EXIT;
        IF failSymbol ('CONST = <Zahl>', TRUE, [IntZahl, StringLit], Symtab) THEN EXIT;

        CASE Symbol OF
          IntZahl: BEGIN
                     GLP (Konstante) := Symtab^.InsertSymbol (Name, IntConst);
                     Konstante^.Token.Intwert := Intwert;
                   END;
          StringLit: BEGIN
                     GLP (Konstante) := Symtab^.InsertSymbol (Name, StringConst);
                     Konstante^.Token.SConst := NewStr (SymString);
                     END;
        END (* CASE *);
      END (* WITH *);
      IF failSymbol ('<ConstDecl> ... ;', TRUE, [Semikolon], Symtab) THEN EXIT;
    END (* getConstDeclaration *);

    PROCEDURE getVarDeclaration (Symtab: einSymtabellenPointer);
    VAR Variable: einSymtabEintragsPointer;
        Name:     STRING;
    BEGIN (* getVarDeclaration *)
      WITH Token DO BEGIN
        Name := SymString;
        IF NOT ((Symbol = Bezeichner) OR
                ((Symbol IN Wortsymbole) AND
                 (Symtab^.findeSymbol (SymString, TRUE) = NIL)
               )) THEN BEGIN
          Fehlermeldung ('<VarDeklaration>',
                         '{' + StringVonSymbol (Symbol) +
                         '} ist kein erlaubter Variablenname oder lokal schon vergeben.',
                         [], leer);
          EXIT;
        END (* IF kein Bezeichner oder lokal verwendet *);
        IF failSymbol ('VAR <n>: ', TRUE, [Doppelpunkt], Symtab) THEN EXIT;
        IF NOT GetSymbol (TRUE, Symtab) THEN EXIT;
        IF NOT (Symbol IN Typsymbole) THEN BEGIN
          Fehlermeldung ('<VarTyp>',
                         '{' + StringVonSymbol (Symbol) +
                         '} ist kein erlaubter Variablentyp.', [], leer);
          EXIT;
        END (* IF NOT Typbezeichner *);
        CASE Symbol OF
          IntType:     GLP (Variable) := Symtab^.InsertSymbol (Name, IntVar);
          FloatType:   GLP (Variable) := Symtab^.InsertSymbol (Name, FloatVar);
          StringType:  GLP (Variable) := Symtab^.InsertSymbol (Name, StringVar);
          ELSE         Fehlermeldung ('<VarTyp>', 'Interner Fehler in Variablentyp',
                                      [], leer);
                       EXIT;
        END (* CASE *);
      END (* WITH *);
      IF failSymbol ('<VarDecl> ... ;', TRUE, [Semikolon], Symtab) THEN EXIT;
    END (* getVarDeclaration *);

    PROCEDURE getMethod (Symtab: einSymtabellenPointer);
    VAR  Methodenname: String;
         LokalSymtab:  einSymtabellenPointer;
         MethodSym:    einSymtabEintragsPointer;

      PROCEDURE doExit;
      BEGIN
        LokalSymtab^.LoeschPfad (neuSig);
        DISPOSE (LokalSymtab, Done);
      END (* doExit *);

    BEGIN (* getMethod *)
      GLP (LokalSymtab) := neuesObjekt (Symtabelle, []);
      LokalSymtab^.AeussererLevel := Symtab;
      WITH Token DO BEGIN
        IF failSymbol ('<Methodenname>', TRUE, [Bezeichner], Symtab) THEN BEGIN
          doExit; EXIT;
        END (* IF *);
        Methodenname := SymString; (* Methodenname merken *)
        Symbol := MethodName;
        IF failSymbol ('; nach Methodenname', TRUE, [Semikolon], Symtab) THEN BEGIN
          doExit; EXIT;
        END (* IF *);
        GLP (MethodSym) := Symtab^.InsertSymbol (MethodenName, MethodName);

        getBlock (LokalSymtab, Methodenname);
        IF Ende THEN BEGIN doExit; EXIT; END;
        IF failSymbol ('END <Methodenname>', TRUE, [MethodName], Symtab) THEN BEGIN
          doExit; EXIT;
        END (* IF *);
        IF Methodenname <> SymString THEN BEGIN
          Fehlermeldung ('Methodenname nach END',
            'gefundener Name "' + SymString + '" ungleich "' +
            Methodenname + '"', [], leer);
          doExit; EXIT;
        END (* IF *);
        IF failSymbol ('; nach END <Methodenname>', TRUE, [Semikolon], Symtab) THEN BEGIN
          doExit; EXIT;
        END (* IF *);
      END (* WITH Token *);
    END (* getMethod *);

    PROCEDURE getExpression (Symtab: einSymtabellenPointer; ExpType: einSymbol);

      PROCEDURE getFactor;
      BEGIN
        IF hatParserFlag (ProtPars) THEN ProtStr ('<Factor>');
        WITH Token DO BEGIN
          CASE Symbol OF
            IntVar, IntConst, IntZahl:
                        BEGIN
                          IF ExpType <> IntType THEN BEGIN
                            Fehlermeldung ('<IntFactor>', 'Typ {' + StringVonSymbol (Symbol)
                              + '} nicht mit <' + StringVonSymbol (ExpType) +
                              '> kompatibel', [], leer);
                            EXIT;
                          END (* IF *);
                          IF NOT getSymbol (TRUE, Symtab) THEN EXIT;
                        END;
            StringVar, StringConst, StringLit:
                        BEGIN
                          IF ExpType <> StringType THEN BEGIN
                            Fehlermeldung ('<StringFactor>', 'Typ {' + StringVonSymbol (Symbol)
                              + '} nicht mit <' + StringVonSymbol (ExpType) +
                              '> kompatibel', [], leer);
                            EXIT;
                          END (* IF *);
                          IF NOT getSymbol (TRUE, Symtab) THEN EXIT;
                        END;
            KlammAuf:   BEGIN
                          getExpression (Symtab, ExpType);
                          IF failSymbol ('<Factor>', FALSE, [KlammZu], Symtab)
                            THEN EXIT;
                          IF NOT getSymbol (TRUE, Symtab) THEN EXIT;
                        END;
            ELSE        Fehlermeldung ('<Factor>', 'Symbol {' + StringVonSymbol (Symbol)
                                    + '} hier nicht erlaubt.', [], leer);
          END (* CASE Symbol *);
        END (* WITH *);
      END (* getFactor *);

      PROCEDURE getTerm;
      BEGIN
        IF hatParserFlag (ProtPars) THEN ProtStr ('<Term>');
        WITH Token DO BEGIN
          getFactor;
          IF Ende THEN EXIT;
          WHILE Symbol IN [MultZeich, DivZeich] DO BEGIN
            IF NOT GetSymbol (TRUE, Symtab) THEN EXIT;
            getFactor;
            IF Ende THEN EXIT;
          END (* WHILE *);
        END (* WITH *);
      END (* getTerm *);

    BEGIN (* getExpression *)
      IF hatParserFlag (ProtPars) THEN ProtStr ('<Expression>');
      WITH Token DO BEGIN
        IF Symbol IN [Plus, Minus] THEN BEGIN
          IF NOT getSymbol (TRUE, Symtab) THEN EXIT;
          getTerm;
          IF Ende THEN EXIT;
        END
        ELSE getTerm;
        IF Ende THEN EXIT;
        WHILE Symbol IN [Plus, Minus] DO BEGIN
          IF NOT getSymbol (TRUE, Symtab) THEN EXIT;
          getTerm;
          IF Ende THEN EXIT;
        END;
      END (* WITH *);
    END (* getExpression *);

    PROCEDURE getCall (Symtab: einSymtabellenPointer);
    BEGIN
      IF failSymbol ('<Methodenaufruf>', TRUE, [Semikolon], Symtab) THEN EXIT;
    END (* getCall *);

    PROCEDURE getCondition (Symtab: einSymtabellenPointer; ExpType: einSymbol);
    BEGIN
      IF hatParserFlag (ProtPars) THEN ProtStr ('<Condition>');
      IF NOT getSymbol (TRUE, Symtab) THEN EXIT;
      WITH Token DO BEGIN
        IF Symbol = NotSym THEN BEGIN
          IF NOT getSymbol (TRUE, Symtab) THEN EXIT;
          getExpression (Symtab, ExpType);
          IF Ende THEN Exit;
        END
        ELSE BEGIN
          getExpression (Symtab, ExpType);
          IF Ende THEN Exit;
          IF Symbol IN [kleinergleich .. groesser] THEN BEGIN
            IF NOT getSymbol (TRUE, Symtab) THEN EXIT;
            getExpression (Symtab, ExpType);
          END
          ELSE
            Fehlermeldung ('<Expression> <|<=|=|>=|<>',
                           'Relation erwartet, aber {' +
                           StringVonSymbol (Symbol) +
                           '} gefunden.', [], leer);
        END (* ELSE nicht verneint *);
      END (* WITH *);
    END (* getCondition *);

    PROCEDURE getStatement (Symtab: einSymtabellenPointer);
    BEGIN
      IF hatParserFlag (ProtPars) THEN ProtStr ('<Statement>');
      WITH Token DO BEGIN
        CASE Symbol OF
          IntVar:     BEGIN
                        IF failSymbol ('<getStatement> :=', TRUE, [Zuweisung], Symtab)
                          THEN EXIT;
                        IF NOT getSymbol (TRUE, Symtab) THEN EXIT;
                        getExpression (Symtab, IntType);
                      END;
          StringVar:  BEGIN
                        IF failSymbol ('<getStatement> :=', TRUE, [Zuweisung], Symtab)
                          THEN EXIT;
                        IF NOT getSymbol (TRUE, Symtab) THEN EXIT;
                        getExpression (Symtab, StringType);
                      END;
          MethodName: BEGIN
                        getCall (Symtab);
                      END;
          IfSym:      BEGIN
                        getCondition (Symtab, IntType);
                        IF Ende THEN EXIT;
                        IF failSymbol ('IF <Bed> <THEN>', FALSE, [ThenSym], Symtab)
                          THEN EXIT;
                        IF NOT getSymbol (TRUE, Symtab) THEN EXIT;
                        WHILE NOT (Symbol = EndIfSym) DO BEGIN
                          getStatement (Symtab);
                          IF Ende THEN EXIT;
                          IF NOT getSymbol (TRUE, Symtab) THEN EXIT;
                          IF NOT (Symbol IN [IntVar, MethodName, IfSym, WhileSym, EndIfSym])
                            THEN Fehlermeldung ('<IF>...',
                              'Anweisung oder EndIF erwartet, aber {' +
                              StringVonSymbol (Symbol) + '} gefunden.', [], leer);
                        END (* WHILE *);
                        IF failSymbol ('IF <Bed> THEN <...> EndIF', FALSE, [EndIfSym], Symtab)
                          THEN Exit;
                        IF Ende THEN EXIT;
                        IF NOT getSymbol (TRUE, Symtab) THEN EXIT;
                      END (* IfSym *);
          WhileSym:   BEGIN
                        getCondition (Symtab, IntType);
                        IF Ende THEN EXIT;
                        IF failSymbol ('WHILE <Bed> <DO>', FALSE, [DoSym], Symtab)
                          THEN EXIT;
                        IF NOT getSymbol (TRUE, Symtab) THEN EXIT;
                        WHILE NOT ((Symbol = EndWhileSym) {OR Ende}) DO BEGIN
                          getStatement (Symtab);
                          IF Ende THEN Exit;
                          IF NOT getSymbol (TRUE, Symtab) THEN EXIT;
                          IF NOT (Symbol IN [IntVar, MethodName, IfSym, WhileSym, EndWhileSym])
                            THEN Fehlermeldung ('<IF>...',
                              'Anweisung oder EndWHILE erwartet, aber {' +
                              StringVonSymbol (Symbol) + '} gefunden.', [], leer);
                        END (* WHILE *);
                        IF Ende THEN Exit;
                        IF failSymbol ('WHILE <Bed> DO <...> EndWHILE', FALSE,
                                       [EndWhileSym], Symtab)
                          THEN Exit;
                        IF Ende THEN EXIT;
                        IF NOT getSymbol (TRUE, Symtab) THEN EXIT;
                      END (* WhileSym *);
          ELSE
            IF Ende THEN Exit;
            Fehlermeldung ('Statement', StringVonSymbolset ([IntVar, StringVar, MethodName,
                            IfSym, WhileSym]) +
                           ' erwartet, aber {' +
                           StringVonSymbol (Symbol) + '} gefunden.', [], leer);
            EXIT;
        END (* CASE Symbol *);
        IF Ende THEN EXIT;
        IF failSymbol ('<Statement>;', FALSE, [Semikolon], Symtab) THEN EXIT;
      END (* WITH *);
    END (* getStatement *);

    PROCEDURE getBlock (Symtab: einSymtabellenPointer;
                        CONST Blockname: STRING);
    BEGIN (* getBlock *)
      WITH Token DO BEGIN
        IF NOT GetSymbol (TRUE, Symtab) THEN EXIT;

        IF Symbol = ConstSym THEN BEGIN
          IF NOT GetSymbol (TRUE, Symtab) THEN EXIT;
          getConstDeclaration (Symtab);
          IF Ende THEN Exit;
          IF NOT GetSymbol (TRUE, Symtab) THEN EXIT;
          WHILE Symbol IN Wortsymbole DO BEGIN
            getConstDeclaration (Symtab);
            IF Ende THEN Exit;
            IF NOT GetSymbol (TRUE, Symtab) THEN EXIT;
          END (* WHILE *);
        END (* IF *);

        IF Symbol = VarSym THEN BEGIN
          IF NOT getSymbol (TRUE, Symtab) THEN EXIT;
          getVarDeclaration (Symtab);
          IF Ende THEN Exit;
          IF NOT GetSymbol (TRUE, Symtab) THEN EXIT;
          WHILE Symbol IN Wortsymbole DO BEGIN
            getVarDeclaration (Symtab);
            IF Ende THEN EXIT;
            IF NOT GetSymbol (TRUE, Symtab) THEN EXIT;
          END (* WHILE *);
        END (* IF varSym *);

        WHILE Symbol = MethodSym DO BEGIN
          getMethod (Symtab);
          IF Ende THEN EXIT;
          IF NOT GetSymbol (TRUE, Symtab) THEN EXIT;
        END (* WHILE *);

        IF failSymbol ('Block <BEGIN>', FALSE, [BeginSym], Symtab)
          THEN EXIT;
        IF NOT getSymbol (TRUE, Symtab) THEN EXIT;
        IF (SymString = Blockname) THEN BEGIN
          IF failSymbol ('<Blockname>;', TRUE, [Semikolon], Symtab) THEN EXIT;
          IF NOT getSymbol (TRUE, Symtab) THEN EXIT;
        END (* IF Blockname nach BEGIN *);
        WHILE NOT (Symbol = EndSym) AND NOT Ende DO BEGIN
          getStatement (Symtab);
          IF Ende THEN EXIT;
          IF NOT getSymbol (TRUE, Symtab) THEN EXIT;
        END (* WHILE *);
      END (* WITH Token *);
    END (* getBlock *);

  BEGIN (* getProgram *)
    IF Ende THEN EXIT;

    WITH Token DO BEGIN
      IF failSymbol ('PROGRAM', TRUE, [ProgSym], globaleSymboltabelle)
        THEN EXIT;
      IF failSymbol ('<Programmname>', TRUE, [Bezeichner], globaleSymboltabelle)
        THEN EXIT;
      Progname := SymString; (* Programmname merken *)
      IF failSymbol ('; nach Programmname', TRUE, [Semikolon], globaleSymboltabelle)
        THEN EXIT;

      getBlock (globaleSymboltabelle, Progname);
      IF Ende THEN EXIT;

      IF failSymbol ('END <Programmname>', TRUE, [Bezeichner], globaleSymboltabelle)
        THEN EXIT;
      IF Progname <> SymString THEN BEGIN
        Fehlermeldung ('Programname nach END',
          'gefundener Name "' + SymString + '" ungleich "' +
          Progname + '"', [], leer);
        EXIT;
      END (* IF *);

      IF failSymbol ('. nach END <Programmname>', TRUE, [Punkt], globaleSymboltabelle)
        THEN EXIT;
    END (* WITH Token *);
  END (* getProgram *);

BEGIN (* Parse *)
  ScanStart (Titel);

  getProgram (globaleSymboltabelle);

  IF NOT (hatParserFlag (ProtScan) OR hatParserFlag (ProtPars)
          OR Ende) THEN
    zeigMeldung ('Parser', 'ohne Protokoll - Fertig');
  IF NOT hatParserflag (Fehler) THEN BEGIN
    zurZeile (OldTextY); TextX := OldTextX;
    zeigFenster (derFensterInhalt, 0, 0, 0, 0, TRUE);
  END (* IF *);
END (* Parse *);

PROCEDURE einParser.Execute;
BEGIN
  Parse (Titel);
END (* Execute *);

PROCEDURE einParser.Fehlermeldung (CONST Titel: STRING; Meldung: STRING;
                                   erwartet: einSymbolSet;
                                   gefunden: einSymbol);
VAR  dummyg: GLP;
BEGIN
  IF Meldung = '' THEN BEGIN
    Meldung := '{' + StringVonSymbolSet (erwartet) + '} erwartet, aber {' +
               StringVonSymbol (gefunden) + '}';
    IF gefunden IN WortSymbole THEN
      Meldung := Meldung + ' "' + SymString + '"';
    Meldung := Meldung + ' gefunden.';
  END (* IF *);
  zeigMeldung (Titel, Meldung);
  Ende := TRUE; setzeParserflag (Fehler);
  zurZeile (ScanY); TextX := OldScanX;
  zeigFenster (derFensterInhalt, 0, 0, 0, 0, TRUE);
  dummyg := Edit (derFensterInhalt, 0, 0, 0, 0, NIL);
END (* Fehlermeldung *);

PROCEDURE einParser.InitMenu (VAR dieMenuLeiste: GLP);
VAR  Eintrag:         GLP;
     dasMenu:         einTVMenuPointer;

BEGIN
  dieMenuLeiste := neuesObjekt (Liste, []);

  (******* Dateimen *******)

  GLP (dasMenu) := neuesObjekt (TVMenu, []);
  WITH dasMenu^ DO BEGIN
    insertTextUndCode ('~D~atei',                      '',         kbNoKey,   cmNothing, hcNoContext);
    insertTextUndCode ('~T~ext laden',                 'Shift-F1', kbShiftF1, cmTextLaden, hcNoContext);
    insertTextUndCode ('~B~lock aus Datei laden',      '',         kbNoKey,   cmBlockLaden, hcNoContext);
    insertTextUndCode ('~S~peichere Text',             'F2',       kbF2,      cmReport, hcNoContext);
    insertTextUndCode ('~M~arkierten Block speichern', '',         kbNoKey,   cmNothing, hcNoContext);
    insertTextUndCode ('~F~ilter fr Texte Laden',     '',         kbNoKey,   cmTexteLaden, hcNoContext);
    insertTextUndCode ('-',                            '',         kbNoKey,   cmNothing, hcNoContext);
    insertTextUndCode ('Text drucken',                 '',         kbNoKey,   cmTextDrucken, hcNoContext);
    insertTextUndCode ('Text lschen',                 '',         kbNoKey,   cmTextLoeschen, hcNoContext);
    insertTextUndCode ('-',                            '',         kbNoKey,   cmNothing, hcNoContext);
    insertTextUndCode ('~V~erzeichnis ndern',         'Alt-V',    kbAltV,    cmChangeDir, hcNoContext);
  END (* WITH *);
  Eintrag := einListenPointer (dieMenuLeiste)^.InsertAfter (dasMenu);

  (* Edit-Men *)

  GLP (dasMenu) := neuesObjekt (TVMenu, []);
  WITH dasMenu^ DO BEGIN
    insertTextUndCode ('~E~ditieren',                '',      kbNoKey,   cmNothing, hcNoContext);
    insertTextUndCode ('~~berschreiben umschalten', 'Einfg', kbNoKey,   cmToggleInsert, hcNoContext);
    insertTextUndCode ('Text (Umbruch)',             '',      kbNoKey,   cmEditTextmodus, hcNoContext);
    insertTextUndCode ('Programm (Autoindent)',      '',      kbNoKey,   cmEditProgrammmodus, hcNoContext);
    insertTextUndCode ('~A~nfang Block setzen',      '^KB',   kbNoKey,   cmEditSetBlockBegin, hcNoContext);
    insertTextUndCode ('~E~nde Block setzen',        '^KK',   kbNoKey,   cmEditSetBlockEnd, hcNoContext);
    insertTextUndCode ('Marke setzen 0-9',           '^K0-9', kbNoKey,   cmEditSet0, hcNoContext);
    insertTextUndCode ('-',                          '',      kbNoKey,   cmNothing, hcNoContext);
    insertTextUndCode ('Zeile lschen',              '^Y',    kbNoKey,   cmEditLoeschZeile, hcNoContext);
    insertTextUndCode ('Undo-Zeilenlschen',         '^U',    kbNoKey,   cmEditUndoLoeschZeile, hcNoContext);
    insertTextUndCode ('~U~ndopuffer editieren',     '',      kbAltU,    cmEditUndo, hcNoContext);
    insertTextUndCode ('-',                          '',      kbNoKey,   cmNothing, hcNoContext);
    insertTextUndCode ('Absatzumbruch',              '^B',    kbNoKey,   cmEditUmbruch, hcNoContext);
  END (* WITH *);
  Eintrag := einListenPointer (dieMenuLeiste)^.InsertAfter (dasMenu);

  (* Cursormen *)

  GLP (dasMenu) := neuesObjekt (TVMenu, []);
  WITH dasMenu^ DO BEGIN
    insertTextUndCode ('~C~ursor',                 '',           kbNoKey,  cmNothing, hcNoContext);
    insertTextUndCode ('Zeilenanfang',             'Pos1',       kbHome,   cmEditHome, hcNoContext);
    insertTextUndCode ('Zeilenende',               'Ende',       kbEnd,    cmEditEnd, hcNoContext);
    insertTextUndCode ('oberste Fensterzeile',     'Bild^',      kbPgUp,   cmEditPgUp, hcNoContext);
    insertTextUndCode ('unterste Fensterzeile',    'Bildv',      kbPgDn,   cmEditPgDown, hcNoContext);
    insertTextUndCode ('Wortanfang',               'Ctrl <-',    kbCtrlLeft, cmEditWortanfang, hcNoContext);
    insertTextUndCode ('Wortende',                 'Ctrl ->',    kbCtrlRight, cmEditWortende, hcNoContext);
    insertTextUndCode ('Absatz-Anfang',            'Ctrl-Pos1',  kbCtrlHome, cmEditCtrlHome, hcNoContext);
    insertTextUndCode ('Absatz-Ende',              'Ctrl-Ende',  kbCtrlEnd, cmEditCtrlEnd, hcNoContext);
    insertTextUndCode ('Textanfang',               'Ctrl-Bild^', kbCtrlPgUp, cmEditCtrlPgUp, hcNoContext);
    insertTextUndCode ('Textende',                 'Ctrl-Bildv', kbCtrlPgDn, cmEditCtrlPgDown, hcNoContext);
  END (* WITH *);
  Eintrag := einListenPointer (dieMenuLeiste)^.InsertAfter (dasMenu);

  (* Merkermen *)

  GLP (dasMenu) := neuesObjekt (TVMenu, []);
  WITH dasMenu^ DO BEGIN
    insertTextUndCode ('~M~arken',                 '',           kbNoKey,  cmNothing, hcNoContext);
    insertTextUndCode ('Blockanfang',              '^QB',        kbNoKey,  cmEditToBlockBegin, hcNoContext);
    insertTextUndCode ('Blockende',                '^QK',        kbNoKey,  cmEditToBlockEnd, hcNoContext);
    insertTextUndCode ('Alte Editposition',        '^QP',        kbNoKey,  cmEditToAltePos, hcNoContext);
    insertTextUndCode ('Merker 0',                 '^Q0',        kbNoKey,  cmEditTo0, hcNoContext);
    insertTextUndCode ('Merker 1',                 '^Q1',        kbNoKey,  cmEditTo1, hcNoContext);
    insertTextUndCode ('Merker 2',                 '^Q2',        kbNoKey,  cmEditTo2, hcNoContext);
    insertTextUndCode ('Merker 3',                 '^Q3',        kbNoKey,  cmEditTo3, hcNoContext);
    insertTextUndCode ('Merker 4',                 '^Q4',        kbNoKey,  cmEditTo4, hcNoContext);
    insertTextUndCode ('Merker 5',                 '^Q5',        kbNoKey,  cmEditTo5, hcNoContext);
    insertTextUndCode ('Merker 6',                 '^Q6',        kbNoKey,  cmEditTo6, hcNoContext);
    insertTextUndCode ('Merker 7',                 '^Q7',        kbNoKey,  cmEditTo7, hcNoContext);
    insertTextUndCode ('Merker 8',                 '^Q8',        kbNoKey,  cmEditTo8, hcNoContext);
    insertTextUndCode ('Merker 9',                 '^Q9',        kbNoKey,  cmEditTo9, hcNoContext);
    insertTextUndCode ('UpdateMerker',             '',           kbNoKey,  cmUpdateMerker, hcNoContext);
  END (* WITH *);
  Eintrag := einListenPointer (dieMenuLeiste)^.InsertAfter (dasMenu);

  (* Suchmen *)

  GLP (dasMenu) := neuesObjekt (TVMenu, []);
  WITH dasMenu^ DO BEGIN
    insertTextUndCode ('~S~uchen',      '',         kbNoKey,  cmNothing, hcNoContext);
    insertTextUndCode ('~B~egriff suchen',         '^QF',      kbNoKey,  cmStringSuchen, hcNoContext);
    insertTextUndCode ('~N~ochmal suchen',         '^L',       kbNoKey,  cmNochmalSuchen, hcNoContext);
    insertTextUndCode ('~A~ustauschen',            '^QA',      kbNoKey,  cmStringTauschen, hcNoContext);
    insertTextUndCode ('N~o~chmal tauschen',       '^O',       kbNoKey,  cmNochmalTauschen, hcNoContext);
    insertTextUndCode ('Rot-13',                   'Alt-R',    kbAltR,   cmEditRot13, hcNoContext);
    insertTextUndCode ('Krypt',                    'Alt-K',    kbAltK,   cmEditKrypt, hcNoContext);
  END (* WITH *);
  Eintrag := einListenPointer (dieMenuLeiste)^.InsertAfter (dasMenu);

  (* Medusa *)

  GLP (dasMenu) := neuesObjekt (TVMenu, []);
  WITH dasMenu^ DO BEGIN
    insertTextUndCode ('~M~edusa',                 '',         kbNoKey,  cmNothing, hcNoContext);
    insertTextUndCode ('~P~arser',                 '',         kbNoKey,  cmParse, hcNoContext);
    insertTextUndCode ('~A~usfhren',              '',         kbNoKey,  cmExecute, hcNoContext);
    insertTextUndCode ('~S~canner starten',        '',         kbNoKey,  cmScan, hcNoContext);
  END (* WITH *);
  Eintrag := einListenPointer (dieMenuLeiste)^.InsertAfter (dasMenu);

  (* Fenstermen *)

  GLP (dasMenu) := neuesObjekt (TVMenu, []);
  WITH dasMenu^ DO BEGIN
    insertTextUndCode ('~F~enster',                  '',        kbNoKey,  cmNothing, hcNoContext);
    insertTextUndCode ('~W~hle Fenster',            'rechte Maust., Alt-0',  kbAlt0,  cmWindowBrowse, hcNoContext);
    insertTextUndCode ('Textschalter',               'Ctrl-F8', kbCtrlF8, cmTextFlags, hcNoContext);
    insertTextUndCode ('Parserschalter',             '',        kbNoKey,  cmParsFlags, hcNoContext);
    insertTextUndCode ('Objektschalter',             '',        kbCtrlF8, cmFlags, hcNoContext);
    insertTextUndCode ('Monitor-Fenster',            'Alt-F9',  kbAltF9, cmMonitor, hcNoContext);
    insertTextUndCode ('-',                          '',        kbNoKey, cmNothing, hcNoContext);
    insertTextUndCode ('Schlieen',                  'Alt-C',   kbAltC,  cmClose, hcNoContext);
    insertTextUndCode ('~N~chstes',                 'Alt-N',   kbAltN,  cmNext, hcNoContext);
    insertTextUndCode ('~V~origes',                  'Alt-V',   kbAltV,  cmPrev, hcNoContext);
    insertTextUndCode ('-',                          '',        kbNoKey, cmNothing, hcNoContext);
    insertTextUndCode ('~Z~oom',                     'Alt-Z',   kbAltZ,  cmZoom, hcNoContext);
    insertTextUndCOde ('~R~esize',                   'Alt-R',   kbAltR,  cmResize, hcNoContext);
    insertTextUndCode ('Stapeln',                    '',        kbNoKey, cmCascade, hcNoContext);
    insertTextUndCode ('Nebeneinander',              '',        kbNoKey, cmTile, hcNoContext);
  END (* WITH *);
  Eintrag := einListenPointer (dieMenuLeiste)^.InsertAfter (dasMenu);
END (* InitMenu *);

BEGIN
END (* MEDUSA *).