UNIT ObjStrings;

{$F+}
{$O+}

(* (C) 1990, 91, 92, 93, 94, 95 by Johannes Leckebusch
   Version: 2.926
   Anpassung an TP: 8. 12. 90
   Stand: 07. 02. 95
*)

INTERFACE

USES Drivers, GLFTypes, GLFBase, GLFStructures, GLFNodes, {My}Views;

TYPE

  eineZeichentabelle =  ARRAY [Low (CHAR)..High (CHAR)] OF WORD;
  (* Tabelle fr die Zeichenposition im String (von hinten) *)

  einStringPointer = ^einString;
  einString = OBJECT (eineStruktur)
                CONSTRUCTOR Init (CONST xflags: einFlagSet);
                DESTRUCTOR Done; VIRTUAL;

                DESTRUCTOR DoneCluster; VIRTUAL;

                FUNCTION erzeugeMich (CONST xflags: einFlagSet): GLP; VIRTUAL;

                FUNCTION isSubclass (CONST class: einGenTyp): BOOLEAN; VIRTUAL;
                FUNCTION StringLaenge: WORD; VIRTUAL;
                PROCEDURE fuegeZchEin (CONST ind: WORD; CONST ch: CHAR); VIRTUAL;
                PROCEDURE entferneZch (CONST ind: WORD); VIRTUAL;
                PROCEDURE setzeZch (CONST ind: WORD; CONST ch: CHAR); VIRTUAL;
                FUNCTION holeZch (CONST ind: WORD): CHAR; VIRTUAL;
                PROCEDURE setzeString (CONST s; CONST dynamisch: BOOLEAN); VIRTUAL;
                PROCEDURE holeString (VAR s); VIRTUAL;
                PROCEDURE setzeText (CONST s: STRING; CONST dynamisch: BOOLEAN); VIRTUAL;
                PROCEDURE holeText (VAR s: STRING); VIRTUAL;
                PROCEDURE kopiereText (VAR s: STRING; CONST Start, Anzahl: WORD);
                  VIRTUAL;
                FUNCTION Cap (CONST gk: BOOLEAN; CONST ch: CHAR): CHAR;
                PROCEDURE Caps (VAR s: STRING);
                PROCEDURE macheSuchtabelle (VAR t: eineZeichentabelle;
                                            VAR Suchbegriff: STRING;
                                            CONST grosskleinEgal: BOOLEAN);
                FUNCTION SPos (CONST start: INTEGER; CONST Suchstr: STRING;
                               CONST Tabelle: eineZeichentabelle;
                               CONST gk, wort: BOOLEAN;
                               CONST dieZeichen: ChSet): INTEGER;
                  VIRTUAL;
                FUNCTION Scan (CONST dieZeichen: ChSet; Start: WORD): WORD;
                  VIRTUAL;
                FUNCTION backScan (CONST dieZeichen: ChSet; Start: WORD): WORD;
                  VIRTUAL;
                PROCEDURE extractText (VAR s: STRING; bis: WORD);
                  VIRTUAL;
                PROCEDURE splitText (VAR s: STRING; CONST Start: WORD);
                  VIRTUAL;
                PROCEDURE deleteText (VAR s: STRING; CONST Start: WORD; Anzahl: WORD);
                  VIRTUAL;
                PROCEDURE anhText (CONST s: STRING); VIRTUAL;
                PROCEDURE einfText (CONST s: STRING; CONST Start: WORD); VIRTUAL;
                PROCEDURE cutText (CONST cutIndex: WORD); VIRTUAL;
                PROCEDURE checkEndBlanks; VIRTUAL;
                FUNCTION AbsatzEnde (CONST Endlos, Blankkennung: BOOLEAN;
                                     CONST AbsKenn: CHSet): BOOLEAN; VIRTUAL;
                FUNCTION StringVonDaten: STRING; VIRTUAL;
                FUNCTION StrLaenge: WORD; VIRTUAL;
                PROCEDURE schreib (CONST view: PBuffText; CONST bs, be: INTEGER); VIRTUAL;
                PROCEDURE OffsetSchreib (CONST view: PBuffText;
                           CONST x: WORD;
                           CONST y: LONGINT;
                           CONST offs: WORD; CONST bs, be: INTEGER;
                           CONST zeigZeilenEnde: BOOLEAN;
                           CONST zeigTextEnde: BOOLEAN); VIRTUAL;
                PROCEDURE WriteReport (VAR Datei: ASCII; CONST formatieren: BOOLEAN;
                                       CONST zeilenAufSeite: WORD;
                                       VAR seite, zeile, xpos: WORD;
                                       CONST endlos, kennung: BOOLEAN;
                                       CONST Filter: PeinDruckerFilter;
                                       CONST Pref, Suff: CHAR;
                                       CONST AbsKenn: CHSet);
                  VIRTUAL;
                PROCEDURE Rot13; VIRTUAL;
                PROCEDURE Krypt; VIRTUAL;
              END (* einString *);

  einString8Pointer = ^einString8;
  einString8 = OBJECT (einString)
                AnzahlElemente: BYTE;
                derString:      StringPointer;

                CONSTRUCTOR Init (CONST xflags: einFlagSet);
                Destructor Done; VIRTUAL;
                FUNCTION isAbstract: BOOLEAN; VIRTUAL;
                FUNCTION erzeugeMich (CONST xflags: einFlagSet): GLP; VIRTUAL;

                FUNCTION isSubclass (CONST class: einGenTyp): BOOLEAN; VIRTUAL;
                FUNCTION StringLaenge: WORD; VIRTUAL;
                FUNCTION LaengeIst: LONGINT; VIRTUAL;
                FUNCTION SPos (CONST start: INTEGER; CONST Suchstr: STRING;
                               CONST Tabelle: eineZeichentabelle;
                               CONST gk, wort: BOOLEAN;
                               CONST dieZeichen: ChSet): INTEGER;
                  VIRTUAL;
                PROCEDURE allocVektor (CONST anzahl); VIRTUAL;
                PROCEDURE deallocVektor; VIRTUAL;
                PROCEDURE resizeVektor (CONST anzahl); VIRTUAL;
                PROCEDURE einfuege (CONST start, anzahl; CONST elem);
                 VIRTUAL;
                PROCEDURE ausfuege (CONST start, anzahl);
                 VIRTUAL;
                PROCEDURE setze (CONST index; CONST elem);
                 VIRTUAL;
                PROCEDURE hole (CONST index; VAR elem);
                 VIRTUAL;
                PROCEDURE zeigFenster (CONST view: PBuffText;
                                       CONST x, y, b, h: WORD;
                                       CONST zeichneFen: BOOLEAN);
                 VIRTUAL;
                FUNCTION Edit (CONST view: PBuffText; CONST x, y, b, h: WORD;
                               CONST name: GLP): GLP;
                 VIRTUAL;
                PROCEDURE setzeString (CONST s; CONST dynamisch: BOOLEAN); VIRTUAL;
                PROCEDURE holeString (VAR s); VIRTUAL;
                PROCEDURE kopiereText (VAR s: STRING; CONST Start, Anzahl: WORD);
                  VIRTUAL;
                FUNCTION Scan (CONST dieZeichen: ChSet; Start: WORD): WORD;
                  VIRTUAL;
                FUNCTION backScan (CONST dieZeichen: ChSet; Start: WORD): WORD;
                  VIRTUAL;
                PROCEDURE extractText (VAR s: STRING; bis: WORD);
                  VIRTUAL;
                PROCEDURE splitText (VAR s: STRING; CONST Start: WORD);
                  VIRTUAL;
                PROCEDURE deleteText (VAR s: STRING; CONST Start: WORD; Anzahl: WORD);
                  VIRTUAL;
                PROCEDURE anhText (CONST s: STRING); VIRTUAL;
                PROCEDURE einfText (CONST s: STRING; CONST Start: WORD); VIRTUAL;
                PROCEDURE cutText (CONST cutIndex: WORD); VIRTUAL;
                PROCEDURE checkEndBlanks; VIRTUAL;
                FUNCTION AbsatzEnde (CONST Endlos, Blankkennung: BOOLEAN;
                                     CONST AbsKenn: CHSet): BOOLEAN; VIRTUAL;
                PROCEDURE schreib (CONST view: PBuffText; CONST bs, be: INTEGER);
                  VIRTUAL;
                PROCEDURE OffsetSchreib (CONST view: PBuffText;
                                         CONST x: WORD;
                                         CONST y: LONGINT;
                                         CONST offs: WORD;
                                         CONST bs, be: INTEGER;
                                         CONST zeigZeilenEnde: BOOLEAN;
                                         CONST zeigTextEnde: BOOLEAN); VIRTUAL;
                PROCEDURE TabsExpandieren (CONST Tablaenge: WORD);
                PROCEDURE Rot13; VIRTUAL;
                PROCEDURE Krypt; VIRTUAL;
                PROCEDURE Monitor (CONST view: PBuffText); VIRTUAL;
  END (* einString8 *);

IMPLEMENTATION

USES DOS, Objects, EditStuff, CRT;

(****************** einString *************************)

CONSTRUCTOR einString.Init;
BEGIN
  INHERITED Init (xflags);
  MeinTyp := StringG;
END;

FUNCTION einString.erzeugeMich (CONST xflags: einFlagSet): GLP;
BEGIN
  erzeugeMich := NEW (einStringPointer, Init (xflags));
END (* erzeugeMich *);

DESTRUCTOR einString.Done;
BEGIN
  deallocVektor;
  INHERITED Done;
END;

DESTRUCTOR einString.DoneCluster;
BEGIN
  deallocVektor;
  INHERITED DoneCluster;
END;

FUNCTION einString.isSubclass (CONST class: einGenTyp): BOOLEAN;
BEGIN
  isSubclass := (class = StringG) OR INHERITED isSubClass (class);
END;

FUNCTION einString.StringLaenge: WORD;
BEGIN StringLaenge := 0;
END (* StringLaenge *);

FUNCTION einString.StrLaenge: WORD;
BEGIN StrLaenge := StringLaenge;
END (* StrLaenge *);

PROCEDURE einString.fuegeZchEin (CONST ind: WORD; CONST ch: CHAR);
VAR     z:      WORD;
BEGIN
  z := 1;
  einfuege (ind, z, ch);
END (* fuegeZchEin *);

PROCEDURE einString.entferneZch (CONST ind: WORD);
VAR     z:      WORD;
BEGIN
  z := 1;
  ausfuege (ind, z);
END (* entferne *);

PROCEDURE einString.setzeZch (CONST ind: WORD; CONST ch: CHAR);
BEGIN
  setze (ind, ch);
END (* setzeZch *);

FUNCTION einString.holeZch (CONST ind: WORD): CHAR;
VAR     ch:     CHAR;
BEGIN
  hole (ind, ch);
  holeZch := ch;
END (* holeZch *);

PROCEDURE einString.setzeString (CONST s; CONST dynamisch: BOOLEAN);
BEGIN Abstract ('setzeString'); END;

PROCEDURE einString.holeString (VAR s);
BEGIN Abstract ('holeString'); END;

PROCEDURE einString.setzeText (CONST s: STRING; CONST dynamisch: BOOLEAN);
BEGIN
  setzeString (s, dynamisch);
END (* setzeText *);

PROCEDURE einString.holeText (VAR s: STRING);
BEGIN
  holeString (s);
END (* holeText *);

FUNCTION einString.Cap (CONST gk: BOOLEAN; CONST ch: CHAR): CHAR;
BEGIN
  IF gk THEN Cap := UpCase (ch) ELSE Cap := ch;
END (* Cap *);

PROCEDURE einString.Caps (VAR s: STRING);
VAR i: INTEGER;
BEGIN
  FOR i := 1 TO LENGTH (s) DO
    s [i] := UpCase (s [i]);
END (* Caps *);

PROCEDURE einString.macheSuchtabelle (VAR t: eineZeichentabelle;
                            VAR Suchbegriff: STRING; (* Var wg. CAPS *)
                            CONST grosskleinEgal: BOOLEAN);
VAR  Suchlaenge: WORD;
     dummy:      CHAR;
     j:          WORD;
BEGIN
  Suchlaenge := LENGTH (Suchbegriff);
  IF grosskleinEgal THEN Caps (Suchbegriff);
  (* Initialisieren der Suchtabelle: Fr jedes Zeichen, das im
     Suchstring vorkommt, wird festgehalten, wie weit sein letztes
     Vorkommen vom Ende des Strings entfernt ist. Zunchst wird die
     Tabelle mit der Suchlnge vorinitialisiert (fr die Zeichen,
     die nicht im String vorkommen). *)
  FOR dummy := Low (CHAR) TO High (Char) DO BEGIN
    t [dummy] := Suchlaenge;
  END (* FOR *);
  FOR j := 1 TO Suchlaenge - 1 DO BEGIN
    t [Suchbegriff [j]] := Suchlaenge - j;
  END (* FOR *);
END (* macheSuchtabelle *);

FUNCTION einString.SPos (CONST start: INTEGER; CONST Suchstr: STRING;
                         CONST Tabelle: eineZeichentabelle;
                         CONST gk, wort: BOOLEAN;
                         CONST dieZeichen: ChSet): INTEGER;
BEGIN SPos := -1;
END (* SPos *);

FUNCTION einString8.SPos (CONST start: INTEGER; CONST Suchstr: STRING;
                          CONST Tabelle: eineZeichentabelle;
                          CONST gk, wort: BOOLEAN;
                          CONST dieZeichen: ChSet): INTEGER;
VAR  index, k, j:  INTEGER;
     ch:           CHAR;
     wt:           BOOLEAN;

  FUNCTION Worttest: BOOLEAN;
  BEGIN
    IF NOT wort THEN Worttest := TRUE
    ELSE BEGIN
{zeigMeldung ('Worttest', 'k = ' + StringVonNum (k) + ', index = ' + StringVonNum (index));}
      Worttest := ((k <= 0) OR
                  (derString^.str [k] IN dieZeichen)) AND
                 ((index = Stringlaenge) OR
                  (derString^.str [index] IN dieZeichen));
    END (* ELSE *);
  END (* Worttest *);

BEGIN
  IF LENGTH (Suchstr) > StringLaenge THEN BEGIN
    SPos := -1; Exit;
  END (* IF *);
  index := LENGTH (Suchstr) + start;
  (* Index, bei dem die Suche startet (Wortende) *)
  REPEAT
    j := LENGTH (Suchstr) + 1; k := index {- 1}; (* Laufindizes setzen *)
    REPEAT
      DEC (k); DEC (j);
    UNTIL (j < 1) OR (Suchstr [j] <> Cap (gk, derString^.str [k]));
    (* vergleicht Suchstring [j] mit str [k] bis Ungleichheit oder
       Suchstring erschpft *)
    wt := WortTest;
    IF (j >= 1) OR NOT wt THEN
      INC (index, Tabelle [Cap (gk, derString^.str [index - 1])]);
  UNTIL (j < 1) OR (index > StringLaenge);
  IF (j < 1) AND (index <= StringLaenge) AND (wt) THEN
    SPos := index - LENGTH (Suchstr)
  ELSE SPos := -1;
END (* SPos *);

FUNCTION einString.Scan (CONST dieZeichen: ChSet; Start: WORD): WORD;
BEGIN Scan := Start;
END (* Scan *);

FUNCTION einString.backScan (CONST dieZeichen: ChSet; Start: WORD): WORD;
BEGIN  backScan := 0;
END (* backScan *);

PROCEDURE einString.extractText (VAR s: STRING; bis: WORD);
BEGIn
  s := '';
END (* extractText *);

PROCEDURE einString.splitText (VAR s: STRING; CONST Start: WORD);
BEGIN
  s := '';
END (* splitText *);

PROCEDURE einString.deleteText (VAR s: STRING; CONST Start: WORD; Anzahl: WORD);
BEGIN
  s := '';
END (* deleteText *);

PROCEDURE einString.anhText (CONST s: STRING);
BEGIN
  Abstract ('anhText');
END (* anhText *);

PROCEDURE einString.einfText (CONST s: STRING; CONST Start: WORD);
BEGIN
  Abstract ('einfText');
END (* einfText *);

PROCEDURE einString.cutText (CONST cutIndex: WORD);
BEGIN
  Abstract ('cutText');
END (* cutText *);

PROCEDURE einString.checkEndBlanks;
BEGIN
  Abstract ('checkEndBlanks');
END (* checkEndBlanks *);

FUNCTION einString.AbsatzEnde (CONST Endlos, Blankkennung: BOOLEAN;
                               CONST AbsKenn: CHSet): BOOLEAN;
BEGIN
  Abstract ('BlankAmEnde'); AbsatzEnde := TRUE;
END (* AbsatzEnde *);

PROCEDURE einString.kopiereText (VAR s: STRING; CONST Start, Anzahl: WORD);
BEGIN
  s := '';
END (* kopiereText *);

FUNCTION einString.StringVonDaten: STRING;
VAR s: STRING;
BEGIN
  holeString (s);
  StringVonDaten := s;
END (* StringVonDaten *);

PROCEDURE einString.schreib;
BEGIN Abstract ('schreib'); END;

PROCEDURE einString.OffsetSchreib (CONST view: PBuffText;
                                   CONST x: WORD;
                                   CONST y: LONGINT;
                                   CONST offs: WORD;
                                   CONST bs, be: INTEGER;
                                   CONST zeigZeilenEnde: BOOLEAN;
                                   CONST zeigTextEnde: BOOLEAN);
BEGIN Abstract ('OffsetSchreib'); END;

PROCEDURE einString.WriteReport (VAR Datei: ASCII; CONST formatieren: BOOLEAN;
                                 CONST zeilenAufSeite: WORD;
                                 VAR seite, zeile, xpos: WORD;
                                 CONST endlos, kennung: BOOLEAN;
                                 CONST Filter: PeinDruckerFilter;
                                 CONST Pref, Suff: CHAR;
                                 CONST AbsKenn: CHSet);
VAR  ds:                   STRING;
     i:                    INTEGER;
     warPrefix, warSuffix: BOOLEAN;
     ch:                   CHAR;
BEGIN
  IF Filter <> NIL THEN BEGIN
    warPrefix := FALSE; warSuffix := TRUE;
    ds := StringVonDaten;
    FOR i := 1 TO LENGTH (ds) DO BEGIN
      IF NOT warPrefix AND (ds [i] = Pref) THEN warPrefix := True
      ELSE BEGIN
        ch := ds [i];
        IF warPrefix AND (ch IN ['A'..'Z']) THEN ch := CHR (ORD (ch) - ORD ('@'));
        warPrefix := FALSE;
        Write (Datei, Filter^[ch]);
      END (* ELSE *);
    END (* FOR *);
  END
  ELSE
    Write (Datei, StringVonDaten);
  IF endlos THEN BEGIN
    IF AbsatzEnde (endlos, kennung, AbsKenn) THEN WriteLn (Datei);
  END
  ELSE IF formatieren THEN WriteLn (Datei);
  INC (zeile);
END (* WriteReport *);

PROCEDURE einString.Rot13;
BEGIN END;

PROCEDURE einString.Krypt;
BEGIN END;

(****************************** einString8 ***********************)

CONSTRUCTOR einString8.Init;
BEGIN
  INHERITED Init (xflags);
  meinTyp := String8;
  {
  AnzahlElemente := 0;
  derString := NIL;
  }
END;

FUNCTION einString8.erzeugeMich (CONST xflags: einFlagSet): GLP;
BEGIN
  erzeugeMich := NEW (einString8Pointer, Init (xflags));
END (* erzeugeMich *);

DESTRUCTOR einString8.Done;
BEGIN
  INHERITED Done;
END;

FUNCTION einString8.isAbstract: BOOLEAN;
BEGIN
  isAbstract := FALSE;
END (* isAbstract *);

FUNCTION einString8.isSubclass (CONST class: einGenTyp): BOOLEAN;
BEGIN
  isSubclass := (class = String8) OR INHERITED isSubClass (class);
END;

FUNCTION einString8.StringLaenge: WORD;
BEGIN
  IF derString = NIL THEN
    StringLaenge := 0
  ELSE StringLaenge := derString^.Laenge;
END (* StringLaenge *);

FUNCTION einString8.LaengeIst: LONGINT;
BEGIN
  IF AnzahlElemente > 0 THEN
    LaengeIst := AnzahlElemente - SizeOf (derString^.Laenge)
  ELSE LaengeIst := 0;
END (* LaengeIst *);

PROCEDURE einString8.allocVektor (CONST anzahl);
(* Achtung: Am 7. 11. 90 Konvention dahingehend gendert, da AnzahlElemente
   das Lngenbyte mitzhlt! *)
BEGIN
  AnzahlElemente := gran (BYTE (anzahl) + SizeOf (derString^.Laenge));
  GetMem (derString, AnzahlElemente);
  derString^.Laenge := 0;
END;

PROCEDURE einString8.deallocVektor;
VAR az: STRING;
BEGIN
  IF (AnzahlElemente > 0) THEN BEGIN
    FreeMem (derString, AnzahlElemente);
  END;
  derString := NIL; AnzahlElemente := 0;
END (* deallocVektor *);

PROCEDURE einString8.resizeVektor (CONST anzahl);
VAR     h:              StringPointer;
        nanzahl:        WORD {BYTE};
BEGIN
(* AnzahlElemente bezieht sich auf die String-Charakters MIT Lngenbyte *)
(* Am 24. 2. 92 Korrektur anzahl um "+ 1", da sonst offenbar String um
   ein Byte zu kurz, so da Speicher berschrieben wurde! *)

  nanzahl := gran (BYTE (anzahl) + SizeOf (derString^.Laenge));
  IF nanzahl > High (BYTE) THEN nanzahl := High (BYTE);

  IF nanzahl <> AnzahlElemente THEN BEGIN
{
zeigMeldung ('String8.resizeVektor (' + StringVonNum (BYTE (anzahl)) + ')',
           StringVonTyp (meinTyp) + atString (@SELF) +
           '; Anzahl: ' + StringVonNum (AnzahlElemente) +
           '; nanzahl: ' + StringVonNum (nanzahl));
}
    GetMem (h, WORD (nanzahl));
    IF derString <> NIL THEN BEGIN
      IF nanzahl > AnzahlElemente THEN BEGIN
        Move (derString^, h^, WORD (AnzahlElemente));
      END
      ELSE BEGIN
        Move (derString^, h^, WORD (nanzahl));
      END;
      FreeMem (derString, AnzahlElemente);
    END (* IF alten String kopieren *)
    ELSE h^.Laenge := 0;
    derString := h;
    AnzahlElemente := nanzahl;
  END (* IF derString <> NIL *);
END (* resizeVektor *);

PROCEDURE einString8.einfuege (CONST start, anzahl; CONST elem);
VAR     ind, off:       INTEGER;
        neueLaenge:     WORD;
        hilfe:          StringPointer;
        slen:           WORD;
BEGIN
  IF BYTE (start) > 254 THEN EXIT;

  slen := StringLaenge;
  IF BYTE (start) > slen THEN BEGIN
    neueLaenge := BYTE (start) + BYTE (anzahl)
  END
  ELSE BEGIN
    neueLaenge := slen + BYTE (anzahl);
  END;
  IF neueLaenge > 255 THEN neueLaenge := 255;

  resizeVektor (neueLaenge);

  IF (BYTE (start) < slen) THEN BEGIN
    off := neueLaenge - slen;
    FOR ind := neueLaenge - 1 DOWNTO neueLaenge - slen + BYTE (start) DO BEGIN
        derString^.Str [ind] := derString^.Str [ind - off];
    END (* FOR *);
  END
  ELSE BEGIN
    FOR ind := slen TO BYTE (start) - 1 DO BEGIN
      derString^.Str [ind] := ' ';
    END (* FOR *);
  END (* kopiere Stringrest *);

  derString^.Laenge := neueLaenge;

  FOR ind := BYTE (start) TO
    BYTE (start) + BYTE (anzahl) - 1 DO BEGIN
    derString^.Str [BYTE (ind)] := CHAR (elem);
  END (* FOR *);
END (* einfuege *);

PROCEDURE einString8.ausfuege (CONST start, anzahl);
BEGIN
  IF (derString <> NIL) AND (BYTE (start) <= derString^.Laenge) THEN BEGIN
    SYSTEM.Delete (STRING (derString^), BYTE (start) + 1, BYTE (anzahl));
    resizeVektor (derString^.Laenge);
  END (* IF <> NIL *);
END (* ausfuege *);

PROCEDURE einString8.setze (CONST index; CONST elem);
VAR     ind:    INTEGER;
BEGIN
  (* In AnzahlElemente steckt das Lngenbyte, und der Index zhlt ab 0! *)
  IF (derString = NIL) OR (BYTE (index) + 1 >= AnzahlElemente) THEN BEGIN
    ind := BYTE (index) + 1;
    resizeVektor (ind);
  END;

  IF BYTE (index) >= StringLaenge THEN BEGIN
    IF BYTE (index) > StringLaenge THEN
      FOR ind := StringLaenge - 1 TO BYTE (index) - 1 DO BEGIN
        derString^.Str [ind] := ' ';
      END (* FOR *);
    derString^.Laenge := BYTE (index) + 1;
  END (* IF Leerzeichen auffllen *);

  derString^.Str [BYTE (index)] := CHAR (elem);
END (* setze *);

PROCEDURE einString8.hole (CONST index; VAR elem);
BEGIN
  IF WORD (index) < StringLaenge THEN BEGIN
    CHAR (elem) := derString^.Str [WORD (index)];
  END (* IF *)
  ELSE CHAR (elem) := CHR (0);
END (* hole *);

PROCEDURE einString8.zeigFenster (CONST view: PBuffText; CONST x, y, b, h: WORD;
                                  CONST zeichneFen: BOOLEAN);
BEGIN END;

FUNCTION einString8.Edit (CONST view: PBuffText; CONST x, y, b, h: WORD;
                          CONST name: GLP): GLP;
VAR     s:      STRING;
BEGIN
  holeString (s);
  Edit := EditName (name, @SELF, x + 1, y + 1, b, s);
  setzeString (s, TRUE);
  setzeFlag (editFlag);
END;

PROCEDURE einString8.setzeString (CONST s; CONST dynamisch: BOOLEAN);
VAR     laen:   WORD;
BEGIN
  laen := LENGTH (STRING (s));
  resizeVektor (laen); (* VAR-Parameter! *)
  derString^.Laenge := laen;
  Move (SSTRING (s).Str [0], derString^.Str [0], laen);
END (* setzeString *);

PROCEDURE einString8.holeString (VAR s);
BEGIN
  IF derString <> NIL THEN BEGIN
    SSTRING (s).Laenge := derString^.Laenge;
    Move (derString^.Str [0], SSTRING (s).Str [0], derString^.Laenge);
  END
  ELSE STRING (s) := '';
END (* holeString *);

FUNCTION einString8.Scan (CONST dieZeichen: ChSet; Start: WORD): WORD;
BEGIN
  IF (derString <> NIL) AND (derString^.Laenge > 0) THEN BEGIN
    IF Start >= derString^.Laenge THEN Start := derString^.Laenge - 1;
    WHILE (Start < derString^.Laenge) AND NOT (derString^.Str [Start] IN dieZeichen) DO BEGIN
      INC (Start);
    END (* WHILE *);
    Scan := Start;
  END
  ELSE Scan := 0;
END (* Scan *);

FUNCTION einString8.backScan (CONST dieZeichen: ChSet; Start: WORD): WORD;
BEGIN
  IF (derString <> NIL) AND (derString^.Laenge > 0) THEN BEGIN
    IF Start >= derString^.Laenge THEN Start := derString^.Laenge - 1;
    WHILE (Start > 0) AND NOT (derString^.Str [Start] IN dieZeichen) DO BEGIN
      DEC (Start);
    END (* WHILE *);
    backScan := Start;
  END
  ELSE backScan := 0;
END (* backScan *);

PROCEDURE einString8.extractText (VAR s: STRING; bis: WORD);
BEGIN
  (* kopiert den Anfang des Strings in s und zieht den Rest nach vorn *)
  IF (derString <> NIL) AND (derString^.Laenge > 0) THEN BEGIN
    IF bis > derString^.Laenge THEN bis := derString^.Laenge;
    s := Copy (STRING (derString^), 1, bis);
    Move (derString^.Str [bis], derString^.Str [0], derString^.Laenge - bis);
    derString^.Laenge := derString^.Laenge - bis;
    resizeVektor (derString^.Laenge);
  END
  ELSE s := '';
END (* extractText *);

PROCEDURE einString8.deleteText (VAR s: STRING; CONST Start: WORD; Anzahl: WORD);
BEGIN
  (* kopiert den Teil des Strings ab Start mit der Lnge Anzahl in s
     und zieht den Rest nach vorn *)
  IF (derString <> NIL) AND (derString^.Laenge > 0) THEN BEGIN
    IF Start + Anzahl > derString^.Laenge THEN
      Anzahl := derString^.Laenge - Start;
    s := Copy (STRING (derString^), Start + 1, Anzahl);
    Move (derString^.Str [Start + Anzahl], derString^.Str [Start],
          derString^.Laenge - Start);
    derString^.Laenge := derString^.Laenge - Anzahl;
    resizeVektor (derString^.Laenge);
  END
  ELSE s := '';
END (* deleteText *);

PROCEDURE einString8.splitText (VAR s: STRING; CONST Start: WORD);
BEGIN
  (* kopiert den Rest des Strings in s und krzt ihn dann *)
  IF (derString <> NIL) AND (Start < derString^.Laenge) THEN BEGIN
    s := Copy (STRING (derString^), Start + 1, derString^.Laenge);
    derString^.Laenge := Start;
    resizeVektor (derString^.Laenge);
  END
  ELSE s := '';
END (* splitText *);

PROCEDURE einString8.anhText (CONST s: STRING);
VAR laen: WORD;
BEGIN
  laen := StringLaenge + LENGTH (s);
  resizeVektor (laen);
  Insert (s, STRING (derString^), derString^.Laenge + 1);
END (* anhText *);

PROCEDURE einString8.einfText (CONST s: STRING; CONST Start: WORD);
VAR laen: WORD;
BEGIN
  laen := StringLaenge + LENGTH (s);
  resizeVektor (laen);
  Insert (s, STRING (derString^), Start);
END (* einfText *);

PROCEDURE einString8.cutText (CONST cutIndex: WORD);
BEGIN
  derString^.Laenge := cutIndex;
  resizeVektor (cutIndex);
END (* cutText *);

PROCEDURE einString8.checkEndBlanks;
BEGIN
  IF derString = NIL THEN EXIT;
  WHILE (derString^.Laenge > 1) AND
        (derString^.Str[derString^.Laenge - 1] = ' ') AND
        (derString^.Str[derString^.Laenge - 2] = ' ') DO BEGIN
     DEC (derString^.Laenge);
  END (* WHILE *);
END (* checkEndBlanks *);

FUNCTION einString8.AbsatzEnde (CONST Endlos, Blankkennung: BOOLEAN;
                                CONST AbsKenn: CHSet): BOOLEAN;
BEGIN
  IF Endlos THEN BEGIN
    AbsatzEnde := (derString = NIL) OR
                  (derString^.Laenge = 0) OR
                  NOT ((derString^.Str[derString^.Laenge - 1] IN AbsKenn)
                        AND Blankkennung
                      )
  END
  ELSE BEGIN
    AbsatzEnde := (derString = NIL) OR
                  ((derString^.Laenge = 0))
  END (* ELSE *);
END (* BlankAmEnde *);

PROCEDURE einString8.kopiereText (VAR s: STRING; CONST Start, Anzahl: WORD);
BEGIN
  IF (derString <> NIL) AND (Start < derString^.Laenge) THEN BEGIN
    s := Copy (STRING (derString^), Start + 1, Anzahl);
  END
  ELSE s := '';
END (* kopiereText *);

PROCEDURE einString8.schreib;
BEGIN
  IF derString <> NIL THEN BEGIN
    view^.WriteString (STRING (derString^), bs, be);
  END
  ELSE view^.ClrEol (FALSE, TRUE);
END (* schreib *);

PROCEDURE einString8.OffsetSchreib (CONST view: PBuffText;
                                    CONST x: WORD;
                                    CONST y: LONGINT;
                                    CONST offs: WORD;
                                    CONST bs, be: INTEGER;
                                    CONST zeigZeilenEnde: BOOLEAN;
                                    CONST zeigTextEnde: BOOLEAN);
(* Spter mal sehen, ob man das nicht optimieren kann... *)
VAR     ind:    WORD;
BEGIN
  view^.GotoXY (x, y);
  IF derString <> NIL THEN BEGIN
    IF derString^.Laenge > offs THEN BEGIN
      view^.WriteStringOff (offs, STRING (derString^), bs, be, zeigZeilenEnde, zeigTextEnde);
    END
    ELSE BEGIN
      IF derString^.Laenge = offs THEN
        view^.ClrEol (zeigZeilenEnde, zeigTextEnde)
      ELSE view^.ClrEol (FALSE, FALSE) ;
    END (* IF *);
  END
  ELSE BEGIN
    view^.ClrEol (zeigZeilenEnde, zeigTextEnde);
  END (* IF <> NIL *);
END (* OffsetSchreib *);

PROCEDURE einString8.TabsExpandieren (CONST Tablaenge: WORD);
BEGIN
END (* TabsExpandieren *);

PROCEDURE einString8.Rot13;
VAR  Ind: WORD;
BEGIN
  IF (derString <> NIL) AND (derString^.Laenge > 0) THEN BEGIN
    FOR Ind := 0 TO derString^.Laenge - 1 DO BEGIN
      IF derString^.Str [Ind] IN ['a'..'z'] THEN BEGIN
        derString^.Str [Ind] :=
          CHR (ORD (derString^.Str [Ind]) + 13);
        IF derString^.Str [Ind] > 'z' THEN
          derString^.Str [Ind] :=
            CHR (ORD (derString^.Str [Ind]) - ORD ('z') + ORD ('a') - 1);
      END
      ELSE IF derString^.Str [Ind] IN ['A'..'Z'] THEN BEGIN
        derString^.Str [Ind] :=
          CHR (ORD (derString^.Str [Ind]) + 13);
        IF derString^.Str [Ind] > 'Z' THEN
          derString^.Str [Ind] :=
            CHR (ORD (derString^.Str [Ind]) - ORD ('Z') + ORD ('A') - 1)
      END (* IF *);
    END (* FOR *);
  END (* IF *);
END (* Rot13 *);

PROCEDURE einString8.Krypt;
VAR  Ind: WORD;

  FUNCTION doIt (ch: CHAR): CHAR;
  BEGIN
    IF ch IN ['A'..'Z'] THEN doIt := CHR (ORD ('A') + ORD ('Z') - ORD (ch))
    ELSE
    IF ch IN ['a'..'z'] THEN doIt := CHR (ORD ('a') + ORD ('z') - ORD (ch))
    ELSE doIt := ch;
  END (* Krypt *);

BEGIN
  IF (derString <> NIL) AND (derString^.Laenge > 0) THEN BEGIN
    FOR Ind := 0 TO derString^.Laenge - 1 DO BEGIN
      derString^.Str [Ind] := doIt (derString^.Str [Ind]);
    END (* FOR *);
  END (* IF *);
END (* Sysop *);

PROCEDURE einString8.Monitor;
BEGIN
  INHERITED Monitor (view);
  view^.WriteString ('AnzahlElemente:   ', 0, 0); view^.WriteInt (AnzahlElemente);
    view^.WriteLn;
  view^.WriteString ('Stringlnge:      ', 0, 0); view^.WriteInt (StringLaenge);
    view^.WriteLn;
  view^.WriteString ('Stringpointer:    ', 0, 0); view^.WritePointer (derString);
  (* holeString (s); *)
  view^.WriteString ('> "', 0, 0);
    IF derString <> NIL THEN view^.WriteString (STRING (derString^), 0, 0);
       view^.WriteChr ('"');
    view^.WriteLn;
END (* Monitor *);

END (* GLFStrings *).
