PROGRAM SimpelEditor;
{$F+}

(* (C) 1990-1995 by Johannes Leckebusch
   Version fr Turbo-Vision
   Stand: 07. 02. 1995
*)

{$I SIMPDEF.INC}

USES
     App, Views, Drivers,
{$IFDEF mitOverlays}
     GLFOverInit,
{$ENDIF mitOverlays}
      DOS, Crt,
     GLFInit, GLFTypes, GLFBase,
     GLFLists, GLFWindows, EditStuff;

{$IFDEF mitOverlays}

{$O DOS}
{$O Memory}
{$O Objects}

{$O Views}
{$O Menus}
{$O App}
{$O Dialogs}
{$O StdDlg}
{$O Fields}
{$O MSGBOX}
{$O HistList}

{$O EditStuff}
{$O GLFInit}
{$O GLFTypes}
{$O GLFBase}
{$O GLFNodes}
{$O GLFLists}
{$O GLFQuadruple}
{$O ObjStrings}
{$O Simpeltext}
{$O GLFViews}
{$O GLFWindows}
{$O TVMenuString}

{$ENDIF mitOverlays}

VAR  derEditor:       PEditor;
     dieMenuLeiste1:  einListenPointer;
     dieMenuLeiste2:  einListenPointer;

     ExitSave:        POINTER;

     oldprintint:     PROCEDURE;

PROCEDURE MyExit; FAR;
BEGIN
  ExitProc := ExitSave;
  doMyExit;
END (* MyExit *);
{
CONST CHeapReserve =           10000;
VAR   HeapReserve:              POINTER;
}
FUNCTION HeapFunc (Size: WORD): INTEGER;
BEGIN

  IF Size <> 0 THEN BEGIN
    { FreeMem (HeapReserve, CHeapReserve); }

    Write ('Heapanforderung fehlgeschlagen: ', StringVonNum (Size));
    ReadLn;

{
    IF doTrace THEN
      zeigTrace ('Heapanforderung fehlgeschlagen', 'Gre: ' + StringVonNum (Size))
    ELSE
      zeigMeldung ('Heapanforderung fehlgeschlagen', 'Gre: ' + StringVonNum (Size));
}
    HeapFunc := 1;
  END
  ELSE BEGIN
    HeapFunc := 0;
  END;
END (* HeapFunc *);

{ Cursorgre von Rasterzeile bis Rasterzeile setzen }
{ 0 = oberste Rasterzeile                            }
{ Farb:  7 = unterste Rasterzeile                    }
{ Mono: 14 = unterste Rasterzeile                    }

procedure CursorForm (von, bis: byte);
begin
  asm
    mov ah,1
    mov ch,von
    mov cl,bis
    int 10h
  end;
end (* CursorForm *);

PROCEDURE CursorOff;
(* Cursor ausschalten: *)
BEGIN
  CursorForm (32,32);
END (* CursorOff *);

PROCEDURE CursorOn;
(* Cursor wieder einschalten: *)
BEGIN
  if mem [$40:$49] <> 7
    then CursorForm (5, 7)    (* Farb-Karte *)
    else CursorForm (12, 14); (* Mono-Karte *)
END (* CursorOn *);

{$F+}
PROCEDURE newprintint; Interrupt;
(* Neuer Interrupt $05 *)
VAR P:  POINTER;
BEGIN
  {WriteLn ('Die Taste "Druck" wurde gedrckt');}
  PrintScreen := TRUE;
  {P := Message (Desktop^.Owner, evCommand, cmTextDrucken, NIL);}
END (* neuwprintint *);
{$F-}

BEGIN (* SIMPEL *)

  {HeapLimit := 8192; HeapBlock := 32768;}
  {TRON; MeldFileOn ('SIMPEL.TRA');}

  ClrScr;
  CursorOff;

  Crt.GotoXY (33, 11); Write  ('S I M P E L');
  Crt.GotoXY (16, 13); Write  ('Der Simpel-Editor (C) 1993 Johannes Leckebusch');
  Crt.GotoXY (32, 15); Write  ('Initialisierung');


  zeigTrace ('SIMPEL-Editor', 'Hauptprogramm initialisieren');

  InitGLF;

{Write ('InitGLF fertig'); ReadLn;}

  InitMenu (dieMenuLeiste1{, dieMenuLeiste2});

  CursorOn;

  zeigTrace ('SIMPEL-Editor', 'Applikationsobjekt erzeugen');

  derEditor := NEW (PEditor, Init (dieMenuLeiste1));

  zeigTrace ('SIMPEL-Editor', 'Hilfsstrukturen f. Menleiste lschen');
  dieMenuLeiste1^.LoeschPfad (dieMenuLeiste1^.neuSig);
  Dispose (dieMenuLeiste1, Done);

  ExitSave := ExitProc;
  ExitProc := @MyExit;
{
  GetMem (HeapReserve, CHeapReserve);
}
  HeapError := @HeapFunc;
{
Write ('MyApp^.Run: '); ReadLn;
}
  checkBreak := TRUE;

  getintvec ($5, @oldprintint); (* alten Interrupt $05 sichern *)
  setintvec ($5, @newprintint); (* neuen Interrupt $05 installieren *)

  zeigTrace ('SIMPEL-Editor', 'Applikation mit RUN starten');
  derEditor^.Run;
  derEditor^.Done;
END.