{$A+,B-,D+,E+,F+,G+,I+,L+,N-,P-,Q+,R+,S+,T-,V-,X+,Y+}
{$M 65520, 0, 655360}
UNIT Simpeltext;

{$F+}
{$O+}

(* (C) 1990, 1991, 1992, 1993, 1994, 1995 by Johannes Leckebusch
   Version 2.926
   Anpassung an TP: 9. 12. 90
   23. 03. 93: Nichtrekursives Lschen von Text und Textobjekt
   Stand: 19. 12. 1995
*)


INTERFACE

USES Objects, Drivers, {My}Views, GLFTypes, GLFBase, ObjStrings, GLFNodes,
     GLFLists, GLFViews, TextBase;

TYPE

  einSimpleTextPointer = ^einSimpleText;
  einSimpleText =       OBJECT (einText)
                          CONSTRUCTOR Init (CONST xflags: einFlagSet);

                          FUNCTION erzeugeMich (CONST xflags: einFlagSet): GLP; VIRTUAL;

                          FUNCTION isSubclass (CONST class: einGenTyp): BOOLEAN; VIRTUAL;

{                          PROCEDURE LiesZeile (VAR Datei: ASCII; VAR zeile: STRING);
}

                          PROCEDURE InitMenu (VAR dieMenuLeiste: GLP);
                            VIRTUAL;
                          PROCEDURE sende (CONST view: PBuffText; VAR ereignis: TEvent;
                                           CONST Sig: LONGINT);
                            VIRTUAL;
                          PROCEDURE WriteReport (VAR Datei: ASCII; CONST formatieren: BOOLEAN;
                                                 CONST zeilenAufSeite: WORD;
                                                 VAR seite, zeile, xpos: WORD;
                                                 CONST endlos, kennung: BOOLEAN;
                                                 CONST Filter: PeinDruckerFilter;
                                                 CONST Pref, Suff: CHAR;
                                                 CONST AbsKenn: CHSet);
                            VIRTUAL;
                          PROCEDURE TextSpeichern; VIRTUAL;
                          PROCEDURE TextDrucken (CONST n: INTEGER); VIRTUAL;
                          PROCEDURE TextLaden (CONST psname: PString; CONST StartZeile: LONGINT;
                                               CONST Block: BOOLEAN);
                            VIRTUAL;

                          PROCEDURE CompiliereDruckerfilter;
                          PROCEDURE GeneriereDruckerfilter;

                          PROCEDURE StringSuchen (CONST Befehl: WORD{;
                                    CONST PosOffset: INTEGER}); VIRTUAL;
                          {
                          PROCEDURE Monitor (CONST view: PBuffText); VIRTUAL;
                          }
                          (* Methoden, die von Edit ausgefhrt werden,
                             sie sollten private sein
                          *)
                 (* PRIVATE (ist SCHEISSE!) *)

                        END (* einSimpleText *);

IMPLEMENTATION

USES DOS, {My}App, {My}Dialogs, StdDlg, Fields, EditStuff,
  GLFStructures, TVMenuString, TVMenus, GLFWindows;

(************************ Methoden zu SimpleText *************************)

CONSTRUCTOR einSimpleText.Init;
BEGIN
  {Trace ('Simpletext.Init');}
  INHERITED Init (xflags);
  MeinTyp := SimpleText;
END (* Init *);

FUNCTION einSimpleText.erzeugeMich (CONST xflags: einFlagSet): GLP;
BEGIN
  erzeugeMich := NEW (einSimpleTextPointer, Init (xflags));
END (* erzeugeMich *);

FUNCTION einSimpleText.isSubclass (CONST class: einGenTyp): BOOLEAN;
BEGIN
  isSubclass := (class = SimpleText) OR INHERITED isSubClass (class);
END;

PROCEDURE einSimpleText.sende (CONST view: PBuffText; VAR Ereignis: TEvent;
                               CONST Sig: LONGINT);

(* Diese Methode entspricht in etwa dem "HandleEvent" von Turbovision,
   dh. hier werden die Benutzereingaben und sonstige Ereignisse vom
   eigentlichen Editor verarbeitet. *)

VAR  ch:          CHAR;
     dummyp:      PView;
     dummyg:      GLP;
     {update:      BOOLEAN;}
     doExit:      BOOLEAN;
     bearbeitet:  BOOLEAN;
     StartZ:      LONGINT;
     keystr:      STRING [4];
     n:           LONGINT;
     textflags:   einTextflagSet;
     zeilPref:    STRING;
     DokName:     STRING;
BEGIN (* sende *)
  IF (Ereignis.What = evBroadCast) AND
  ((Ereignis.Command >= cmReceivedFocus) AND (Ereignis.Command <= 99))
    THEN EXIT;

  GLF.sende (view, Ereignis, Sig);
  IF Ereignis.What = evNothing THEN EXIT;

  IF (Ereignis.What = evCommand) AND (Ereignis.Command = cmOeffneFormular)
  THEN BEGIN
    dummyg := Edit (view, 0, 0, 0, 0, TextName);
    EXIT;
  END
  ELSE IF (derFensterInhalt = NIL) THEN BEGIN
    EXIT;
  END;
  view^.GotoXY (TextX, TextY);
  setzeMerker (laufendeZeile);
  {update := FALSE;} bearbeitet := TRUE;

  IF Ereignis.What = evKeyDown THEN BEGIN
    meineNachrichten := Ereignis;
    InitEreignis (Ereignis);
    WITH meineNachrichten DO BEGIN
{
HexWord (KeyCode, keystr);
zeigMeldung ('evKeyDown', keystr);
}
      doExit := TRUE;
      IF (Prefix = 0) AND NOT insertCode THEN BEGIN
        CASE KeyCode OF
          {kbCtrlA, kbCtrlB, kbCtrlC, kbCtrlD, kbCtrlE, kbCtrlF, kbCtrlG,
          kbCtrlH, kbCtrlI, kbCtrlJ,} kbCtrlK, {kbCtrlL, kbCtrlM, kbCtrlN,}
          kbCtrlO, {kbCtrlP,} kbCtrlQ{, kbCtrlR, kbCtrlS, kbCtrlT, kbCtrlU,
          kbCtrlV, kbCtrlW, kbCtrlX, kbCtrlZ}:
            Prefix := KeyCode;
          kbAltW: insertCode := TRUE;
        ELSE doExit := FALSE;
        END (* ELSE/CASE *);
      END (* IF Prefix = nul *)
      ELSE IF NOT insertCode THEN BEGIN
           doexit := FALSE;
           CASE Prefix OF
             kbCtrlK:  CASE KeyCode OF
                         kbCtrlB, kbb:   BEGIN setzeMerker (MerkerBlockAnfang);
                                           updateFenster (derFensterInhalt, derFensterInhalt^.LongDelta.Y);
                                         END;
                         kbCtrlC, kbc:   BEGIN
                                           IF NoEdit THEN EXIT;

                                           setzeMerker (MerkerBlockMove);

                                           CopyBlockToClipboard;

                                           zuMerker (MerkerBlockMove);

                                           PasteBlockFromClipboard;
                                           updateFenster (derFensterInhalt, derFensterInhalt^.LongDelta.Y);
                                         END;
                         kbCtrlH, kbh:   BEGIN loescheBlock;
                                           updateFenster (derFensterInhalt, derFensterInhalt^.LongDelta.Y);
                                         END;
                         kbCtrlK, kbk:   BEGIN setzeMerker (MerkerBlockEnde);
                                           updateFenster (derFensterInhalt, derFensterInhalt^.LongDelta.Y);
                                         END;
                         kbCtrlL, kbl:   zeigBlocklaenge;
                         kbCtrlM, kbm:   BEGIN
                                           CopyBlockToClipboard;
                                           updateFenster (derFensterInhalt, derFensterInhalt^.LongDelta.Y);
                                         END;
                         kbCtrlP, kbp:   BEGIN
                                           IF NoEdit THEN EXIT;
                                           PasteBlockFromClipboard;
                                           updateFenster (derFensterInhalt, derFensterInhalt^.LongDelta.Y);
                                         END;
                         kbCtrlR, kbr:   BEGIN
                                           IF NoEdit THEN EXIT;
                                           setzeMerker (MerkerBlockAnfang);
                                           StartZ := TextY;
                                           TextLaden (Ereignis.InfoPtr, StartZ, TRUE);
                                           setzeInternFlag (TextEditiert);
                                           setzeFlag (editFlag);
                                         END;
                         kbCtrlV, kbv:   BEGIN
                                           IF NoEdit THEN EXIT;

                                           setzeMerker (MerkerBlockMove);

                                           CutBlockToClipboard (TRUE);

                                           zuMerker (MerkerBlockMove);

                                           PasteBlockFromClipboard;
                                           updateFenster (derFensterInhalt, derFensterInhalt^.LongDelta.Y);
                                         END;
                         kbCtrlY, kby:   BEGIN
                                           IF NoEdit THEN EXIT;
                                           CutBlockToClipboard (hatTextflag (loescheInClipboard));
                                           updateFenster (derFensterInhalt, derFensterInhalt^.LongDelta.Y);
                                         END;
                         kb0:            setzeMerker (Merker0);
                         kb1:            setzeMerker (Merker1);
                         kb2:            setzeMerker (Merker2);
                         kb3:            setzeMerker (Merker3);
                         kb4:            setzeMerker (Merker4);
                         kb5:            setzeMerker (Merker5);
                         kb6:            setzeMerker (Merker6);
                         kb7:            setzeMerker (Merker7);
                         kb8:            setzeMerker (Merker8);
                         kb9:            setzeMerker (Merker9);
                       ELSE doExit := TRUE;
                       END (* CASE kbCtrlK *);
             kbCtrlO:  CASE KeyCode OF
                         kbCtrlC, kbc:   BEGIN
                                           IF NoEdit THEN EXIT;
                                           zentriereZeile;
                                         END;
                       ELSE doExit := TRUE;
                       END (* CASE kbCtrlO *);
             kbCtrlQ:  CASE KeyCode OF
                         kbCtrlA, kba:   StringSuchen (cmStringTauschen);
                         kbCtrlB, kbb:   zuMerker (MerkerBlockAnfang);
                         kbCtrlC, kbc:   letzteZeile;
                         kbCtrlF, kbf:   StringSuchen (cmStringSuchen);
                         kbCtrlG, kbg:   StringSuchen (cmStringRueckSuchen);
                         kbCtrlK, kbk:   zuMerker (MerkerBlockEnde);
                         kbCtrlP, kbp:   zuMerker (altePos);
                         kbCtrlR, kbr:   ersteZeile;
                         kb0:            zuMerker (Merker0);
                         kb1:            zuMerker (Merker1);
                         kb2:            zuMerker (Merker2);
                         kb3:            zuMerker (Merker3);
                         kb4:            zuMerker (Merker4);
                         kb5:            zuMerker (Merker5);
                         kb6:            zuMerker (Merker6);
                         kb7:            zuMerker (Merker7);
                         kb8:            zuMerker (Merker8);
                         kb9:            zuMerker (Merker9);
                       ELSE doExit := TRUE;
                       END (* CASE kbCtrlQ *);
           ELSE doExit := TRUE;
           END (* CASE *);
           Prefix := 0; KeyCode := 0;
      END (* ELSE *)
      ELSE doExit := FALSE;
      IF doExit THEN EXIT;

      IF CharCode <> nul THEN BEGIN
        ScanCode := BYTE (nul);
      END;

      {update := TRUE;}

      CASE CHR (ScanCode) OF
        nul:          BEGIN
                        IF (laufendeZeile <> NIL) AND
                           (laufendeZeile^.GetZ^.isSubclass (StringG)) THEN BEGIN
                          IF (CharCode >= ' ') OR insertCode THEN BEGIN
                            IF NoEdit THEN EXIT;
                            doCh; {update := FALSE;}
                            setzeFlag (editFlag);
                            setzeInternFlag (TextEditiert);
                          END
                          ELSE CASE CharCode OF
                            ctrla:      TextX := sucheWortAnfang (stopSet);
                            ctrlb:      BEGIN
                                          IF NoEdit THEN EXIT;
                                          doFormat;
                                        END;
                            ctrlc:      doPgDown;
                            ctrld:      doRight;
                            ctrle:      doUp;
                            ctrlf:      TextX := sucheNaechstesWort (stopSet);
                            ctrlg:      BEGIN
                                          IF NoEdit THEN EXIT;
                                          doDokFormat;
                                        END;
                            ctrll:      StringSuchen (cmNochmalSuchen);
                            ctrln:      BEGIN
                                          IF NoEdit THEN EXIT;
                                          StringSuchen (cmNochmalTauschen);
                                        END;
                            ctrlr:      doPgUp;
                            ctrls:      doLeft;
                            ctrlw:      FensterScroll (0, -1);
                            ctrlx:      DoDown;
                            ctrlz:      FensterScroll (0, 1);
                            bs:         BEGIN
                                          IF NoEdit THEN EXIT;
                                          doBs; {update := FALSE;}
                                          setzeFlag (editFlag);
                                          setzeInternFlag (TextEditiert);
                                        END;
                            linedel:    BEGIN
                                          IF NoEdit THEN EXIT;
                                          doLinedel;
                                          setzeFlag (editFlag);
                                          setzeInternFlag (TextEditiert);
                                        END;
                            lineundel:  BEGIN
                                          IF NoEdit THEN EXIT;
                                          doLineUndel;
                                          setzeFlag (editFlag);
                                          setzeInternFlag (TextEditiert);
                                        END;
                            cr, lf:     BEGIN
{zeigMeldung ('cr, lf', 'Das war cr oder lf');}
                                          IF NoEdit THEN EXIT;
                                          doCr;
                                          IF charcode = lf THEN BEGIN
                                           zeilPref := holeName (zeilPrefix);
                                           laufendeZeile^.GetZ^.einfText (zeilPref, TextX);
                                           derFensterInhalt^.GotoXY (TextX, TextY);
                                           derFensterInhalt^.WriteString (zeilPref, 1, 1);
                                           INC (TextX, LENGTH (zeilPref));
                                          END (* IF *);
                                          setzeFlag (editFlag);
                                          setzeInternFlag (TextEditiert);
                                        END;
                            tab:        BEGIN
                                          IF NoEdit THEN EXIT;
                                          doTab;
                                          setzeFlag (editFlag);
                                          setzeInternFlag (TextEditiert);
                                        END;
                            esc:        BEGIN
                                          IF zeigFrage ('Escape gedrckt',
                                          'Wollen Sie wirklich das Textfenster schlieen?') THEN BEGIN
                                            dummyp := Message (Desktop,
                                            evCommand, cmClose, NIL);
                                            EXIT;
                                          END;
                                        END (* esc *);
                            nul:
                            ELSE        BEGIN
                                          IF NoEdit THEN EXIT;
                                          doCh; {update := FALSE;}
                                          setzeFlag (editFlag);
                                          setzeInternFlag (TextEditiert);
                                        END;
                          END (* IF  *);
                        END (* IF Member (laufendeZeile...) *);
                        insertCode := FALSE;
                      END (* CASE-Label *);
         f1:          doF1;
         upkey:       doUp;
         scrollupkey: FensterScroll (0, 1);
         downkey:     doDown;
         scrolldownkey: FensterScroll (0, -1);
         leftkey:     doLeft;
         ctrlleft:    TextX := sucheWortAnfang (stopSet);
         rightkey:    doRight;
         ctrlright:   TextX := sucheNaechstesWort (stopSet);
         pgupkey:     doPgup;
         ctrlpgup:    ersteZeile;
         pgdownkey:   doPgdown;
         ctrlpgdn:    letzteZeile;
         homekey:     doHome;
         ctrlhome:    AbsatzAnfang (TRUE);
         endkey:      doEnd;
         ctrlend:     AbsatzEnde (TRUE);
         inskey:      doIns;
         delkey:      BEGIN
                        IF NoEdit THEN EXIT;
                        doDel;
                        setzeFlag (editFlag);
                        setzeInternFlag (TextEditiert);
                      END;
         ELSE         BEGIN
                        {update := FALSE;}
                      END;
      END (* CASE *);

      schreibStatus;
      view^.GotoXY (TextX, TextY);
      IF (laufendeZeile <> NIL) AND (laufendeZeile^.GetZ^.isSubclass (StringG)) THEN BEGIN
        laufendeZeile^.GetZ^.OffsetSchreib (view, TextX, TextY, TextX,
                                            BlockStart (laufendeZeile),
                                            BlockEnd (laufendeZeile),
                                            hatTextFlag (markiereAbschnitte),
                                            NOT hatNaechsteZeile (laufendeZeile));
      END (* IF Member *);
      view^.GotoXY (TextX, TextY);
    END (* WITH *);
  END (* IF evKeyDown *)
  ELSE IF Ereignis.What = evMouseDown THEN BEGIN
    doMaus (Ereignis.Where.X, Ereignis.Where.Y);
  END
  ELSE IF Ereignis.What = evCommand THEN BEGIN
    CASE Ereignis.Command OF
      cmCr:                 BEGIN
                              IF NoEdit THEN EXIT;
                              meineNachrichten := Ereignis;
                              doCr;
                            END;
      cmWriteZch:           BEGIN
                              IF NoEdit THEN EXIT;
                              meineNachrichten := Ereignis;
                              doZch; {update := FALSE;}
                            END;
      cmWriteText:          BEGIN
                              IF NoEdit THEN EXIT;
                              meineNachrichten := Ereignis;
                              doStr; {update := FALSE;}
                            END;
      cmF1String:           BEGIN
                              IF NoEdit THEN EXIT;
                              InsStr (F1F);
                            END;
      cmF2String:           BEGIN
                              IF NoEdit THEN EXIT;
                              InsStr (F2F);
                            END;
      cmF3String:           BEGIN
                              IF NoEdit THEN EXIT;
                              InsStr (F3F);
                            END;
      cmF4String:           BEGIN
                              IF NoEdit THEN EXIT;
                              InsStr (F4F);
                            END;
      cmF5String:           BEGIN
                              IF NoEdit THEN EXIT;
                              InsStr (F5F);
                            END;
      cmF6String:           BEGIN
                              IF NoEdit THEN EXIT;
                              InsStr (F6F);
                            END;
      cmF7String:           BEGIN
                              IF NoEdit THEN EXIT;
                              InsStr (F7F);
                            END;
      cmF8String:           BEGIN
                              IF NoEdit THEN EXIT;
                              InsStr (F8F);
                            END;
      cmF9String:           BEGIN
                              IF NoEdit THEN EXIT;
                              InsStr (F9F);
                            END;
      cmF0String:           BEGIN
                              IF NoEdit THEN EXIT;
                              InsStr (F0F);
                            END;
      cmTextFlags:    BEGIN
                        zeigTextFlags ('Schalter fr Textmodus');
                      END;
      cmFStrings:     BEGIN
                        zeigFStrings ('Funktionstasten-Strings');
                      END;
      cmToggleInsert: BEGIN
                        doIns;
                      END;
      cmEditTextmodus: BEGIN
                         setzeTextflag (AutoUmbruch);
                         loescheTextflag (AutoIndent);
                       END;
      cmEditProgrammmodus: BEGIN
                             setzeTextflag (AutoIndent);
                             loescheTextflag (AutoUmbruch);
                           END;
      cmEditHome:     doHome;
      cmEditEnd:      doEnd;
      cmEditPgUp:     doPgUp;
      cmEditPgDown:   doPgDown;
      cmEditWortanfang: TextX := sucheWortAnfang (stopSet);
      cmEditWortende: TextX := sucheNaechstesWort (stopSet);
      cmEditCtrlHome: AbsatzAnfang (TRUE);
      cmEditCtrlEnd:  AbsatzEnde (TRUE);
      cmEditCtrlPgUp: ersteZeile;
      cmEditCtrlPgDown: letzteZeile;
      cmEditScrollDown: FensterScroll (0, -1);
      cmEditScrollUp:   FensterScroll (0, 1);
      cmEditUmbruch:  BEGIN
                        IF NoEdit THEN EXIT;
                        doFormat;
                      END;
      cmEditDokUmbruch: BEGIN
                          IF NoEdit THEN EXIT;
                          doDokFormat;
                        END;
      cmEditRot13:    BEGIN
                        IF NoEdit THEN EXIT;
                        doRot13;
                      END;
      cmEditKrypt:    BEGIN
                        IF NoEdit THEN EXIT;
                        doKrypt;
                      END;
      cmEditLoeschZeile: BEGIN
                           IF NoEdit THEN EXIT;
                           doLinedel;
                           setzeFlag (editFlag);
                           setzeInternFlag (TextEditiert);
                         END;
      cmEditUndoLoeschZeile: BEGIN
                               IF NoEdit THEN EXIT;
                               doLineUndel;
                               setzeFlag (editFlag);
                               setzeInternFlag (TextEditiert);
                             END;
      cmEditSteuerzeichen: insertCode := TRUE;
      cmFlags:        BEGIN
                        zeigFlags ('Schalter fr Objekte');
                      END;
      cmReport:       BEGIN
{zeigMeldung ('cmReport', 'Text speichern');}
                        TextSpeichern;
                        InitEreignis (Ereignis);
                      END;
      cmReportName:   BEGIN
{zeigMeldung ('cmReportName', 'Text mit Abfrage speichern');}
                        textflags := meineTextflags;
                        setzeTextFlag (SpeichImmerFragen);
                        TextSpeichern;
                        meineTextflags := textflags;
                        InitEreignis (Ereignis);
                      END;
      cmNameAendern:  BEGIN
                        DokName := holeName (TextName);
                        ch := EditStringTitel (4, 10, 70, 'Neuen Namen angeben', DokName);
                        IF ch <> ESC THEN BEGIN
                          setzeName (TextName, DokName);
                          PMyWindow (derFensterInhalt^.Owner)^.setTitle (DokName);
                        END (* IF Esc *);
                      END;
      cmEditUndo:     BEGIN
                        IF meinUndoText <> NIL THEN BEGIN
                          dummyG := meinUndoText^.Edit (NIL, 0, 0, 0, 0,
                            einSimpleTextPointer (meinUndoText)^.TextName);
                        END
                        ELSE zeigMeldung ('Undo editieren',
                                          'es ist kein Undopuffer vorhanden');
                      END;
      cmTextDrucken:  BEGIN
                        TextDrucken (1);
                      END;
      cmTextNDrucken: BEGIN
                        n := 1;
                        EditZahl ('Text mehrmals drucken, Anzahl eingeben:',
                                  1, 1, 5, 0, 32765, n);
                        TextDrucken (n);
                      END;
      cmCompiliereDruckerfilter: BEGIN
                        CompiliereDruckerfilter;
                      END;
      cmGeneriereDruckerfilter: BEGIN
                        GeneriereDruckerfilter;
                      END;
      cmTextLoeschen: BEGIN
                        IF NoEdit THEN EXIT;
                        TextLoeschen;
                      END;
      cmCfgSpeichern: BEGIN CfgSpeichern;
                      END;
      cmCfgLaden:     BEGIN
                        IF NoEdit THEN EXIT;
                        CfgLaden (TRUE);
                      END;
      cmTextlaenge:   zeigTextlaenge;
      cmBlocklaenge:   zeigBlocklaenge;
      cmEditSetBlockBegin: BEGIN setzeMerker (MerkerBlockAnfang);
                                 updateFenster (derFensterInhalt, derFensterInhalt^.LongDelta.Y);
                           END;
      cmEditPasteBlock:    BEGIN
                             IF NoEdit THEN EXIT;
                             PasteBlockFromClipboard;
                             updateFenster (derFensterInhalt, derFensterInhalt^.LongDelta.Y);
                           END;
      cmEditDoubleBlock:     BEGIN

                             setzeMerker (MerkerBlockMove);

                             CopyBlockToClipboard;

                             zuMerker (MerkerBlockMove);

                             PasteBlockFromClipboard;
                             updateFenster (derFensterInhalt, derFensterInhalt^.LongDelta.Y);
                           END;
      cmEditMoveBlock:     BEGIN
                             IF NoEdit THEN EXIT;

                             setzeMerker (MerkerBlockMove);

                             zuMerker (MerkerBlockAnfang);
                             CutBlockToClipboard (TRUE);
                             MerkerUpdate (LaufendeZeile);

                             zuMerker (MerkerBlockMove);

                             PasteBlockFromClipboard;
                             updateFenster (derFensterInhalt, derFensterInhalt^.LongDelta.Y);
                           END;
      cmEditHideBlock:     BEGIN loescheBlock;
                                 updateFenster (derFensterInhalt, derFensterInhalt^.LongDelta.Y);
                           END;
      cmEditSetBlockEnd:   BEGIN setzeMerker (MerkerBlockEnde);
                                 updateFenster (derFensterInhalt, derFensterInhalt^.LongDelta.Y);
                           END;
      cmEditCopyBlock:     BEGIN
                             CopyBlockToClipboard;
                             updateFenster (derFensterInhalt, derFensterInhalt^.LongDelta.Y);
                           END;
      cmEditCutBlock:      BEGIN
                             IF NoEdit THEN EXIT;
                             CutBlockToClipboard (hatTextflag (loescheInClipboard));
                             updateFenster (derFensterInhalt, derFensterInhalt^.LongDelta.Y);
                           END;
      cmEditSet0:          setzeMerker (Merker0);
      cmEditSet1:          setzeMerker (Merker1);
      cmEditSet2:          setzeMerker (Merker2);
      cmEditSet3:          setzeMerker (Merker3);
      cmEditSet4:          setzeMerker (Merker4);
      cmEditSet5:          setzeMerker (Merker5);
      cmEditSet6:          setzeMerker (Merker6);
      cmEditSet7:          setzeMerker (Merker7);
      cmEditSet8:          setzeMerker (Merker8);
      cmEditSet9:          setzeMerker (Merker9);
      cmEditToBlockBegin:  zuMerker (MerkerBlockAnfang);
      cmEditToBlockEnd:    zuMerker (MerkerBlockEnde);
      cmEditToAltePos:     zuMerker (altePos);
      cmEditTo0:           zuMerker (Merker0);
      cmEditTo1:           zuMerker (Merker1);
      cmEditTo2:           zuMerker (Merker2);
      cmEditTo3:           zuMerker (Merker3);
      cmEditTo4:           zuMerker (Merker4);
      cmEditTo5:           zuMerker (Merker5);
      cmEditTo6:           zuMerker (Merker6);
      cmEditTo7:           zuMerker (Merker7);
      cmEditTo8:           zuMerker (Merker8);
      cmEditTo9:           zuMerker (Merker9);
      cmZentriereZeile:    BEGIN
                             IF NoEdit THEN EXIT;
                             zentriereZeile;
                           END;
      cmStringSuchen,
      cmStringRueckSuchen,
      cmStringTauschen,
      cmNochmalSuchen,
      cmNochmalTauschen: BEGIN
                           StringSuchen (Ereignis.Command);
                         END;
      cmTextLaden,
      cmBlockLaden:   BEGIN
                        IF NoEdit THEN EXIT;
                        IF Ereignis.Command <> cmBlockLaden THEN BEGIN
                          TextLoeschen; StartZ := 0;
                        END (* IF *)
                        ELSE BEGIN
                          setzeMerker (MerkerBlockAnfang);
                          StartZ := TextY;
                        END (* ELSE *);
{zeigMeldung ('cmTextLaden', '?');}
                        TextLaden (Ereignis.InfoPtr, StartZ, Ereignis.Command = cmBlockladen);
                        IF Ereignis.Command = cmBlockLaden THEN BEGIN
                          setzeInternFlag (TextEditiert);
                        END (* IF *);
                        setzeFlag (editFlag);
                        {InitEreignis (Ereignis);}
                      END;
      cmUpdateMerker: BEGIN
                        MerkerUpdate (laufendeZeile);
                      END;
      cmMonitor:      BEGIN
                        zeigMonitorFenster (0, 0, 60, 16, NIL);
                      END;
      ELSE              bearbeitet := FALSE;
    END (* CASE *);

      schreibStatus;
      view^.GotoXY (TextX, TextY);
  END (* IF evCommand *)
  ELSE IF Ereignis.What = evBroadcast THEN BEGIN
    bearbeitet := FALSE;
    CASE Ereignis.Command OF
      cmTexteDrucken: TextDrucken (1);
    END (* CASE *);
  END (* IF evBroadcast *)
  ELSE bearbeitet := FALSE;

  IF hatTextflag (Autosave) AND (getippt >= AutoSaveN) AND
     zeigFrage ('Automatisch speichern', 'Soll der Text gesichert werden?')
  THEN BEGIN
    getippt := 0; TextSpeichern;
  END (* AutoSave *);

  IF bearbeitet THEN
    InitEreignis (Ereignis)
  ELSE BEGIN
  END (* ELSE *);
END (* sende *);

PROCEDURE einSimpleText.InitMenu (VAR dieMenuLeiste: GLP);
VAR  Eintrag:         GLP;
     dasMenu:         einTVMenuPointer;

BEGIN
  dieMenuLeiste := neuesObjekt (Liste, []);

  (******* Dateimen *******)

  GLP (dasMenu) := neuesObjekt (TVMenu, []);
  WITH dasMenu^ DO BEGIN
    insertTextUndCode ('D~a~tei',                      '',         kbNoKey,   cmNothing, hcNoContext);
    insertTextUndCode ('~T~ext laden',                 'Shift-F3', kbShiftF3, cmTextLaden, hcNoContext);
    insertTextUndCode ('~B~lock aus Datei laden',      '^KR',      kbNoKey,   cmBlockLaden, hcNoContext);
    insertTextUndCode ('~S~peichere Text',             'F2',       kbF2,      cmReport, hcNoContext);
    insertTextUndCode ('Speichern unter Name',         'Shift-F2', kbShiftF2, cmReportName, hcNoContext);
    insertTextUndCode ('Dokumentname ndern',          'Ctrl-F2',  kbCtrlF2,  cmNameAendern, hcNoContext);
    insertTextUndCode ('Text lschen',                 '',         kbNoKey,   cmTextLoeschen, hcNoContext);
    insertTextUndCode ('-',                            '',         kbNoKey,   cmNothing, hcNoContext);
    insertTextUndCode ('SIMPEL.CFG speichern',         '',         kbNoKey,   cmCfgSpeichern, hcNoContext);
    insertTextUndCode ('SIMPEL.CFG laden',             '',         kbNoKey,   cmCfgLaden, hcNoContext);
    insertTextUndCode ('-',                            '',         kbNoKey,   cmNothing, hcNoContext);
    insertTextUndCode ('~L~nge des Textes in Bytes',  'Alt-L',    kbAltL,    cmTextlaenge, hcNoContext);
  END (* WITH *);
  Eintrag := einListenPointer (dieMenuLeiste)^.InsertAfter (dasMenu);

  (* Edit-Men *)

  GLP (dasMenu) := neuesObjekt (TVMenu, []);
  WITH dasMenu^ DO BEGIN
    insertTextUndCode ('Ed~i~t',                     '',      kbNoKey,   cmNothing, hcNoContext);
    insertTextUndCode ('~~berschreiben umschalten', 'Einfg', kbNoKey,   cmToggleInsert, hcNoContext);
    insertTextUndCode ('ASCII-Codeeingabe',          'Alt-W', kbAltW,    cmEditSteuerzeichen, hcNoContext);
    insertTextUndCode ('Text (Umbruch)',             '',      kbNoKey,   cmEditTextmodus, hcNoContext);
    insertTextUndCode ('Programm (Autoindent)',      '',      kbNoKey,   cmEditProgrammmodus, hcNoContext);
    insertTextUndCode ('-',                          '',      kbNoKey,   cmNothing, hcNoContext);
    insertTextUndCode ('Zeile lschen',              '^Y',    kbNoKey,   cmEditLoeschZeile, hcNoContext);
    insertTextUndCode ('Undo-Zeilenlschen',         '^U',    kbNoKey,   cmEditUndoLoeschZeile, hcNoContext);
    insertTextUndCode ('~U~ndopuffer editieren',     '',      kbAltU,    cmEditUndo, hcNoContext);
    insertTextUndCode ('-',                          '',      kbNoKey,   cmNothing, hcNoContext);
    insertTextUndCode ('Absatzumbruch',              '^B',    kbNoKey,   cmEditUmbruch, hcNoContext);
    insertTextUndCode ('Dokumentumbruch',            '^G',    kbNoKey,   cmEditDokUmbruch, hcNoContext);
    insertTextUndCode ('Zeile zentrieren',           '^OC',   kbNoKey,   cmZentriereZeile, hcNoContext);
  END (* WITH *);
  Eintrag := einListenPointer (dieMenuLeiste)^.InsertAfter (dasMenu);

  (* Cursormen *)

  GLP (dasMenu) := neuesObjekt (TVMenu, []);
  WITH dasMenu^ DO BEGIN
    insertTextUndCode ('Cursor',                   '',           kbNoKey,  cmNothing, hcNoContext);
    insertTextUndCode ('Zeilenanfang',             'Pos1',       kbHome,   cmEditHome, hcNoContext);
    insertTextUndCode ('Zeilenende',               'Ende',       kbEnd,    cmEditEnd, hcNoContext);
    insertTextUndCode ('oberste Fensterzeile',     'Bild^',      kbPgUp,   cmEditPgUp, hcNoContext);
    insertTextUndCode ('unterste Fensterzeile',    'Bildv',      kbPgDn,   cmEditPgDown, hcNoContext);
    insertTextUndCode ('Wortanfang',               'Ctrl <-',    kbCtrlLeft, cmEditWortanfang, hcNoContext);
    insertTextUndCode ('Wortende',                 'Ctrl ->',    kbCtrlRight, cmEditWortende, hcNoContext);
    insertTextUndCode ('Absatz-Anfang',            'Ctrl-Pos1',  kbCtrlHome, cmEditCtrlHome, hcNoContext);
    insertTextUndCode ('Absatz-Ende',              'Ctrl-Ende',  kbCtrlEnd, cmEditCtrlEnd, hcNoContext);
    insertTextUndCode ('Textanfang',               'Ctrl-Bild^', kbCtrlPgUp, cmEditCtrlPgUp, hcNoContext);
    insertTextUndCode ('Textende',                 'Ctrl-Bildv', kbCtrlPgDn, cmEditCtrlPgDown, hcNoContext);
    insertTextUndCode ('Scroll Up',                'Ctrl-Z',     kbNoKey {kbShiftUp}, cmEditScrollUp, hcNoContext);
    insertTextUndCode ('Scroll Down',              'Ctrl-W',     kbNoKey {kbShiftDown}, cmEditScrollDown, hcNoContext);
  END (* WITH *);
  Eintrag := einListenPointer (dieMenuLeiste)^.InsertAfter (dasMenu);

  (* Blockmen *)

  GLP (dasMenu) := neuesObjekt (TVMenu, []);
  WITH dasMenu^ DO BEGIN
    insertTextUndCode ('~B~lock',                    '',           kbNoKey,  cmNothing, hcNoContext);
    insertTextUndCode ('~A~nfang Block setzen',      '^KB',        kbNoKey,  cmEditSetBlockBegin, hcNoContext);
    insertTextUndCode ('~E~nde Block setzen',        '^KK',        kbNoKey,  cmEditSetBlockEnd, hcNoContext);
    insertTextUndCode ('~M~erke Block',              '^KM',        kbCtrlIns,  cmEditCopyBlock, hcNoContext);
    insertTextUndCode ('~L~sche Block',             '^KY',        kbShiftDel,  cmEditCutBlock, hcNoContext);
    insertTextUndCode ('~E~infge Block',            '^KP',        kbShiftIns,  cmEditPasteBlock, hcNoContext);
    insertTextUndCode ('~K~opiere Block',            '^KC',        kbNoKey,  cmEditDoubleBlock, hcNoContext);
    insertTextUndCode ('~V~erschiebe Block',         '^KV',        kbNoKey,  cmEditMoveBlock, hcNoContext);
    insertTextUndCode ('-',                          '',           kbNoKey,  cmNothing, hcNoContext);
    insertTextUndCode ('Zum Blockanfang',            '^QB',        kbNoKey,  cmEditToBlockBegin, hcNoContext);
    insertTextUndCode ('Zum Blockende',              '^QK',        kbNoKey,  cmEditToBlockEnd, hcNoContext);
    insertTextUndCode ('Blockmarkierung aufheben',   '^KH',        kbNoKey,  cmEditHideBlock, hcNoContext);
    insertTextUndCode ('Blocklnge in Bytes anz.',   '^KL',        kbNoKey,  cmBlocklaenge, hcNoContext);
  END (* WITH *);
  Eintrag := einListenPointer (dieMenuLeiste)^.InsertAfter (dasMenu);

  (* Merkermen *)

  GLP (dasMenu) := neuesObjekt (TVMenu, []);
  WITH dasMenu^ DO BEGIN
    insertTextUndCode ('~M~arken',                 '',           kbNoKey,  cmNothing, hcNoContext);
    insertTextUndCode ('Alte Editposition',        '^QP',        kbNoKey,  cmEditToAltePos, hcNoContext);
    insertTextUndCode ('Marke setzen 0-9',         '^K0-9',      kbNoKey,   cmEditSet0, hcNoContext);
    insertTextUndCode ('Merker 0',                 '^Q0',        kbNoKey,  cmEditTo0, hcNoContext);
    insertTextUndCode ('Merker 1',                 '^Q1',        kbNoKey,  cmEditTo1, hcNoContext);
    insertTextUndCode ('Merker 2',                 '^Q2',        kbNoKey,  cmEditTo2, hcNoContext);
    insertTextUndCode ('Merker 3',                 '^Q3',        kbNoKey,  cmEditTo3, hcNoContext);
    insertTextUndCode ('Merker 4',                 '^Q4',        kbNoKey,  cmEditTo4, hcNoContext);
    insertTextUndCode ('Merker 5',                 '^Q5',        kbNoKey,  cmEditTo5, hcNoContext);
    insertTextUndCode ('Merker 6',                 '^Q6',        kbNoKey,  cmEditTo6, hcNoContext);
    insertTextUndCode ('Merker 7',                 '^Q7',        kbNoKey,  cmEditTo7, hcNoContext);
    insertTextUndCode ('Merker 8',                 '^Q8',        kbNoKey,  cmEditTo8, hcNoContext);
    insertTextUndCode ('Merker 9',                 '^Q9',        kbNoKey,  cmEditTo9, hcNoContext);
    insertTextUndCode ('UpdateMerker',             '',           kbNoKey,  cmUpdateMerker, hcNoContext);
  END (* WITH *);
  Eintrag := einListenPointer (dieMenuLeiste)^.InsertAfter (dasMenu);

  (* Suchmen *)

  GLP (dasMenu) := neuesObjekt (TVMenu, []);
  WITH dasMenu^ DO BEGIN
    insertTextUndCode ('S~u~chen',      '',         kbNoKey,  cmNothing, hcNoContext);
    insertTextUndCode ('~B~egriff suchen',         '^QF',      kbNoKey,  cmStringSuchen, hcNoContext);
    insertTextUndCode ('~R~ckwrts suchen',       '^QG',      kbNoKey,  cmStringRueckSuchen, hcNoContext);
    insertTextUndCode ('~N~ochmal suchen',         '^L',       kbNoKey,  cmNochmalSuchen, hcNoContext);
    insertTextUndCode ('~A~ustauschen',            '^QA',      kbNoKey,  cmStringTauschen, hcNoContext);
    insertTextUndCode ('Nochmal ~t~auschen',       '^N',       kbNoKey,  cmNochmalTauschen, hcNoContext);
    insertTextUndCode ('Rot-13',                   'Alt-O',    kbAltO,   cmEditRot13, hcNoContext);
    insertTextUndCode ('Krypt',                    'Alt-K',    kbAltK,   cmEditKrypt, hcNoContext);
  END (* WITH *);
  Eintrag := einListenPointer (dieMenuLeiste)^.InsertAfter (dasMenu);

  (* Fenstermen *)

  GLP (dasMenu) := neuesObjekt (TVMenu, []);
  WITH dasMenu^ DO BEGIN
    insertTextUndCode ('~F~enster',                  '',        kbNoKey,  cmNothing, hcNoContext);
    insertTextUndCode ('~W~hle Fenster',            'rechte Maust., Alt-0',  kbAlt0,  cmWindowBrowse, hcNoContext);
    insertTextUndCode ('Textschalter',               'F7',   kbF7, cmTextFlags, hcNoContext);
    insertTextUndCode ('F-Strings',                  'F8',   kbF8, cmFStrings, hcNoContext);
    {
    insertTextUndCode ('Objektschalter',             '',        kbNoKey, cmFlags, hcNoContext);
    insertTextUndCode ('Merkerfenster',              '',        kbNoKey, cmMerker, hcNoContext);
    insertTextUndCode ('Einfgen aus Merkerfenster', '',        kbNoKey, cmChangeMerkerAktiv, hcNoContext);

    insertTextUndCode ('Monitor-Fenster',            'Shift-F7', kbShiftF7, cmMonitor, hcNoContext);
    }

    insertTextUndCode ('-',                          '',         kbNoKey,   cmNothing, hcNoContext);
    insertTextUndCode ('Schlieen',                  'Escape',   kbNoKey,   cmClose, hcNoContext);
    insertTextUndCode ('~N~chstes',                 'F6',       kbF6,      cmNext, hcNoContext);
    insertTextUndCode ('~V~origes',                  'Shift-F6', kbShiftF6, cmPrev, hcNoContext);
    insertTextUndCode ('-',                          '',         kbNoKey,   cmNothing, hcNoContext);
    insertTextUndCode ('~Z~oom',                     'F5',       kbF5,      cmZoom, hcNoContext);
    insertTextUndCode ('~R~esize',                   'Ctrl-F5',  kbCtrlF5,  cmResize, hcNoContext);
    insertTextUndCode ('Stapeln',                    '',         kbNoKey,   cmCascade, hcNoContext);
    insertTextUndCode ('Nebeneinander',              '',         kbNoKey,   cmTile, hcNoContext);
  END (* WITH *);
  Eintrag := einListenPointer (dieMenuLeiste)^.InsertAfter (dasMenu);

  GLP (dasMenu) := neuesObjekt (TVMenu, []);
  WITH dasMenu^ DO BEGIN
    insertTextUndCode ('D~r~ucker',                  '',        kbNoKey,  cmNothing, hcNoContext);
    insertTextUndCode ('Text drucken',               'Alt-P',    kbAltP,    cmTextDrucken, hcNoContext);
    insertTextUndCode ('Text mehrmals drucken',      'Alt-N',    kbAltN,    cmTextNDrucken, hcNoContext);
    insertTextUndCode ('-',                          '',         kbNoKey,   cmNothing, hcNoContext);
    insertTextUndCode ('Druckerfilter compilieren',  '',         kbNoKey,   cmCompiliereDruckerfilter, hcNoContext);
    insertTextUndCode ('Druckerfilter generieren',   '',         kbNoKey,   cmGeneriereDruckerfilter, hcNoContext);
  END (* WITH *);
  Eintrag := einListenPointer (dieMenuLeiste)^.InsertAfter (dasMenu);

  GLP (dasMenu) := neuesObjekt (TVMenu, []);
  WITH dasMenu^ DO BEGIN
    insertTextUndCode ('F-Strings',                  '',         kbNoKey,  cmNothing, hcNoContext);
    insertTextUndCode ('F1-String',               'Alt-F1',      kbAltF1,  cmF1String, hcNoContext);
    insertTextUndCode ('F2-String',               'Alt-F2',      kbAltF2,  cmF2String, hcNoContext);
    insertTextUndCode ('F3-String',               'Alt-F3',      kbAltF3,  cmF3String, hcNoContext);
    insertTextUndCode ('F4-String',               'Alt-F4',      kbAltF4,  cmF4String, hcNoContext);
    insertTextUndCode ('F5-String',               'Alt-F5',      kbAltF5,  cmF5String, hcNoContext);
    insertTextUndCode ('F6-String',               'Alt-F6',      kbAltF6,  cmF6String, hcNoContext);
    insertTextUndCode ('F7-String',               'Alt-F7',      kbAltF7,  cmF7String, hcNoContext);
    insertTextUndCode ('F8-String',               'Alt-F8',      kbAltF8,  cmF8String, hcNoContext);
    insertTextUndCode ('F9-String',               'Alt-F9',      kbAltF9,  cmF9String, hcNoContext);
    insertTextUndCode ('F0-String',               'Alt-F0',      kbAltF10, cmF0String, hcNoContext);
  END (* WITH *);
  Eintrag := einListenPointer (dieMenuLeiste)^.InsertAfter (dasMenu);
END (* InitMenu *);

PROCEDURE einSimpleText.WriteReport (VAR Datei: ASCII; CONST formatieren: BOOLEAN;
                                     CONST zeilenAufSeite: WORD;
                                     VAR seite, zeile, xpos: WORD;
                                     CONST endlos, kennung: BOOLEAN;
                                     CONST Filter: PeinDruckerFilter;
                                     CONST Pref, Suff: CHAR;
                                     CONST AbsKenn: CHSet);
VAR zeilp:       einTriplePointer;
    heads:       STRING;
    inspos:      INTEGER;
    i:           INTEGER;
    druckzeile:  WORD;
    ch:          CHAR;

  PROCEDURE lzentriereZeile (VAR s: STRING);
  VAR  i, teil: INTEGER;
  BEGIN
    teil := (Umbruchbreite - LENGTH (s)) DIV 2;
    FOR i := 1 TO teil DO Insert (' ', s, 1);
  END (* lzentriereZeile *);

  PROCEDURE lrechtsZeile (VAR s: STRING);
  VAR  i, teil: INTEGER;
  BEGIN
    teil := (Umbruchbreite - LENGTH (s)) - 1;
    FOR i := 1 TO teil DO Insert (' ', s, 1);
  END (* lrechtsZeile *);

  PROCEDURE druckeKopf;
  VAR i:    INTEGER;
  BEGIN
    heads := holeName (KopfZeile);
    inspos := POS ('$', heads);
    IF inspos > 0 THEN BEGIN
      SYSTEM.Delete (heads, inspos, 1);
      Insert (holeName (TextName), heads, inspos);
    END (* Dateinamen einfgen *);
    inspos := POS ('#', heads);
    IF inspos > 0 THEN BEGIN
      SYSTEM.Delete (heads, inspos, 1);
      Insert (StringVonNum (seite), heads, inspos);
    END (* Dateinamen einfgen *);
    IF zentriereKopfFuss IN meineTextflags THEN lzentriereZeile (heads);
    IF rechtsKopfFuss IN meineTextflags THEN lrechtsZeile (heads);
    FOR i := 1 TO Druckoffset DO Write (Datei, ' ');
    WriteLn (Datei, heads); WriteLn (Datei);
    INC (druckzeile, 2);
  END (* druckeKopf *);

  PROCEDURE druckeFuss;
  VAR  i:   INTEGER;
  BEGIN
    heads := holeName (FussZeile);
    inspos := POS ('$', heads);
    IF inspos > 0 THEN BEGIN
      SYSTEM.Delete (heads, inspos, 1);
      Insert (holeName (TextName), heads, inspos);
    END (* Dateinamen einfgen *);
    inspos := POS ('#', heads);
    IF inspos > 0 THEN BEGIN
      SYSTEM.Delete (heads, inspos, 1);
      Insert (StringVonNum (seite), heads, inspos);
    END (* Dateinamen einfgen *);
    IF zentriereKopfFuss IN meineTextflags THEN lzentriereZeile (heads);
    IF rechtsKopfFuss IN meineTextflags THEN lrechtsZeile (heads);
    WriteLn (Datei);
    FOR i := 1 TO Druckoffset DO Write (Datei, ' ');
    WriteLn (Datei, heads);
    INC (druckzeile, 2);
  END (* druckeFuss *);

BEGIN (* WriteReport *)
  GLP (zeilp) := Rechts;
  druckzeile := zeile;
  IF formatieren AND hatTextflag (EinzelblattEinzug) THEN
    IF NOT zeigFrage ('Drucken', 'Bitte neues Blatt einlegen (Ja) oder Ende (Nein)')
    THEN BEGIN
      EXIT;
    END (* IF Abbruch *);
  WHILE zeilp <> NIL DO BEGIN
    IF formatieren AND (DruckeMitKopfzeile IN meineTextFlags) AND
       (druckzeile MOD zeilenAufSeite = 1) THEN BEGIN
      druckeKopf;
    END (* Kopfzeile *);
    IF (zeilp^.Rechts <> NIL) AND (zeilp^.Rechts^.isSubclass (Struktur)) THEN BEGIN
      IF formatieren THEN BEGIN
      {
        IF keypressed AND zeigFrage ('Drucken', 'Druckvorgang abbrechen?') THEN BEGIN
          ch := readKey;
          EXIT
        END;
        }
        FOR i := 1 TO Druckoffset DO Write (Datei, ' ');
        IF ZeilenNumerieren IN meineTextFlags THEN BEGIN
          Write (Datei, zeile:4, '  ');
        END (* IF NumFlag *);
      END (* IF *);

      (* eigentliches Ausgeben der Zeile/des Abschnittes: *)
      einStrukturPointer (zeilp^.Rechts)^.WriteReport
        (Datei, TRUE, zeilenAufSeite, seite, zeile, xpos, endlos, kennung, Filter,
         DruckerPrefix, DruckerSuffix, AbsatzKennSet);
      INC (druckzeile);
      (****************)

    END (* IF *);
    IF formatieren AND (DruckeMitFusszeile IN meineTextFlags) AND
       (druckzeile MOD zeilenAufSeite = zeilenAufSeite - 2) THEN BEGIN
      druckeFuss;
    END (* Fusszeile *);
    IF formatieren AND (druckzeile MOD zeilenAufSeite = 0) THEN BEGIN
      Write (Datei, ff); INC (seite); INC (druckzeile);
      IF hatTextflag (EinzelblattEinzug) THEN
        IF NOT zeigFrage ('Drucken', 'Bitte neues Blatt einlegen (Ja) oder Ende (Nein)')
        THEN BEGIN
          EXIT;
        END (* IF Abbruch *);
    END (* IF SeitenUmbruch *);
    GLP (zeilp) := zeilp^.Links;
  END (* WHILE *);
  IF formatieren AND (DruckeMitFusszeile IN meineTextflags) THEN BEGIN
    FOR i := druckzeile MOD zeilenAufSeite TO zeilenAufSeite - 2 DO
      WriteLn (Datei);
    druckeFuss;
  END;
  IF formatieren AND (FormfeedFlag IN meineTextFlags) THEN Write (Datei, ff);
END (* WriteReport *);

PROCEDURE einSimpleText.TextSpeichern;
VAR  Dateiname:    STRING;
     BAKname:      STRING;
     {PN:           PathStr;}
     Dir:          DirStr;
     Name:         NameStr;
     Ext:          ExtStr;
     Datei:        ASCII;
     seite, zeile,
     xpos:         WORD;
     ok:           BOOLEAN;
     Clip:         einTextPointer;
BEGIN
{zeigMeldung (StringVonTyp, 'TextSpeichern');}
  IF TextName = NIL THEN BEGIN
    setzeInternFlag (DateinameAbfragen);
    Dateiname := '*' + holeName (DateiSuffix);
  END
  ELSE BEGIN
    Textname^.holeString (Dateiname);
  END (* IF TextName <> NIL *);

{
  IF Desktop <> NIL THEN
    Clip := Message (Desktop^.Owner, evCommand, cmGetClipboard, NIL)
  ELSE Clip := NIL;
  IF (Clip <> NIL) THEN IF Clip^.hatTextFlag (SpeichImmerFragen)
    THEN setzeInternFlag (DateinameAbfragen)
  ELSE loescheInternFlag (DateinameAbfragen);
}

  IF hatTextFlag (ExitOhneFrage) OR NOT (hatTextFlag (SpeichImmerFragen))
    THEN loescheInternFlag (DateinameAbfragen);
  IF hatTextFlag (SpeichImmerFragen) THEN setzeInternFlag (DateinameAbfragen);

  IF hatInternFlag (DateinameAbfragen) THEN BEGIN
    getFilename (Dateiname, 'Text speichern', 'Textdatei', FALSE);
  END;
  IF (Dateiname <> '') THEN BEGIN
    FSplit (Dateiname, Dir, Name, Ext);
    IF Ext = '.' THEN Ext := '.TXT';
    setzeName (DateiSuffix, Ext);
    Dateiname := Dir + Name + Ext;
    setzeName (TextName, Dateiname);
    IF derFensterInhalt <> NIL THEN BEGIN
      PMyWindow (derFensterInhalt^.Owner)^.setPTitle (TextName);
    END;

    IF hatTextFlag (BackupDatei) THEN BEGIN
{$I-}
      FSplit (Dateiname, Dir, Name, Ext);
      Ext := '.BAK';
      BAKname := Dir + Name + Ext;
      Assign (Datei, BAKname); Erase (Datei);
      ok := IOResult = 0;
      Assign (Datei, Dateiname);
      Rename (Datei, BAKname);
      ok := IOResult = 0;
    END (* IF .BAK-Datei anlegen *);
{zeigMeldung ('Datei speichern', Dateiname);}
    Assign (Datei, Dateiname);
    Rewrite (Datei);
    IF IOResult <> 0 THEN BEGIN
      zeigMeldung ('Datei speichern', 'Die Datei "' + Dateiname +
                   '" konnte nicht erzeugt werden!');
      EXIT;
    END (* IF IORESULT *);
    seite := 1; zeile := 1; xpos := 0;
    WriteReport (Datei, FALSE, Seitenlaenge, seite, zeile, xpos,
                 hatTextflag (endlosAbsatz), hatTextFlag (Absatzkennung),
                 NIL {DruckerFilter}, nul, nul, AbsatzKennSet);
    Close (Datei);
    loescheInternFlag (TextEditiert);
{$I+}
  END (* IF Datei schreiben *);
END (* TextSpeichern *);

PROCEDURE einSimpleText.TextDrucken (CONST n: INTEGER);
VAR  Dateiname:    STRING;
     Datei:        ASCII;
     seite, zeile,
     xpos:        WORD;
     formf:       BOOLEAN;
     {buf:         ARRAY [0..4095] OF CHAR;}
     i:           INTEGER;
     Clip:        einSimpletextPointer;
BEGIN
  Dateiname := 'PRN'; {Dateiname := 'Test.PRN';}
  formf := FormfeedFlag IN meineTextFlags;
  Clip := Message (Desktop^.Owner, evCommand, cmGetClipboard, NIL);
  IF Clip <> NIL THEN DruckerFilter := Clip^.DruckerFilter
  ELSE zeigMeldung ('Druckerfilter', 'Nicht geladen');
  IF DruckFormfeed IN meineTextFlags THEN
    setzeTextFlag (FormfeedFlag)
  ELSE
    loescheTextFlag (FormfeedFlag);
  IF (Dateiname <> '') THEN BEGIN
    Assign (Datei, Dateiname);
    {SetTextBuf (Datei, buf);}
    Rewrite (Datei);
    IF DruckerInit <> NIL THEN
      DruckerInit^.WriteReport (Datei, FALSE, Seitenlaenge, seite, zeile, xpos, FALSE, FALSE, DruckerFilter,
                   DruckerPrefix, DruckerSuffix, AbsatzKennSet);
    FOR i := 1 TO n DO BEGIN
      seite := 1; zeile := 1; xpos := 0;
      WriteReport (Datei, TRUE, Seitenlaenge, seite, zeile, xpos, FALSE, FALSE, DruckerFilter,
                   DruckerPrefix, DruckerSuffix, AbsatzKennSet);
    END (* FOR *);
    IF DruckerExit <> NIL THEN
      DruckerExit^.WriteReport (Datei, FALSE, Seitenlaenge, seite, zeile, xpos, FALSE, FALSE, DruckerFilter,
                   DruckerPrefix, DruckerSuffix, AbsatzKennSet);
    Close (Datei);
  END (* IF Datei schreiben *);
  IF formf THEN setzeTextFlag (FormfeedFlag)
  ELSE loescheTextFlag (FormfeedFlag);
END (* TextDrucken *);

PROCEDURE einSimpleText.TextLaden (CONST psname: PString; CONST StartZeile: LONGINT;
                                   CONST Block: BOOLEAN);
VAR  Dateiname:    STRING;
     PN:           PathStr;
     DN:           DirStr;
     NN:           NameStr;
     EN:           ExtStr;
     Datei:        FILE; {ASCII;}
     zeile:        STRING;
     resetzeile:   STRING;
     ok, neu:      BOOLEAN;
     Dateiende:    BOOLEAN;
     buf:          ARRAY [0..4095] OF CHAR;
     schreibind,
     leseind:      INTEGER;
     umbruch:      INTEGER;

  PROCEDURE liesZeile (VAR Datei: FILE; VAR zeile: STRING;
                       CONST NoUmbruch: BOOLEAN);
  VAR i, j, oldi:    INTEGER;
      weiter:        BOOLEAN;
      ch, oldch:     CHAR;

    PROCEDURE liesBuffer;
    BEGIN
      IF EOF (Datei) THEN BEGIN
        weiter := FALSE; schreibind := 0; leseind := 0; Dateiende := TRUE;
{
ok := zeigFrage ('liesBuffer', 'EOF');
IF NOT ok THEN Halt;
}
      END
      ELSE BEGIN
        BlockRead (Datei, buf, SizeOf (buf), schreibind);
        leseind := 0;
{
ok := zeigFrage ('liesBuffer', 'BlockRead ausgefhrt');
IF NOT ok THEN HALT;
}
      END (* ELSE *);
    END (* liesBuffer *);

  BEGIN (* liesZeile *)
    IF (leseind >= schreibind) THEN liesBuffer;
    zeile := resetzeile; i := LENGTH (zeile);
    weiter := TRUE; resetzeile := ''; ch := nul;

    (* Zeile lesen bis zur Umbruchbreite oder Zeilenende *)
    WHILE weiter AND (NoUmbruch OR (i <= Umbruch)) AND (i < 255) DO BEGIN
      oldch := ch; ch := buf [leseind];
      IF (ch = cr) {OR (ch = lf)} THEN
        weiter := ((oldch = ' ') OR (oldch = '-')) AND hatTextflag (Absatzkennung)
      ELSE BEGIN
        IF (ch <> lf) AND (ch <> cr) THEN BEGIN
          INC (i);
          zeile [i] := ch;
        END (* IF kein lf *);
      END (* ELSE *);
      INC (leseind);
      IF leseind = schreibind THEN liesBuffer;
    END (* WHILE *);
{}
    (* ev. Umbruch rcksetzen *)
    IF NOT NoUmbruch AND (i > Umbruch) THEN BEGIN
{ok := zeigFrage ('i > Umbruch', zeile);
IF NOT ok THEN HALT;
}
      oldi := i;
      WHILE (i > 0) AND NOT (zeile [i] IN BlankSet) DO BEGIN
        DEC (i);
      END (* WHILE *);
      IF (oldi > i) AND (i > 0) THEN BEGIN
        FOR j := 1 TO oldi - i DO BEGIN
          resetzeile [j] := zeile [i + j];
        END (* FOR *);
        resetzeile [0] := CHR (oldi - i);
      END
      ELSE BEGIN
        i := oldi;
      END;
    END (* IF Umbruch *);

    IF NOT noUmbruch AND NOT weiter THEN BEGIN
      WHILE (i > 0) AND (zeile [i] = ' ') DO
        DEC (i);
    END (* Plenks entfernen *);
{}
    zeile [0] := CHR (i);
{ok := zeigFrage ('LiesZeile', zeile);
IF NOT ok THEN Halt;
}
  END (* LiesZeile *);

BEGIN (* TextLaden *)
  neu := FALSE;
  IF psname = NIL THEN BEGIN
    Dateiname := '*' + holeName (DateiSuffix);
    getFilename (Dateiname, '*Text laden', 'Textdatei', TRUE);
  END
  ELSE
    DateiName := psname^;
{
zeigMeldung ('SimpleText.TextLaden', DateiName);
}
  IF (Dateiname <> '') THEN BEGIN
{$I-}
    REPEAT
      Assign (Datei, Dateiname);
      {SetTextBuf (Datei, buf);}
      Reset (Datei, 1);
      ok := IOResult = 0;
      IF NOT ok THEN BEGIN
        ok := zeigFrage ('Text neu erzeugen',
        'Wollen Sie den Text "' + Dateiname + '" wirklich neu erzeugen');
        IF ok THEN neu := TRUE;
      END;
      IF NOT ok THEN BEGIN
{zeigMeldung ('SimpleText.TextLaden', 'Not ok: ' + DateiName);}
        getFileName (Dateiname, 'Text laden', 'Textdatei', TRUE);
        IF Dateiname = '' THEN EXIT;
      END (* IF NOT ok *);
    UNTIL ok;
{$I+}

    IF TextName = NIL THEN
      TextName := einString8Pointer (neuesObjekt (String8, []));

    IF NOT Block THEN TextName^.setzeString (Dateiname, TRUE);
    FSplit (Dateiname, DN, NN, EN);
    IF EN = '' THEN EN := '.TXT';
    setzeName (DateiSuffix, EN);
    IF derFensterInhalt <> NIL THEN BEGIN
      PMyWindow (derFensterInhalt^.Owner)^.setPTitle (TextName);
    END;

    leseind := 0; schreibind := 0; Dateiende := FALSE;
    umbruch := Umbruchbreite + 1; resetzeile := '';

    IF NOT neu THEN BEGIN
      IF NOT EOF (Datei) THEN BEGIN
        liesZeile (Datei, zeile, NOT hatTextflag (endlosAbsatz));
        IF Block THEN insertText (zeile) ELSE setzeText (zeile);
        IF Block THEN BEGIN
  {zeigMeldung ('Blockanfang', 'Zeile Nr. ' + StringVonNum (ZeilenNr));}
          setzeMerker (MerkerBlockAnfang);
        END;
      END (* IF *);

      WHILE NOT Dateiende AND (MaxAvail > needHeap (standardZeile)) DO BEGIN
        liesZeile (Datei, zeile, NOT hatTextflag (endlosAbsatz));
        IF NOT Dateiende OR (LENGTH (zeile) > 0) THEN BEGIN
          IF TabsFiltern IN meineTextFlags THEN expandiereTabs (zeile);
          insertText (zeile);
        END (* IF NOT Dateiende gelesen *);
      END (* WHILE *);
      IF MaxAvail <= needHeap (standardZeile) THEN BEGIN
        zeigMeldung (Dateiname, 'Text konnte nicht vollstndig geladen werden');
      END (* IF MaxAvail *);
      Close (Datei);
      IF Block THEN BEGIN
        {doEnd}
        {war eigentlich doEnd, aber das fhrt zu komischem Fehler
         durch ScrollTo}
        IF laufendeZeile <> NIL THEN BEGIN
          TextX := laufendeZeile^.getZ^.StringLaenge;
        END;
        setzeMerker (MerkerBlockEnde);
      END;
      zurZeile (Startzeile); doHome;
    END (* IF NOT neu *);
    derFensterInhalt^.SetLongLimit (255, AnzahlElemente);
    updateFenster (derFensterInhalt, 0);
  END (* IF Dateiname gltig *);
END (* TextLaden *);

PROCEDURE einSimpleText.CompiliereDruckerfilter;
VAR  index:  CHAR;
     outstr: STRING;
     ok:     BOOLEAN;
     i:      INTEGER;

  PROCEDURE getBefehl (VAR ind: CHAR; VAR out: STRING; VAR ok: BOOLEAN);
  VAR bef:    STRING;
      zch:    CHAR;

    PROCEDURE getCharConst (VAR ch: CHAR; VAR ok: BOOLEAN);
    VAR num: BYTE;
    BEGIN
      ch := CHR (0); num := 0; ok := FALSE;
      IF NOT (bef [i] IN ['0'..'9']) THEN BEGIN
        zeigMeldung ('getCharConst: "' + bef + '"',
                     'Ziffer von Zeichenkonstante erwartet, "'
                     + bef [i] + '" gefunden! [' + StringVonNum (i) + ']');
        ch := CHR (0); EXIT;
      END;
      WHILE (i <= LENGTH (bef)) AND (bef [i] IN ['0'..'9']) DO BEGIN
        num := num * 10 + ORD (bef [i]) - ORD ('0');
        INC (i);
      END (* WHILE *);
      IF num <= 255 THEN BEGIN
        ch := CHR (num); ok := TRUE;
      END
      ELSE zeigMeldung ('getCharConst', 'keine gltige Zeichenkonstante 0..255, "'
                         + StringVonNum (num) + '"');
    END (* getCharConst *);

    PROCEDURE getIndex (VAR ind: CHAR; VAR ok: BOOLEAN);
    BEGIN (* getIndex *)
      IF (i <= LENGTH (bef)) AND
        (bef [i] IN [' '..High (CHAR)]) AND (bef [i] <> '#') THEN BEGIN
        ind := bef [i]; ok := TRUE; INC (i);
      END
      ELSE BEGIN
        IF bef [i] = '#' THEN BEGIN
          INC (i);
          getCharConst (ind, ok);
        END
        ELSE BEGIN
          zeigMeldung ('getIndex', 'Zeichenkonstante ("A..Z" etc. oder "#" erwartet, aber "'
                        + bef [i] + '" gefunden!');
          ind := CHR (0); ok := FALSE;
        END (* ELSE *);
      END (* ELSE *);
    END (* getIndex *);

  BEGIN (* getBefehl *)
    out := '';
    IF laufendeZeile^.getZ <> NIL THEN BEGIN
      i := 1;
      bef := laufendeZeile^.getZ^.StringVonDaten;
    END
    ELSE BEGIN
      ind := CHR (0); EXIT;
    END;

    IF bef [1] = ';' THEN BEGIN
      ind := CHR (0); ok := TRUE; EXIT;
    END;

    getIndex (ind, ok);
    IF bef [i] <> ':' THEN BEGIN
      zeigMeldung ('getBefehl', '":" fehlt');
      ok := FALSE;
    END (* IF <> ':' *)
    ELSE BEGIN (* outstring kopieren *)
      {out := Copy (bef, i + 2, LENGTH (bef) - 1);}
      INC (i, 2);
      WHILE i <= LENGTH (bef) DO BEGIN
        IF bef [i] = '#' THEN BEGIN
          INC (i); getCharConst (zch, ok);
{zeigMeldung ('getCharConst', StringVonNum (ORD (zch)));}
          Insert (zch, out, LENGTH (out) + 1);
        END
        ELSE BEGIN
          Insert (bef [i], out, LENGTH (out) + 1);
          INC (i);
        END;
      END (* WHILE *);
    END (* ELSE outstring *);
  END (* getBefehl *);

BEGIN (* CompiliereDruckerfilter *)
{  zeigMeldung ('einSimpleText', 'CompiliereDruckerfilter');}

  ersteZeile;
  REPEAT
    getBefehl (index, outstr, ok);
    IF ok THEN BEGIN
      ok := SizeOf (DruckerFilter^[index]) - 1 >= LENGTH (outstr);
      IF NOT ok THEN BEGIN
        zeigMeldung ('Druckerbefehl ist zu lang:', outstr);
        EXIT;
      END
      ELSE DruckerFilter^[index] := outstr;
    END (* IF ok *);
    {IF not zeigFrage ('Outstring', index + ': ' + DruckerFilter^[index]) THEN EXIT;}
    IF NOT ok THEN BEGIN
      derFensterInhalt^.scrollTo (i, TextY + derFensterInhalt^.Size.Y DIV 2);
      {zeigMeldung ('Compiliere Druckerfilter', 'Wird wegen Fehler abgebrochen');}
      TextX := i - 1;
      updateFenster (derFensterInhalt, 0);
      EXIT;
    END;
    ZeilenVor (FALSE, 1);
  UNTIL NOT (hatNaechsteZeile (laufendeZeile));
  derFensterInhalt^.scrollTo (i, TextY + derFensterInhalt^.Size.Y DIV 2);
  TextX := i - 1;
  updateFenster (derFensterInhalt, 0);
END (* CompiliereDruckerfilter *);

PROCEDURE einSimpleText.GeneriereDruckerfilter;
VAR  index:    CHAR;
     fil:      STRING;

     FUNCTION TokenFrom (ch: CHAR): STRING;
     BEGIN
       IF (ch < ' ') OR (ch = '#') THEN BEGIN
         {TokenFrom := '<#' + StringVonNum (ORD (ch)) + '>'}
         TokenFrom := '#' + StringVonNum (ORD (ch))
       END
       ELSE TokenFrom := ch;
     END (* Token *);

BEGIN (* GeneriereDruckerfilter *)
  {zeigMeldung ('einSimpleText', 'GeneriereDruckerfilter');}
  TextLoeschen;
  macheZeilen (ORD (High (index)), AnzahlZeichen, UmbruchBreite, meineTextFlags, StandardZeile);
  ersteZeile;
  FOR index := Low (CHAR) TO High (Char) DO BEGIN
    IF (index <= ' ') OR (index = '#') THEN
         fil := '#' + StringVonNum (ORD (index)) + ': ' + TokenFrom (index)
    ELSE fil := index + ': ' + index;
    setzeText (fil);
    ZeilenVor (FALSE, 1);
  END (* FOR *);
  ersteZeile;
  updateFenster (derFensterInhalt, 0);
  setzeInternFlag (Texteditiert);
END (* GeneriereDruckerfilter *);

PROCEDURE einSimpleText.StringSuchen (CONST Befehl: WORD{;
                                      CONST PosOffset: INTEGER});
(* vorlufige provisorische Implementierung *)
VAR  ch:      CHAR;
     sw, tw:  STRING;
     t:       eineZeichenTabelle;
     fp:      INTEGER;
     gk, ws:  BOOLEAN;
     PosOffs: INTEGER;
BEGIN
  setzeMerker (altePos);
  sw := holeName (SuchWort);
  tw := holeName (TauschWort);

  {sucheVorwaerts := TRUE;}
  IF Befehl = cmStringRueckSuchen THEN sucheVorwaerts := FALSE
  ELSE IF Befehl = cmStringSuchen THEN sucheVorwaerts := TRUE;

  IF (Befehl <> cmNochmalSuchen) AND (Befehl <> cmNochmalTauschen) THEN BEGIN
    ch := EditStringTitel (4, 10, 70, 'Suchbegriff eingeben', sw);
    IF ch = Esc THEN EXIT;
    setzeName (SuchWort, sw);
    IF Befehl = cmStringTauschen THEN BEGIN
      IF NoEdit THEN EXIT;
      ch := EditStringTitel (4, 10, 70, 'Tauschbegriff eingeben', tw);
      IF ch = Esc THEN EXIT;
      setzeName (TauschWort, tw);
    END (* IF *);
  END (* IF *);
  IF sw = '' THEN EXIT;
  IF laufendeZeile <> NIL THEN BEGIN
    gk := GrossKleinEgal IN meineTextFlags;
    ws := WortSuche IN meineTextFlags;
    laufendeZeile^.getZ^.macheSuchTabelle (t, sw, gk);
    fp := laufendeZeile^.GetZ^.SPos (TextX + 1, sw, t, gk, ws, stopSet);
    IF sucheVorwaerts THEN
      WHILE hatNextElement AND (fp < 0) DO BEGIN
        ZeilenVor (FALSE, 1);
        fp := laufendeZeile^.GetZ^.SPos (0, sw, t, gk, ws, stopSet);
      END (* WHILE *)
    ELSE
      WHILE hatPrevElement AND (fp < 0) DO BEGIN
        ZeilenZurueck (FALSE, 1);
        fp := laufendeZeile^.GetZ^.SPos (0, sw, t, gk, ws, stopSet);
      END (* WHILE *);
    IF fp >= 0 THEN BEGIN (* der Suchbegriff wurde gefunden *)
      TextX := fp {+ LENGTH (sw)};
      IF Befehl = cmStringTauschen THEN BEGIN
      END (* IF *);
      IF (derFensterInhalt <> NIL) THEN BEGIN
        IF hatTextflag (FundstelleOnTop) THEN BEGIN
          IF sucheVorwaerts THEN
            PosOffs := derFensterInhalt^.Size.Y - 1

          ELSE
            PosOffs := 0
        END
        ELSE PosOffs := derFensterInhalt^.Size.Y DIV 2;
        {IF sucheVorwaerts THEN}
          derFensterInhalt^.ScrollTo (TextX, TextY + PosOffs)
        {
        ELSE
          derFensterInhalt^.ScrollTo (TextX, TextY - PosOffs)
        }
      END (* IF FensterInhalt <> NIL *);
      IF ((Befehl = cmStringTauschen) OR (Befehl = cmNochmalTauschen)) AND
         (NOT (TauschAbfrage IN meineTextFlags) OR
              zeigFrage ('Tausche', sw + ' durch ' + tw + ' ersetzen? '))
      THEN BEGIN
        IF NoEdit THEN EXIT;
        laufendeZeile^.GetZ^.ausfuege (fp, LENGTH (sw));
        laufendeZeile^.GetZ^.einfText (tw, fp + 1);
        TextX := fp + LENGTH (tw);
        laufendeZeile^.GetZ^.OffsetSchreib (derFensterInhalt, 0, TextY,
                                            derFensterInhalt^.Delta.X,
                                            Blockstart (laufendeZeile),
                                            Blockend (laufendeZeile),
                                            hatTextFlag (markiereAbschnitte),
                                            NOT hatNaechsteZeile (laufendeZeile));
        setzeInternFlag (TextEditiert);
      END (* IF *);
    END
    ELSE BEGIN zeigMeldung ('Nicht gefunden:', sw);
               zuMerker (altePos);
         END;
{zeigMeldung ('Suche: ' + sw, 'Position: ' + StringVonNum (fp))}
  END (* IF *);
END (* StringSuchen *);

END (* Simpeltext *).