{$A+,B-,D+,E+,F+,G+,I+,L+,N-,P-,Q+,R+,S+,T-,V-,X+,Y+}
{$M 65520, 0, 655360}
UNIT TextBase;

{$F+}
{$O+}

(* (C) 1990, 1991, 1992, 1993, 1994, 1995, 1996 by Johannes Leckebusch
   Version 1.000
   Anpassung an TP: 9. 12. 90
   23. 03. 93: Nichtrekursives Lschen von Text und Textobjekt
   Stand: 19. 12. 1995
*)


INTERFACE

USES Objects, Drivers, {My}Views, GLFTypes, GLFBase, ObjStrings, GLFNodes,
     GLFLists, GLFViews;

TYPE

  (* Diese Klasse ist fr die Korrespondenz zwischen Zeilen zustndig,
     z. B. fr weiterversendete Nachrichten von Zeile zu Zeile. *)

  einTextGluePointer = ^einTextGlue;
  einTextGlue = OBJECT (einTriple)
                          CONSTRUCTOR Init (CONST xflags: einFlagSet);
                          DESTRUCTOR Done; VIRTUAL;
                          PROCEDURE LoeschPfad (Const Sig: LONGINT); VIRTUAL;
                          FUNCTION erzeugeMich (CONST xflags: einFlagSet): GLP; VIRTUAL;
                          FUNCTION isSubclass (CONST class: einGenTyp): BOOLEAN; VIRTUAL;
                          FUNCTION getDataStr: STRING; VIRTUAL;
                          FUNCTION getDataPointer: GLP; VIRTUAL;
                          PROCEDURE sende (CONST view: PBuffText; VAR ereignis: TEvent;
                                           CONST Sig: LONGINT);
                            VIRTUAL;
                          FUNCTION ZeileLeer: BOOLEAN; VIRTUAL;
                          FUNCTION AbsatzEnde (CONST Blankkennung: BOOLEAN;
                                               CONST AbsKenn: CHSet): BOOLEAN; VIRTUAL;
                          PROCEDURE insertAtBeginFrom (CONST StringP: GLP; CONST Start: LONGINT);
                            VIRTUAL;
                          PROCEDURE appendAtEndFrom (CONST s: STRING);
                            VIRTUAL;
                          FUNCTION getFromBegin (CONST Anzahl: LONGINT;
                                   CONST blankSet: CHSet;
                                   CONST Blankkennung: BOOLEAN;
                                   VAR geleert: LONGINT): STRING;
                            VIRTUAL;
                END (* einTextGlue *);

  MerkerRelation = (undefiniert, davor, drauf, danach);

                einMerkerPointer = ^einMerker;
                einMerker = OBJECT (einTextGlue)
                (* Letzten Endes sind Merker Iteratoren ... *)
                              derKnoten: GLP;
                              ZeilenX: LONGINT;
                              ZeilenNummer: LONGINT;
                              CONSTRUCTOR Init (CONST xflags: einFlagSet);
                              DESTRUCTOR Done; VIRTUAL;
                              FUNCTION erzeugeMich (CONST xflags: einFlagSet): GLP; VIRTUAL;
                              FUNCTION isSubclass (CONST class: einGenTyp): BOOLEAN; VIRTUAL;
                              FUNCTION getZ: einStringPointer;
                              FUNCTION MerkerIst (CONST Bezugsmerker: einMerkerPointer;
                                                  VAR XDiff, BE: LONGINT): MerkerRelation;
                              PROCEDURE MerkerAuf (CONST Bezugsmerker: einMerkerPointer);
                              PROCEDURE MerkerAufNr (CONST Nummer: LONGINT);
                              PROCEDURE MerkerZeilenVor (Anzahl: LONGINT);
                              PROCEDURE MerkerNaechsteZeile;
                              PROCEDURE MerkerVorigeZeile;
                            END (* einMerker *);

  einTextFlag = (
                 (* Edit-Flags *)
                 InsertFlag, {0}
                 AutoIndent,
                 AutoUmbruch, {2}
                 AutoAppend,
                 LoescheBlanks,
                 NurLesen, {5}

                 (* Datei-Flags *)
                 TabsFiltern, {6}
                 AutoSave, {7}
                 BackupDatei,
                 SpeichImmerFragen,
                 ExitOhneFrage, {10}

                 (* Drucker-Flags *)
                 ZeilenNumerieren, {11}
                 FormfeedFlag,
                 DruckFormfeed,
                 EinzelblattEinzug,
                 DruckeMitKopfzeile, {15}
                 DruckeMitFusszeile,
                 zentriereKopfFuss, {17}
                 rechtsKopfFuss, {18}

                 (* Block & Clipboard *)
                 loescheInUndo, {19}
                 loescheInClipboard,
                 ClipboardLoeschen, {21}

                 (* Suchen & Tauschen *)
                 WortSuche, {22}
                 GrossKleinEgal,
                 TauschAbfrage,
                 markiereAbschnitte,
                 FundstelleOnTop, {26}

                 (* Oberflaeche *)
                 FensterImmerGross, {27}
                 UmgebungWHerstell, {28}
                 FrageVorFormat,

                 (* Reserviert *)
                 EndlosAbsatz,
                 Absatzkennung
                 );


  einInternFlag = (
                 istUndopuffer, {Internflag0}
                 TextOffen,
                 TextEditiert,
                 istProtokollpuffer,
                 istClipboard, {4}
                 DateinameAbfragen,
                 istFalte, {6}
                 benutzeDruckerFilter,
                 Internflag8,
                 Internflag9,
                 Internflag10,
                 Internflag11,
                 Internflag12,
                 Internflag13,
                 Internflag14,
                 Internflag15
                 );


(* Flags (16 Bit):
   InsertFlag: Wenn gesetzt, Zeichen einfgen, sonst berschreiben
   NumFlag: Wenn gesetzt, bei Ausdruck Zeilen numerieren
   AutoAppend: Bei Return neue Zeile anfgen (bei berschreiben)
   *** nicht mehr vorgesehen ***
   FixZeilen: Anzahl Zeilen fest vorgegeben (Displays)
   FixZeichen: Anzahl Zeichen fest vorgegeben (Displays)
   *****************************
   TabsFiltern: Tab-Steuerzeichen beim Laden von Texten expandieren
   Formfeedflag: Beim Abspeichern v. Text FF einfgen
   DruckFormfeed: Beim Drucken Seiten durch FF vorschieben
   NurLesen: Hilfstext etc., der nicht editierbar ist
   AutoIndent: Automatisch einrcken bei Return
   TextEditiert: Text wurde verndert
   AutoSave: Nach AutoSaveN Eingaben oder Zeit automatisch sichern
   LoescheInUndo: Gelschte Zeilen in meinUndoText kopieren
   LoescheInClipboard: Gelschten Block in Clipboard kopieren
   KeinVorlauf: Wenn Edit von Unterklasse aufgerufen wird: Vorlauf
     (Anzeige der Seite etc.) unterdrcken
   KeinNachlauf: Nachlauf in Edit unterlassen
   LoescheBlanks: Leerzeichen am Ende der Zeile automatisch entfernen
*)

  einTextFlagset =      SET OF einTextFlag;
  einInternFlagset =    SET OF einInternFlag;

  einTextPointer = ^einText;
  einText =       OBJECT (eineTabelle)
                          AnzahlZeichen:        LONGINT; (* max pro Zeile *)
                          UmbruchBreite:        WORD;
                          Seitenlaenge:         WORD;
                          Tablaenge:            WORD;
                          Druckoffset:          WORD;
                          AbsatzKennSet:        CHSet;
                          blankSet:             CHSet;
                          stopSet:              CHSet;
                          nonblankSet:          CHSet;
                          FensterAnzeigen:      BOOLEAN;

                          TextX:                LONGINT;

                          AutoSaveN:            WORD;
                          meineTextFlags:       einTextFlagset;
                          meineInternFlags:     einInternFlagset;
                          meineNachrichten:     TEvent;
                          StandardZeile:        einGenTyp;

                          meineDatei:           GLP;
                          meinUndoText:         GLP;
                          derFensterInhalt:     PTextGrafik;
                          (* das ist der Fenster-Inhalt! *)

                          laufendeZeile:        einMerkerPointer;
                          Alias:                einListenPointer;
                          (* Pointer auf eine Liste von Merkern *)
                          TextName:             einString8Pointer;
                          KopfZeile:            einString8Pointer;
                          FussZeile:            einString8Pointer;
                          DateiSuffix:          einString8Pointer;
                          ZeilPrefix:           einString8Pointer;
                          DruckerInit:          einString8Pointer;
                          DruckerExit:          einString8Pointer;
                          SuchWort:             einString8Pointer;
                          TauschWort:           einString8Pointer;
                          F1F:                  einString8Pointer;
                          F2F:                  einString8Pointer;
                          F3F:                  einString8Pointer;
                          F4F:                  einString8Pointer;
                          F5F:                  einString8Pointer;
                          F6F:                  einString8Pointer;
                          F7F:                  einString8Pointer;
                          F8F:                  einString8Pointer;
                          F9F:                  einString8Pointer;
                          F0F:                  einString8Pointer;
                          sucheVorwaerts:       BOOLEAN;
                          insertCode:           BOOLEAN;
                          Prefix:               WORD;

                          altePos:              einMerkerPointer;
                          MerkerBlockanfang:    einMerkerPointer;
                          MerkerBlockende:      einMerkerPointer;
                          MerkerBlockmove:      einMerkerPointer;
                          {ff vorlufig - mchte lieber Merkerliste!}
                          Merker0:              einMerkerPointer;
                          Merker1:              einMerkerPointer;
                          Merker2:              einMerkerPointer;
                          Merker3:              einMerkerPointer;
                          Merker4:              einMerkerPointer;
                          Merker5:              einMerkerPointer;
                          Merker6:              einMerkerPointer;
                          Merker7:              einMerkerPointer;
                          Merker8:              einMerkerPointer;
                          Merker9:              einMerkerPointer;

                          DruckerFilter:        PeinDruckerFilter;
                          DruckerPrefix:        CHAR;
                          DruckerSuffix:        CHAR;

                          TextLaenge:           LONGINT;
                          getippt:              LONGINT;

                          CONSTRUCTOR Init (CONST xflags: einFlagSet);
                          DESTRUCTOR Done; VIRTUAL;
                          PROCEDURE LoeschPfad (CONST Sig: LONGINT); VIRTUAL;

                          FUNCTION erzeugeMich (CONST xflags: einFlagSet): GLP; VIRTUAL;

                          FUNCTION isSubclass (CONST class: einGenTyp): BOOLEAN; VIRTUAL;
                          FUNCTION neuesElement (CONST Objekt: GLP): GLP;
                            VIRTUAL;

                          PROCEDURE initDruckerFilter;

                          PROCEDURE zeigFenster (CONST view: PBuffText; CONST x, y, b, h: WORD;
                                      CONST zeichneFen: BOOLEAN); VIRTUAL;
                          PROCEDURE schreibStatus;
                          PROCEDURE zeigTextFlags (CONST Titel: STRING); VIRTUAL;
                          PROCEDURE zeigFStrings (CONST Titel: STRING); VIRTUAL;
                          PROCEDURE updateFenster (CONST view: PBuffText; CONST abZeile: LONGINT);
                            VIRTUAL;
                          PROCEDURE setzFensterInhalt (CONST FensterInhalt: PBuffText); VIRTUAL;
                          FUNCTION getFensterInhalt: PBuffText; VIRTUAL;

                          PROCEDURE setzeName (VAR derString: einString8Pointer;
                                               CONST n: STRING);
                          FUNCTION holeName (derString: einString8Pointer): STRING;
                          FUNCTION Edit (CONST view: PBuffText; CONST x, y, b, h: WORD;
                                         CONST name: GLP): GLP; VIRTUAL;
                          PROCEDURE initAbmess (VAR a: TRect; VAR spbreite: INTEGER);
                            VIRTUAL;
                          PROCEDURE setzeFensterAbmess (a: TRect);
                            VIRTUAL;

                          FUNCTION TextY: LONGINT;

                          PROCEDURE TextLoeschen; VIRTUAL;

                          PROCEDURE macheZeilen (CONST Zeilen, Zeichen: LONGINT;
                                                 CONST Breite: WORD;
                                                 CONST TextFlags: einTextFlagset;
                                                 CONST ZeilenTyp: einGenTyp);
                                                  VIRTUAL;
                          PROCEDURE insertZeile; VIRTUAL;
                          PROCEDURE appendZeile; VIRTUAL;
                          PROCEDURE insertZeileVor; VIRTUAL;
                          FUNCTION deleteZeile: GLP; VIRTUAL;
                          FUNCTION getZeile: GLP; VIRTUAL;
                          FUNCTION popZeile: GLP; VIRTUAL;
                          PROCEDURE deleteZeilen (CONST n: LONGINT); VIRTUAL;
                          PROCEDURE insertObjektBefore (CONST O: GLP); VIRTUAL;
                          PROCEDURE insertObjekt (CONST O: GLP); VIRTUAL;
                          PROCEDURE ersteZeile; VIRTUAL;
                          PROCEDURE FensterScroll (CONST X, Y: LONGINT);
                          PROCEDURE ZeilenZurueck (CONST scroll: BOOLEAN; CONST n: LONGINT);
                          PROCEDURE ZeilenVor (CONST scroll: BOOLEAN; CONST n: LONGINT);
                            VIRTUAL;
                          PROCEDURE letzteZeile; VIRTUAL;
                          PROCEDURE zurZeile (CONST n: LONGINT); VIRTUAL;
                          PROCEDURE zuMerker (m: einMerkerPointer); VIRTUAL;
                          PROCEDURE setzeMerker (VAR m: einMerkerPointer); VIRTUAL;
                          PROCEDURE PasteBlockFromClipboard; VIRTUAL;
                          PROCEDURE loescheBlock; VIRTUAL;
                          PROCEDURE CopyBlockToClipboard; VIRTUAL;
                          PROCEDURE CutBlockToClipboard (CONST toClipboard: BOOLEAN); VIRTUAL;
                          PROCEDURE NILMerker (VAR m: einMerkerPointer); VIRTUAL;
                          PROCEDURE NILAllMerker; VIRTUAL;
                          PROCEDURE MerkerUpdate (Von: einMerkerPointer); VIRTUAL;
                          FUNCTION BlockStart (CONST BezugsMerker: einMerkerPointer): INTEGER;
                          FUNCTION BlockEnd (CONST BezugsMerker: einMerkerPointer): INTEGER;
                          FUNCTION hatNaechsteZeile (CONST zuZeile: einMerkerPointer): BOOLEAN;
                          FUNCTION hatVorigeZeile (CONST zuZeile: einMerkerPointer): BOOLEAN;
                          PROCEDURE setzeText (CONST s: STRING); VIRTUAL;
                          PROCEDURE insertText (CONST s: STRING); VIRTUAL;
                          PROCEDURE expandiereTabs (VAR s: STRING);
                          PROCEDURE holeText (VAR s: STRING); VIRTUAL;
                          PROCEDURE setzeLongText (CONST s); VIRTUAL;
                          PROCEDURE insertLongText (CONST s); VIRTUAL;
                          PROCEDURE holeLongText (VAR s); VIRTUAL;

                          PROCEDURE setzeTextFlag (CONST f: einTextFlag); VIRTUAL;
                          PROCEDURE loescheTextFlag (CONST f: einTextFlag); VIRTUAL;
                          PROCEDURE toggleTextFlag (CONST f: einTextFlag); VIRTUAL;
                          FUNCTION  hatTextFlag (CONST f: einTextFlag): BOOLEAN; VIRTUAL;
                          FUNCTION StringVonTextflag (CONST Flag: einTextFlag): STRING;
                          FUNCTION StringVonTextflags: STRING;

                          PROCEDURE setzeInternFlag (CONST f: einInternFlag); VIRTUAL;
                          PROCEDURE loescheInternFlag (CONST f: einInternFlag); VIRTUAL;
                          PROCEDURE toggleInternFlag (CONST f: einInternFlag); VIRTUAL;
                          FUNCTION  hatInternFlag (CONST f: einInternFlag): BOOLEAN; VIRTUAL;
                          FUNCTION StringVonInternflag (CONST Flag: einInternFlag): STRING;
                          FUNCTION StringVonInternflags: STRING;

                          FUNCTION NoEdit: BOOLEAN;

                          PROCEDURE CfgSpeichern; VIRTUAL;
                          PROCEDURE CfgLaden (CONST fragen: BOOLEAN); VIRTUAL;
                          PROCEDURE zeigTextlaenge; VIRTUAL;
                          PROCEDURE zeigBlocklaenge; VIRTUAL;

                          PROCEDURE doCh; VIRTUAL;
                          PROCEDURE doZch; VIRTUAL;
                          PROCEDURE doStr; VIRTUAL;
                          PROCEDURE InsStr (CONST SP: einString8Pointer); VIRTUAL;
                          PROCEDURE zentriereZeile; VIRTUAL;
                          PROCEDURE doUmbruch; VIRTUAL;
                          PROCEDURE AbsatzAnfang (CONST Skip: BOOLEAN); VIRTUAL;
                          PROCEDURE AbsatzEnde (CONST Skip: BOOLEAN); VIRTUAL;
                          PROCEDURE DownFormat; VIRTUAL;
                          PROCEDURE doDownFormat; VIRTUAL;
                          PROCEDURE doFormat; VIRTUAL;
                          PROCEDURE doDokFormat; VIRTUAL;
                          PROCEDURE doRot13; VIRTUAL;
                          PROCEDURE doDownRot13; VIRTUAL;
                          PROCEDURE doKrypt; VIRTUAL;
                          PROCEDURE doDownKrypt; VIRTUAL;
                          PROCEDURE doBs; VIRTUAL;
                          PROCEDURE doLinedel; VIRTUAL;
                          PROCEDURE doLineUndel; VIRTUAL;
                          PROCEDURE doCr; VIRTUAL;
                          PROCEDURE doTab; VIRTUAL;
                          PROCEDURE doF1; VIRTUAL;
                          PROCEDURE doUp; VIRTUAL;
                          PROCEDURE doDown; VIRTUAL;
                          PROCEDURE doLeft; VIRTUAL;
                          PROCEDURE doRight; VIRTUAL;
                          PROCEDURE doPgup; VIRTUAL;
                          PROCEDURE doPgdown; VIRTUAL;
                          PROCEDURE doHome; VIRTUAL;
                          PROCEDURE doEnd; VIRTUAL;
                          FUNCTION sucheWortAnfang (CONST zset: CHSet): LONGINT; VIRTUAL;
                          FUNCTION sucheWortEnde (CONST zset: CHSet): LONGINT; VIRTUAL;
                          FUNCTION sucheNaechstesWort (CONST zset: CHSet): LONGINT; VIRTUAL;
                          PROCEDURE doIns; VIRTUAL;
                          PROCEDURE doDel; VIRTUAL;
                          PROCEDURE doMaus (x, y: LONGINT); VIRTUAL;
                        END (* einText *);


IMPLEMENTATION

USES DOS, {My}App, {My}Dialogs, StdDlg, Fields, EditStuff,
  GLFStructures, TVMenuString, GLFWindows;

(************************ Methoden zu TextGlues **************************)

CONSTRUCTOR einTextGlue.Init;
BEGIN
  INHERITED Init (xflags);
  MeinTyp := TextGlue;
END (* Init *);

DESTRUCTOR einTextGlue.Done;
(* Update: 23. 3. 93, iteratives Done *)
VAR  p, next:  GLP;
BEGIN
  {INHERITED Done;}

  p := Links; IF Rechts <> NIL THEN Dispose (Rechts, Done);
  WHILE p <> NIL DO BEGIN
    WITH einTextGluePointer (p)^ DO BEGIN
      next := Links;
      Links := NIL;
      IF Rechts <> NIL THEN Dispose (Rechts, Done); Rechts := NIL;
      Dispose (p, Done);
      (* ohne Aufruf des Destructors wird nicht aller Speicher frei *)
    END (* WITH *);
    p := next;
  END (* WHILE *);

END (* Done *);

PROCEDURE einTextGlue.LoeschPfad;
(* Update: 23. 3. 93: iteratives LoeschPfad *)
VAR  p, next:  GLP;
BEGIN
  Rueck := NIL;
  p := Links;
  WHILE p <> NIL DO BEGIN
    WITH einTextGluePointer (p)^ DO BEGIN
      Rueck := NIL;
      next := Links;
    END (* WITH *);
    p := next;
  END (* WHILE *);
END (* LoeschPfad *);

FUNCTION einTextGlue.erzeugeMich (CONST xflags: einFlagSet): GLP;
BEGIN
  erzeugeMich := NEW (einTextGluePointer, Init (xflags));
END (* erzeugeMich *);

FUNCTION einTextGlue.isSubclass (CONST class: einGenTyp): BOOLEAN;
BEGIN
  isSubclass := (class = TextGlue) OR INHERITED isSubClass (class);
END (* Member *);

FUNCTION einTextGlue.getDataStr: STRING;
BEGIN
  IF Rechts <> NIL THEN BEGIN
    getDataStr := einStrukturPointer (Rechts)^.StringVonDaten;
  END
  ELSE BEGIN
    getDataStr := '<Leerzeile>';
  END;
END (* getDataString *);

FUNCTION einTextGlue.getDataPointer: GLP;
BEGIN
  getDataPointer := Rechts;
END (* getDataPointer *);

PROCEDURE einTextGlue.sende (CONST view: PBuffText; VAR ereignis: TEvent;
                             CONST Sig: LONGINT);
BEGIN
  GLF.sende (view, ereignis, Sig); (* setzt msgFlag *)
  IF (Rechts <> NIL) AND (Rechts^.meineSignatur <> Sig) AND (ereignis.what <> evNothing) THEN
    Rechts^.sende (view, ereignis, Sig);
  IF (Links <> NIL) AND (Links^.meineSignatur <> Sig) AND (ereignis.what <> evNothing) THEN
    Links^.sende (view, ereignis, Sig);
END (* sende *);

FUNCTION einTextGlue.ZeileLeer: BOOLEAN;
BEGIN
  ZeileLeer := (Rechts = NIL) OR
    ((Rechts^.isSubClass (StringG)) AND
     (einStringPointer (Rechts)^.StringLaenge = 0))
END (* ZeileLeer *);

FUNCTION einTextGlue.AbsatzEnde (CONST Blankkennung: BOOLEAN;
                                 CONST AbsKenn: CHSet): BOOLEAN;
BEGIN
  AbsatzEnde := (Rechts = NIL) OR
    ((Rechts^.isSubClass (StringG)) AND
     (einStringPointer (Rechts)^.AbsatzEnde (TRUE, Blankkennung, AbsKenn)))
END (* ZeileLeer *);

PROCEDURE einTextGlue.insertAtBeginFrom (CONST StringP: GLP; CONST Start: LONGINT);
VAR  s:  STRING;
BEGIN
  IF (Rechts <> NIL) AND (Rechts^.isSubClass (StringG)) THEN BEGIN
    einStringPointer (StringP)^.splitText (s, Start);
    einStringPointer (Rechts)^.einfText (s, 1);
  END (* IF *);
END (* InsertAtBeginFrom *);

PROCEDURE einTextGlue.appendAtEndFrom (CONST s: STRING);
BEGIN
  IF (Rechts <> NIL) AND (Rechts^.isSubClass (StringG)) THEN BEGIN
    einStringPointer (Rechts)^.anhText (s);
  END (* IF *);
END (* appendAtEndFrom *);

FUNCTION einTextGlue.getFromBegin (CONST Anzahl: LONGINT; CONST blankSet: CHSet;
           CONST Blankkennung: BOOLEAN; VAR geleert: LONGINT): STRING;
VAR  s, s1:  STRING;
     cutInd: LONGINT;
     {letzte: BOOLEAN;}
BEGIN
  IF (Rechts <> NIL) AND (Rechts^.isSubClass (StringG)) AND
     (einStringPointer (Rechts)^.StringLaenge > 0) THEN BEGIN
     {NOT (einStringPointer (Rechts)^.AbsatzEnde (Blankkennung)) THEN BEGIN}
    {letzte := einStringPointer (Rechts)^.AbsatzEnde (Blankkennung);}
    IF (einStringPointer (Rechts)^.StringLaenge < Anzahl) THEN
      (* Nimm das letzte Wort auf jeden Fall mit, wenn die Zeile zu
         kurz ist - nicht erst das Wort davor oder keines! *)
      cutInd := einStringPointer (Rechts)^.StringLaenge
    ELSE
      cutInd := einStringPointer (Rechts)^.backScan (blankSet, Anzahl);
    IF (einStringPointer (Rechts)^.holeZch (cutInd) IN blankSet) (* Nicht Wort anschneiden! *)
      AND (cutInd < einStringPointer (Rechts)^.StringLaenge) THEN
      INC (cutInd); (* Plenk nach Wort mitkopieren! *)
    einStringPointer (Rechts)^.extractText (s, cutInd);
    IF (einStringPointer (Rechts)^.StringLaenge = 0) AND (Links <> NIL)
    {IF (einStringPointer (Rechts)^.AbsatzEnde (Blankkennung)) AND (Links <> NIL)}
    {IF NOT letzte AND (Links <> NIL)}
       AND (cutInd < Anzahl) THEN BEGIN
      s1 := einTextGluePointer (Links)^.getFromBegin (Anzahl - cutInd, blankSet, Blankkennung, geleert);
    END (* IF hat nicht gereicht *)
    ELSE BEGIN s1 := '';
{zeigMeldung ('getFromBegin', 'Terminiere 1');}
    END;
    IF einStringPointer (Rechts)^.StringLaenge = 0 THEN INC (geleert);
    getFromBegin := s + s1;
  END
  ELSE BEGIN getFromBegin := '';
{zeigMeldung ('getFromBegin', 'Terminiere END');}
  END;
END (* getFromBegin *);

(*************************** Methoden zu Merker ************************)

CONSTRUCTOR einMerker.Init;
BEGIN
  INHERITED Init (xflags);
  MeinTyp := Merker;
  {derKnoten := NIL; ZeilenX := 0; ZeilenNummer := 0;}
END (* Init *);

DESTRUCTOR einMerker.Done;
BEGIN
  setLinks (NIL); setRechts (NIL); setRueck (NIL); derKnoten := NIL;
  INHERITED Done;
END (* Done *);

FUNCTION einMerker.erzeugeMich (CONST xflags: einFlagSet): GLP;
BEGIN
  erzeugeMich := NEW (einMerkerPointer, Init (xflags));
END (* erzeugeMich *);

FUNCTION einMerker.isSubclass (CONST class: einGenTyp): BOOLEAN;
BEGIN
  isSubclass := (class = Merker) OR INHERITED isSubClass (class);
END (* Member *);

FUNCTION einMerker.getZ: einStringPointer;
(* Dies ist eigentlich "syntactic shugar", da man sonst immer schreiben
   mte: einStringPointer (MerkerPointer^.Rechts).
   Es ist eine TP-Spezialitt, das Dereferenzieren des von einer Funktion
   zurckgegebenen Pointers zuzulassen! Effizienter wre freilich obiger
   Schmus! *)
BEGIN
  getZ := einStringPointer (Rechts);
END (* getZ *);

FUNCTION einMerker.MerkerIst (CONST Bezugsmerker: einMerkerPointer;
                              VAR XDiff, Be: LONGINT): MerkerRelation;
BEGIN
  IF BezugsMerker = NIL THEN BEGIN
    XDiff := 0; Be := 0; MerkerIst := undefiniert;
  END
  ELSE IF ZeilenNummer > Bezugsmerker^.Zeilennummer THEN BEGIN
    MerkerIst := davor; XDiff := 0; Be := 0;
  END
  ELSE IF ZeilenNummer < Bezugsmerker^.Zeilennummer THEN BEGIN
    MerkerIst := danach;
    IF Rechts = NIL THEN Be := 0
    ELSE Be := einStringPointer (Rechts)^.StringLaenge;
    XDiff := Be;
  END
  ELSE BEGIN
    MerkerIst := drauf; Be := Bezugsmerker^.ZeilenX;
    XDiff := Be - ZeilenX;
  END;
END (* MerkerIst *);

PROCEDURE einMerker.MerkerAuf (CONST BezugsMerker: einMerkerPointer);
BEGIN
  IF BezugsMerker = NIL THEN EXIT;
  derKnoten := BezugsMerker^.derKnoten;
  ZeilenX := BezugsMerker^.ZeilenX;
  ZeilenNummer := BezugsMerker^.ZeilenNummer;
  setRechts (einKnotenPointer (derKnoten)^.RechtsIst);
END (* MerkerAuf *);

PROCEDURE einMerker.MerkerAufNr (CONST Nummer: LONGINT);
BEGIN
  WHILE (Nummer > ZeilenNummer) AND (derKnoten <> NIL) DO BEGIN
    derKnoten := einKnotenPointer (derKnoten)^.Links;
    INC (ZeilenNummer);
  END (* WHILE *);
  WHILE (Nummer < ZeilenNummer) AND (derKnoten <> NIL) DO BEGIN
    derKnoten := einTriplePointer (derKnoten)^.Rueck;
    DEC (ZeilenNummer);
  END (* WHILE *);
  IF derKnoten <> NIL THEN setRechts (einKnotenPointer (derKnoten)^.RechtsIst);
END (* MerkerAufNr *);

PROCEDURE einMerker.MerkerZeilenVor (Anzahl: LONGINT);
BEGIN
  WHILE (Anzahl > 0) AND (derKnoten <> NIL) DO BEGIN
    derKnoten := einKnotenPointer (derKnoten)^.Links;
    INC (ZeilenNummer); DEC (Anzahl);
  END (* WHILE *);
  WHILE (Anzahl < 0) AND (derKnoten <> NIL) DO BEGIN
    derKnoten := einTriplePointer (derKnoten)^.Rueck;
    DEC (ZeilenNummer); INC (Anzahl);
  END (* WHILE *);
  IF derKnoten <> NIL THEN setRechts (einKnotenPointer (derKnoten)^.RechtsIst);
END (* MerkerZeilenVor *);

PROCEDURE einMerker.MerkerNaechsteZeile;
BEGIN
  IF derKnoten <> NIL THEN derKnoten := einKnotenPointer (derKnoten)^.Links;
  INC (ZeilenNummer);
  IF derKnoten <> NIL THEN setRechts (einKnotenPointer (derKnoten)^.RechtsIst);
END (* MerkerNaechsteZeile *);

PROCEDURE einMerker.MerkerVorigeZeile;
BEGIN
  IF derKnoten <> NIL THEN derKnoten := einTriplePointer (derKnoten)^.Rueck;
  DEC (ZeilenNummer);
  IF derKnoten <> NIL THEN setRechts (einKnotenPointer (derKnoten)^.RechtsIst);
END (* MerkerVorigeZeile *);

(**************************** Methoden zu einText ************************)

CONSTRUCTOR einText.Init;
VAR  n:     LONGINT;
     Clip:  einTextPointer;
BEGIN
  {Trace ('Simpletext.Init');}
  INHERITED Init (xflags);
  MeinTyp := TextBas;

  IF noXInit IN meineFlags THEN
    TextName := NIL
  ELSE BEGIN
    {TextName := einString8Pointer (neuesObjekt (String8, []));}
    n := neuNum;
    setzeName (TextName, 'TEXT' + StringVonNum (n) + '.TXT');
  END (* ELSE noXInit *);

  sucheVorwaerts := TRUE;

  IF Desktop <> NIL THEN
    Clip := Message (Desktop^.Owner, evCommand, cmGetClipboard, NIL)
  ELSE Clip := NIL;
  IF Clip = NIL THEN BEGIN
    AnzahlZeichen := 255; (* Default max. Zeilenlnge/Vorgabelnge *)
    UmbruchBreite := 70;  (* Default Breite fr Textumbruch *)
    Seitenlaenge := 59;   (* Default Lnge fr Seitenumbruch *)
    Tablaenge := 8;       (* Default Lnge fr Tab-Abstnde *)
    Druckoffset := 5;     (* Default Einrckung beim Drucken *)

    stopSet := [' ',  ',', ';', '.', '!', '?', '<', '>', '|', '/', '(',  ')',
                 '[', ']', '{', '}', '\', '+', '-', '*', '~', '#'];
    blankSet := [' ', '|', '/', '\', '+', '-', '*', '~'{, '#'}];
    AbsatzKennSet := [' ', '-'];
    nonBlankSet := [#1..#255] - blankSet;
    FensterAnzeigen := TRUE;
    {TextX := 0;} (* Macht der Konstruktor *)
    (* TextY := 0; ist jetzt eine Funktion, die ElementIndex liefert *)
    AutoSaveN := 2000;
    meineTextFlags := [InsertFlag, AutoAppend, AutoUmbruch, DruckFormfeed,
                       loescheBlanks,
                       TabsFiltern, loescheInUndo, loescheInClipboard,
                       ClipboardLoeschen,
                       DruckeMitKopfzeile, zentriereKopfFuss {,
                       DruckeMitFusszeile, rechtsKopfFuss},
                       grossKleinEgal, BackupDatei, SpeichImmerFragen,
                       markiereAbschnitte, FensterImmerGross{,
                       AbsatzNoBlank, EndlosAbsatz}];
    meineInternFlags := [DateinameAbfragen, benutzeDruckerFilter];

    setzeName (KopfZeile, 'Datei: $, Seite - # -');
    {setzeName (Fusszeile, 'Seite - # -');}
    setzeName (DateiSuffix, '.TXT');
    setzeName (ZeilPrefix, ':');
    setzeName (DruckerInit, ' '); setzeName (DruckerExit, ' ');
    setzeName (F1F, 'Alt-F1');
    setzeName (F2F, 'Alt-F2');
    setzeName (F3F, 'Alt-F3');
    setzeName (F4F, 'Alt-F4');
    setzeName (F5F, 'Alt-F5');
    setzeName (F6F, 'Alt-F6');
    setzeName (F7F, 'Alt-F7');
    setzeName (F8F, 'Alt-F8');
    setzeName (F9F, 'Alt-F9');
    setzeName (F0F, 'Alt-F0');
    DruckerPrefix := ''; DruckerSuffix := '';

    IF ObjekteInitialisiert THEN BEGIN
      initDruckerfilter;
      CFGLaden (false);
    END;

    InitEreignis (meineNachrichten);
    StandardZeile := String8;
    {
    meineDatei := NIL; meinUndoText := NIL;
    derFensterInhalt := NIL;
    }
    InitAbmess (Abmess, Spaltenbreite);
    {
    FenOffset.X := 0; FenOffset.Y := 0;
    laufendeZeile := NIL; Alias := NIL;
    }
    {
    KopfZeile := NIL; FussZeile := NIL; DateiSuffix := NIL;
    SuchWort := NIL; TauschWort := NIL;
    F1 := NIL; F2 := NIL; F3 := NIL; F4 := NIL; F5 := NIL;
    F6 := NIL; F7 := NIL; F8 := NIL; F9 := NIL; F0 := NIL;
    }

    insertCode := FALSE;
    {
    Prefix := 0;

    altePos := NIL; MerkerBlockanfang := NIL; MerkerBlockende := NIL;
    Merker0 := NIL; Merker1 := NIL; Merker2 := NIL; Merker3 := NIL; Merker4 := NIL;
    Merker5 := NIL; Merker6 := NIL; Merker7 := NIL; Merker8 := NIL; Merker9 := NIL;
    }
  END
  ELSE BEGIN
    (* Parameter aus Clipboard-Textobjekt bernehmen *)
    AnzahlZeichen := Clip^.AnzahlZeichen; (* Default max. Zeilenlnge/Vorgabelnge *)
    UmbruchBreite := Clip^.Umbruchbreite;  (* Default Breite fr Textumbruch *)
    Seitenlaenge := Clip^.Seitenlaenge;   (* Default Lnge fr Seitenumbruch *)
    Tablaenge := Clip^.Tablaenge;       (* Default Lnge fr Tab-Abstnde *)
    Druckoffset := Clip^.Druckoffset;     (* Defailt Einrckung beim Drucken *)

    stopSet := Clip^.stopSet;
    blankSet := Clip^.blankSet;
    AbsatzKennSet := Clip^.AbsatzKennSet;
    nonBlankSet := [#1..#255] - blankSet;
    FensterAnzeigen := TRUE;
    {TextX := 0;} (* Macht der Konstruktor *)
    (* TextY := 0; ist jetzt eine Funktion, die ElementIndex liefert *)
    AutoSaveN := Clip^.AutoSaveN;
    meineTextFlags := Clip^.meineTextFlags;
    meineInternFlags := Clip^.meineInternFlags - [istClipboard, Texteditiert];

    InitEreignis (meineNachrichten);
    StandardZeile := String8;
    {
    meineDatei := NIL; meinUndoText := NIL;
    derFensterInhalt := NIL;
    }
    InitAbmess (Abmess, Spaltenbreite);
    {
    FenOffset.X := 0; FenOffset.Y := 0;
    laufendeZeile := NIL; Alias := NIL;
    }
    {
    KopfZeile := NIL; FussZeile := NIL; DateiSuffix := NIL;
    SuchWort := NIL; TauschWort := NIL;
    F1 := NIL; F2 := NIL; F3 := NIL; F4 := NIL; F5 := NIL;
    F6 := NIL; F7 := NIL; F8 := NIL; F9 := NIL; F0 := NIL;
    }
    setzeName (KopfZeile, Clip^.holeName (Clip^.KopfZeile));
    setzeName (Fusszeile, Clip^.holeName (Clip^.Fusszeile));
    setzeName (DateiSuffix, Clip^.holeName (Clip^.DateiSuffix));
    setzeName (ZeilPrefix, Clip^.holeName (Clip^.ZeilPrefix));
    setzeName (DruckerInit, Clip^.holeName (Clip^.DruckerInit));
    setzeName (DruckerExit, Clip^.holeName (Clip^.DruckerExit));
    setzeName (F1F, Clip^.holeName (Clip^.F1F));
    setzeName (F2F, Clip^.holeName (Clip^.F2F));
    setzeName (F3F, Clip^.holeName (Clip^.F3F));
    setzeName (F4F, Clip^.holeName (Clip^.F4F));
    setzeName (F5F, Clip^.holeName (Clip^.F5F));
    setzeName (F6F, Clip^.holeName (Clip^.F6F));
    setzeName (F7F, Clip^.holeName (Clip^.F7F));
    setzeName (F8F, Clip^.holeName (Clip^.F8F));
    setzeName (F9F, Clip^.holeName (Clip^.F9F));
    setzeName (F0F, Clip^.holeName (Clip^.F0F));

    Druckerfilter := Clip^.Druckerfilter;
    DruckerPrefix := Clip^.DruckerPrefix;
    DruckerSuffix := Clip^.DruckerSuffix;

    insertCode := FALSE;
    {
    Prefix := 0;

    altePos := NIL; MerkerBlockanfang := NIL; MerkerBlockende := NIL;
    Merker0 := NIL; Merker1 := NIL; Merker2 := NIL; Merker3 := NIL; Merker4 := NIL;
    Merker5 := NIL; Merker6 := NIL; Merker7 := NIL; Merker8 := NIL; Merker9 := NIL;
    }
  END (* IF Clip <> NIL *);
  getippt := 0;
END (* Init *);

FUNCTION einText.erzeugeMich (CONST xflags: einFlagSet): GLP;
BEGIN
  erzeugeMich := NEW (einTextPointer, Init (xflags));
END (* erzeugeMich *);

FUNCTION einText.isSubclass (CONST class: einGenTyp): BOOLEAN;
BEGIN
  isSubclass := (class = TextBas) OR INHERITED isSubClass (class);
END;

PROCEDURE einText.initDruckerFilter;
VAR index:  CHAR;
BEGIN
  IF Druckerfilter = NIL THEN NEW (Druckerfilter);
  FOR index := Low (CHAR) TO High (CHAR) DO BEGIN
    Druckerfilter^ [index] := (index);
  END (* FOR *);
END (* initDruckerFilter *);

PROCEDURE einText.CFGSpeichern;
VAR  dat:        einText;
     fil:        FILE;
     nam:        STRING [80];
     s:          STRING;
     Size:      INTEGER;
     Version:    LONGINT;
BEGIN
  nam := 'SIMPEL.CFG';
  getFilename (nam, 'SIMPEL.CFG speichern', 'Konfiguration', FALSE);

  IF nam = '' THEN EXIT;

  Assign (fil, nam);
  Rewrite (fil, 1);

  (* ACHTUNG: Die Abfrage "SizeOf (dat)" liefert absurde Ergebnisse,
     wahrscheinlich, weil das Objekt nicht initialisiert ist!!! *)

    Size := SizeOf (einText);
    Version := cVersion;
    Blockwrite (fil, size, SizeOf (size));
    Blockwrite (fil, Version, SizeOf (Version));

    dat.AnzahlZeichen := AnzahlZeichen; (* Default max. Zeilenlnge/Vorgabelnge *)
    dat.UmbruchBreite := Umbruchbreite;  (* Default Breite fr Textumbruch *)
    dat.Seitenlaenge := Seitenlaenge;   (* Default Lnge fr Seitenumbruch *)
    dat.Tablaenge := Tablaenge;       (* Default Lnge fr Tab-Abstnde *)
    dat.Druckoffset := Druckoffset;     (* Default Einrckung beim Drucken *)

    dat.stopSet := stopSet;
    dat.blankSet := blankSet;
    dat.AbsatzKennSet := AbsatzKennSet;
    dat.nonBlankSet := nonblankSet;
    {FensterAnzeigen := TRUE;}
    {TextX := 0;} (* Macht der Konstruktor *)
    (* TextY := 0; ist jetzt eine Funktion, die ElementIndex liefert *)
    dat.AutoSaveN := AutoSaveN;
    dat.meineTextFlags := meineTextFlags;
    dat.meineInternFlags := meineInternFlags - [istClipboard, Texteditiert];

  Blockwrite (fil, dat, SizeOf (einText));

  s := holeName (KopfZeile);
  Blockwrite (fil, s, SizeOf (s));
  s := holeName (FussZeile);
  Blockwrite (fil, s, SizeOf (s));
  s := holeName (DateiSuffix);
  Blockwrite (fil, s, SizeOf (s));
  s := holeName (ZeilPrefix);
  Blockwrite (fil, s, SizeOf (s));
  s := holeName (DruckerInit);
  Blockwrite (fil, s, SizeOf (s));
  s := holeName (DruckerExit);
  Blockwrite (fil, s, SizeOf (s));

  s := holeName (Suchwort);
  Blockwrite (fil, s, SizeOf (s));
  s := holeName (Tauschwort);
  Blockwrite (fil, s, SizeOf (s));

  s := holeName (F1F);
  Blockwrite (fil, s, SizeOf (s));
  s := holeName (F2F);
  Blockwrite (fil, s, SizeOf (s));
  s := holeName (F3F);
  Blockwrite (fil, s, SizeOf (s));
  s := holeName (F4F);
  Blockwrite (fil, s, SizeOf (s));
  s := holeName (F5F);
  Blockwrite (fil, s, SizeOf (s));
  s := holeName (F6F);
  Blockwrite (fil, s, SizeOf (s));
  s := holeName (F7F);
  Blockwrite (fil, s, SizeOf (s));
  s := holeName (F8F);
  Blockwrite (fil, s, SizeOf (s));
  s := holeName (F9F);
  Blockwrite (fil, s, SizeOf (s));
  s := holeName (F0F);
  Blockwrite (fil, s, SizeOf (s));

  Close (fil);
END (* CFGSpeichern *);

PROCEDURE einText.CFGLaden (CONST fragen: BOOLEAN);
VAR dat:     einText;
    fil:     FILE;
    nam:     STRING [80];
    s:       STRING;
    Dir:     DirStr;
    Name:    NameStr;
    Ext:     ExtStr;
    Size:    INTEGER;
    Version: LONGINT;
BEGIN
  {EXIT;}
  nam := 'SIMPEL.CFG';
  IF fragen THEN
    getFilename (nam, 'SIMPEL.CFG laden', 'Konfiguration', FALSE);

  IF nam = '' THEN EXIT;

  Assign (fil, nam);
(*$I-*)
  Reset (fil, 1);

  IF IOResult <> 0 THEN BEGIN
    FSplit (ParamStr (0), Dir, Name, Ext);
    nam := Dir + nam;
    Assign (fil, nam);
    Reset (fil, 1);
  END (* IF lokal nicht vorhanden *);
  IF IOResult = 0 THEN BEGIN
    {zeigMeldung ('loadCFG', 'SIMPEL.CFG laden');}

    BlockRead (fil, size, SizeOf (size));

    IF size <> SizeOf (einText) THEN BEGIN
      zeigMeldung ('SizeOf SIMPEL.CFG falsch',
                   'Gre der SIMPEL.CFG ist ' + StringVonNum (size) +
                   ' statt ' + StringVonNum (SizeOf (einText)) +
                   ', wird nicht geladen');
      EXIT;
    END (* IF size *);

    BlockRead (fil, Version, SizeOf (Version));

    IF Version <> cVersion THEN BEGIN
      IF NOT zeigfrage ('Versionskonflikt in SIMPEL.CFG',
                        'Version ist ' + StringVonNum (Version) + ' statt ' +
                        StringVonNum (cVersion) + #13 + #3 +
                        'Trotzdem laden?')
      THEN EXIT;
    END (* IF Version *);

    BlockRead (fil, dat, SizeOf (einText));
    AnzahlZeichen := dat.AnzahlZeichen; (* Default max. Zeilenlnge/Vorgabelnge *)
    UmbruchBreite := dat.Umbruchbreite;  (* Default Breite fr Textumbruch *)
    Seitenlaenge := dat.Seitenlaenge;   (* Default Lnge fr Seitenumbruch *)
    Tablaenge := dat.Tablaenge;       (* Default Lnge fr Tab-Abstnde *)
    Druckoffset := dat.Druckoffset;     (* Defailt Einrckung beim Drucken *)

    stopSet := dat.stopSet;
    blankSet := dat.blankSet;
    nonBlankSet := {[#1..#255] -} dat.nonblankSet;
    AbsatzKennSet := dat.AbsatzKennSet;
    {FensterAnzeigen := TRUE;}
    {TextX := 0;} (* Macht der Konstruktor *)
    (* TextY := 0; ist jetzt eine Funktion, die ElementIndex liefert *)
    AutoSaveN := dat.AutoSaveN;
    meineTextFlags := dat.meineTextFlags;
    meineInternFlags := dat.meineInternFlags - [istClipboard, Texteditiert];

    Blockread (fil, s, SizeOf (s));
    setzeName (KopfZeile, s);
    Blockread (fil, s, SizeOf (s));
    setzeName (FussZeile, s);
    Blockread (fil, s, SizeOf (s));
    setzeName (DateiSuffix, s);
    Blockread (fil, s, SizeOf (s));
    setzeName (ZeilPrefix, s);
    Blockread (fil, s, SizeOf (s));
    setzeName (DruckerInit, s);
    Blockread (fil, s, SizeOf (s));
    setzeName (DruckerExit, s);

    Blockread (fil, s, SizeOf (s));
    setzeName (Suchwort, s);
    Blockread (fil, s, SizeOf (s));
    setzeName (Tauschwort, s);

    Blockread (fil, s, SizeOf (s));
    setzeName (F1F, s);
    Blockread (fil, s, SizeOf (s));
    setzeName (F2F, s);
    Blockread (fil, s, SizeOf (s));
    setzeName (F3F, s);
    Blockread (fil, s, SizeOf (s));
    setzeName (F4F, s);
    Blockread (fil, s, SizeOf (s));
    setzeName (F5F, s);
    Blockread (fil, s, SizeOf (s));
    setzeName (F6F, s);
    Blockread (fil, s, SizeOf (s));
    setzeName (F7F, s);
    Blockread (fil, s, SizeOf (s));
    setzeName (F8F, s);
    Blockread (fil, s, SizeOf (s));
    setzeName (F9F, s);
    Blockread (fil, s, SizeOf (s));
    setzeName (F0F, s);

    Close (fil);
  END
(*$I+*)
  ELSE BEGIN
    zeigMeldung ('Lade SIMPEL.CFG', 'Die Datei "' + nam + '" wurde nicht gefunden');
  END;
END (* CFGLaden *);

PROCEDURE einText.setzeName (VAR derString: einString8Pointer;
                                   CONST n: STRING);
BEGIN
  IF derString = NIL THEN
    derString := einString8Pointer (neuesObjekt (String8, []));
  derString^.setzeString (n, TRUE);
END (* setzeName *);

FUNCTION einText.holeName (derString: einString8Pointer): STRING;
BEGIN
  IF derString = NIL THEN holeName := ''
  ELSE holeName := derString^.StringVonDaten;
END (* holeName *);

DESTRUCTOR einText.Done;
VAR  dummyp:  POINTER;
     help:    GLP;
BEGIN
{zeigMeldung ('SimpleText.Done', 'BEGIN');}
  IF TextEditiert IN meineInternFlags THEN TextSpeichern;

  IF (derFensterInhalt <> NIL) THEN BEGIN
    dummyp := Message (derFensterInhalt^.Owner, evCommand, cmClose, NIL);
  END;

  help := Message (Desktop^.Owner, evCommand, cmGetHelp, NIL);

  IF help = @SELF THEN Message (Desktop^.Owner, evCommand, cmClearHelp, NIL);

  INHERITED Done;
  IF meineDatei <> NIL THEN DISPOSE (meineDatei, Done);
  IF meinUndoText <> NIL THEN DISPOSE (meinUndoText, Done);
  IF laufendeZeile <> NIL THEN DISPOSE (laufendeZeile, Done);
  IF Alias <> NIL THEN DISPOSE (Alias, Done);
  IF TextName <> NIL THEN DISPOSE (TextName, Done);
  IF KopfZeile <> NIL THEN DISPOSE (KopfZeile, Done);
  IF FussZeile <> NIL THEN DISPOSE (FussZeile, Done);
  IF DateiSuffix <> NIL THEN DISPOSE (DateiSuffix, Done);
  IF ZeilPrefix <> NIL THEN DISPOSE (ZeilPrefix, Done);
  IF DruckerInit <> NIL THEN DISPOSE (DruckerInit, Done);
  IF DruckerExit <> NIL THEN DISPOSE (DruckerExit, Done);
  IF SuchWort <> NIL THEN DISPOSE (Suchwort, Done);
  IF TauschWort <> NIL THEN DISPOSE (Tauschwort, Done);
  IF F1F <> NIL THEN DISPOSE (F1F, Done);
  IF F2F <> NIL THEN DISPOSE (F2F, Done);
  IF F3F <> NIL THEN DISPOSE (F3F, Done);
  IF F4F <> NIL THEN DISPOSE (F4F, Done);
  IF F5F <> NIL THEN DISPOSE (F5F, Done);
  IF F6F <> NIL THEN DISPOSE (F6F, Done);
  IF F7F <> NIL THEN DISPOSE (F7F, Done);
  IF F8F <> NIL THEN DISPOSE (F8F, Done);
  IF F9F <> NIL THEN DISPOSE (F9F, Done);
  IF F0F <> NIL THEN DISPOSE (F0F, Done);
  NilAllMerker;
END (* Done *);

PROCEDURE einText.LoeschPfad;
(* Update: 23. 3. 93 *)
BEGIN
  Verweis := NIL; (* Heuristik! --- gendert, siehe unten *)
  INHERITED LoeschPfad (Sig);
  IF meineDatei <> NIL THEN BEGIN
    IF Sig = meineDatei^.meineSignatur THEN meineDatei := NIL
    ELSE meineDatei^.LoeschPfad (Sig);
  END;
  IF meinUndoText <> NIL THEN BEGIN
    IF Sig = meinUndoText^.meineSignatur THEN meinUndoText := NIL
    ELSE meinUndoText^.LoeschPfad (Sig);
  END;
  IF laufendeZeile <> NIL THEN BEGIN
    IF Sig = laufendeZeile^.meineSignatur THEN laufendeZeile := NIL
    ELSE laufendeZeile^.LoeschPfad (Sig);
  END;
  IF TextName <> NIL THEN BEGIN
    IF Sig = TextName^.meineSignatur THEN TextName := NIL
    ELSE TextName^.LoeschPfad (Sig);
  END;
  IF KopfZeile <> NIL THEN BEGIN
    IF Sig = KopfZeile^.meineSignatur THEN KopfZeile := NIL
    ELSE KopfZeile^.LoeschPfad (Sig);
  END;
  IF FussZeile <> NIL THEN BEGIN
    IF Sig = FussZeile^.meineSignatur THEN FussZeile := NIL
    ELSE FussZeile^.LoeschPfad (Sig);
  END;
  IF DateiSuffix <> NIL THEN BEGIN
    IF Sig = DateiSuffix^.meineSignatur THEN DateiSuffix := NIL
    ELSE DateiSuffix^.LoeschPfad (Sig);
  END;
  IF ZeilPrefix <> NIL THEN BEGIN
    IF Sig = ZeilPrefix^.meineSignatur THEN ZeilPrefix := NIL
    ELSE ZeilPrefix^.LoeschPfad (Sig);
  END;
  IF DruckerInit <> NIL THEN BEGIN
    IF Sig = DruckerInit^.meineSignatur THEN DruckerInit := NIL
    ELSE DruckerInit^.LoeschPfad (Sig);
  END;
  IF DruckerExit <> NIL THEN BEGIN
    IF Sig = DruckerExit^.meineSignatur THEN DruckerExit := NIL
    ELSE DruckerExit^.LoeschPfad (Sig);
  END;
  IF Suchwort <> NIL THEN BEGIN
    IF Sig = Suchwort^.meineSignatur THEN Suchwort := NIL
    ELSE Suchwort^.LoeschPfad (Sig);
  END;
  IF Tauschwort <> NIL THEN BEGIN
    IF Sig = Tauschwort^.meineSignatur THEN Tauschwort := NIL
    ELSE Tauschwort^.LoeschPfad (Sig);
  END;
  IF F1F <> NIL THEN BEGIN
    IF Sig = F1F^.meineSignatur THEN F1F := NIL
    ELSE F1F^.LoeschPfad (Sig);
  END;
  IF F2F <> NIL THEN BEGIN
    IF Sig = F2F^.meineSignatur THEN F2F := NIL
    ELSE F2F^.LoeschPfad (Sig);
  END;
  IF F3F <> NIL THEN BEGIN
    IF Sig = F3F^.meineSignatur THEN F3F := NIL
    ELSE F3F^.LoeschPfad (Sig);
  END;
  IF F4F <> NIL THEN BEGIN
    IF Sig = F4F^.meineSignatur THEN F4F := NIL
    ELSE F4F^.LoeschPfad (Sig);
  END;
  IF F5F <> NIL THEN BEGIN
    IF Sig = F5F^.meineSignatur THEN F5F := NIL
    ELSE F5F^.LoeschPfad (Sig);
  END;
  IF F6F <> NIL THEN BEGIN
    IF Sig = F6F^.meineSignatur THEN F6F := NIL
    ELSE F6F^.LoeschPfad (Sig);
  END;
  IF F7F <> NIL THEN BEGIN
    IF Sig = F7F^.meineSignatur THEN F7F := NIL
    ELSE F7F^.LoeschPfad (Sig);
  END;
  IF F8F <> NIL THEN BEGIN
    IF Sig = F8F^.meineSignatur THEN F8F := NIL
    ELSE F8F^.LoeschPfad (Sig);
  END;
  IF F9F <> NIL THEN BEGIN
    IF Sig = F9F^.meineSignatur THEN F9F := NIL
    ELSE F9F^.LoeschPfad (Sig);
  END;
  IF F0F <> NIL THEN BEGIN
    IF Sig = F0F^.meineSignatur THEN F0F := NIL
    ELSE F0F^.LoeschPfad (Sig);
  END;

  IF Alias <> NIL THEN BEGIN
    IF Sig = Alias^.meineSignatur THEN Alias := NIL
    ELSE Alias^.LoeschPfad (Sig);
  END;
END (* LoeschPfad *);

PROCEDURE einText.TextLoeschen;
(* Update 23. 3. 93: nichtrekursives Textlschen *)
{VAR  p, next:  GLP;}
BEGIN
  IF (hatInternFlag (TextEditiert)) AND NOT
    zeigFrage ('Text Lschen', 'Wollen Sie wirklich den editierten Text lschen?')
  THEN EXIT;

  IF Rechts <> NIL THEN BEGIN
    DISPOSE (Rechts, Done); (* machen Textglues doch schon nichtrekursiv! *)
    AnzahlElemente := 0; ElementIndex := 0;
    Textlaenge := 0;
    Rechts := NIL; Verweis := NIL;
    {NILMerker (laufendeZeile);}
    NILAllMerker;
    TextX := 0;
    macheZeilen (1, AnzahlZeichen, UmbruchBreite, meineTextFlags, StandardZeile);
    setzeMerker (laufendeZeile);
    setzeMerker (MerkerBlockanfang);
    setzeMerker (MerkerBlockende);
    LoescheInternFlag (TextEditiert);
    IF derFensterInhalt <> NIL THEN updateFenster (derFensterInhalt, 0);
  END (* IF Rechts <> NIL *);
END (* TextLoeschen *);

PROCEDURE einText.zeigTextlaenge;
VAR s:               STRING [80];
    Laenge, KByte:   STRING [12];
    zeile:           einMerkerPointer;
BEGIN
  zeile := NIL;
  setzeMerker (zeile);
  zeile^.MerkerAufNr (0);
  Textlaenge := 0;
  WHILE zeile^.derKnoten <> NIL DO BEGIN
    INC (Textlaenge, zeile^.GetZ^.Stringlaenge + 1{2});
    zeile^.MerkerNaechsteZeile;
  END (* WHILE *);
  Dispose (zeile, Done);
  Str (Textlaenge, Laenge);
  Str (Textlaenge DIV 1024, KByte);
  s := 'Text in Bytes: ' + Laenge + ', in KB: ' + KByte;
  zeigMeldung ('Textlnge (inkl. CR)', s);
END (* zeigTextlaenge *);

PROCEDURE einText.zeigBlocklaenge;
VAR s:               STRING [80];
    Blocklaenge:     LONGINT;
    Laenge, KByte:   STRING [12];
    zeile:           einMerkerPointer;
    Diff, be:        LONGINT;
BEGIN
  zeile := NIL;
  setzeMerker (zeile);
  zeile^.MerkerAuf (MerkerBlockanfang);
  IF (zeile = NIL) OR ((MerkerBlockanfang^.MerkerIst (MerkerBlockEnde, Diff, be)
    IN [undefiniert, drauf]) AND (Diff = 0)) THEN BEGIN
    zeigMeldung ('Block nicht markiert', 'Blocklnge nicht definiert');
    EXIT;
  END;
  IF (MerkerBlockanfang^.MerkerIst (MerkerBlockEnde, Diff, be)) = drauf
    THEN Blocklaenge := Diff
  ELSE BEGIN
    Blocklaenge := 0;
    WHILE (zeile^.derKnoten <> NIL) AND (zeile^.derKnoten <> MerkerBlockEnde^.derKnoten) DO BEGIN
      IF (zeile^.derKnoten = MerkerBlockAnfang^.derKnoten) THEN
      INC (Blocklaenge, zeile^.GetZ^.Stringlaenge + 1{2} - MerkerBlockAnfang^.ZeilenX)
      ELSE
        INC (Blocklaenge, zeile^.GetZ^.Stringlaenge + 1{2});
      zeile^.MerkerNaechsteZeile;
    END (* WHILE *);
    IF (zeile^.derKnoten <> NIL) AND (zeile^.derKnoten = MerkerBlockEnde^.derKnoten) THEN BEGIN
      INC (Blocklaenge, MerkerBlockEnde^.ZeilenX + 1{2});
    END (* letzte Zeile *);
  END (* Blockmarken nicht in derselben Zeile *);
  Dispose (zeile, Done);
  Str (Blocklaenge, Laenge);
  Str (Blocklaenge DIV 1024, KByte);
  s := 'Text in Bytes: ' + Laenge + ', in KB: ' + KByte;
  zeigMeldung ('Blocklnge (inkl. CR)', s);
END (* zeigBlocklaenge *);

PROCEDURE einText.setzeMerker (VAR m: einMerkerPointer);
BEGIN
  IF m = NIL THEN GLP (m) := neuesObjekt (Merker, []);
  WITH m^ DO BEGIN
    ZeilenX := TextX; ZeilenNummer := TextY;
    setRechts (SELF.getActual); derKnoten := SELF.CursorIst;
    IF (hatTextFlag (LoescheBlanks)) AND (getZ <> NIL) THEN getZ^.checkEndBlanks;
  END (* WITH *);
END (* setzeMerker *);

PROCEDURE einText.loescheBlock;
BEGIN
  setzeMerker (MerkerBlockAnfang); setzeMerker (MerkerBlockEnde);
END (* loescheMerker *);

PROCEDURE einText.PasteBlockFromClipboard;
VAR Clip:             einTextPointer;
    derZeilenString:  einStringPointer;
    Zeilenrest:       STRING;
    warletzteZeile:   BOOLEAN;
BEGIN (* PasteBlockFromClipboard *)
  Clip := Message (Desktop^.Owner, evCommand, cmGetClipboard, NIL);
  IF Clip = NIL THEN
    zeigMeldung ('Block einfgen', 'Es ist nichts im Clipboard!')
  ELSE BEGIN
    Clip^.ersteZeile; (* Clipboard auf erste Zeile einstellen *)
    GLP (derZeilenString) := Clip^.getZeile; (* diese kopiert *)
    IF derZeilenString = NIL THEN EXIT;

    setzeMerker (MerkerBlockMove); (* Position Blockanfang merken *)

    laufendeZeile^.GetZ^.splitText (Zeilenrest, TextX);
      (* Zeile bei Cursor aufspalten *)
    laufendeZeile^.GetZ^.anhText (derZeilenString^.StringVonDaten);
      (* erste Zeile aus CLPB anhngen *)
    INC (TextX, LENGTH (derZeilenString^.StringVonDaten));
    IF Clip^.hatNextElement THEN BEGIN
      (* es gibt noch mehr Zeilen im CLPB *)
      Clip^.ZeilenVor (FALSE, 1); (* Im CLPB auf die nchste Zeile *)
      GLP (derZeilenString) := Clip^.getZeile;
      IF derZeilenString = NIL THEN BEGIN
        laufendeZeile^.GetZ^.anhText (Zeilenrest);
      END
      ELSE BEGIN
        warletzteZeile := FALSE;
        REPEAT
          IF memAvail < cHeapMin THEN BEGIN
            zeigMeldung ('Speicher ist erschpft', 'Kopiervorgang abgebrochen');
            Break;
          END (* IF *);
          insertObjekt (derZeilenString);
          IF Clip^.hatNextElement THEN BEGIN
            Clip^.ZeilenVor (FALSE, 1);
            GLP (derZeilenString) := Clip^.getZeile; {deleteZeile;}
          END
          ELSE BEGIN derZeilenString := NIL; warletzteZeile := TRUE; END;
        UNTIL warletzteZeile;
        IF memAvail < cHeapMin THEN BEGIN
          zeigMeldung ('Speicher ist erschpft', 'Kopiervorgang unvollstndig');
        END
        ELSE IF derZeilenString <> NIL THEN BEGIN
          laufendeZeile^.GetZ^.einfText (derZeilenString^.StringVonDaten, 1);
          {insertObjekt (derZeilenString);}
        END;
        TextX := laufendeZeile^.getZ^.StringLaenge;
        {insertText (Zeilenrest);}
        laufendeZeile^.GetZ^.anhText (Zeilenrest);
      END (* ELSE *);
    END
    ELSE BEGIN
      laufendeZeile^.GetZ^.anhText (Zeilenrest);
    END (* ELSE *);
    TextX := 0;

    zuMerker (MerkerBlockMove);

    {zeigMeldung ('Block einfgen', 'Dummy');}
    setzeInternflag (Texteditiert);
    derFensterInhalt^.SetLongLimit (255, AnzahlElemente);
  END (* ELSE *);
END (* PasteBlockFormClipboard *);

PROCEDURE einText.CopyBlockToClipboard;
VAR  Clip:      einTextPointer;
     m:         einMerkerPointer;
     s:         STRING;
     XDiff, Be: LONGINT;
BEGIN
  Clip := Message (Desktop^.Owner, evCommand, cmSetClipboard, NIL);
  {zeigMeldung ('Block merken', 'Dummy');}
  IF Clip <> NIL THEN BEGIN
    IF hatTextflag (ClipboardLoeschen) THEN Clip^.TextLoeschen;
    GLP (m) := neuesObjekt (Merker, []);
    CASE MerkerBlockAnfang^.MerkerIst (MerkerBlockEnde, XDiff, Be) OF
      danach: BEGIN
        m^.MerkerAuf (MerkerBlockAnfang);
        IF (m^.derKnoten <> NIL) THEN BEGIN
          m^.getZ^.kopiereText (s, m^.ZeilenX, m^.getZ^.StrLaenge - m^.ZeilenX);
          Clip^.setzeText (s);
        END;
        WHILE (m^.derKnoten <> NIL) AND (m^.derKnoten <> MerkerBlockEnde^.derKnoten)
          DO BEGIN
          IF memAvail < cHeapMin THEN BEGIN
            zeigMeldung ('Speicher ist erschpft', 'Kopiervorgang abgebrochen');
            Break;
          END (* IF *);
          m^.MerkerNaechsteZeile;
          IF (m^.derKnoten <> NIL) THEN BEGIN
            IF m^.derKnoten = MerkerBlockEnde^.derKnoten THEN
              m^.getZ^.kopiereText (s, 0, MerkerBlockEnde^.ZeilenX)
            ELSE m^.getZ^.holeString (s);
            Clip^.InsertText (s);
          END;
        END (* WHILE *);
      END (* danach *);
      drauf: BEGIN
        IF MerkerBlockEnde^.ZeilenX > MerkerBlockAnfang^.ZeilenX THEN BEGIN
          MerkerBlockAnfang^.getZ^.kopiereText (s, MerkerBlockAnfang^.ZeilenX,
                                                   MerkerBlockEnde^.ZeilenX -
                                                   MerkerBlockAnfang^.ZeilenX);
          Clip^.setzeText (s);
        END (* IF *);
        {zeigMeldung ('CopyBlockToClipboard', 'Blockende drauf');}
      END (* drauf *);
      ELSE zeigMeldung ('CopyBlockToClipboard', 'Kein gltiger Block');
    END (* CASE *);
    DISPOSE (m, Done);
    IF Clip^.getFensterInhalt <> NIL THEN
      Clip^.updateFenster (Clip^.getFensterInhalt,
                         (Clip^.getFensterInhalt^.LongDelta.Y));
  END (* IF Clip *);
END (* CopyBlockToClipboard *);

PROCEDURE einText.CutBlockToClipboard (CONST toClipboard: BOOLEAN);
VAR  Clip:            einTextPointer;
     z:               einStringPointer;
     s:               STRING;
     Ende:            BOOLEAN;
     XDiff, Be:       LONGINT;
BEGIN
  Clip := Message (Desktop^.Owner, evCommand, cmSetClipboard, NIL);
  IF Clip <> NIL THEN BEGIN
    IF hatTextflag (ClipboardLoeschen) THEN Clip^.TextLoeschen;
    CASE MerkerBlockAnfang^.MerkerIst (MerkerBlockEnde, XDiff, Be) OF
      danach: BEGIN
        zuMerker (MerkerBlockAnfang);
        Ende := ActualElement = MerkerBlockEnde^.derKnoten;
        IF MerkerBlockAnfang^.ZeilenX = 0 THEN BEGIN
          GLP (z) := DeleteZeile;
          IF (z <> NIL) THEN BEGIN
            z^.holeString (s);
            IF toClipboard THEN Clip^.setzeText (s);
          END;
        END (* IF ganze erste Zeile *)
        ELSE BEGIN
          MerkerBlockAnfang^.getZ^.deleteText (s, MerkerBlockAnfang^.ZeilenX,
                                                  MerkerBlockAnfang^.getZ^.StrLaenge -
                                                  MerkerBlockAnfang^.ZeilenX);
          IF toClipboard THEN Clip^.setzeText (s);
          ZeilenVor (TRUE, 1);
        END (* ELSE *);
        WHILE {(z <> NIL) AND} NOT Ende DO BEGIN
          Ende := ActualElement = MerkerBlockEnde^.derKnoten;
          IF memAvail < cHeapMin THEN BEGIN
            zeigMeldung ('Speicher ist erschpft', 'Kopiervorgang abgebrochen');
            Break;
          END (* IF *);
          IF Ende AND (MerkerBlockEnde^.ZeilenX < MerkerBlockEnde^.GetZ^.StrLaenge)
            THEN BEGIN
            MerkerBlockEnde^.getZ^.deleteText (s, 0, MerkerBlockEnde^.ZeilenX);
            setzeMerker (laufendeZeile);
            IF toClipboard THEN Clip^.InsertText (s);
          END
          ELSE BEGIN
            GLP (z) := DeleteZeile;
            IF toClipboard THEN BEGIN
              IF z <> NIL THEN BEGIN
                z^.holeString (s);
                Clip^.InsertText (s);
              END
              ELSE Clip^.InsertText ('');
            END (* IF toClipboard *);
          END (* ELSE ganze letzte oder nichtletzte Zeile *);
        END (* WHILE *);
        setzeInternflag (Texteditiert);
      END (* danach *);
      drauf: BEGIN
        IF MerkerBlockEnde^.ZeilenX > MerkerBlockAnfang^.ZeilenX THEN BEGIN
          setzeMerker (MerkerBlockMove);
          MerkerBlockAnfang^.getZ^.deleteText (s, MerkerBlockAnfang^.ZeilenX,
                                                  MerkerBlockEnde^.ZeilenX -
                                                  MerkerBlockAnfang^.ZeilenX);
          IF toClipboard THEN Clip^.setzeText (s);

          IF MerkerBlockMove^.ZeilenX >= MerkerBlockEnde^.ZeilenX
            THEN MerkerBlockMove^.ZeilenX :=
                 MerkerBlockMove^.ZeilenX + MerkerBlockAnfang^.ZeilenX - MerkerBlockEnde^.ZeilenX;
          zuMerker (MerkerBlockMove);
          setzeInternflag (Texteditiert);
        END (* IF *);
        {zeigMeldung ('CutBlockToClipboard', 'Blockende drauf');}
      END (* drauf *);
    END (* CASE *);
    loescheBlock;
    IF toClipboard AND (Clip^.getFensterInhalt <> NIL) THEN
      Clip^.updateFenster (Clip^.getFensterInhalt,
                         (Clip^.getFensterInhalt^.LongDelta.Y));
    derFensterInhalt^.SetLongLimit (255, AnzahlElemente);
  END (* IF Clip *);
  {zeigMeldung ('Block lschen', 'Dummy');}
END (* CutBlockToClipboard *);

PROCEDURE einText.zuMerker (m: einMerkerPointer);
BEGIN
  IF m = NIL THEN EXIT;
  zurZeile (m^.ZeilenNummer);
  TextX := m^.ZeilenX;
END (* zuMerker *);

PROCEDURE einText.NILAllMerker;
BEGIN
  NilMerker (altePos);
  NilMerker (MerkerBlockanfang);
  NilMerker (MerkerBlockende);
  NilMerker (MerkerBlockMove);
  NilMerker (Merker0);
  NilMerker (Merker1);
  NilMerker (Merker2);
  NilMerker (Merker3);
  NilMerker (Merker4);
  NilMerker (Merker5);
  NilMerker (Merker6);
  NilMerker (Merker7);
  NilMerker (Merker8);
  NilMerker (Merker9);
END (* NILAllMerker *);

PROCEDURE einText.NILMerker (VAR m: einMerkerPointer);
BEGIN
  IF m = NIL THEN EXIT;
  WITH m^ DO BEGIN
    setLinks (NIL); setRechts (NIL); setRueck (NIL);
    derKnoten := NIL;
  END (* WITH *);
  DISPOSE (m, Done);
  m := NIL;
END (* NILMerker *);

PROCEDURE einText.MerkerUpdate (Von: einMerkerPointer);
VAR  m:               einMerker;
     contA, contE,
     contM:           BOOLEAN;
BEGIN
  (* Bearbeitet vorlufig nur die Blockmarken und MerkerBlockMove.
     N-Merker sollen Liste werden! *)
  IF Von = NIL THEN EXIT;
  m.Init ([]);
  m := Von^;
  WITH m DO BEGIN
    contA := MerkerBlockAnfang <> NIL; contE := MerkerBlockEnde <> NIL;

    contM := MerkerBlockMove <> NIL;

    WHILE (derKnoten <> NIL) AND (contA OR contE OR contM) DO BEGIN
      IF contA AND (MerkerBlockAnfang <> NIL) AND (MerkerBlockAnfang^.derKnoten = derKnoten) THEN BEGIN
        MerkerBlockAnfang^.ZeilenNummer := ZeilenNummer; contA := FALSE;
      END (* IF *);
      IF contE AND (MerkerBlockEnde <> NIL) AND (MerkerBlockEnde^.derKnoten = derKnoten) THEN BEGIN
        MerkerBlockEnde^.ZeilenNummer := ZeilenNummer; contE := FALSE;
      END (* IF *);

      IF contM AND (MerkerBlockMove <> NIL) AND (MerkerBlockMove^.derKnoten = derKnoten) THEN BEGIN
        MerkerBlockMove^.ZeilenNummer := ZeilenNummer; contM := FALSE;
      END (* IF *);

      derKnoten := einKnotenPointer (derKnoten)^.LinksIst;
      INC (ZeilenNummer);
    END (* WHILE *);
  END (* WITH *);
END (* MerkerUpdate *);

FUNCTION einText.Blockstart (CONST BezugsMerker: einMerkerPointer): INTEGER;
VAR diff, bs:  LONGINT;
    rel:       MerkerRelation;
BEGIN
  (* Als Bezugsmerker wird die aktuell auszugebende Zeile eingesetzt *)
  IF (BezugsMerker <> NIL) AND (MerkerBlockAnfang <> NIL) THEN BEGIN
    rel := BezugsMerker^.MerkerIst (MerkerBlockAnfang, diff, bs);
{zeigMeldung ('Blockstart', StringVonNum (bs));}
    Blockstart := bs;
  END
  ELSE Blockstart := 0;
END (* Blockstart *);

FUNCTION einText.Blockend (CONST BezugsMerker: einMerkerPointer): INTEGER;
VAR diff, be:  LONGINT;
    rel: MerkerRelation;
BEGIN
  (* Als Bezugsmerker wird die aktuell auszugebende Zeile eingesetzt *)
  IF (BezugsMerker <> NIL) AND (MerkerBlockEnde <> NIL) THEN BEGIN
    rel := BezugsMerker^.MerkerIst (MerkerBlockEnde, diff, be);
    BlockEnd := be;
  END
  ELSE Blockend := 0;
END (* Blockend *);

FUNCTION einText.hatNaechsteZeile (CONST zuZeile: einMerkerPointer): BOOLEAN;
BEGIN
  hatNaechsteZeile :=
    (zuZeile <> NIL) AND
      (einKnotenPointer (einMerkerPointer (zuZeile)^.derKnoten)^.Links <> NIL)
END (* hatNaechsteZeile *);

FUNCTION einText.hatVorigeZeile (CONST zuZeile: einMerkerPointer): BOOLEAN;
BEGIN
  hatVorigeZeile :=
    (zuZeile <> NIL) AND
      (einTriplePointer (einMerkerPointer (zuZeile)^.derKnoten)^.Rueck <> NIL) AND
      (einTriplePointer (einMerkerPointer (zuZeile)^.derKnoten)^.Rueck <> @SELF);
END (* hatVorigeZeile *);

PROCEDURE einText.initAbmess (VAR a: TRect; VAR spbreite: INTEGER);
BEGIN
  IF hatTextFlag (FensterImmerGross) THEN BEGIN
    a.Assign (0, 0, ScreenWidth, ScreenHeight - 2);
  END
  ELSE BEGIN
    a.Assign (0, 0, 77, 20);
    zentriere (a);
  END;
  spbreite := 1;
END (* initAbmess *);

PROCEDURE einText.setzeFensterAbmess (a: TRect);
BEGIN
  IF derFensterInhalt <> NIL THEN BEGIN
    derFensterInhalt^.Owner^.ChangeBounds (a);
  END (* IF *);
END (* setzeFensterAbmess *);

FUNCTION einText.neuesElement (CONST Objekt: GLP): GLP;
VAR  neu: GLP;
BEGIN
  neu := neuesObjekt (TextGlue, []);
  einTextGluePointer (neu)^.Rechts := Objekt;
  neuesElement := neu;
END (* neuesElement *);

PROCEDURE einText.updateFenster (CONST view: PBuffText;
                                       CONST abZeile: LONGINT);
VAR    hZeile:         einMerkerPointer;
       x, y:           LONGINT;
       oben, unten:    LONGINT;
BEGIN
  IF derFensterInhalt = NIL THEN EXIT;
  oben := derFensterInhalt^.LongDelta.Y;
  unten := derFensterInhalt^.Size.Y + derFensterInhalt^.LongDelta.Y;
  y := TextY; x := derFensterInhalt^.Delta.X;

  IF (Rechts (* TextListe - sollte abstrahiert werden *) <> NIL) THEN BEGIN

    derFensterInhalt^.HideCursor;

    (* Einstellen der obersten Zeile: *)
    GLP (hZeile) := neuesObjekt (Merker, []);
    setzeMerker (hZeile);

{
zeigMeldung ('updateFenster, oben: ' + StringVonNum (oben),
             'abZeile: ' + StringVonNum (abzeile));
}
    hZeile^.MerkerAufNr (abZeile);
    y := hZeile^.ZeilenNummer;

    (* Anzeigen des Fensterauschnittes *)

    WHILE (hZeile^.derKnoten <> NIL) AND (hZeile^.ZeilenNummer <= unten) DO BEGIN
      IF (hZeile^.Rechts <> NIL) AND
         (hZeile^.Rechts^.isSubclass (StringG)) AND
         (hZeile^.Zeilennummer >= oben) THEN BEGIN
         hZeile^.getZ^.OffsetSchreib (derFensterInhalt, x, y, x,
                                      BlockStart (hZeile),
                                      BlockEnd (hZeile),
                                      hatTextFlag (markiereAbschnitte),
                                      NOT hatNaechsteZeile (hZeile));
      END (* IF *);
      INC (y); hZeile^.MerkernaechsteZeile;
    END (* WHILE *);

    IF hZeile^.Rechts = NIL THEN BEGIN
      derFensterInhalt^.GotoXY (x, y);
      derFensterInhalt^.ClrEol ({hatTextFlag (markiereAbschnitte),
                                NOT hatNaechsteZeile (hZeile)}
                                FALSE, FALSE);
    END (* IF *);
    NilMerker (hZeile);
  END (* IF TextListe *);

  IF TextY < oben THEN ZeilenVor (TRUE, oben - TextY)
  ELSE IF TextY > unten THEN ZeilenZurueck (TRUE, TextY - unten);

  derFensterInhalt^.GotoXY (x, y);
  derFensterInhalt^.ClrEOS; (* impliziert ShowCursor *)
  derFensterInhalt^.GotoXY (TextX, TextY);
END (* updateFenster *);

PROCEDURE einText.zeigFenster (CONST view: PBuffText; CONST x, y, b, h: WORD;
                                     CONST zeichneFen: BOOLEAN);
VAR     i:              WORD;
        hZeile:                 einTriplePointer;
BEGIN
  IF derFensterInhalt = NIL THEN EXIT;
  updateFenster (view, derFensterInhalt^.LongDelta.Y);
END (* zeigFenster *);

PROCEDURE einText.schreibStatus;
VAR inf:           STRING [24];
    SpiegelOffset: INTEGER;
    ch:            CHAR;
BEGIN
  IF derFensterInhalt <> NIL THEN BEGIN
    SpiegelOffset := 1;
    IF DruckeMitKopfZeile IN meineTextFlags THEN INC (SpiegelOffset, 2);
    IF DruckeMitFussZeile IN meineTextFlags THEN INC (SpiegelOffset, 2);
    IF hatTextflag (nurLesen) THEN           inf := '' + '#' + '' ELSE
    IF TextEditiert IN meineInternFlags THEN inf := '' + #15 + ' '
    ELSE inf := ' ';
    inf := inf + 'Z:' +
      StringVonNum (TextY + 1) + ', C:' + StringVonNum (TextX + 1) +
      ', S:' + StringVonNum (TextY DIV (Seitenlaenge - SpiegelOffset) + 1) +
    { Hier mssen noch die Zeilen fr Kopf- und Fuzeilen abgezogen werden! }
    {', ' + StringVonNum (derFensterInhalt^.Delta.Y) + ' ';}
    ' ';
    PSimpleTextWindow (derFensterInhalt^.Owner)^.WriteStatus (inf);
    IF laufendeZeile <> NIL THEN
      ch := laufendeZeile^.GetZ^.holeZch (TextX)
    ELSE ch := nul;
    inf := '<' + StringVonNumF (ORD (ch), 3) + '|'
               + StringVonByte (ORD (ch)) + 'h>';
    PSimpleTextWindow (derFensterInhalt^.Owner)^.WriteCharCode (inf);
  END;
END (* schreibStatus *);

FUNCTION einText.StringVonTextflag (CONST flag: einTextflag): STRING;
BEGIN
      CASE flag OF
        (* Edit-Flags *)
        InsertFlag:         StringVonTextFlag := 'InsertFlag';
        AutoIndent:         StringVonTextFlag := 'AutoIndent';
        AutoUmbruch:        StringVonTextFlag := 'AutoUmbruch';
        AutoAppend:         StringVonTextFlag := 'AutoAppend';
        LoescheBlanks:      StringVonTextFlag := 'LscheBlanks';
        NurLesen:           StringVonTextFlag := 'NurLesen';

        (* Datei-Flags *)
        TabsFiltern:        StringVonTextFlag := 'TabsFiltern';
        AutoSave:           StringVonTextFlag := 'AutoSave';
        BackupDatei:        StringVonTextFlag := 'BackupDatei';
        SpeichImmerFragen:  StringVonTextFlag := 'SpeichImmerFragen';
        ExitOhneFrage:      StringVonTextFlag := 'ExitOhneFrage';

        (* Drucker-Flags *)
        ZeilenNumerieren:   StringVonTextFlag := 'ZeilenNumerieren';
        FormfeedFlag:       StringVonTextFlag := 'FormfeedFlag';
        DruckFormfeed:      StringVonTextFlag := 'DruckFormfeed';
        EinzelBlattEinzug:  StringVonTextFlag := 'EinzelBlattEinzug';
        DruckeMitKopfzeile: StringVonTextFlag := 'DruckeMitKopfzeile';
        DruckeMitFusszeile: StringVonTextFlag := 'DruckeMitFuzeile';
        zentriereKopfFuss:  StringVonTextFlag := 'zentriereKopfFu';
        rechtsKopfFuss:     StringVonTextFlag := 'rechtsKopfFu';

        (* Block & Clipboard *)
        loescheInUndo:      StringVonTextFlag := 'lscheInUndo';
        loescheInClipboard: StringVonTextFlag := 'lscheInClipboard';
        ClipboardLoeschen:  StringVonTextFlag := 'ClipboardLschen';

        (* Suchen & Tauschen *)
        WortSuche:          StringVonTextFlag := 'WortSuche';
        GrossKleinEgal:     StringVonTextFlag := 'GroKleinEgal';
        TauschAbfrage:      StringVonTextFlag := 'TauschAbfrage';
        markiereAbschnitte: StringVonTextFlag := 'markiereAbschnitte';
        FundStelleOnTop:    StringVonTextFlag := 'FundStelleOnTop';

        (* Oberflaeche *)
        FensterImmerGross:  StringVonTextFlag := 'FensterImmerGro';
        UmgebungWHerstell:  StringVonTextFlag := 'UmgebungWHerstell';
        FrageVorFormat:     StringVonTextFlag := 'FrageVorFormat';

        (* Reserviert *)
        EndlosAbsatz:       StringVonTextFlag := 'EndlosAbsatz';
        Absatzkennung:      StringVonTextFlag := 'Absatzkennung';
      END (* CASE *);
END (* StringVonTextFlag *);

FUNCTION einText.StringVonInternflag (CONST flag: einInternflag): STRING;
BEGIN
      CASE flag OF
        istUndopuffer:      StringVonInternFlag := 'istUndopuffer';
        TextOffen:          StringVonInternFlag := 'TextOffen';
        TextEditiert:       StringVonInternFlag := 'TextEditiert';
        istProtokollPuffer: StringVonInternFlag := 'istProtokollPuffer';
        istClipboard:       StringVonInternFlag := 'istClipboard';
        DateinameAbfragen:  StringVonInternFlag := 'DateinameAbfragen';
        istFalte:           StringVonInternFlag := 'istFalte';
        benutzeDruckerFilter: StringVonInternFlag := 'benutzeDruckerFilter';
        Internflag8:        StringVonInternFlag := 'Internflag8';
        Internflag9:        StringVonInternFlag := 'Internflag9';
        Internflag10:       StringVonInternFlag := 'Internflag10';
        Internflag11:       StringVonInternFlag := 'Internflag11';
        Internflag12:       StringVonInternFlag := 'Internflag12';
        Internflag13:       StringVonInternFlag := 'Internflag13';
        Internflag14:       StringVonInternFlag := 'Internflag14';
        Internflag15:       StringVonInternFlag := 'Internflag15';
      END (* CASE *);
END (* StringVonTextFlag *);

FUNCTION einText.StringVonTextflags: STRING;
VAR     i:      einTextflag;
        s:      STRING;
BEGIN
  s := '{';
  FOR i := LOW (einTextFlag) TO HIGH (einTextFlag) DO BEGIN
    IF i IN meineTextflags THEN BEGIN
      Insert (StringVonTextFlag (i) + ' ', s, LENGTH (s) + 1);
    END (* IF *);
  END (* FOR *);
  s := s + '}';
  StringVonTextflags := s;
END (* StringVonTextflags *);

FUNCTION einText.StringVonInternflags: STRING;
VAR     i:      einInternflag;
        s:      STRING;
BEGIN
  s := '{';
  FOR i := LOW (einInternFlag) TO HIGH (einInternFlag) DO BEGIN
    IF i IN meineInternflags THEN BEGIN
      Insert (StringVonInternFlag (i) + ' ', s, LENGTH (s) + 1);
    END (* IF *);
  END (* FOR *);
  s := s + '}';
  StringVonInternflags := s;
END (* StringVonInternflags *);

PROCEDURE einText.zeigTextFlags (CONST Titel: STRING);

CONST cFlagBreite =  24;
      cFlagHoehe =   16;
      cBoxBreite =   2 * cFlagBreite + 22;
      cBoxHoehe =    cFlagHoehe + 7;

TYPE TFlagboxDaten =  RECORD
                        LCheckBoxData:  WORD;
                        HCheckBoxData:  WORD;

                        UmbruchData:    LONGINT;
                        ZeilenData:     LONGINT;
                        TabData:        LONGINT;
                        OffsData:       LONGINT;
                        SaveData:       LONGINT;

                        KopfData:       STRING;
                        FussData:       STRING;
                        PrefData:       STRING;
                        SuffData:       STRING;
                        InitData:       STRING;
                        ExitData:       STRING;

                      END (* RECORD *);

     Tricky =         RECORD
                        CASE BOOLEAN OF
                          FALSE: (dieFlags: einTextFlagset);
                          TRUE:  (LowFlags, HighFlags: WORD);
                        END;

VAR  Box:             PDialog;
     R:               TRect;
     Schalter:        PCheckBoxes;
     Umbreite:        PNumInputLine;
     Zeilen:          PNumInputLine;
     Tabs:            PNumInputLine;
     DrOffs:          PNumInputLine;
     Save:            PNumInputLine;
     Kopf, Fuss, ZPrefix,
     Suffix,
     InitDr, ExitDr:  PInputLine;
     SItem:           PSItem;
     Flag:            einTextFlag;
     Control:         WORD;
     Daten:           TFlagBoxDaten;
     Trick:           Tricky;

BEGIN (* zeigTextFlags *)
{zeigMeldung ('einSimpleText', 'zeigTextflags');}
    R.Assign (0, 0, cBoxBreite, cBoxHoehe);
    zentriere (R);
    Box := NEW (PDialog, Init (R, Titel));
    WITH Box^ DO BEGIN

      R.Assign (3, 2, 3 + cFlagBreite, 2 + cFlagHoehe);

      SItem := NIL;
      FOR Flag := DruckeMitKopfzeile DOWNTO InsertFlag DO BEGIN
        SItem := NewSItem (StringVonTextFlag (Flag), SItem);
      END (* FOR *);
      Schalter := NEW (PCheckBoxes, Init (R, SItem));
      Insert (Schalter);

      R.Assign (5 + cFlagBreite, 2, 5 + 2 * cFlagBreite, 2 + cFlagHoehe);

      SItem := NIL;
      FOR Flag := Absatzkennung DOWNTO DruckeMitFusszeile DO BEGIN
        SItem := NewSItem (StringVonTextFlag (Flag), SItem);
      END (* FOR *);
      Schalter := NEW (PCheckBoxes, Init (R, SItem));
      Insert (Schalter);

(* Numerische Eingabefelder: *)
{}
      R.Assign (2 * cFlagBreite + 7, cBoxHoehe DIV 2 - 8, 2 * cFlagBreite + 19, cBoxHoehe DIV 2 - 7);
      Umbreite := NEW (PNumInputLine, Init (R, 3, 10, 254));
      Insert (Umbreite);
      R.Assign (2 * cFlagBreite + 7, cBoxHoehe DIV 2 - 9, 2 * cFlagBreite + 19, cBoxHoehe DIV 2 - 8);
      Insert (NEW (PLabel, Init (R, 'Umbruch', Umbreite)));
(*---------------------------------------------------------------*)

      R.Assign (2 * cFlagBreite + 7, cBoxHoehe DIV 2 - 6, 2 * cFlagBreite + 19, cBoxHoehe DIV 2 - 5);
      Zeilen := NEW (PNumInputLine, Init (R, 3, 10, 254));
      Zeilen^.SetState (sfCursorIns, FALSE);
      Insert (Zeilen);
      R.Assign (2 * cFlagBreite + 7, cBoxHoehe DIV 2 - 7, 2 * cFlagBreite + 19, cBoxHoehe DIV 2 - 6);
      Insert (NEW (PLabel, Init (R, 'Seitenlnge', Zeilen)));
(*---------------------------------------------------------------*)
      R.Assign (2 * cFlagBreite + 7, cBoxHoehe DIV 2 - 4, 2 * cFlagBreite + 19, cBoxHoehe DIV 2 - 3);
      Tabs := NEW (PNumInputLine, Init (R, 3, 2, 254));
      Tabs^.SetState (sfCursorIns, FALSE);
      Insert (Tabs);
      R.Assign (2 * cFlagBreite + 7, cBoxHoehe DIV 2 - 5, 2 * cFlagBreite + 19, cBoxHoehe DIV 2 - 4);
      Insert (NEW (PLabel, Init (R, 'Tablnge', Tabs)));
(*---------------------------------------------------------------*)
      R.Assign (2 * cFlagBreite + 7, cBoxHoehe DIV 2 - 2, 2 * cFlagBreite + 19, cBoxHoehe DIV 2 - 1);
      DrOffs := NEW (PNumInputLine, Init (R, 3, 0, 254));
      DrOffs^.SetState (sfCursorIns, FALSE);
      Insert (DrOffs);
      R.Assign (2 * cFlagBreite + 7, cBoxHoehe DIV 2 - 3, 2 * cFlagBreite + 19, cBoxHoehe DIV 2 - 2);
      Insert (NEW (PLabel, Init (R, 'DrOffset', DrOffs)));
(*---------------------------------------------------------------*)
      R.Assign (2 * cFlagBreite + 7, cBoxHoehe DIV 2 - 0, 2 * cFlagBreite + 19, cBoxHoehe DIV 2 + 1);
      Save := NEW (PNumInputLine, Init (R, 5, 80, 65534));
      Save^.SetState (sfCursorIns, FALSE);
      Insert (Save);
      R.Assign (2 * cFlagBreite + 7, cBoxHoehe DIV 2 - 1, 2 * cFlagBreite + 19, cBoxHoehe DIV 2 - 0);
      Insert (NEW (PLabel, Init (R, 'AutoSave', Save)));
(*---------------------------------------------------------------*)

(* Stringeingabefelder *)

      R.Assign (3, 3 + cFlagHoehe, 3 + cFlagBreite, 4 + cFlagHoehe);
      Kopf := NEW (PInputLine, Init (R, 255));
      Insert (Kopf);
      R.Assign (3, 2 + cFlagHoehe, 3 + cFlagBreite, 3 + cFlagHoehe);
      Insert (NEW (PLabel, Init (R, 'Kopfzeile', Kopf)));

      R.Assign (5 + cFlagBreite, 3 + cFlagHoehe, 5 + 2 * cFlagBreite, 4 + cFlagHoehe);
      Fuss := NEW (PInputLine, Init (R, 255));
      Insert (Fuss);
      R.Assign (5 + cFlagBreite, 2 + cFlagHoehe, 5 + 2 * cFlagBreite, 3 + cFlagHoehe);
      Insert (NEW (PLabel, Init (R, 'Fuzeile', Fuss)));

      R.Assign (2 * cFlagBreite + 7, 3 + cFlagHoehe, 2 * cFlagBreite + 18, 4 + cFlagHoehe);
      ZPrefix := NEW (PInputLine, Init (R, 255));
      Insert (ZPrefix);
      R.Assign (2 * cFlagBreite + 5, 2 + cFlagHoehe, 2 * cFlagBreite + 19, 3 + cFlagHoehe);
      Insert (NEW (PLabel, Init (R, 'Zeilen-Prefix', ZPrefix)));

      R.Assign (2 * cFlagBreite + 7, 5 + cFlagHoehe, 2 * cFlagBreite + 18, 6 + cFlagHoehe);
      Suffix := NEW (PInputLine, Init (R, 255));
      Insert (Suffix);
      R.Assign (2 * cFlagBreite + 7, 4 + cFlagHoehe, 2 * cFlagBreite + 18, 5 + cFlagHoehe);
      Insert (NEW (PLabel, Init (R, 'Suffix', Suffix)));

      R.Assign (5 + 11, 5 + cFlagHoehe, 5 + 11 + 11, 6 + cFlagHoehe);
      InitDr := NEW (PInputLine, Init (R, 255));
      Insert (InitDr);
      R.Assign (3, 5 + cFlagHoehe, 3 + 12, 6 + cFlagHoehe);
      Insert (NEW (PLabel, Init (R, 'DruckerInit', InitDr)));

      R.Assign (18 + cFlagBreite, 5 + cFlagHoehe, 18 + cFlagBreite + 11, 6 + cFlagHoehe);
      ExitDr := NEW (PInputLine, Init (R, 255));
      Insert (ExitDr);
      R.Assign (5 + cFlagBreite, 5 + cFlagHoehe, 5 + cFlagBreite + 12, 6 + cFlagHoehe);
      Insert (NEW (PLabel, Init (R, 'DruckerExit', ExitDr)));

(* Dialogschalter OK, Abbruch *)

      R.Assign (2 * cFlagBreite + 7, cBoxHoehe DIV 2 + 2, 2 * cFlagBreite + 18, cBoxHoehe DIV 2 + 4);
      Insert (NEW (PButton, Init (R, '~O~K', cmOK, bfDefault)));
      R.Assign (2 * cFlagBreite + 7, cBoxHoehe DIV 2 + 4, 2 * cFlagBreite + 18, cBoxHoehe DIV 2 + 6);
      Insert (NEW (PButton, Init (R, 'Abbruch', cmCancel, bfNormal)));

    END (* WITH *);

(* Daten setzen *)
{
zeigMeldung ('zeigTextflags', 'Daten setzen');
}
    Trick.dieFlags := meineTextFlags;
    Daten.LCheckboxData := Trick.LowFlags;
    Daten.HCheckboxData := Trick.HighFlags;
{}
    Daten.UmbruchData := UmbruchBreite;
    Daten.ZeilenData := Seitenlaenge;
    Daten.TabData := Tablaenge;
    Daten.OffsData := Druckoffset;
    Daten.SaveData := AutoSaveN;

    Daten.KopfData := holeName (KopfZeile);
    Daten.FussData := holeName (FussZeile);
    Daten.SuffData := holeName (DateiSuffix);
    Daten.PrefData := holeName (ZeilPrefix);
    Daten.InitData := holeName (DruckerInit);
    Daten.ExitData := holeName (DruckerExit);

{
zeigMeldung ('zeigTextflags', 'SetData');
}
    Box^.SetData (Daten);
{}

(* Dialog anzeigen *)
{
zeigMeldung ('zeigTextFlags', 'DeskTop^.ExecView');
}
    Control := DeskTop^.ExecView (Box);

(* Daten holen *)
{
zeigMeldung ('zeigTextFlags', 'Daten holen');
}
    IF Control <> cmCancel THEN BEGIN

       Box^.GetData (Daten);
       Trick.Lowflags := Daten.LCheckboxData;
       Trick.Highflags := Daten.HCheckboxData;
       meineTextFlags := Trick.dieFlags;
{}
       UmbruchBreite := Daten.UmbruchData;
       Seitenlaenge := Daten.ZeilenData;
       Tablaenge := Daten.TabData;
       Druckoffset := Daten.OffsData;
       AutoSaveN := Daten.SaveData;

       setzeName (KopfZeile, Daten.KopfData);
       setzeName (FussZeile, Daten.FussData);
       setzeName (DateiSuffix, Daten.SuffData);
       setzeName (ZeilPrefix, Daten.PrefData);
       setzeName (DruckerInit, Daten.InitData);
       setzeName (DruckerExit, Daten.ExitData);

    END;
{
zeigMeldung ('zeigTextFlags', 'Dispose Box, Done');
}
    Dispose (Box, Done);
{
zeigMeldung ('zeigTextFlags', 'updateFenster');
}
    IF derFensterInhalt <> NIL THEN updateFenster (derFensterInhalt, 0);
{
zeigMeldung ('zeigTextFlags', 'END');
}
END (* zeigTextFlags *);

PROCEDURE einText.zeigFStrings (CONST Titel: STRING);

CONST cBoxBreite =   76;
      cBoxHoehe =    22;

TYPE TStringDaten =  RECORD

                        F1Data:       STRING;
                        F2Data:       STRING;
                        F3Data:       STRING;
                        F4Data:       STRING;
                        F5Data:       STRING;
                        F6Data:       STRING;
                        F7Data:       STRING;
                        F8Data:       STRING;
                        F9Data:       STRING;
                        F0Data:       STRING;
                        BlankData:    STRING;
                        NonBlankData: STRING;
                        StopData:     STRING;
                        AbsKennData:  STRING;

                      END (* RECORD *);

VAR  Box:             PDialog;
     R:               TRect;
     Schalter:        PCheckBoxes;
     F1I, F2I, F3I, F4I, F5I,
     F6I, F7I, F8I, F9I, F0I,
     bl, sto, nbl, absk: PInputLine;
     SItem:           PSItem;
     Control:         WORD;
     Daten:           TStringDaten;

  FUNCTION StringVonSet (S: CHSet): STRING;
  VAR ch: CHAR;
      res: STRING;
  BEGIN
    res := '';
    FOR ch := Low (Char) TO High (Char) DO BEGIN
      IF ch IN S THEN res := res + ch;
    END (* FOR *);
    StringVonSet := res;
  END (* StringVonSet *);

  PROCEDURE MakeSet (VAR chs: CHSet; CONST s: STRING);
  VAR i: INTEGER;
  BEGIN
    chs := [];
    FOR i := 1 TO LENGTH (s) DO BEGIN
      INCLUDE (chs, s [i]);
    END (* FOR *);
  END (* MakeSet *);

BEGIN (* zeigTextFlags *)
{zeigMeldung ('einSimpleText', 'zeigTextflags');}
    R.Assign (0, 0, cBoxBreite, cBoxHoehe);
    zentriere (R);
    Box := NEW (PDialog, Init (R, Titel));
    WITH Box^ DO BEGIN

(* Stringeingabefelder *)

      R.Assign (7, 2, 73, 3);
      F1I := NEW (PInputLine, Init (R, 255));
      Insert (F1I);
      R.Assign (2, 2, 5, 3);
      Insert (NEW (PLabel, Init (R, 'F1', F1I)));

      R.Assign (7, 3, 73, 4);
      F2I := NEW (PInputLine, Init (R, 255));
      Insert (F2I);
      R.Assign (2, 3, 5, 4);
      Insert (NEW (PLabel, Init (R, 'F2', F2I)));

      R.Assign (7, 4, 73, 5);
      F3I := NEW (PInputLine, Init (R, 255));
      Insert (F3I);
      R.Assign (2, 4, 5, 5);
      Insert (NEW (PLabel, Init (R, 'F3', F3I)));

      R.Assign (7, 5, 73, 6);
      F4I := NEW (PInputLine, Init (R, 255));
      Insert (F4I);
      R.Assign (2, 5, 5, 6);
      Insert (NEW (PLabel, Init (R, 'F4', F2I)));

      R.Assign (7, 6, 73, 7);
      F5I := NEW (PInputLine, Init (R, 255));
      Insert (F5I);
      R.Assign (2, 6, 5, 7);
      Insert (NEW (PLabel, Init (R, 'F5', F2I)));

      R.Assign (7, 7, 73, 8);
      F6I := NEW (PInputLine, Init (R, 255));
      Insert (F6I);
      R.Assign (2, 7, 5, 8);
      Insert (NEW (PLabel, Init (R, 'F6', F2I)));

      R.Assign (7, 8, 73, 9);
      F7I := NEW (PInputLine, Init (R, 255));
      Insert (F7I);
      R.Assign (2, 8, 5, 9);
      Insert (NEW (PLabel, Init (R, 'F7', F2I)));

      R.Assign (7, 9, 73, 10);
      F8I := NEW (PInputLine, Init (R, 255));
      Insert (F8I);
      R.Assign (2, 9, 5, 10);
      Insert (NEW (PLabel, Init (R, 'F8', F2I)));

      R.Assign (7, 10, 73, 11);
      F9I := NEW (PInputLine, Init (R, 255));
      Insert (F9I);
      R.Assign (2, 10, 5, 11);
      Insert (NEW (PLabel, Init (R, 'F9', F2I)));

      R.Assign (7, 11, 73, 12);
      F0I := NEW (PInputLine, Init (R, 255));
      Insert (F0I);
      R.Assign (2, 11, 5, 12);
      Insert (NEW (PLabel, Init (R, 'F0', F2I)));

(* Steuermengen *)

      R.Assign (10, 14, 73, 15);
      bl := NEW (PInputLine, Init (R, 255));
      Insert (bl);
      R.Assign (2, 14, 9, 15);
      Insert (NEW (PLabel, Init (R, 'Blank', F2I)));

      R.Assign (10, 15, 73, 16);
      nbl := NEW (PInputLine, Init (R, 255));
      Insert (nbl);
      R.Assign (2, 15, 9, 16);
      Insert (NEW (PLabel, Init (R, 'NonBlank', F2I)));

      R.Assign (10, 16, 73, 17);
      sto := NEW (PInputLine, Init (R, 255));
      Insert (sto);
      R.Assign (2, 16, 9, 17);
      Insert (NEW (PLabel, Init (R, 'StopZei', F2I)));

      R.Assign (10, 17, 73, 18);
      absk := NEW (PInputLine, Init (R, 255));
      Insert (absk);
      R.Assign (2, 17, 9, 18);
      Insert (NEW (PLabel, Init (R, 'AbsKenn', F2I)));

(* Dialogschalter OK, Abbruch *)

      R.Assign (10, 19, 10 + 10, 21);
      Insert (NEW (PButton, Init (R, '~O~K', cmOK, bfDefault)));

      R.Assign (43, 19, 43 + 10, 21);
      Insert (NEW (PButton, Init (R, 'Abbruch', cmCancel, bfNormal)));

    END (* WITH *);

(* Daten setzen *)
{
zeigMeldung ('zeigTextflags', 'Daten setzen');
}

    Daten.F1Data := holeName (F1F);
    Daten.F2Data := holeName (F2F);
    Daten.F3Data := holeName (F3F);
    Daten.F4Data := holeName (F4F);
    Daten.F5Data := holeName (F5F);
    Daten.F6Data := holeName (F6F);
    Daten.F7Data := holeName (F7F);
    Daten.F8Data := holeName (F8F);
    Daten.F9Data := holeName (F9F);
    Daten.F0Data := holeName (F0F);

    Daten.BlankData := StringVonSet (blankSet);
    Daten.StopData := StringVonSet (stopSet);
    Daten.NonBlankData := StringVonSet (nonblankSet);
    Daten.AbsKennData := StringVonSet (AbsatzKennSet);

{
zeigMeldung ('zeigTextflags', 'SetData');
}
    Box^.SetData (Daten);
{}

(* Dialog anzeigen *)
{
zeigMeldung ('zeigTextFlags', 'DeskTop^.ExecView');
}
    Control := DeskTop^.ExecView (Box);

(* Daten holen *)
{
zeigMeldung ('zeigTextFlags', 'Daten holen');
}
    IF Control <> cmCancel THEN BEGIN

       Box^.GetData (Daten);

       setzeName (F1F, Daten.F1Data);
       setzeName (F2F, Daten.F2Data);
       setzeName (F3F, Daten.F3Data);
       setzeName (F4F, Daten.F4Data);
       setzeName (F5F, Daten.F5Data);
       setzeName (F6F, Daten.F6Data);
       setzeName (F7F, Daten.F7Data);
       setzeName (F8F, Daten.F8Data);
       setzeName (F9F, Daten.F9Data);
       setzeName (F0F, Daten.F0Data);

       MakeSet (blankSet, Daten.BlankData);
       MakeSet (stopSet, Daten.StopData);
       MakeSet (nonblankSet, Daten.NonBlankData);
       MakeSet (AbsatzKennSet, Daten.AbsKennData);

    END;
{
zeigMeldung ('zeigTextFlags', 'Dispose Box, Done');
}
    Dispose (Box, Done);
{
zeigMeldung ('zeigTextFlags', 'updateFenster');
}
    IF derFensterInhalt <> NIL THEN updateFenster (derFensterInhalt, 0);
{
zeigMeldung ('zeigTextFlags', 'END');
}
END (* zeigFStrings *);

PROCEDURE einText.setzFensterInhalt (CONST FensterInhalt: PBuffText);
BEGIN
  derFensterInhalt := PTextGrafik (FensterInhalt);
  IF FensterInhalt = NIL THEN loescheInternFlag (TextOffen);
END (* setzFenster *);

FUNCTION einText.getFensterInhalt: PBuffText;
BEGIN
  getFensterInhalt := derFensterInhalt;
END (* getFensterInhalt *);

FUNCTION einText.Edit (CONST view: PBuffText; CONST x, y, b, h: WORD;
                             CONST name: GLP): GLP;
VAR  PWin:       PSimpleTextWindow;
     nam:        STRING [80];
BEGIN
{
IF derFensterInhalt <> NIL THEN
zeigMeldung ('einSimpletext.Edit', 'meineTextFlags: ' + StringVonTextFlags +
             '; derFensterInhalt: ' + atString (derFensterInhalt));
}
  IF hatInternFlag (TextOffen) AND (derFensterInhalt <> NIL) THEN BEGIN
{
zeigMeldung ('TextOffen', 'derFensterInhalt^.Owner^.Select');
}
    derFensterInhalt^.Owner^.Select;
    schreibStatus;
  END
  ELSE BEGIN

    (* Grenparameter x, y, h, b werden ignoriert - siehe Abmess! *)
{zeigMeldung ('ELSE nichtTextOffen', 'name^.StringVonDaten');}

    IF name <> NIL THEN nam := name^.StringVonDaten
    ELSE nam := '<SimpleText>';
{zeigMeldung ('ELSE nichtTextOffen', 'PWin := NEW (PSimpleTextWindow ...)');}
    PWin := NEW (PSimpleTextWindow, Init (Abmess, 255, AnzahlElemente,
                                          FenOffset, nam, @SELF));
    (* hat "meinFenster" gesetzt! *)
{zeigMeldung ('ELSE nichtTextOffen', 'Desktop^.Insert(PWin)');}
    Desktop^.Insert (Pwin);
    IF ActualElement = NIL THEN BEGIN
      macheZeilen (1, AnzahlZeichen, UmbruchBreite, meineTextFlags, StandardZeile);
      setzeMerker (laufendeZeile);
      setzeMerker (MerkerBlockanfang);
      setzeMerker (MerkerBlockende);
    END (* IF *);
    setzeInternFlag (TextOffen);
    Edit := NIL;
    schreibStatus;
  END (* IF NOT TextOffen *);
{zeigMeldung ('Edit', 'END');}
END (* Edit *);

FUNCTION einText.NoEdit: BOOLEAN;
BEGIN
  IF hatTextFlag (nurLesen) THEN BEGIN
    zeigMeldung ('Dieser Text kann nicht verndert werden',
                 'Um diesen Text zu editieren, mssen Sie das NurLesen-Flag lschen');
    NoEdit := TRUE;
  END
  ELSE NoEdit := FALSE;
END (* NoEdit *);

PROCEDURE einText.doCh;
BEGIN
  IF InsertFlag IN meineTextFlags THEN BEGIN
    laufendeZeile^.GetZ^.fuegeZchEin (TextX, meineNachrichten.CharCode);
  END
  ELSE BEGIN
    laufendeZeile^.GetZ^.setzeZch (TextX, meineNachrichten.CharCode);
  END (* IF Insert *);
  INC (TextX); INC (getippt);
  IF AutoUmbruch IN meineTextFlags THEN BEGIN
    doUmbruch;
  END (* IF *);

  IF derFensterInhalt <> NIL THEN BEGIN
    derFensterInhalt^.WriteChr (meineNachrichten.CharCode);
    derFensterInhalt^.Scrollto (TextX, TextY);
  END (* IF *);
END (* doCH *);

PROCEDURE einText.doZch;
BEGIN
  IF InsertFlag IN meineTextFlags THEN BEGIN
    laufendeZeile^.getZ^.fuegeZchEin (TextX, meineNachrichten.InfoChar);
  END
  ELSE BEGIN
    laufendeZeile^.getZ^.setzeZch (TextX, meineNachrichten.InfoChar);
  END (* IF Insert *);
  INC (TextX);
{
zeigMeldung ('SimpleText.doZch', 'doUmbruch');
}
  IF AutoUmbruch IN meineTextFlags THEN BEGIN
    doUmbruch;
  END (* IF *);
{
zeigMeldung ('SimpleText.doZch', 'UpdateFenster');
}
  IF derFensterInhalt <> NIL THEN BEGIN
    derFensterInhalt^.WriteChr (meineNachrichten.InfoChar);
    derFensterInhalt^.Scrollto (TextX, TextY);
  END;
END (* doZch *);

PROCEDURE einText.doStr;
BEGIN
  IF InsertFlag IN meineTextFlags THEN BEGIN
    laufendeZeile^.getZ^.EinfText (PString (meineNachrichten.InfoPtr)^, TextX);
  END
  ELSE BEGIN
    laufendeZeile^.getZ^.EinfText (PString (meineNachrichten.InfoPtr)^, TextX);
  END (* IF Insert *);
  INC (TextX, LENGTH (PString (meineNachrichten.InfoPtr)^));
  IF AutoUmbruch IN meineTextFlags THEN BEGIN
    doUmbruch;
  END (* IF *);
  IF derFensterInhalt <> NIL THEN BEGIN
    derFensterInhalt^.WriteString (PString (meineNachrichten.InfoPtr)^, 0, 0);
    derFensterInhalt^.Scrollto (TextX, TextY);
  END;
END (* doStr *);

PROCEDURE einText.InsStr (CONST SP: einString8Pointer);
BEGIN
  IF SP = NIL THEN EXIT;
  INC (TextX);
  IF InsertFlag IN meineTextFlags THEN BEGIN
    laufendeZeile^.getZ^.EinfText (SP^.StringVonDaten, TextX);
  END
  ELSE BEGIN
    laufendeZeile^.getZ^.EinfText (SP^.StringVonDaten, TextX);
  END (* IF Insert *);
  INC (TextX, SP^.StrLaenge - 1);
  IF AutoUmbruch IN meineTextFlags THEN BEGIN
    doUmbruch;
  END (* IF *);
  updateFenster (derFensterInhalt, derFensterInhalt^.LongDelta.Y);
  {
  IF derFensterInhalt <> NIL THEN BEGIN
    derFensterInhalt^.WriteString (SP^.StringVonDaten, 0, 0);
    derFensterInhalt^.Scrollto (TextX, TextY);
  END;
  }
END (* InsStr *);

PROCEDURE einText.zentriereZeile;
VAR dieZeile:      einStringPointer;
    einfuegen:     INTEGER;
    start, anzahl: INTEGER;
    blank:         CHAR;
BEGIN
  dieZeile := laufendeZeile^.GetZ;
  IF dieZeile <> NIL THEN BEGIN
    start := 0;
    anzahl := dieZeile^.Scan ([#33..#255], 0);
    dieZeile^.ausfuege (start, anzahl);
    einfuegen := (Umbruchbreite - dieZeile^.StringLaenge) DIV 2;
    IF einfuegen > 0 THEN BEGIN
      start := 0; (* Warum ist hier eine Variable ntig - Parameter sind CONST *)
      blank := ' ';
      dieZeile^.einfuege (start, einfuegen, blank);
    END (* IF einfuegen *);
    TextX := dieZeile^.StringLaenge;
    updateFenster (derFensterInhalt, TextY);
  END (* IF *);
END (* zentriereZeile *);

PROCEDURE einText.doBs;
(* VAR  kitt:  STRING; *)
VAR alteZeile, aktuelleZeile: einTriplePointer;
BEGIN
  IF TextX > 0 THEN BEGIN
    DEC (TextX);
    laufendeZeile^.GetZ^.entferneZch (TextX);
  END
  ELSE BEGIN
    IF TextY > 0 THEN BEGIN
      doUp;
      TextX := laufendeZeile^.GetZ^.StringLaenge;
      GLP (alteZeile) := Delete;
      setzeMerker (laufendeZeile);
      MerkerUpdate (laufendeZeile);
      IF alteZeile^.Rechts <> NIL THEN BEGIN
        laufendeZeile^.GetZ^.einfText
          (einStringPointer (alteZeile^.Rechts)^.StringVonDaten, 0);
      END (* IF *);
      alteZeile^.Rueck := NIL; alteZeile^.Links := NIL;
      DISPOSE (alteZeile, Done);
      updateFenster (derFensterInhalt, TextY);
    END (* IF nicht erste Zeile *);
  END (* IF > 0 *);
  IF derFensterInhalt <> NIL THEN derFensterInhalt^.ScrollTo (TextX, TextY);
END (* doBs *);

PROCEDURE einText.doDel;
VAR  naechsteZeile: einTriplePointer;
BEGIN
  IF TextX < laufendeZeile^.getZ^.StringLaenge THEN BEGIN
    laufendeZeile^.getZ^.entferneZch (TextX);
  END
  ELSE BEGIN
    GLP (naechsteZeile) := DeleteNext;
    IF naechsteZeile <> NIL THEN BEGIN
      laufendeZeile^.getZ^.anhText
        (einStringPointer (naechsteZeile^.Rechts)^.StringVonDaten);
      naechsteZeile^.Rueck := NIL; naechsteZeile^.Links := NIL;
      DISPOSE (naechsteZeile, Done);
    END (* naechsteZeile <> NIL *);
    MerkerUpdate (laufendeZeile);

    updateFenster (derFensterInhalt, TextY);
  END (* ELSE *);
END (* doDel *);

PROCEDURE einText.doUmbruch;
VAR  X:    LONGINT;
     offs: LONGINT;
BEGIN
  IF TextX >= Umbruchbreite THEN BEGIN
    X := sucheWortAnfang (blankSet);
    offs := TextX - X;
    IF X > 0 THEN TextX := X + 1;
    doCr;
    derFensterInhalt^.GotoXY (TextX, TextY);
    setzeMerker (laufendeZeile);
    IF (laufendeZeile <> NIL) AND (laufendeZeile^.getZ^.isSubclass (StringG)) THEN BEGIN
      laufendeZeile^.getZ^.OffsetSchreib (derFensterInhalt, TextX, TextY, TextX,
                                          Blockstart (laufendeZeile),
                                          BlockEnd (laufendeZeile),
                                          hatTextflag (markiereAbschnitte),
                                          NOT hatNaechsteZeile (laufendeZeile));
    END (* IF Member *);
    IF TextX >= laufendeZeile^.getZ^.StringLaenge THEN BEGIN
      PBuffText (derFensterInhalt)^.ClrEol (hatTextFlag (markiereAbschnitte),
                                            NOT hatNaechsteZeile (laufendeZeile));
    END (* IF *);
    TextX := offs;
    derFensterInhalt^.GotoXY (TextX, TextY);
  END (* IF Insert *);
END (* doUmbruch *);

PROCEDURE einText.DownFormat;
VAR  cutIndex:  LONGINT;
     geleert:   LONGINT;
     curLine:   einTextGluePointer;
     weiter:    BOOLEAN;
BEGIN
  weiter := TRUE; geleert := 0;
  IF (laufendeZeile <> NIL) AND (laufendeZeile^.getZ^.isSubClass (StringG)) AND
     (laufendeZeile^.getZ^.AbsatzEnde (hatTextFlag (Absatzkennung), hatTextFlag (Absatzkennung),
                                       AbsatzKennSet)) AND hatNextElement THEN BEGIN
    ZeilenVor (TRUE, 1);
  END
  ELSE

  WHILE (laufendeZeile <> NIL) AND (laufendeZeile^.getZ^.isSubClass (StringG)) AND
        {(laufendeZeile^.getZ^.StringLaenge > 0) AND weiter DO BEGIN}
        NOT (laufendeZeile^.getZ^.AbsatzEnde (hatTextFlag (Absatzkennung), hatTextflag (Absatzkennung),
                                              AbsatzKennSet)) AND weiter
  DO BEGIN

    (********** Die laufende Zeile ist zu lang! ***********************)
    IF (laufendeZeile^.getZ^.StringLaenge > UmbruchBreite) THEN BEGIN
{zeigMeldung ('SimpleText', 'Zeile zu lang');}
      (* Wir wollen berschssige Wrter loswerden *)
      cutIndex := laufendeZeile^.getZ^.backScan (blankSet, UmbruchBreite);
      IF (laufendeZeile^.getZ^.holeZch (cutIndex) IN blankSet) (* Nicht Wort anschneiden! *)
        AND (cutIndex < laufendeZeile^.getZ^.StringLaenge) THEN BEGIN
        INC (cutIndex); (* Plenk nach Wort mitkopieren! *)
      END;
      IF cutIndex = 0 THEN cutIndex := UmbruchBreite;
      IF NOT hatNextElement THEN BEGIN
        appendZeile; ZeilenZurueck (TRUE, 1);
      END
      ELSE IF NOT (hatTextflag (Absatzkennung)) AND
                einTextGluePointer (einTextGluePointer (Verweis)^.Links)^.ZeileLeer
               THEN BEGIN
                 insertZeile; ZeilenZurueck (TRUE, 1);
               END;
{
IF (einTextGluePointer (Verweis)^.Links = NIL) THEN
zeigMeldung ('DownFormat', 'Verweis^.Links = NIL');
}
      einTextGluePointer (einTextGluePointer (Verweis)^.Links)^.InsertAtBeginFrom (laufendeZeile^.getZ, cutIndex);
{zeigMeldung ('SimpleText', 'nachInsertAtBeginFrom');}
      laufendeZeile^.getZ^.cutText (cutIndex);
        (* Lnge des Strings auf cutIndex, ResizeVektor *)
    END (* IF Zeile zu lang *)

    (*********** die laufende Zeile ist zu kurz! *******************)
    ELSE IF hatNextElement AND
            (laufendeZeile^.getZ^.StringLaenge < UmbruchBreite) AND
            NOT (laufendeZeile^.getZ^.AbsatzEnde (hatTextflag (Absatzkennung), hatTextflag (Absatzkennung),
                                                  AbsatzKennSet)) THEN BEGIN
      (* Wir haben zu wenig Wrter und wollen welche von der nchsten Zeile *)
      geleert := 0;
      GLP (curLine) := ActualElement;
      curLine^.AppendAtEndFrom (einTextGluePointer (curLine^.Links)^.getFromBegin
         (UmbruchBreite - laufendeZeile^.getZ^.StringLaenge, blankSet,
          hatTextflag (Absatzkennung), geleert));
    END (* ELSE IF zeile zu kurz *);
    (***********************************************)
{
IF NOT hatNextElement THEN
zeigMeldung ('SimpleText', 'NOT hatNextElement');
}
    IF hatNextElement THEN BEGIN
      IF geleert > 0 THEN BEGIN
        ZeilenVor (TRUE, 1);
        deleteZeilen (geleert);
        ZeilenZurueck (TRUE, 1);
      END;
      IF hatNextElement THEN BEGIN
        ZeilenVor (TRUE, 1);
      END (* IF *)
      ELSE EXIT;
    END (* IF weiter mit der nchsten Zeile *)
    ELSE weiter := FALSE;
  END (* WHILE *);
END (* DownFormat *);

PROCEDURE einText.doDownFormat;
BEGIN
  DownFormat;
  derFensterInhalt^.SetLongLimit (255, AnzahlElemente);
  updateFenster (derFensterInhalt, derFensterInhalt^.LongDelta.Y);
  derFensterInhalt^.GotoXY (TextX, TextY);
END (* doDownFormat *);

PROCEDURE einText.doFormat;
BEGIN
  IF hatTextFlag (FrageVorFormat) AND
     NOT zeigFrage ('Absatz neu formatieren', 'Wollen Sie den Absatz neu formatieren?')
  THEN EXIT;
  IF (laufendeZeile <> NIL) AND (laufendeZeile^.getZ^.isSubClass (StringG)) AND
     ((laufendeZeile^.getZ^.StringLaenge = 0) OR hatTextflag (Absatzkennung))
     AND hatNextElement THEN BEGIN
    ZeilenVor (TRUE, 1);
  END;
  AbsatzAnfang (FALSE);
  doDownFormat;
  setzeFlag (editFlag); setzeInternFlag (TextEditiert);
END (* doFormat *);

PROCEDURE einText.doDokFormat;
BEGIN
  IF hatTextFlag (FrageVorFormat) AND
     NOT zeigFrage ('Dokument neu formatieren', 'Wollen Sie das Dokument neu formatieren?')
  THEN EXIT;
  IF (laufendeZeile <> NIL) AND (laufendeZeile^.getZ^.isSubClass (StringG)) AND
     (laufendeZeile^.getZ^.StringLaenge = 0) AND hatNextElement THEN BEGIN
    ZeilenVor (TRUE, 1);
  END;
  AbsatzAnfang (FALSE);
  WHILE hatNextElement DO BEGIN
    doDownFormat;
  END;
  setzeFlag (editFlag); setzeInternFlag (TextEditiert);
END (* doDokFormat *);

PROCEDURE einText.doDownRot13;
VAR  weiter: BOOLEAN;
BEGIN
  weiter := TRUE;
  IF (laufendeZeile <> NIL) AND (laufendeZeile^.getZ^.isSubClass (StringG)) AND
     (laufendeZeile^.getZ^.StringLaenge = 0) AND hatNextElement THEN BEGIN
    ZeilenVor (TRUE, 1);
  END
  ELSE
  WHILE (laufendeZeile <> NIL) AND (laufendeZeile^.getZ^.isSubClass (StringG)) AND
        (laufendeZeile^.getZ^.StringLaenge > 0) AND weiter DO BEGIN
    laufendeZeile^.getZ^.Rot13;

    IF hatNextElement THEN BEGIN
      ZeilenVor (TRUE, 1);
    END (* IF weiter mit der nchsten Zeile *)
    ELSE weiter := FALSE;
  END (* WHILE *);
END (* doDownRot13 *);

PROCEDURE einText.doRot13;
BEGIN
  IF NOT zeigFrage ('Text mit ROT13 verschlsseln',
    'Wirklich verschlsseln/entschlssen?') THEN EXIT;
  IF (laufendeZeile <> NIL) AND (laufendeZeile^.GetZ^.isSubClass (StringG)) AND
     (laufendeZeile^.GetZ^.StringLaenge = 0) AND hatNextElement THEN BEGIN
    ZeilenVor (TRUE, 1);
  END;
  AbsatzAnfang (FALSE);
  doDownRot13;
  derFensterInhalt^.SetLongLimit (255, AnzahlElemente);
  updateFenster (derFensterInhalt, derFensterInhalt^.LongDelta.Y);
  derFensterInhalt^.GotoXY (TextX, TextY);
END (* doRot13 *);

PROCEDURE einText.doDownKrypt;
VAR  weiter: BOOLEAN;
BEGIN
  weiter := TRUE;
  IF (laufendeZeile <> NIL) AND (laufendeZeile^.getZ^.isSubClass (StringG)) AND
     (laufendeZeile^.getZ^.StringLaenge = 0) AND hatNextElement THEN BEGIN
    ZeilenVor (TRUE, 1);
  END
  ELSE
  WHILE (laufendeZeile <> NIL) AND (laufendeZeile^.getZ^.isSubClass (StringG)) AND
        (laufendeZeile^.getZ^.StringLaenge > 0) AND weiter DO BEGIN
    laufendeZeile^.getZ^.Krypt;

    IF hatNextElement THEN BEGIN
      ZeilenVor (TRUE, 1);
    END (* IF weiter mit der nchsten Zeile *)
    ELSE weiter := FALSE;
  END (* WHILE *);
END (* doDownKrypt *);

PROCEDURE einText.doKrypt;
BEGIN
  IF NOT zeigFrage ('Text mit Krypt verschlsseln',
     'Wirklich verschlsseln/entschlsseln?') THEN EXIT;
  IF (laufendeZeile <> NIL) AND (laufendeZeile^.getZ^.isSubClass (StringG)) AND
     (laufendeZeile^.getZ^.StringLaenge = 0) AND hatNextElement THEN BEGIN
    ZeilenVor (TRUE, 1);
  END;
  AbsatzAnfang (FALSE);
  doDownKrypt;
  derFensterInhalt^.SetLongLimit (255, AnzahlElemente);
  updateFenster (derFensterInhalt, derFensterInhalt^.LongDelta.Y);
  derFensterInhalt^.GotoXY (TextX, TextY);
END (* doKrypt *);

FUNCTION einText.sucheWortAnfang (CONST zSet: CHSet): LONGINT;
BEGIN
  IF TextX > 0 THEN BEGIN
    DEC (TextX);
    sucheWortAnfang := laufendeZeile^.getZ^.backScan (zSet, TextX);
  END
  ELSE BEGIN
    doUp; doEnd;
    sucheWortAnfang := TextX;
  END;
END (* sucheWortAnfang *);

FUNCTION einText.sucheWortEnde (CONST zSet: CHSet): LONGINT;
BEGIN
  IF TextX + 1 < laufendeZeile^.getZ^.StringLaenge THEN BEGIN
    INC (TextX);
    sucheWortEnde := laufendeZeile^.getZ^.Scan (zSet, TextX);
  END
  ELSE BEGIN
    doDown; doHome;
    sucheWortEnde := TextX;
  END;
END (* sucheWortEnde *);

FUNCTION einText.sucheNaechstesWort (CONST zSet: CHSet): LONGINT;
BEGIN
  IF TextX + 1 < laufendeZeile^.getZ^.StringLaenge THEN BEGIN
    INC (TextX);
    TextX := laufendeZeile^.getZ^.Scan (zSet, TextX);
    sucheNaechstesWort := laufendeZeile^.getZ^.Scan (nonblankSet, TextX);
  END
  ELSE BEGIN
    doDown; doHome;
    sucheNaechstesWort := TextX;
  END;
END (* sucheNaechstesWort *);

PROCEDURE einText.doCr;
(* Update 23. 3. 93: Verhalten bei Overwrite korrigiert *)
VAR  split:    STRING;
     Y:        LONGINT;
     vorZeile: einTextGluePointer;
BEGIN
  IF (InsertFlag IN meineTextFlags) OR (AutoAppend IN meineTextFlags) THEN BEGIN
    IF (InsertFlag IN meineTextFlags) OR NOT hatNextElement THEN BEGIN
      IF InsertFlag IN meineTextFlags THEN
        laufendeZeile^.getZ^.splitText (split, TextX)
      ELSE split := '';
      insertText (split); (* Zeilen-Objekt einfgen *)
    END
    ELSE zeilenVor (TRUE, 1);
    Y := TextY; IF Y > 0 THEN DEC (Y);
    derFensterInhalt^.SetLongLimit (255, AnzahlElemente);
{
zeigMeldung ('doCr, nach SetLongLimit', 'LongDelta.Y = ' +
              StringVonNum (derFensterInhalt^.LongDelta.Y));
}
    updateFenster (derFensterInhalt, Y);
  END (* IF Insert *);
  IF (AutoIndent IN meineTextFlags) AND (PrevElementIs <> NIL) THEN BEGIN
    GLP (vorZeile) := PrevElementIs;
    TextX := einStringPointer (vorZeile^.Rechts)^.Scan (nonBlankSet, 0);
  END
  ELSE TextX := 0;
  derFensterInhalt^.ScrollTo (TextX, TextY);
END (* doCr *);

PROCEDURE einText.doLineUndel;
VAR  loeschZeile:  GLP;
BEGIN
  IF meinUndoText <> NIL THEN BEGIN
    loeschZeile := einTextPointer (meinUndoText)^.popZeile;
    IF loeschZeile <> NIL THEN BEGIN
      insertObjektBefore (loeschZeile);
      IF TextX > laufendeZeile^.getZ^.StringLaenge THEN
        TextX := laufendeZeile^.getZ^.StringLaenge;
      updateFenster (derFensterInhalt, TextY);
      derFensterInhalt^.SetLongLimit (255, AnzahlElemente);
    END (* IF loeschZeile *)
    ELSE zeigMeldung ('Undo', 'Es ist nichts im Undo-Puffer');
  END (* IF meinUndoText *)
  ELSE zeigMeldung ('Undo', 'Es gibt noch keinen Undo-Puffer');
END (* doLineUndel *);

PROCEDURE einText.doLinedel;
VAR  loeschZeile:  GLP;
     name:         STRING;
     PN, KN:       GLP;
BEGIN
  loeschZeile := deleteZeile;
  IF (loeschZeile <> NIL) AND hatTextFlag (loescheInUndo) THEN BEGIN
    IF meinUndoText = NIL THEN BEGIN
      name := holeName (TextName) + '-Undopuffer';
      meinUndoText := neuesObjekt (SimpleText, []);
      einTextPointer (meinUndoText)^.loescheTextFlag (loescheInUndo);
      einTextPointer (meinUndoText)^.setzeInternFlag (istUndopuffer);
      einTextPointer (meinUndoText)^.setzeName
        (einTextPointer (meinUndoText)^.TextName, name);
    END (* IF meinUndoText = NIL *);
    einTextPointer (meinUndoText)^.insertObjekt (loeschZeile);
  END (* IF loeschZeile <> NIL *)
  ELSE IF loeschZeile <> NIL THEN DISPOSE (loeschZeile, Done);
  IF TextX > laufendeZeile^.getZ^.StringLaenge THEN
    TextX := laufendeZeile^.getZ^.StringLaenge;
  updateFenster (derFensterInhalt, TextY);
  derFensterInhalt^.SetLongLimit (255, AnzahlElemente);
END (* doLinedel *);

PROCEDURE einText.doF1;
BEGIN
END (* doF1 *);

PROCEDURE einText.doUp;
BEGIN
  ZeilenZurueck (TRUE, 1);
END (* doUp *);

PROCEDURE einText.doDown;
BEGIN
  ZeilenVor (TRUE, 1);
END (* doDown *);

PROCEDURE einText.doLeft;
BEGIN
  IF TextX > 0 THEN DEC (TextX)
  ELSE BEGIN doUp; doEnd; END;
  derFensterInhalt^.ScrollTo (TextX, TextY);
END (* doLeft *);

PROCEDURE einText.doRight;
BEGIN
  IF TextX < AnzahlZeichen THEN INC (TextX)
  ELSE BEGIN doDown; doHome; END;
  derFensterInhalt^.ScrollTo (TextX, TextY);
END (* doRight *);

PROCEDURE einText.doTab;
VAR ind:   LONGINT;
    anz:   WORD;
    blank: CHAR;
BEGIN
  ind := Tablaenge * (TextX DIV Tablaenge + 1);
  IF InsertFlag IN meineTextFlags THEN BEGIN
    anz := ind - TextX; blank := ' ';
    laufendeZeile^.getZ^.einfuege (TextX, anz, blank);
    IF (laufendeZeile <> NIL) AND (laufendeZeile^.getZ^.isSubclass (StringG)) THEN BEGIN
      laufendeZeile^.getZ^.OffsetSchreib (derFensterInhalt, TextX, TextY, TextX,
                                          BlockStart (laufendeZeile),
                                          BlockEnd (laufendeZeile),
                                          hatTextflag (markiereAbschnitte),
                                          hatNextElement);
    END (* IF Member *);
    INC (TextX, anz);
    IF AutoUmbruch IN meineTextFlags THEN doUmbruch;
  END
  ELSE BEGIN
    IF ind <= AnzahlZeichen THEN TextX := ind
    ELSE BEGIN DoDown; doHome; END;
  END;
  derFensterInhalt^.ScrollTo (TextX, TextY);
END (* doTab *);

PROCEDURE einText.doPgup;
BEGIN
  ZeilenZurueck (TRUE, derFensterInhalt^.Size.Y - 1);
END (* doPgup *);

PROCEDURE einText.doPgdown;
BEGIN
  ZeilenVor (TRUE, derFensterInhalt^.Size.Y - 1);
END (* doPgdown *);

PROCEDURE einText.doMaus (x, y: LONGINT);
BEGIN
  TextX := derFensterInhalt^.Delta.X + x; zurZeile (derFensterInhalt^.LongDelta.Y + y);
  schreibStatus;
  derFensterInhalt^.GotoXY (TextX, TextY);
END (* doMaus *);

PROCEDURE einText.doHome;
BEGIN
  TextX := 0;
  derFensterInhalt^.ScrollTo (TextX, TextY);
END (* doHome *);

PROCEDURE einText.doEnd;
BEGIN
  IF laufendeZeile <> NIL THEN BEGIN
    TextX := laufendeZeile^.getZ^.StringLaenge;
    derFensterInhalt^.ScrollTo (TextX, TextY);
  END;
END (* doEnd *);

PROCEDURE einText.doIns;
(* Update 30. 3. 93: Cursor bei Overwrite auf Block umschalten *)
BEGIN
  toggleTextFlag (InsertFlag);
  IF hatTextFlag (InsertFlag) THEN derFensterInhalt^.NormalCursor
  ELSE derFensterInhalt^.BlockCursor;
END (* doIns *);

FUNCTION einText.TextY: LONGINT;
BEGIN
  TextY := ElementIndex;
END (* CursorY *);

PROCEDURE einText.macheZeilen (CONST Zeilen, Zeichen: LONGINT;
                                     CONST Breite: WORD;
                                     CONST TextFlags: einTextFlagset;
                                     CONST ZeilenTyp: einGenTyp);
VAR     i:      LONGINT;
BEGIN
  meineTextFlags := [InsertFlag];
  StandardZeile := ZeilenTyp;
  FOR i := 1 TO Zeilen DO BEGIN
    insertObjekt (neuesObjekt (ZeilenTyp, []));
  END (* FOR *);
  AnzahlZeichen := Zeichen;
  UmbruchBreite := Breite;
  meineTextFlags := TextFlags;
END (* MacheZeilen *);

PROCEDURE einText.insertZeile;
(* Zeile nach der laufenden anfgen oder erste Zeile anlegen *)
BEGIN
  insertObjekt (neuesObjekt (StandardZeile, []));
  MerkerUpdate (laufendeZeile);
END (* insertZeile *);

PROCEDURE einText.appendZeile;
(* Zeile nach der laufenden anfgen oder erste Zeile anlegen *)
VAR     d:    GLP;
BEGIN
  d := LastElement;
  insertObjekt (neuesObjekt (StandardZeile, []));
END (* appendZeile *);

PROCEDURE einText.insertZeileVor;
(* Zeile nach der laufenden einfgen und auf diese vorrcken *)
(* eigentlich berflssig bzw. unsinnig, weil das schon insertZeile macht,
   so wie es jetzt implementiert ist... *)
BEGIN
  insertZeile; ZeilenVor (TRUE, 1);
END (* insertZeileVor *);

PROCEDURE einText.insertObjektBefore (CONST O: GLP);
VAR     zeile:  GLP;
BEGIN
  IF ActualElement = NIL (* Anfangszustand *) THEN BEGIN
    (* Es wird genau eine Zeile angelegt *)
    zeile := insertFirstElement (O);
    TextX := 0;
  END
  ELSE BEGIN
    (* Es wird eine Zeile eingefgt oder nach unten gegangen *)
    IF (InsertFlag IN meineTextFlags) OR (AutoAppend IN meineTextFlags)
    THEN BEGIN
      zeile := InsertBefore (O);
    END (* IF Flags *);
  END (* ELSE *);
  setzeMerker (laufendeZeile);
END (* insertObjektBefore *);

PROCEDURE einText.insertObjekt (CONST O: GLP);
VAR     zeile:  GLP;
BEGIN
  IF ActualElement = NIL (* Anfangszustand *) THEN BEGIN
    (* Es wird genau eine Zeile angelegt *)
    zeile := insertFirstElement (O);
    TextX := 0;
  END
  ELSE BEGIN
    (* Es wird eine Zeile eingefgt oder nach unten gegangen *)
    IF (InsertFlag IN meineTextFlags) OR (AutoAppend IN meineTextFlags)
    THEN BEGIN
      zeile := InsertAfter (O);
    END (* IF Flags *);
  END (* ELSE *);
  setzeMerker (laufendeZeile);
END (* insertObjekt *);

PROCEDURE einText.setzeText (CONST s: STRING);
BEGIN
  IF (ActualElement = NIL) OR (laufendeZeile = NIL) THEN BEGIN
    macheZeilen (1, AnzahlZeichen, UmbruchBreite, meineTextFlags, StandardZeile);
    (* setzt "laufendeZeile" als Pointer auf den String *)
  END (* IF *);
  IF (laufendeZeile <> NIL) AND (laufendeZeile^.getZ^.isSubclass (String8)) THEN BEGIN
    laufendeZeile^.getZ^.setzeString (s, TRUE);
  END;
END (* setzeText *);

PROCEDURE einText.insertText (CONST s: STRING);
BEGIN
  insertZeile;
  setzeText (s);
END (* insertText *);

PROCEDURE einText.expandiereTabs (VAR s: STRING);
VAR tabpos: INTEGER;
    blanks: STRING [30];
BEGIN
  tabpos := POS (Tab, s);
  FillChar (blanks, SizeOf (blanks), ' ');
  blanks [0] := #30;
  WHILE tabpos > 0 DO BEGIN
    SYSTEM.Delete (s, tabpos, 1);
    blanks [0] := CHR (Tablaenge - (tabpos MOD Tablaenge) + 1);
    Insert (blanks, s, tabpos);
    tabpos := POS (Tab, s);
  END (* WHILE *);
END (* expandiereTabs *);

PROCEDURE einText.setzeLongText (CONST s);
(* String mit WORD-Lngenattribut *)
BEGIN
  IF ActualElement = NIL THEN BEGIN
    macheZeilen (1, AnzahlZeichen, UmbruchBreite, meineTextFlags, StandardZeile);
    (* setzt "laufendeZeile^.Rechts" als Pointer auf den String *)
  END (* IF *);
  IF laufendeZeile^.getZ^.isSubclass (String16) THEN BEGIN
    laufendeZeile^.getZ^.setzeString (s, TRUE);
  END;
END (* setzeLongText *);

PROCEDURE einText.insertLongText (CONST s);
BEGIN
  insertZeile;
  setzeLongText (s);
END (* insertText *);

PROCEDURE einText.holeText (VAR s: STRING);
BEGIN
  IF (laufendeZeile <> NIL) AND (laufendeZeile^.getZ^.isSubclass (String8)) THEN BEGIN
    laufendeZeile^.getZ^.holeString (s);
  END;
END (* holeText *);

PROCEDURE einText.holeLongText (VAR s);
BEGIN
END (* holeLongText *);

PROCEDURE einText.deleteZeilen (CONST n: LONGINT);
VAR i:  LONGINT;
    l:  GLP;
BEGIN
  FOR i := 1 TO n DO BEGIN
    l := deleteZeile; IF l <> NIL THEN DISPOSE (l, Done);
  END (* FOR *);
END (* deleteZeilen *);

FUNCTION einText.deleteZeile: GLP;
VAR     loeschTriple:           einTextGluePointer;
        derZeilenString:        einStringPointer;
BEGIN
{zeigMeldung ('deleteZeile', Verweis^.StringVonDaten);}
  derZeilenString := NIL;
  IF (ActualElement <> NIL) THEN BEGIN

    GLP (derZeilenString) := getActual;
    (* das ist der String, den wir auf jeden Fall lschen *)
{
zeigMeldung ('deleteZeile', 'AnzahlElemente: ' + StringVonNum (AnzahlElemente) +
                            '; TextY: ' + StringVonNum (TextY));
}
    IF hatNextElement THEN BEGIN
      GLP (loeschTriple) := Delete;
      IF loeschTriple <> NIL THEN BEGIN
        WITH loeschTriple^ DO BEGIN
          Links := NIL; Rechts := NIL; Rueck := NIL;
        END (* WITH *);
        killObjekt (GLP (loeschTriple));
      END (* IF <> NIL *);
    END
    ELSE BEGIN
      IF einTextGluePointer (ActualElement)^.ZeileLeer THEN BEGIN
        IF derZeilenString <> NIL THEN DISPOSE (derZeilenString, Done);
        derZeilenString := NIL;
      END (* IF *);
      putActual (neuesObjekt (StandardZeile, []));
    END;

  END (* IF *);
  setzeMerker (laufendeZeile);
  MerkerUpdate (laufendeZeile);
{zeigMeldung ('deleteZeile', 'END');}
  deleteZeile := derZeilenString;
END (* deleteZeile *);

FUNCTION einText.getZeile: GLP;
VAR     {loeschTriple:           einTextGluePointer;}
        derZeilenString:        einStringPointer;
        Stringkopie:            einStringPointer;
BEGIN
{zeigMeldung ('deleteZeile', Verweis^.StringVonDaten);}
  Stringkopie := NIL;
  IF (ActualElement <> NIL) THEN BEGIN
    GLP (Stringkopie) := neuesObjekt (getActual^.meinTypIst, []);
    GLP (derZeilenString) := getActual;
    Stringkopie^.setzeText (derZeilenString^.StringVonDaten, TRUE);
  END (* IF *);
  getZeile := Stringkopie;
END (* deleteZeile *);

FUNCTION einText.popZeile: GLP;
VAR     loeschTriple:           einTextGluePointer;
        derZeilenString:        einStringPointer;
BEGIN
  derZeilenString := NIL;
  IF (ActualElement <> NIL) THEN BEGIN

    GLP (derZeilenString) := getActual;
    (* das ist der String, den wir auf jeden Fall lschen *)

    GLP (loeschTriple) := Delete;
    IF loeschTriple <> NIL THEN BEGIN
      WITH loeschTriple^ DO BEGIN
        Links := NIL; Rechts := NIL; Rueck := NIL;
      END (* WITH *);
      killObjekt (GLP (loeschTriple));
      ZeilenZurueck (TRUE, 1);
    END (* IF <> NIL *);

  END (* IF *);
  setzeMerker (laufendeZeile);
  MerkerUpdate (laufendeZeile);
  updateFenster (derFensterInhalt, TextY);
  popZeile := derZeilenString;
END (* popZeile *);

PROCEDURE einText.ersteZeile;
VAR     d:  GLP;
BEGIN
  d := FirstElement;
  setzeMerker (laufendeZeile);
  IF derFensterInhalt <> NIL THEN derFensterInhalt^.ScrollTo (TextX, TextY);
END (* ersteZeile *);

PROCEDURE einText.FensterScroll (CONST X, Y: LONGINT);
VAR  oben, unten: LONGINT;
BEGIN
  derFensterInhalt^.Scroll (X, Y);

  oben := derFensterInhalt^.LongDelta.Y;
  unten := derFensterInhalt^.Size.Y + derFensterInhalt^.LongDelta.Y;
  IF TextY < oben THEN ZeilenVor (TRUE, oben - TextY)
  ELSE IF TextY > unten THEN ZeilenZurueck (TRUE, TextY - unten);
END (* Scroll *);

PROCEDURE einText.ZeilenVor (CONST scroll: BOOLEAN; CONST n: LONGINT);
VAR  d:  GLP;
BEGIN
  IF ElementIndex + n < AnzahlElemente THEN
    d := NtesElement (ElementIndex + n)
  ELSE d := LastElement;
  setzeMerker (laufendeZeile);
  IF scroll AND (derFensterInhalt <> NIL) THEN derFensterInhalt^.ScrollTo (TextX, TextY);
  (* OffsetY??? *)
END (* ZeilenVor *);

PROCEDURE einText.ZeilenZurueck (CONST scroll: BOOLEAN; CONST n: LONGINT);
VAR  d:  GLP;
BEGIN
  IF n <= ElementIndex THEN
    d := NtesElement (ElementIndex - n)
  ELSE d := FirstElement;
  setzeMerker (laufendeZeile);
  IF scroll AND (derFensterInhalt <> NIL) THEN derFensterInhalt^.ScrollTo (TextX, TextY);
  (* OffsetY??? *)
END (* ZeilenZurueck *);

PROCEDURE einText.AbsatzEnde (CONST Skip: BOOLEAN);
VAR  curLine:  einMerkerPointer;
BEGIN

  IF Skip THEN BEGIN
    ZeilenVor (TRUE, 1);
    IF NOT hatTextflag (Absatzkennung) THEN ZeilenVor (TRUE, 1);
  END;

  (* Geht von der aktuellen Zeile aus, auf die SimpleText.Verweis deutet.
     Verweis deutet auf den aktuellen TextGlue.
     Verfolgt so lange die Pointer Verweis^.Links, bis eine leere Zeile
     oder Zeile ohne Blank am Ende
     gefunden wird oder das letzte Element der Liste erreicht ist.
  *)
  curLine := NIL;
  setzeMerker (curLine);

  (* Wenn die aktuelle Zeile das Ende eines Absatzes ist, gehen wir
     zur nchsten Zeile: *)
{
  IF hatNaechsteZeile (curLine) AND
     (curLine^.getZ <> NIL) AND
     curLine^.getZ^.AbsatzEnde (hatTextflag (Absatzkennung))
  THEN curLine^.MerkerNaechsteZeile;
}
    (* Wenn die aktuelle Zeile kein Absatzende darstellt, gehen wir
       zur nchsten Zeile: *)

  WHILE hatNaechsteZeile (curline) AND
        (curLine^.getZ <> NIL) AND
        NOT curLine^.getZ^.AbsatzEnde (hatTextflag (Absatzkennung), hatTextflag (Absatzkennung),
                                       AbsatzKennSet)
    DO curLine^.MerkerNaechsteZeile;

  IF NOT hatTextflag (Absatzkennung) THEN
    curLine^.MerkerVorigeZeile;

  zuMerker (curLine);
  TextX := laufendeZeile^.getZ^.StringLaenge;
  derFensterInhalt^.ScrollTo (TextX, TextY);

  Dispose (curLine, Done);
END (* AbsatzEnde *);

PROCEDURE einText.AbsatzAnfang (CONST Skip: BOOLEAN);
VAR curLine:  einMerkerPointer;
BEGIN
  IF Skip THEN BEGIN
    ZeilenZurueck (TRUE, 1);
    IF NOT hatTextflag (Absatzkennung) THEN ZeilenZurueck (TRUE, 1);
  END;

  curLine := NIL;
  setzeMerker (curLine);

  IF hatVorigeZeile (curLine) AND
     (curLine^.getZ <> NIL) AND
     curLine^.getZ^.AbsatzEnde (hatTextflag (Absatzkennung), hatTextflag (Absatzkennung),
                                AbsatzKennSet)
  THEN curLine^.MerkerVorigeZeile;

  WHILE hatVorigeZeile (curline) AND
        (curLine^.getZ <> NIL) AND
        NOT curLine^.getZ^.AbsatzEnde (hatTextflag (Absatzkennung), hatTextflag (Absatzkennung),
                                       AbsatzKennSet)
  DO curLine^.MerkerVorigeZeile;

  {IF NOT hatTextflag (Absatzkennung) THEN}
     curLine^.MerkerNaechsteZeile;

  zuMerker (curLine);
  TextX := 0;
  derFensterInhalt^.ScrollTo (TextX, TextY);

  Dispose (curLine, Done);
END (* AbsatzAnfang *);

PROCEDURE einText.letzteZeile;
VAR   d:  GLP;
BEGIN
  d := LastElement;
  setzeMerker (laufendeZeile);
  derFensterInhalt^.ScrollTo (TextX, TextY);
END (* letzteZeile *);

PROCEDURE einText.zurZeile (CONST n: LONGINT);
VAR  d:  GLP;
BEGIN
  d := NtesElement (n);
  setzeMerker (laufendeZeile);
  derFensterInhalt^.ScrollTo (TextX, TextY);
END (* zurZeile *);

PROCEDURE einText.setzeTextFlag (CONST f: einTextFlag);
BEGIN
  Include (meineTextFlags, f);
END (* setzeTextFlag *);

PROCEDURE einText.loescheTextFlag (CONST f: einTextFlag);
BEGIN
  Exclude (meineTextFlags, f);
END (* loescheTextFlag *);

PROCEDURE einText.toggleTextFlag (CONST f: einTextFlag);
BEGIN
  IF f IN meineTextFlags THEN Exclude (meineTextflags, f)
  ELSE Include (meineTextFlags, f);
END (* toggleTextFlag *);

FUNCTION einText.hatTextFlag (CONST f: einTextFlag): BOOLEAN;
BEGIN
  hatTextFlag := f IN meineTextFlags;
END (* hatTextFlag *);

PROCEDURE einText.setzeInternFlag (CONST f: einInternFlag);
BEGIN
  Include (meineInternFlags, f);
  IF f = TextEditiert THEN setzeMerker (altePos);
END (* setzeInternFlag *);

PROCEDURE einText.loescheInternFlag (CONST f: einInternFlag);
BEGIN
  Exclude (meineInternFlags, f);
END (* loescheTextFlag *);

PROCEDURE einText.toggleInternFlag (CONST f: einInternFlag);
BEGIN
  IF f IN meineInternFlags THEN Exclude (meineInternflags, f)
  ELSE Include (meineInternFlags, f);
END (* toggleInternFlag *);

FUNCTION einText.hatInternFlag (CONST f: einInternFlag): BOOLEAN;
BEGIN
  hatInternFlag := f IN meineInternFlags;
END (* hatTextFlag *);

{
PROCEDURE einSimpleText.Monitor;
VAR     f:      einTextFlag;
BEGIN
(*
    INHERITED Monitor (view);
*)
  view^.GotoXY (0, 0);

    view^.WriteString ('AnzahlZeichen:    ', 0, 0); view^.WriteInt (AnzahlZeichen);
      view^.WriteStrLn ('');
    view^.WriteString ('UmbruchBreite:    ', 0, 0); view^.WriteInt (UmbruchBreite);
      view^.WriteStrLn ('');
    view^.WriteString ('Seitenlaenge:     ', 0, 0); view^.WriteInt (Seitenlaenge);
      view^.WriteStrLn ('');
    view^.WriteString ('Tablaenge:        ', 0, 0); view^.WriteInt (Tablaenge);
      view^.WriteStrLn ('');
    view^.WriteString ('FensterAnzeigen:  ', 0, 0);
      view^.WriteBool (FensterAnzeigen); view^.WriteStrLn ('');
    view^.WriteString ('TextX:            ', 0, 0); view^.WriteInt (TextX);
      view^.WriteString (', AutoSaveN:        ', 0, 0); view^.WriteInt (AutoSaveN);
      view^.WriteStrLn ('');
    view^.WriteString ('meineTextFlags:   ', 0, 0);
      FOR f := InsertFlag TO Absatzkennung DO BEGIN
        IF f IN meineTextFlags THEN view^.WriteChr ('1') ELSE view^.WriteChr ('0');
      END (* FOR *);
    view^.WriteStrLn ('');
    view^.WriteString ('StandardZeile:    ', 0, 0); view^.WriteTyp (StandardZeile);
      view^.WriteLn;
    view^.WriteString ('meineDatei:       ', 0, 0); view^.WritePointer (meineDatei);
      view^.WriteStrLn ('');
    view^.WriteString ('meinUndoText:     ', 0, 0); view^.WritePointer (meinUndoText);
      view^.WriteStrLn ('');
    view^.WriteString ('derFensterInhalt: ', 0, 0); view^.WritePointer (derFensterInhalt);
      view^.WriteStrLn ('');
    view^.WriteString ('laufendeZeile:    ', 0, 0); view^.WritePointer (laufendeZeile^.GetZ);
      view^.WriteStrLn ('');
    view^.WriteString ('Textname:         ', 0, 0); view^.WritePointer (TextName);
    IF TextName <> NIL THEN BEGIN
      view^.WriteString (': ', 0, 0); view^.WriteString (TextName^.StringVonDaten, 0, 0);
    END (* IF TextName <> NIL *);
      view^.WriteStrLn ('');

    view^.WriteString ('Kopfzeile:         ', 0, 0); view^.WritePointer (Kopfzeile);
    IF Kopfzeile <> NIL THEN BEGIN
      view^.WriteString (': ', 0, 0); view^.WriteString (Kopfzeile^.StringVonDaten, 0, 0);
    END (* IF Kopfzeile <> NIL *);
      view^.WriteStrLn ('');

    view^.WriteString ('Fusszeile:         ', 0, 0); view^.WritePointer (Fusszeile);
    IF Fusszeile <> NIL THEN BEGIN
      view^.WriteString (': ', 0, 0); view^.WriteString (Fusszeile^.StringVonDaten, 0, 0);
    END (* IF Fusszeile <> NIL *);
      view^.WriteStrLn ('');

    view^.WriteString ('DateiSuffix:         ', 0, 0); view^.WritePointer (DateiSuffix);
    IF DateiSuffix <> NIL THEN BEGIN
      view^.WriteString (': ', 0, 0); view^.WriteString (DateiSuffix^.StringVonDaten, 0, 0);
    END (* IF DateiSuffix <> NIL *);
      view^.WriteStrLn ('');

    view^.WriteString ('Suchwort:         ', 0, 0); view^.WritePointer (Suchwort);
    IF Suchwort <> NIL THEN BEGIN
      view^.WriteString (': ', 0, 0); view^.WriteString (Suchwort^.StringVonDaten, 0, 0);
    END (* IF Suchwort <> NIL *);
      view^.WriteStrLn ('');

    view^.WriteString ('Tauschwort:         ', 0, 0); view^.WritePointer (Tauschwort);
    IF Tauschwort <> NIL THEN BEGIN
      view^.WriteString (': ', 0, 0); view^.WriteString (Tauschwort^.StringVonDaten, 0, 0);
    END (* IF Tauschwort <> NIL *);
      view^.WriteStrLn ('');

END (* Monitor *);
}

END (* TextBase *).