UNIT TVMenuString;

{$F+}
{$O+}

(* (C) 1990-1995 by Johannes Leckebusch
   Version 0.902
   Stand: 07. 02. 1995
*)

INTERFACE

USES GLFTypes, GLFBase, ObjStrings, Views;

TYPE

  einMenuStringPointer = ^einMenuString;
  einMenuString = OBJECT (einString8)
                    Anzahl2:         BYTE;
                    derSuffix:       StringPointer;
                    TastenCode:      WORD;
                    MenuBefehl:      WORD;
                    Kontext:         WORD;
                    CONSTRUCTOR Init (CONST xflags: einFlagSet);
                    DESTRUCTOR Done; VIRTUAL;
                    FUNCTION erzeugeMich (CONST xflags: einFlagSet): GLP; VIRTUAL;

                    FUNCTION isSubclass (CONST class: einGenTyp): BOOLEAN; VIRTUAL;
                    PROCEDURE allocSuffix (VAR anzahl); VIRTUAL;
                    PROCEDURE deallocSuffix; VIRTUAL;
                    PROCEDURE resizeSuffix (VAR anzahl); VIRTUAL;
                    PROCEDURE setzeSuffix (CONST suf; CONST dynamisch: BOOLEAN);
                      VIRTUAL;
                    PROCEDURE holeSuffix (VAR suf); VIRTUAL;
                    PROCEDURE setzeStringUndCode (CONST s, suf;
                                CONST c, b, k: WORD; CONST dynamisch: BOOLEAN);
                      VIRTUAL;
                    PROCEDURE holeStringUndCode (VAR s, suf;
                                VAR c, b, k: WORD); VIRTUAL;
                    PROCEDURE Monitor (CONST view: PBuffText); VIRTUAL;
                  END (* einMenuString *);

IMPLEMENTATION

USES EditStuff;

CONSTRUCTOR einMenuString.Init;
BEGIN
  INHERITED Init (xflags);
  {
  derSuffix := NIL;
  Anzahl2 := 0;
  }
  MeinTyp := MenuString;
  {TastenCode := 0; MenuBefehl := 0; Kontext := 0;}
END (* Init *);

DESTRUCTOR einMenuString.Done;
BEGIN
  deAllocSuffix;
  INHERITED Done;
END;

FUNCTION einMenuString.erzeugeMich (CONST xflags: einFlagSet): GLP;
BEGIN
  erzeugeMich := NEW (einMenuStringPointer, Init (xflags));
END (* erzeugeMich *);

FUNCTION einMenuString.isSubclass (CONST class: einGenTyp): BOOLEAN;
BEGIN
  isSubclass := (class = MenuString) OR INHERITED isSubClass (class);
END (* Member *);

PROCEDURE einMenuString.allocSuffix (VAR anzahl);
BEGIN
  Anzahl2 := gran (BYTE (anzahl) + SizeOf (derSuffix^.Laenge));
  GetMem (derSuffix, Anzahl2);
  derSuffix^.Laenge := 0;
END (* allocSuffix *);

PROCEDURE einMenuString.deallocSuffix;
BEGIN
  IF (Anzahl2 > 0) THEN BEGIN
    FreeMem (derSuffix, Anzahl2);
  END;
  derSuffix := NIL; Anzahl2 := 0;
END (* deallocSuffix *);

PROCEDURE einMenuString.resizeSuffix (VAR anzahl);
VAR    h:        StringPointer;
       nanzahl:  BYTE;
BEGIN
  nanzahl := gran (BYTE (anzahl) + SizeOf (derSuffix^.Laenge));
  IF nanzahl <> Anzahl2 THEN BEGIN
    GetMem (h, WORD (nanzahl));
    IF derSuffix <> NIL THEN BEGIN
      IF nanzahl > Anzahl2 THEN BEGIN
        Move (derSuffix^, h^, WORD (Anzahl2));
      END
      ELSE BEGIN
        Move (derSuffix^, h^, WORD (nanzahl));
      END;
      FreeMem (derSuffix, Anzahl2);
    END (* IF alten String kopieren *)
    ELSE h^.Laenge := 0;
    derSuffix := h;
    Anzahl2 := nanzahl;
  END (* IF nanzahl <> Anzahl2 *);
END (* resizeSuffix *);

PROCEDURE einMenuString.setzeSuffix (CONST suf; CONST dynamisch: BOOLEAN);
VAR   laen:  WORD;
BEGIN
  laen := LENGTH (STRING (suf));
  resizeSuffix (laen);
  derSuffix^.Laenge := laen;
  Move (SSTRING (suf).Str [0], derSuffix^.Str [0], laen);
END (* setzeSuffix *);

PROCEDURE einMenuString.holeSuffix (VAR suf);
BEGIN
  IF derSuffix <> NIL THEN BEGIN
    SSTRING (suf).Laenge := derSuffix^.Laenge;
    Move (derSuffix^.Str [0], SSTRING (suf).Str [0], derSuffix^.Laenge);
  END
  ELSE STRING (suf) := '';
END (* holeSuffix *);

PROCEDURE einMenuString.setzeStringUndCode (CONST s, suf;
                        CONST c, b, k: WORD; CONST dynamisch: BOOLEAN);
BEGIN
  INHERITED setzeString (s, dynamisch);
  setzeSuffix (suf, dynamisch);
  TastenCode := c; MenuBefehl := b; Kontext := k;
END (* setzeStringUndCode *);

PROCEDURE einMenuString.holeStringUndCode (VAR s, suf; VAR c, b, k: WORD);
BEGIN
  INHERITED holeString (s);
  holeSuffix (suf);
  c := TastenCode; b := MenuBefehl; k := Kontext;
END (* holeStringUndCode *);

PROCEDURE einMenuString.Monitor;
BEGIN
  INHERITED Monitor (view);
  WriteString (view, 'TastaturCode:  '); WriteInt (view, TastenCode);
  WriteStrLn (view, '');
END (* Monitor *);

END (* TVMenuStrings *).